/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/platform/log/common/log","vs/base/common/network","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(Y){for(var e=[],w=0,I=Y.length;w<I;w++)e[w]=we[Y[w]];return e};define(we[42],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(I,A){if(!I)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=w}),define(we[51],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const w=Object.prototype.hasOwnProperty;function I(P){const d=[];for(let h in P)w.call(P,h)&&d.push(P[h]);return d}e.values=I;function A(P,d){for(let h in P)if(w.call(P,h)&&d({key:h,value:P[h]},function(){delete P[h]})===!1)return}e.forEach=A;function T(P,d){const h=Object.create(null);for(const r of P){const a=d(r);let p=h[a];p||(p=h[a]=[]),p.push(r)}return h}e.groupBy=T;function y(P,d){const h=new Map;for(const r of P){const a=d(r);let p=h.get(a);p||(p=[],h.set(a,p)),p.push(r)}return h}e.groupByNumber=y;function D(P){const d=Object.create(null);return P&&P.forEach((h,r)=>{d[r]=h}),d}e.fromMap=D;function S(P,d){const h=[],r=[];for(let a of P)d.has(a)||h.push(a);for(let a of d)P.has(a)||r.push(a);return{removed:h,added:r}}e.diffSets=S;function C(P,d){const h=[],r=[];for(let[a,p]of P)d.has(a)||h.push(p);for(let[a,p]of d)P.has(a)||r.push(p);return{removed:h,added:r}}e.diffMaps=C;class i{constructor(){this.map=new Map}add(d,h){let r=this.map.get(d);r||(r=new Set,this.map.set(d,r)),r.add(h)}delete(d,h){const r=this.map.get(d);!r||(r.delete(h),r.size===0&&this.map.delete(d))}forEach(d,h){const r=this.map.get(d);!r||r.forEach(h)}}e.SetMap=i}),define(we[52],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function w(S){return(C,i,P)=>{let d=null,h=null;if(typeof P.value=="function"?(d="value",h=P.value):typeof P.get=="function"&&(d="get",h=P.get),!h)throw new Error("not supported");P[d]=S(h,i)}}e.createDecorator=w;let I=0;function A(){const S=`$memoize${I++}`;let C;const i=function(d,h,r){let a=null,p=null;if(typeof r.value=="function"?(a="value",p=r.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof r.get=="function"&&(a="get",p=r.get),!p)throw new Error("not supported");const m=`${S}:${h}`;r[a]=function(...E){return C=this,this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!0,enumerable:!1,writable:!0,value:p.apply(this,E)}),this[m]}};return i.clear=()=>{typeof C!="undefined"&&Object.getOwnPropertyNames(C).forEach(P=>{P.indexOf(S)===0&&delete C[P]})},i}e.createMemoizer=A;function T(S,C,i){return A()(S,C,i)}e.memoize=T;function y(S,C,i){return w((P,d)=>{const h=`$debounce$${d}`,r=`$debounce$result$${d}`;return function(...a){this[r]||(this[r]=i?i():void 0),clearTimeout(this[h]),C&&(this[r]=C(this[r],...a),a=[this[r]]),this[h]=setTimeout(()=>{P.apply(this,a),this[r]=i?i():void 0},S)}})}e.debounce=y;function D(S,C,i){return w((P,d)=>{const h=`$throttle$timer$${d}`,r=`$throttle$result$${d}`,a=`$throttle$lastRun$${d}`,p=`$throttle$pending$${d}`;return function(...m){if(this[r]||(this[r]=i?i():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),C&&(this[r]=C(this[r],...m)),!this[p]){const E=this[a]+S;E<=Date.now()?(this[a]=Date.now(),P.apply(this,[this[r]]),this[r]=i?i():void 0):(this[p]=!0,this[h]=setTimeout(()=>{this[p]=!1,this[a]=Date.now(),P.apply(this,[this[r]]),this[r]=i?i():void 0},E-Date.now()))}}})}e.throttle=D}),define(we[12],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=w,e.errorHandler=new w;function I(b){e.errorHandler.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=I;function A(b){S(b)||e.errorHandler.onUnexpectedError(b)}e.onUnexpectedError=A;function T(b){S(b)||e.errorHandler.onUnexpectedExternalError(b)}e.onUnexpectedExternalError=T;function y(b){if(b instanceof Error){let{name:t,message:n}=b;const u=b.stacktrace||b.stack;return{$isError:!0,name:t,message:n,stack:u}}return b}e.transformErrorForSerialization=y;const D="Canceled";function S(b){return b instanceof Error&&b.name===D&&b.message===D}e.isPromiseCanceledError=S;class C extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=C;function i(){const b=new Error(D);return b.name=b.message,b}e.canceled=i;function P(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.illegalArgument=P;function d(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.illegalState=d;function h(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function r(b){const t=new Error(`${b} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function a(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.getErrorMessage=a;class p extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=p;class m extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=m;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function f(b){const t=b;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=f;function l(b,t=Object.create(null)){const n=new Error(b);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=l}),define(we[15],_e([0,1,12]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I($,F=0){return $[$.length-(1+F)]}e.tail=I;function A($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=A;function T($,F,L=(M,U)=>M===U){if($===F)return!0;if(!$||!F||$.length!==F.length)return!1;for(let M=0,U=$.length;M<U;M++)if(!L($[M],F[M]))return!1;return!0}e.equals=T;function y($,F,L){let M=0,U=$.length-1;for(;M<=U;){const G=(M+U)/2|0,J=L($[G],F);if(J<0)M=G+1;else if(J>0)U=G-1;else return G}return-(M+1)}e.binarySearch=y;function D($,F){let L=0,M=$.length;if(M===0)return 0;for(;L<M;){const U=Math.floor((L+M)/2);F($[U])?M=U:L=U+1}return L}e.findFirstInSorted=D;function S($,F,L){if($=$|0,$>=F.length)throw new TypeError("invalid index");let M=F[Math.floor(F.length*Math.random())],U=[],G=[],J=[];for(let re of F){const pe=L(re,M);pe<0?U.push(re):pe>0?G.push(re):J.push(re)}return $<U.length?S($,U,L):$<U.length+J.length?J[0]:S($-(U.length+J.length),G,L)}e.quickSelect=S;function C($,F){const L=[];let M;for(const U of $.slice(0).sort(F))!M||F(M[0],U)!==0?(M=[U],L.push(M)):M.push(U);return L}e.groupBy=C;function i($,F,L){const M=[];function U(re,pe,Te){if(!(pe===0&&Te.length===0)){const Be=M[M.length-1];Be&&Be.start+Be.deleteCount===re?(Be.deleteCount+=pe,Be.toInsert.push(...Te)):M.push({start:re,deleteCount:pe,toInsert:Te})}}let G=0,J=0;for(;;){if(G===$.length){U(G,0,F.slice(J));break}if(J===F.length){U(G,$.length-G,[]);break}const re=$[G],pe=F[J],Te=L(re,pe);Te===0?(G+=1,J+=1):Te<0?(U(G,1,[]),G+=1):Te>0&&(U(G,0,[pe]),J+=1)}return M}e.sortedDiff=i;function P($,F,L){const M=i($,F,L),U=[],G=[];for(const J of M)U.push(...$.slice(J.start,J.start+J.deleteCount)),G.push(...J.toInsert);return{removed:U,added:G}}e.delta=P;function d($,F,L){if(L===0)return[];const M=$.slice(0,L).sort(F);return r($,F,M,L,$.length),M}e.top=d;function h($,F,L,M,U){return L===0?Promise.resolve([]):new Promise((G,J)=>{(async()=>{const re=$.length,pe=$.slice(0,L).sort(F);for(let Te=L,Be=Math.min(L+M,re);Te<re;Te=Be,Be=Math.min(Be+M,re)){if(Te>L&&await new Promise(Ae=>setTimeout(Ae)),U&&U.isCancellationRequested)throw(0,w.canceled)();r($,F,pe,Te,Be)}return pe})().then(G,J)})}e.topAsync=h;function r($,F,L,M,U){for(const G=L.length;M<U;M++){const J=$[M];if(F(J,L[G-1])<0){L.pop();const re=D(L,pe=>F(J,pe)<0);L.splice(re,0,J)}}}function a($){return $.filter(F=>!!F)}e.coalesce=a;function p($){let F=0;for(let L=0;L<$.length;L++)$[L]&&($[F]=$[L],F+=1);$.length=F}e.coalesceInPlace=p;function m($,F,L){$.splice(L,0,$.splice(F,1)[0])}e.move=m;function E($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=E;function f($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=f;function l($,F){if(!F)return $.filter((M,U)=>$.indexOf(M)===U);const L=Object.create(null);return $.filter(M=>{const U=F(M);return L[U]?!1:(L[U]=!0,!0)})}e.distinct=l;function b($){const F=new Set;return $.filter(L=>F.has(L)?!1:(F.add(L),!0))}e.distinctES6=b;function t($){const F=Object.create(null);return L=>{const M=$(L);return F[M]?!1:(F[M]=!0,!0)}}e.uniqueFilter=t;function n($,F){for(let L=$.length-1;L>=0;L--){const M=$[L];if(F(M))return L}return-1}e.lastIndex=n;function u($,F){return $.length>0?$[0]:F}e.firstOrDefault=u;function o($,F,L=(M,U)=>M===U){let M=0;for(let U=0,G=Math.min($.length,F.length);U<G&&L($[U],F[U]);U++)M++;return M}e.commonPrefixLength=o;function s($){return[].concat(...$)}e.flatten=s;function c($,F){let L=typeof F=="number"?$:0;typeof F=="number"?L=$:(L=0,F=$);const M=[];if(L<=F)for(let U=L;U<F;U++)M.push(U);else for(let U=L;U>F;U--)M.push(U);return M}e.range=c;function v($,F,L){return $.reduce((M,U)=>(M[F(U)]=L?L(U):U,M),Object.create(null))}e.index=v;function k($,F){return $.push(F),()=>g($,F)}e.insert=k;function g($,F){const L=$.indexOf(F);if(L>-1)return $.splice(L,1),F}e.remove=g;function _($,F,L){const M=$.slice(0,F),U=$.slice(F);return M.concat(L,U)}e.arrayInsert=_;function R($,F){let L;if(typeof F=="number"){let M=F;L=()=>{const U=Math.sin(M++)*179426549;return U-Math.floor(U)}}else L=Math.random;for(let M=$.length-1;M>0;M-=1){const U=Math.floor(L()*(M+1)),G=$[M];$[M]=$[U],$[U]=G}}e.shuffle=R;function B($,F){const L=$.indexOf(F);L>-1&&($.splice(L,1),$.unshift(F))}e.pushToStart=B;function Q($,F){const L=$.indexOf(F);L>-1&&($.splice(L,1),$.push(F))}e.pushToEnd=Q;function ge($,F){return Array.isArray($)?$.map(F):F($)}e.mapArrayOrNot=ge;function V($){return Array.isArray($)?$:[$]}e.asArray=V;function H($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=H;function te($,F){for(const L of $){const M=F(L);if(M!==void 0)return M}}e.mapFind=te}),define(we[53],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(I){const A=this;let T=!1,y;return function(){return T||(T=!0,y=I.apply(A,arguments)),y}}e.once=w}),define(we[54],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class w{constructor(A){this._prefix=A,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=w,e.defaultGenerator=new w("id#")}),define(we[43],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(I){function A(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}I.is=A;const T=Object.freeze([]);function y(){return T}I.empty=y;function*D(b){yield b}I.single=D;function S(b){return b||T}I.from=S;function C(b){return!b||b[Symbol.iterator]().next().done===!0}I.isEmpty=C;function i(b){return b[Symbol.iterator]().next().value}I.first=i;function P(b,t){for(const n of b)if(t(n))return!0;return!1}I.some=P;function d(b,t){for(const n of b)if(t(n))return n}I.find=d;function*h(b,t){for(const n of b)t(n)&&(yield n)}I.filter=h;function*r(b,t){for(const n of b)yield t(n)}I.map=r;function*a(...b){for(const t of b)for(const n of t)yield n}I.concat=a;function*p(b){for(const t of b)for(const n of t)yield n}I.concatNested=p;function m(b,t,n){let u=n;for(const o of b)u=t(u,o);return u}I.reduce=m;function*E(b,t,n=b.length){for(t<0&&(t+=b.length),n<0?n+=b.length:n>b.length&&(n=b.length);t<n;t++)yield b[t]}I.slice=E;function f(b,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,b];const u=b[Symbol.iterator]();for(let o=0;o<t;o++){const s=u.next();if(s.done)return[n,I.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return u}}]}I.consume=f;function l(b,t,n=(u,o)=>u===o){const u=b[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const s=u.next(),c=o.next();if(s.done!==c.done)return!1;if(s.done)return!0;if(!n(s.value,c.value))return!1}}I.equals=l})(w=e.Iterable||(e.Iterable={}))}),define(we[44],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let u=0,o=t.length,s="",c=0,v=16,k=0;function g(H){let te=0,$=0;for(;te<H;){const F=t.charCodeAt(u);if(F>=48&&F<=57)$=$*16+F-48;else if(F>=65&&F<=70)$=$*16+F-65+10;else if(F>=97&&F<=102)$=$*16+F-97+10;else break;u++,te++}return te<H&&($=-1),$}function _(H){u=H,s="",c=0,v=16,k=0}function R(){const H=u;if(t.charCodeAt(u)===48)u++;else for(u++;u<t.length&&C(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===46)if(u++,u<t.length&&C(t.charCodeAt(u)))for(u++;u<t.length&&C(t.charCodeAt(u));)u++;else return k=3,t.substring(H,u);let te=u;if(u<t.length&&(t.charCodeAt(u)===69||t.charCodeAt(u)===101))if(u++,(u<t.length&&t.charCodeAt(u)===43||t.charCodeAt(u)===45)&&u++,u<t.length&&C(t.charCodeAt(u))){for(u++;u<t.length&&C(t.charCodeAt(u));)u++;te=u}else k=3;return t.substring(H,te)}function B(){let H="",te=u;for(;;){if(u>=o){H+=t.substring(te,u),k=2;break}const $=t.charCodeAt(u);if($===34){H+=t.substring(te,u),u++;break}if($===92){if(H+=t.substring(te,u),u++,u>=o){k=2;break}switch(t.charCodeAt(u++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:const L=g(4);L>=0?H+=String.fromCharCode(L):k=4;break;default:k=5}te=u;continue}if($>=0&&$<=31)if(S($)){H+=t.substring(te,u),k=2;break}else k=6;u++}return H}function Q(){if(s="",k=0,c=u,u>=o)return c=o,v=17;let H=t.charCodeAt(u);if(D(H)){do u++,s+=String.fromCharCode(H),H=t.charCodeAt(u);while(D(H));return v=15}if(S(H))return u++,s+=String.fromCharCode(H),H===13&&t.charCodeAt(u)===10&&(u++,s+=`
`),v=14;switch(H){case 123:return u++,v=1;case 125:return u++,v=2;case 91:return u++,v=3;case 93:return u++,v=4;case 58:return u++,v=6;case 44:return u++,v=5;case 34:return u++,s=B(),v=10;case 47:const te=u-1;if(t.charCodeAt(u+1)===47){for(u+=2;u<o&&!S(t.charCodeAt(u));)u++;return s=t.substring(te,u),v=12}if(t.charCodeAt(u+1)===42){u+=2;const $=o-1;let F=!1;for(;u<$;){if(t.charCodeAt(u)===42&&t.charCodeAt(u+1)===47){u+=2,F=!0;break}u++}return F||(u++,k=1),s=t.substring(te,u),v=13}return s+=String.fromCharCode(H),u++,v=16;case 45:if(s+=String.fromCharCode(H),u++,u===o||!C(t.charCodeAt(u)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=R(),v=11;default:for(;u<o&&ge(H);)u++,H=t.charCodeAt(u);if(c!==u){switch(s=t.substring(c,u),s){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return s+=String.fromCharCode(H),u++,v=16}}function ge(H){if(D(H)||S(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let H;do H=Q();while(H>=12&&H<=15);return H}return{setPosition:_,getPosition:()=>u,scan:n?V:Q,getToken:()=>v,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>u-c,getTokenError:()=>k}}e.createScanner=y;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function P(t,n){const u=[],o=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function k(g,_,R,B){c.value=g,c.offset=_,c.length=R,c.type=B,c.colonOffset=void 0,s=c}try{f(t,{onObjectBegin:(g,_)=>{if(n<=g)throw o;s=void 0,v=n>g,u.push("")},onObjectProperty:(g,_,R)=>{if(n<_||(k(g,_,R,"property"),u[u.length-1]=g,n<=_+R))throw o},onObjectEnd:(g,_)=>{if(n<=g)throw o;s=void 0,u.pop()},onArrayBegin:(g,_)=>{if(n<=g)throw o;s=void 0,u.push(0)},onArrayEnd:(g,_)=>{if(n<=g)throw o;s=void 0,u.pop()},onLiteralValue:(g,_,R)=>{if(n<_||(k(g,_,R,b(g)),n<=_+R))throw o},onSeparator:(g,_,R)=>{if(n<=_)throw o;if(g===":"&&s&&s.type==="property")s.colonOffset=_,v=!1,s=void 0;else if(g===","){const B=u[u.length-1];typeof B=="number"?u[u.length-1]=B+1:(v=!0,u[u.length-1]=""),s=void 0}}})}catch(g){if(g!==o)throw g}return{path:u,previousNode:s,isAtPropertyKey:v,matches:g=>{let _=0;for(let R=0;_<g.length&&R<u.length;R++)if(g[_]===u[R]||g[_]==="*")_++;else if(g[_]!=="**")return!1;return _===g.length}}}e.getLocation=P;function d(t,n=[],u=T.DEFAULT){let o=null,s=[];const c=[];function v(g){Array.isArray(s)?s.push(g):o!==null&&(s[o]=g)}return f(t,{onObjectBegin:()=>{const g={};v(g),c.push(s),s=g,o=null},onObjectProperty:g=>{o=g},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const g=[];v(g),c.push(s),s=g,o=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:v,onError:(g,_,R)=>{n.push({error:g,offset:_,length:R})}},u),s[0]}e.parse=d;function h(t,n=[],u=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(g){o.type==="property"&&(o.length=g-o.offset,o=o.parent)}function c(g){return o.children.push(g),g}f(t,{onObjectBegin:g=>{o=c({type:"object",offset:g,length:-1,parent:o,children:[]})},onObjectProperty:(g,_,R)=>{o=c({type:"property",offset:_,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:g,offset:_,length:R,parent:o})},onObjectEnd:(g,_)=>{o.length=g+_-o.offset,o=o.parent,s(g+_)},onArrayBegin:(g,_)=>{o=c({type:"array",offset:g,length:-1,parent:o,children:[]})},onArrayEnd:(g,_)=>{o.length=g+_-o.offset,o=o.parent,s(g+_)},onLiteralValue:(g,_,R)=>{c({type:b(g),offset:_,length:R,parent:o,value:g}),s(_+R)},onSeparator:(g,_,R)=>{o.type==="property"&&(g===":"?o.colonOffset=_:g===","&&s(_))},onError:(g,_,R)=>{n.push({error:g,offset:_,length:R})}},u);const k=o.children[0];return k&&delete k.parent,k}e.parseTree=h;function r(t,n){if(!!t){let u=t;for(let o of n)if(typeof o=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let s=!1;for(const c of u.children)if(Array.isArray(c.children)&&c.children[0].value===o){u=c.children[1],s=!0;break}if(!s)return}else{const s=o;if(u.type!=="array"||s<0||!Array.isArray(u.children)||s>=u.children.length)return;u=u.children[s]}return u}}e.findNodeAtLocation=r;function a(t){if(!t.parent||!t.parent.children)return[];const n=a(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;n.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&n.push(u)}return n}e.getNodePath=a;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const n=Object.create(null);for(let u of t.children){const o=u.children[1];o&&(n[u.children[0].value]=p(o))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function m(t,n,u=!1){return n>=t.offset&&n<t.offset+t.length||u&&n===t.offset+t.length}e.contains=m;function E(t,n,u=!1){if(m(t,n,u)){const o=t.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=n;s++){const c=E(o[s],n,u);if(c)return c}return t}}e.findNodeAtOffset=E;function f(t,n,u=T.DEFAULT){const o=y(t,!1);function s(pe){return pe?()=>pe(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(pe){return pe?Te=>pe(Te,o.getTokenOffset(),o.getTokenLength()):()=>!0}const v=s(n.onObjectBegin),k=c(n.onObjectProperty),g=s(n.onObjectEnd),_=s(n.onArrayBegin),R=s(n.onArrayEnd),B=c(n.onLiteralValue),Q=c(n.onSeparator),ge=s(n.onComment),V=c(n.onError),H=u&&u.disallowComments,te=u&&u.allowTrailingComma;function $(){for(;;){const pe=o.scan();switch(o.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:H||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(pe){case 12:case 13:H?F(10):ge();break;case 16:F(1);break;case 15:case 14:break;default:return pe}}}function F(pe,Te=[],Be=[]){if(V(pe),Te.length+Be.length>0){let Ae=o.getToken();for(;Ae!==17;){if(Te.indexOf(Ae)!==-1){$();break}else if(Be.indexOf(Ae)!==-1)break;Ae=$()}}}function L(pe){const Te=o.getTokenValue();return pe?B(Te):k(Te),$(),!0}function M(){switch(o.getToken()){case 11:let pe=0;try{pe=JSON.parse(o.getTokenValue()),typeof pe!="number"&&(F(2),pe=0)}catch(Te){F(2)}B(pe);break;case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return $(),!0}function U(){return o.getToken()!==10?(F(3,[],[2,5]),!1):(L(!1),o.getToken()===6?(Q(":"),$(),re()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function G(){v(),$();let pe=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(pe||F(4,[],[]),Q(","),$(),o.getToken()===2&&te)break}else pe&&F(6,[],[]);U()||F(4,[],[2,5]),pe=!0}return g(),o.getToken()!==2?F(7,[2],[]):$(),!0}function J(){_(),$();let pe=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(pe||F(4,[],[]),Q(","),$(),o.getToken()===4&&te)break}else pe&&F(6,[],[]);re()||F(4,[],[4,5]),pe=!0}return R(),o.getToken()!==4?F(8,[4],[]):$(),!0}function re(){switch(o.getToken()){case 3:return J();case 1:return G();case 10:return L(!0);default:return M()}}return $(),o.getToken()===17?u.allowEmptyContent?!0:(F(4,[],[]),!1):re()?(o.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=f;function l(t,n){let u=y(t),o=[],s,c=0,v;do switch(v=u.getPosition(),s=u.scan(),s){case 12:case 13:case 17:c!==v&&o.push(t.substring(c,v)),n!==void 0&&o.push(u.getTokenValue().replace(/[^\r\n]/g,n)),c=u.getPosition();break}while(s!==17);return o.join("")}e.stripComments=l;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(we[106],_e([0,1,44]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(S,C,i){let P,d,h,r,a;if(C){for(r=C.offset,a=r+C.length,h=r;h>0&&!D(S,h-1);)h--;let c=a;for(;c<S.length&&!D(S,c);)c++;d=S.substring(h,c),P=T(d,i)}else d=S,P=0,h=0,r=0,a=S.length;const p=y(i,S);let m=!1,E=0,f;i.insertSpaces?f=A(" ",i.tabSize||4):f="	";const l=(0,w.createScanner)(d,!1);let b=!1;function t(){return p+A(f,P+E)}function n(){let c=l.scan();for(m=!1;c===15||c===14;)m=m||c===14,c=l.scan();return b=c===16||l.getTokenError()!==0,c}const u=[];function o(c,v,k){!b&&v<a&&k>r&&S.substring(v,k)!==c&&u.push({offset:v,length:k-v,content:c})}let s=n();if(s!==17){const c=l.getTokenOffset()+h,v=A(f,P);o(v,h,c)}for(;s!==17;){let c=l.getTokenOffset()+l.getTokenLength()+h,v=n(),k="";for(;!m&&(v===12||v===13);){const _=l.getTokenOffset()+h;o(" ",c,_),c=l.getTokenOffset()+l.getTokenLength()+h,k=v===12?t():"",v=n()}if(v===2)s!==1&&(E--,k=t());else if(v===4)s!==3&&(E--,k=t());else{switch(s){case 3:case 1:E++,k=t();break;case 5:case 12:k=t();break;case 13:m?k=t():k=" ";break;case 6:k=" ";break;case 10:if(v===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?k=" ":v!==5&&v!==17&&(b=!0);break;case 16:b=!0;break}m&&(v===12||v===13)&&(k=t())}const g=l.getTokenOffset()+h;o(k,c,g),s=v}return u}e.format=I;function A(S,C){let i="";for(let P=0;P<C;P++)i+=S;return i}function T(S,C){let i=0,P=0;const d=C.tabSize||4;for(;i<S.length;){const h=S.charAt(i);if(h===" ")P++;else if(h==="	")P+=d;else break;i++}return Math.floor(P/d)}function y(S,C){for(let i=0;i<C.length;i++){const P=C.charAt(i);if(P==="\r")return i+1<C.length&&C.charAt(i+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=y;function D(S,C){return`\r
`.indexOf(S.charAt(C))!==-1}e.isEOL=D}),define(we[107],_e([0,1,44,106]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(C,i,P){return T(C,i,void 0,P)}e.removeProperty=A;function T(C,i,P,d,h){const r=i.slice(),a=[],p=(0,w.parseTree)(C,a);let m,E;for(;r.length>0&&(E=r.pop(),m=(0,w.findNodeAtLocation)(p,r),m===void 0&&P!==void 0);)typeof E=="string"?P={[E]:P}:P=[P];if(m)if(m.type==="object"&&typeof E=="string"&&Array.isArray(m.children)){const f=(0,w.findNodeAtLocation)(m,[E]);if(f!==void 0)if(P===void 0){if(!f.parent)throw new Error("Malformed AST");const l=m.children.indexOf(f.parent);let b,t=f.parent.offset+f.parent.length;if(l>0){const n=m.children[l-1];b=n.offset+n.length}else b=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return y(C,{offset:b,length:t-b,content:""},d)}else return y(C,{offset:f.offset,length:f.length,content:JSON.stringify(P)},d);else{if(P===void 0)return[];const l=`${JSON.stringify(E)}: ${JSON.stringify(P)}`,b=h?h(m.children.map(n=>n.children[0].value)):m.children.length;let t;if(b>0){const n=m.children[b-1];t={offset:n.offset+n.length,length:0,content:","+l}}else m.children.length===0?t={offset:m.offset+1,length:0,content:l}:t={offset:m.offset+1,length:0,content:l+","};return y(C,t,d)}}else if(m.type==="array"&&typeof E=="number"&&Array.isArray(m.children))if(P!==void 0){const f=`${JSON.stringify(P)}`;let l;if(m.children.length===0||E===0)l={offset:m.offset+1,length:0,content:m.children.length===0?f:f+","};else{const b=E===-1||E>m.children.length?m.children.length:E,t=m.children[b-1];l={offset:t.offset+t.length,length:0,content:","+f}}return y(C,l,d)}else{const f=E,l=m.children[f];let b;if(m.children.length===1)b={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===f){const t=m.children[f-1],n=t.offset+t.length,u=m.offset+m.length;b={offset:n,length:u-2-n,content:""}}else b={offset:l.offset,length:m.children[f+1].offset-l.offset,content:""};return y(C,b,d)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${m.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return y(C,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(P)},d)}}e.setProperty=T;function y(C,i,P){let d=D(C,i),h=i.offset,r=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;h>0&&!(0,I.isEOL)(d,h-1);)h--;for(;r<d.length&&!(0,I.isEOL)(d,r);)r++}const a=(0,I.format)(d,{offset:h,length:r-h},P);for(let m=a.length-1;m>=0;m--){const E=a[m];d=D(d,E),h=Math.min(h,E.offset),r=Math.max(r,E.offset+E.length),r+=E.content.length-E.length}const p=C.length-(d.length-r)-h;return[{offset:h,length:p,content:d.substring(h,r)}]}e.withFormatting=y;function D(C,i){return C.substring(0,i.offset)+i.content+C.substring(i.offset+i.length)}e.applyEdit=D;function S(C,i){let P=i.slice(0).sort((h,r)=>{const a=h.offset-r.offset;return a===0?h.length-r.length:a}),d=C.length;for(let h=P.length-1;h>=0;h--){let r=P[h];if(r.offset+r.length<=d)C=D(C,r);else throw new Error("Overlapping edit");d=r.offset}return C}e.applyEdits=S}),define(we[108],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(A){this.executor=A,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(A){return new w(()=>A(this.getValue()))}}e.Lazy=w}),define(we[6],_e([0,1,53,43]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let T=null;function y(f){T=f}if(e.setDisposableTracker=y,A){const f="__is_disposable_tracked__";T=new class{trackDisposable(l){const b=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[f]||console.log(b)},3e3)}markTracked(l){if(l&&l!==a.None)try{l[f]=!0}catch(b){}}}}function D(f){!T||T.markTracked(f)}function S(f){return T&&T.trackDisposable(f),f}e.trackDisposable=S;class C extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=C;function i(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=i;function P(f){if(I.Iterable.is(f)){let l=[];for(const b of f)if(b){D(b);try{b.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new C(l);return Array.isArray(f)?[]:f}else if(f)return D(f),f.dispose(),f}e.dispose=P;function d(...f){return f.forEach(D),h(()=>P(f))}e.combinedDisposable=d;function h(f){const l=S({dispose:()=>{D(l),f()}});return l}e.toDisposable=h;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{P(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return D(l),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class a{constructor(){this._store=new r,S(this)}dispose(){D(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=a,a.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var b;this._isDisposed||l===this._value||((b=this._value)===null||b===void 0||b.dispose(),l&&D(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,D(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=p;class m{constructor(){this.references=new Map}acquire(l,...b){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...b)},this.references.set(l,t));const{object:n}=t,u=(0,w.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:n,dispose:u}}}e.ReferenceCollection=m;class E{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=E}),define(we[45],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(T){this.element=T,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class I{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,y){const D=new w(T);if(this._first===w.Undefined)this._first=D,this._last=D;else if(y){const C=this._last;this._last=D,D.prev=C,C.next=D}else{const C=this._first;this._first=D,D.next=C,C.prev=D}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(D))}}shift(){if(this._first!==w.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==w.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==w.Undefined&&T.next!==w.Undefined){const y=T.prev;y.next=T.next,T.next.prev=y}else T.prev===w.Undefined&&T.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):T.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):T.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==w.Undefined;)yield T.element,T=T.next}}e.LinkedList=I}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(W,ie){for(var ce=0;ce<ie.length;ce++){var j=ie[ce];j.enumerable=j.enumerable||!1,j.configurable=!0,"value"in j&&(j.writable=!0),Object.defineProperty(W,j.key,j)}}function e(W,ie,ce){return ie&&Y(W.prototype,ie),ce&&Y(W,ce),W}function w(W,ie){if(!!W){if(typeof W=="string")return I(W,ie);var ce=Object.prototype.toString.call(W).slice(8,-1);if(ce==="Object"&&W.constructor&&(ce=W.constructor.name),ce==="Map"||ce==="Set")return Array.from(W);if(ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ce))return I(W,ie)}}function I(W,ie){(ie==null||ie>W.length)&&(ie=W.length);for(var ce=0,j=new Array(ie);ce<ie;ce++)j[ce]=W[ce];return j}function A(W,ie){var ce;if(typeof Symbol=="undefined"||W[Symbol.iterator]==null){if(Array.isArray(W)||(ce=w(W))||ie&&W&&typeof W.length=="number"){ce&&(W=ce);var j=0;return function(){return j>=W.length?{done:!0}:{done:!1,value:W[j++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ce=W[Symbol.iterator](),ce.next.bind(ce)}function T(W){var ie={exports:{}};return W(ie,ie.exports),ie.exports}var y=T(function(W){function ie(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ce(j){W.exports.defaults=j}W.exports={defaults:ie(),getDefaults:ie,changeDefaults:ce}}),D=/[&<>"']/,S=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(ie){return P[ie]};function h(W,ie){if(ie){if(D.test(W))return W.replace(S,d)}else if(C.test(W))return W.replace(i,d);return W}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(W){return W.replace(r,function(ie,ce){return ce=ce.toLowerCase(),ce==="colon"?":":ce.charAt(0)==="#"?ce.charAt(1)==="x"?String.fromCharCode(parseInt(ce.substring(2),16)):String.fromCharCode(+ce.substring(1)):""})}var p=/(^|[^\[])\^/g;function m(W,ie){W=W.source||W,ie=ie||"";var ce={replace:function(X,ae){return ae=ae.source||ae,ae=ae.replace(p,"$1"),W=W.replace(X,ae),ce},getRegex:function(){return new RegExp(W,ie)}};return ce}var E=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(W,ie,ce){if(W){var j;try{j=decodeURIComponent(a(ce)).replace(E,"").toLowerCase()}catch(X){return null}if(j.indexOf("javascript:")===0||j.indexOf("vbscript:")===0||j.indexOf("data:")===0)return null}ie&&!f.test(ce)&&(ce=o(ie,ce));try{ce=encodeURI(ce).replace(/%25/g,"%")}catch(X){return null}return ce}var b={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(W,ie){b[" "+W]||(t.test(W)?b[" "+W]=W+"/":b[" "+W]=k(W,"/",!0)),W=b[" "+W];var ce=W.indexOf(":")===-1;return ie.substring(0,2)==="//"?ce?ie:W.replace(n,"$1")+ie:ie.charAt(0)==="/"?ce?ie:W.replace(u,"$1")+ie:W+ie}var s={exec:function(){}};function c(W){for(var ie=1,ce,j;ie<arguments.length;ie++){ce=arguments[ie];for(j in ce)Object.prototype.hasOwnProperty.call(ce,j)&&(W[j]=ce[j])}return W}function v(W,ie){var ce=W.replace(/\|/g,function(ae,he,ye){for(var ze=!1,xe=he;--xe>=0&&ye[xe]==="\\";)ze=!ze;return ze?"|":" |"}),j=ce.split(/ \|/),X=0;if(j.length>ie)j.splice(ie);else for(;j.length<ie;)j.push("");for(;X<j.length;X++)j[X]=j[X].trim().replace(/\\\|/g,"|");return j}function k(W,ie,ce){var j=W.length;if(j===0)return"";for(var X=0;X<j;){var ae=W.charAt(j-X-1);if(ae===ie&&!ce)X++;else if(ae!==ie&&ce)X++;else break}return W.substr(0,j-X)}function g(W,ie){if(W.indexOf(ie[1])===-1)return-1;for(var ce=W.length,j=0,X=0;X<ce;X++)if(W[X]==="\\")X++;else if(W[X]===ie[0])j++;else if(W[X]===ie[1]&&(j--,j<0))return X;return-1}function _(W){W&&W.sanitize&&!W.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(W,ie){if(ie<1)return"";for(var ce="";ie>1;)ie&1&&(ce+=W),ie>>=1,W+=W;return ce+W}var B={escape:h,unescape:a,edit:m,cleanUrl:l,resolveUrl:o,noopTest:s,merge:c,splitCells:v,rtrim:k,findClosingBracket:g,checkSanitizeDeprecation:_,repeatString:R},Q=y.defaults,ge=B.rtrim,V=B.splitCells,H=B.escape,te=B.findClosingBracket;function $(W,ie,ce){var j=ie.href,X=ie.title?H(ie.title):null,ae=W[1].replace(/\\([\[\]])/g,"$1");return W[0].charAt(0)!=="!"?{type:"link",raw:ce,href:j,title:X,text:ae}:{type:"image",raw:ce,href:j,title:X,text:H(ae)}}function F(W,ie){var ce=W.match(/^(\s+)(?:```)/);if(ce===null)return ie;var j=ce[1];return ie.split(`
`).map(function(X){var ae=X.match(/^\s+/);if(ae===null)return X;var he=ae[0];return he.length>=j.length?X.slice(j.length):X}).join(`
`)}var L=function(){function W(ce){this.options=ce||Q}var ie=W.prototype;return ie.space=function(j){var X=this.rules.block.newline.exec(j);if(X)return X[0].length>1?{type:"space",raw:X[0]}:{raw:`
`}},ie.code=function(j){var X=this.rules.block.code.exec(j);if(X){var ae=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?ae:ge(ae,`
`)}}},ie.fences=function(j){var X=this.rules.block.fences.exec(j);if(X){var ae=X[0],he=F(ae,X[3]||"");return{type:"code",raw:ae,lang:X[2]?X[2].trim():X[2],text:he}}},ie.heading=function(j){var X=this.rules.block.heading.exec(j);if(X){var ae=X[2].trim();if(/#$/.test(ae)){var he=ge(ae,"#");(this.options.pedantic||!he||/ $/.test(he))&&(ae=he.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:ae}}},ie.nptable=function(j){var X=this.rules.block.nptable.exec(j);if(X){var ae={type:"table",header:V(X[1].replace(/^ *| *\| *$/g,"")),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:X[3]?X[3].replace(/\n$/,"").split(`
`):[],raw:X[0]};if(ae.header.length===ae.align.length){var he=ae.align.length,ye;for(ye=0;ye<he;ye++)/^ *-+: *$/.test(ae.align[ye])?ae.align[ye]="right":/^ *:-+: *$/.test(ae.align[ye])?ae.align[ye]="center":/^ *:-+ *$/.test(ae.align[ye])?ae.align[ye]="left":ae.align[ye]=null;for(he=ae.cells.length,ye=0;ye<he;ye++)ae.cells[ye]=V(ae.cells[ye],ae.header.length);return ae}}},ie.hr=function(j){var X=this.rules.block.hr.exec(j);if(X)return{type:"hr",raw:X[0]}},ie.blockquote=function(j){var X=this.rules.block.blockquote.exec(j);if(X){var ae=X[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:X[0],text:ae}}},ie.list=function(j){var X=this.rules.block.list.exec(j);if(X){var ae=X[0],he=X[2],ye=he.length>1,ze={type:"list",raw:ae,ordered:ye,start:ye?+he.slice(0,-1):"",loose:!1,items:[]},xe=X[0].match(this.rules.block.item),Ne=!1,Ge,nt,dt,it,Je,mt,bt,be,de=xe.length;dt=this.rules.block.listItemStart.exec(xe[0]);for(var oe=0;oe<de;oe++){if(Ge=xe[oe],ae=Ge,oe!==de-1){if(it=this.rules.block.listItemStart.exec(xe[oe+1]),this.options.pedantic?it[1].length>dt[1].length:it[1].length>dt[0].length||it[1].length>3){xe.splice(oe,2,xe[oe]+`
`+xe[oe+1]),oe--,de--;continue}else(!this.options.pedantic||this.options.smartLists?it[2][it[2].length-1]!==he[he.length-1]:ye===(it[2].length===1))&&(Je=xe.slice(oe+1).join(`
`),ze.raw=ze.raw.substring(0,ze.raw.length-Je.length),oe=de-1);dt=it}nt=Ge.length,Ge=Ge.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ge.indexOf(`
 `)&&(nt-=Ge.length,Ge=this.options.pedantic?Ge.replace(/^ {1,4}/gm,""):Ge.replace(new RegExp("^ {1,"+nt+"}","gm"),"")),mt=Ne||/\n\n(?!\s*$)/.test(Ge),oe!==de-1&&(Ne=Ge.charAt(Ge.length-1)===`
`,mt||(mt=Ne)),mt&&(ze.loose=!0),this.options.gfm&&(bt=/^\[[ xX]\] /.test(Ge),be=void 0,bt&&(be=Ge[1]!==" ",Ge=Ge.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:ae,task:bt,checked:be,loose:mt,text:Ge})}return ze}},ie.html=function(j){var X=this.rules.block.html.exec(j);if(X)return{type:this.options.sanitize?"paragraph":"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):H(X[0]):X[0]}},ie.def=function(j){var X=this.rules.block.def.exec(j);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var ae=X[1].toLowerCase().replace(/\s+/g," ");return{tag:ae,raw:X[0],href:X[2],title:X[3]}}},ie.table=function(j){var X=this.rules.block.table.exec(j);if(X){var ae={type:"table",header:V(X[1].replace(/^ *| *\| *$/g,"")),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:X[3]?X[3].replace(/\n$/,"").split(`
`):[]};if(ae.header.length===ae.align.length){ae.raw=X[0];var he=ae.align.length,ye;for(ye=0;ye<he;ye++)/^ *-+: *$/.test(ae.align[ye])?ae.align[ye]="right":/^ *:-+: *$/.test(ae.align[ye])?ae.align[ye]="center":/^ *:-+ *$/.test(ae.align[ye])?ae.align[ye]="left":ae.align[ye]=null;for(he=ae.cells.length,ye=0;ye<he;ye++)ae.cells[ye]=V(ae.cells[ye].replace(/^ *\| *| *\| *$/g,""),ae.header.length);return ae}}},ie.lheading=function(j){var X=this.rules.block.lheading.exec(j);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1]}},ie.paragraph=function(j){var X=this.rules.block.paragraph.exec(j);if(X)return{type:"paragraph",raw:X[0],text:X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1]}},ie.text=function(j){var X=this.rules.block.text.exec(j);if(X)return{type:"text",raw:X[0],text:X[0]}},ie.escape=function(j){var X=this.rules.inline.escape.exec(j);if(X)return{type:"escape",raw:X[0],text:H(X[1])}},ie.tag=function(j,X,ae){var he=this.rules.inline.tag.exec(j);if(he)return!X&&/^<a /i.test(he[0])?X=!0:X&&/^<\/a>/i.test(he[0])&&(X=!1),!ae&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?ae=!0:ae&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(ae=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:X,inRawBlock:ae,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):H(he[0]):he[0]}},ie.link=function(j){var X=this.rules.inline.link.exec(j);if(X){var ae=X[2].trim();if(!this.options.pedantic&&/^</.test(ae)){if(!/>$/.test(ae))return;var he=ge(ae.slice(0,-1),"\\");if((ae.length-he.length)%2==0)return}else{var ye=te(X[2],"()");if(ye>-1){var ze=X[0].indexOf("!")===0?5:4,xe=ze+X[1].length+ye;X[2]=X[2].substring(0,ye),X[0]=X[0].substring(0,xe).trim(),X[3]=""}}var Ne=X[2],Ge="";if(this.options.pedantic){var nt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ne);nt&&(Ne=nt[1],Ge=nt[3])}else Ge=X[3]?X[3].slice(1,-1):"";return Ne=Ne.trim(),/^</.test(Ne)&&(this.options.pedantic&&!/>$/.test(ae)?Ne=Ne.slice(1):Ne=Ne.slice(1,-1)),$(X,{href:Ne&&Ne.replace(this.rules.inline._escapes,"$1"),title:Ge&&Ge.replace(this.rules.inline._escapes,"$1")},X[0])}},ie.reflink=function(j,X){var ae;if((ae=this.rules.inline.reflink.exec(j))||(ae=this.rules.inline.nolink.exec(j))){var he=(ae[2]||ae[1]).replace(/\s+/g," ");if(he=X[he.toLowerCase()],!he||!he.href){var ye=ae[0].charAt(0);return{type:"text",raw:ye,text:ye}}return $(ae,he,ae[0])}},ie.emStrong=function(j,X,ae){ae===void 0&&(ae="");var he=this.rules.inline.emStrong.lDelim.exec(j);if(!!he&&!(he[3]&&ae.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ye=he[1]||he[2]||"";if(!ye||ye&&(ae===""||this.rules.inline.punctuation.exec(ae))){var ze=he[0].length-1,xe,Ne,Ge=ze,nt=0,dt=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(dt.lastIndex=0,X=X.slice(-1*j.length+ze);(he=dt.exec(X))!=null;)if(xe=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!xe){if(Ne=xe.length,he[3]||he[4]){Ge+=Ne;continue}else if((he[5]||he[6])&&ze%3&&!((ze+Ne)%3)){nt+=Ne;continue}if(Ge-=Ne,!(Ge>0)){if(Ge+nt-Ne<=0&&!X.slice(dt.lastIndex).match(dt)&&(Ne=Math.min(Ne,Ne+Ge+nt)),Math.min(ze,Ne)%2)return{type:"em",raw:j.slice(0,ze+he.index+Ne+1),text:j.slice(1,ze+he.index+Ne)};if(Math.min(ze,Ne)%2==0)return{type:"strong",raw:j.slice(0,ze+he.index+Ne+1),text:j.slice(2,ze+he.index+Ne-1)}}}}}},ie.codespan=function(j){var X=this.rules.inline.code.exec(j);if(X){var ae=X[2].replace(/\n/g," "),he=/[^ ]/.test(ae),ye=/^ /.test(ae)&&/ $/.test(ae);return he&&ye&&(ae=ae.substring(1,ae.length-1)),ae=H(ae,!0),{type:"codespan",raw:X[0],text:ae}}},ie.br=function(j){var X=this.rules.inline.br.exec(j);if(X)return{type:"br",raw:X[0]}},ie.del=function(j){var X=this.rules.inline.del.exec(j);if(X)return{type:"del",raw:X[0],text:X[2]}},ie.autolink=function(j,X){var ae=this.rules.inline.autolink.exec(j);if(ae){var he,ye;return ae[2]==="@"?(he=H(this.options.mangle?X(ae[1]):ae[1]),ye="mailto:"+he):(he=H(ae[1]),ye=he),{type:"link",raw:ae[0],text:he,href:ye,tokens:[{type:"text",raw:he,text:he}]}}},ie.url=function(j,X){var ae;if(ae=this.rules.inline.url.exec(j)){var he,ye;if(ae[2]==="@")he=H(this.options.mangle?X(ae[0]):ae[0]),ye="mailto:"+he;else{var ze;do ze=ae[0],ae[0]=this.rules.inline._backpedal.exec(ae[0])[0];while(ze!==ae[0]);he=H(ae[0]),ae[1]==="www."?ye="http://"+he:ye=he}return{type:"link",raw:ae[0],text:he,href:ye,tokens:[{type:"text",raw:he,text:he}]}}},ie.inlineText=function(j,X,ae){var he=this.rules.inline.text.exec(j);if(he){var ye;return X?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):H(he[0]):he[0]:ye=H(this.options.smartypants?ae(he[0]):he[0]),{type:"text",raw:he[0],text:ye}}},W}(),M=B.noopTest,U=B.edit,G=B.merge,J={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};J._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,J._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,J.def=U(J.def).replace("label",J._label).replace("title",J._title).getRegex(),J.bullet=/(?:[*+-]|\d{1,9}[.)])/,J.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,J.item=U(J.item,"gm").replace(/bull/g,J.bullet).getRegex(),J.listItemStart=U(/^( *)(bull)/).replace("bull",J.bullet).getRegex(),J.list=U(J.list).replace(/bull/g,J.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+J.def.source+")").getRegex(),J._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",J._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,J.html=U(J.html,"i").replace("comment",J._comment).replace("tag",J._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),J.paragraph=U(J._paragraph).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",J._tag).getRegex(),J.blockquote=U(J.blockquote).replace("paragraph",J.paragraph).getRegex(),J.normal=G({},J),J.gfm=G({},J.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),J.gfm.nptable=U(J.gfm.nptable).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",J._tag).getRegex(),J.gfm.table=U(J.gfm.table).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",J._tag).getRegex(),J.pedantic=G({},J.normal,{html:U(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",J._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:U(J.normal._paragraph).replace("hr",J.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",J.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=U(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=U(J._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=U(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=U(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=U(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=U(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=U(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=U(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=U(re.reflink).replace("label",re._label).getRegex(),re.reflinkSearch=U(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=G({},re),re.pedantic=G({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:U(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:U(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=G({},re.normal,{escape:U(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),re.gfm.url=U(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=G({},re.gfm,{br:U(re.br).replace("{2,}","*").getRegex(),text:U(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var pe={block:J,inline:re},Te=y.defaults,Be=pe.block,Ae=pe.inline,We=B.repeatString;function x(W){return W.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(W){var ie="",ce,j,X=W.length;for(ce=0;ce<X;ce++)j=W.charCodeAt(ce),Math.random()>.5&&(j="x"+j.toString(16)),ie+="&#"+j+";";return ie}var ne=function(){function W(ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=ce||Te,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var j={block:Be.normal,inline:Ae.normal};this.options.pedantic?(j.block=Be.pedantic,j.inline=Ae.pedantic):this.options.gfm&&(j.block=Be.gfm,this.options.breaks?j.inline=Ae.breaks:j.inline=Ae.gfm),this.tokenizer.rules=j}W.lex=function(j,X){var ae=new W(X);return ae.lex(j)},W.lexInline=function(j,X){var ae=new W(X);return ae.inlineTokens(j)};var ie=W.prototype;return ie.lex=function(j){return j=j.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(j,this.tokens,!0),this.inline(this.tokens),this.tokens},ie.blockTokens=function(j,X,ae){X===void 0&&(X=[]),ae===void 0&&(ae=!0),this.options.pedantic&&(j=j.replace(/^ +$/gm,""));for(var he,ye,ze,xe;j;){if(he=this.tokenizer.space(j)){j=j.substring(he.raw.length),he.type&&X.push(he);continue}if(he=this.tokenizer.code(j)){j=j.substring(he.raw.length),xe=X[X.length-1],xe&&xe.type==="paragraph"?(xe.raw+=`
`+he.raw,xe.text+=`
`+he.text):X.push(he);continue}if(he=this.tokenizer.fences(j)){j=j.substring(he.raw.length),X.push(he);continue}if(he=this.tokenizer.heading(j)){j=j.substring(he.raw.length),X.push(he);continue}if(he=this.tokenizer.nptable(j)){j=j.substring(he.raw.length),X.push(he);continue}if(he=this.tokenizer.hr(j)){j=j.substring(he.raw.length),X.push(he);continue}if(he=this.tokenizer.blockquote(j)){j=j.substring(he.raw.length),he.tokens=this.blockTokens(he.text,[],ae),X.push(he);continue}if(he=this.tokenizer.list(j)){for(j=j.substring(he.raw.length),ze=he.items.length,ye=0;ye<ze;ye++)he.items[ye].tokens=this.blockTokens(he.items[ye].text,[],!1);X.push(he);continue}if(he=this.tokenizer.html(j)){j=j.substring(he.raw.length),X.push(he);continue}if(ae&&(he=this.tokenizer.def(j))){j=j.substring(he.raw.length),this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(j)){j=j.substring(he.raw.length),X.push(he);continue}if(he=this.tokenizer.lheading(j)){j=j.substring(he.raw.length),X.push(he);continue}if(ae&&(he=this.tokenizer.paragraph(j))){j=j.substring(he.raw.length),X.push(he);continue}if(he=this.tokenizer.text(j)){j=j.substring(he.raw.length),xe=X[X.length-1],xe&&xe.type==="text"?(xe.raw+=`
`+he.raw,xe.text+=`
`+he.text):X.push(he);continue}if(j){var Ne="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(Ne);break}else throw new Error(Ne)}}return X},ie.inline=function(j){var X,ae,he,ye,ze,xe,Ne=j.length;for(X=0;X<Ne;X++)switch(xe=j[X],xe.type){case"paragraph":case"text":case"heading":{xe.tokens=[],this.inlineTokens(xe.text,xe.tokens);break}case"table":{for(xe.tokens={header:[],cells:[]},ye=xe.header.length,ae=0;ae<ye;ae++)xe.tokens.header[ae]=[],this.inlineTokens(xe.header[ae],xe.tokens.header[ae]);for(ye=xe.cells.length,ae=0;ae<ye;ae++)for(ze=xe.cells[ae],xe.tokens.cells[ae]=[],he=0;he<ze.length;he++)xe.tokens.cells[ae][he]=[],this.inlineTokens(ze[he],xe.tokens.cells[ae][he]);break}case"blockquote":{this.inline(xe.tokens);break}case"list":{for(ye=xe.items.length,ae=0;ae<ye;ae++)this.inline(xe.items[ae].tokens);break}}return j},ie.inlineTokens=function(j,X,ae,he){X===void 0&&(X=[]),ae===void 0&&(ae=!1),he===void 0&&(he=!1);var ye,ze,xe=j,Ne,Ge,nt;if(this.tokens.links){var dt=Object.keys(this.tokens.links);if(dt.length>0)for(;(Ne=this.tokenizer.rules.inline.reflinkSearch.exec(xe))!=null;)dt.includes(Ne[0].slice(Ne[0].lastIndexOf("[")+1,-1))&&(xe=xe.slice(0,Ne.index)+"["+We("a",Ne[0].length-2)+"]"+xe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ne=this.tokenizer.rules.inline.blockSkip.exec(xe))!=null;)xe=xe.slice(0,Ne.index)+"["+We("a",Ne[0].length-2)+"]"+xe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ne=this.tokenizer.rules.inline.escapedEmSt.exec(xe))!=null;)xe=xe.slice(0,Ne.index)+"++"+xe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;j;){if(Ge||(nt=""),Ge=!1,ye=this.tokenizer.escape(j)){j=j.substring(ye.raw.length),X.push(ye);continue}if(ye=this.tokenizer.tag(j,ae,he)){j=j.substring(ye.raw.length),ae=ye.inLink,he=ye.inRawBlock;var it=X[X.length-1];it&&ye.type==="text"&&it.type==="text"?(it.raw+=ye.raw,it.text+=ye.text):X.push(ye);continue}if(ye=this.tokenizer.link(j)){j=j.substring(ye.raw.length),ye.type==="link"&&(ye.tokens=this.inlineTokens(ye.text,[],!0,he)),X.push(ye);continue}if(ye=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(ye.raw.length);var Je=X[X.length-1];ye.type==="link"?(ye.tokens=this.inlineTokens(ye.text,[],!0,he),X.push(ye)):Je&&ye.type==="text"&&Je.type==="text"?(Je.raw+=ye.raw,Je.text+=ye.text):X.push(ye);continue}if(ye=this.tokenizer.emStrong(j,xe,nt)){j=j.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ae,he),X.push(ye);continue}if(ye=this.tokenizer.codespan(j)){j=j.substring(ye.raw.length),X.push(ye);continue}if(ye=this.tokenizer.br(j)){j=j.substring(ye.raw.length),X.push(ye);continue}if(ye=this.tokenizer.del(j)){j=j.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ae,he),X.push(ye);continue}if(ye=this.tokenizer.autolink(j,q)){j=j.substring(ye.raw.length),X.push(ye);continue}if(!ae&&(ye=this.tokenizer.url(j,q))){j=j.substring(ye.raw.length),X.push(ye);continue}if(ye=this.tokenizer.inlineText(j,he,x)){j=j.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(nt=ye.raw.slice(-1)),Ge=!0,ze=X[X.length-1],ze&&ze.type==="text"?(ze.raw+=ye.raw,ze.text+=ye.text):X.push(ye);continue}if(j){var mt="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return X},e(W,null,[{key:"rules",get:function(){return{block:Be,inline:Ae}}}]),W}(),le=y.defaults,fe=B.cleanUrl,Se=B.escape,Oe=function(){function W(ce){this.options=ce||le}var ie=W.prototype;return ie.code=function(j,X,ae){var he=(X||"").match(/\S*/)[0];if(this.options.highlight){var ye=this.options.highlight(j,he);ye!=null&&ye!==j&&(ae=!0,j=ye)}return j=j.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+Se(he,!0)+'">'+(ae?j:Se(j,!0))+`</code></pre>
`:"<pre><code>"+(ae?j:Se(j,!0))+`</code></pre>
`},ie.blockquote=function(j){return`<blockquote>
`+j+`</blockquote>
`},ie.html=function(j){return j},ie.heading=function(j,X,ae,he){return this.options.headerIds?"<h"+X+' id="'+this.options.headerPrefix+he.slug(ae)+'">'+j+"</h"+X+`>
`:"<h"+X+">"+j+"</h"+X+`>
`},ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ie.list=function(j,X,ae){var he=X?"ol":"ul",ye=X&&ae!==1?' start="'+ae+'"':"";return"<"+he+ye+`>
`+j+"</"+he+`>
`},ie.listitem=function(j){return"<li>"+j+`</li>
`},ie.checkbox=function(j){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ie.paragraph=function(j){return"<p>"+j+`</p>
`},ie.table=function(j,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+j+`</thead>
`+X+`</table>
`},ie.tablerow=function(j){return`<tr>
`+j+`</tr>
`},ie.tablecell=function(j,X){var ae=X.header?"th":"td",he=X.align?"<"+ae+' align="'+X.align+'">':"<"+ae+">";return he+j+"</"+ae+`>
`},ie.strong=function(j){return"<strong>"+j+"</strong>"},ie.em=function(j){return"<em>"+j+"</em>"},ie.codespan=function(j){return"<code>"+j+"</code>"},ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},ie.del=function(j){return"<del>"+j+"</del>"},ie.link=function(j,X,ae){if(j=fe(this.options.sanitize,this.options.baseUrl,j),j===null)return ae;var he='<a href="'+Se(j)+'"';return X&&(he+=' title="'+X+'"'),he+=">"+ae+"</a>",he},ie.image=function(j,X,ae){if(j=fe(this.options.sanitize,this.options.baseUrl,j),j===null)return ae;var he='<img src="'+j+'" alt="'+ae+'"';return X&&(he+=' title="'+X+'"'),he+=this.options.xhtml?"/>":">",he},ie.text=function(j){return j},W}(),me=function(){function W(){}var ie=W.prototype;return ie.strong=function(j){return j},ie.em=function(j){return j},ie.codespan=function(j){return j},ie.del=function(j){return j},ie.html=function(j){return j},ie.text=function(j){return j},ie.link=function(j,X,ae){return""+ae},ie.image=function(j,X,ae){return""+ae},ie.br=function(){return""},W}(),Ce=function(){function W(){this.seen={}}var ie=W.prototype;return ie.serialize=function(j){return j.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ie.getNextSafeSlug=function(j,X){var ae=j,he=0;if(this.seen.hasOwnProperty(ae)){he=this.seen[j];do he++,ae=j+"-"+he;while(this.seen.hasOwnProperty(ae))}return X||(this.seen[j]=he,this.seen[ae]=0),ae},ie.slug=function(j,X){X===void 0&&(X={});var ae=this.serialize(j);return this.getNextSafeSlug(ae,X.dryrun)},W}(),Pe=y.defaults,$e=B.unescape,Ee=function(){function W(ce){this.options=ce||Pe,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new me,this.slugger=new Ce}W.parse=function(j,X){var ae=new W(X);return ae.parse(j)},W.parseInline=function(j,X){var ae=new W(X);return ae.parseInline(j)};var ie=W.prototype;return ie.parse=function(j,X){X===void 0&&(X=!0);var ae="",he,ye,ze,xe,Ne,Ge,nt,dt,it,Je,mt,bt,be,de,oe,K,Re,Ie,Qe=j.length;for(he=0;he<Qe;he++)switch(Je=j[he],Je.type){case"space":continue;case"hr":{ae+=this.renderer.hr();continue}case"heading":{ae+=this.renderer.heading(this.parseInline(Je.tokens),Je.depth,$e(this.parseInline(Je.tokens,this.textRenderer)),this.slugger);continue}case"code":{ae+=this.renderer.code(Je.text,Je.lang,Je.escaped);continue}case"table":{for(dt="",nt="",xe=Je.header.length,ye=0;ye<xe;ye++)nt+=this.renderer.tablecell(this.parseInline(Je.tokens.header[ye]),{header:!0,align:Je.align[ye]});for(dt+=this.renderer.tablerow(nt),it="",xe=Je.cells.length,ye=0;ye<xe;ye++){for(Ge=Je.tokens.cells[ye],nt="",Ne=Ge.length,ze=0;ze<Ne;ze++)nt+=this.renderer.tablecell(this.parseInline(Ge[ze]),{header:!1,align:Je.align[ze]});it+=this.renderer.tablerow(nt)}ae+=this.renderer.table(dt,it);continue}case"blockquote":{it=this.parse(Je.tokens),ae+=this.renderer.blockquote(it);continue}case"list":{for(mt=Je.ordered,bt=Je.start,be=Je.loose,xe=Je.items.length,it="",ye=0;ye<xe;ye++)oe=Je.items[ye],K=oe.checked,Re=oe.task,de="",oe.task&&(Ie=this.renderer.checkbox(K),be?oe.tokens.length>0&&oe.tokens[0].type==="text"?(oe.tokens[0].text=Ie+" "+oe.tokens[0].text,oe.tokens[0].tokens&&oe.tokens[0].tokens.length>0&&oe.tokens[0].tokens[0].type==="text"&&(oe.tokens[0].tokens[0].text=Ie+" "+oe.tokens[0].tokens[0].text)):oe.tokens.unshift({type:"text",text:Ie}):de+=Ie),de+=this.parse(oe.tokens,be),it+=this.renderer.listitem(de,Re,K);ae+=this.renderer.list(it,mt,bt);continue}case"html":{ae+=this.renderer.html(Je.text);continue}case"paragraph":{ae+=this.renderer.paragraph(this.parseInline(Je.tokens));continue}case"text":{for(it=Je.tokens?this.parseInline(Je.tokens):Je.text;he+1<Qe&&j[he+1].type==="text";)Je=j[++he],it+=`
`+(Je.tokens?this.parseInline(Je.tokens):Je.text);ae+=X?this.renderer.paragraph(it):it;continue}default:{var Ze='Token with "'+Je.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}return ae},ie.parseInline=function(j,X){X=X||this.renderer;var ae="",he,ye,ze=j.length;for(he=0;he<ze;he++)switch(ye=j[he],ye.type){case"escape":{ae+=X.text(ye.text);break}case"html":{ae+=X.html(ye.text);break}case"link":{ae+=X.link(ye.href,ye.title,this.parseInline(ye.tokens,X));break}case"image":{ae+=X.image(ye.href,ye.title,ye.text);break}case"strong":{ae+=X.strong(this.parseInline(ye.tokens,X));break}case"em":{ae+=X.em(this.parseInline(ye.tokens,X));break}case"codespan":{ae+=X.codespan(ye.text);break}case"br":{ae+=X.br();break}case"del":{ae+=X.del(this.parseInline(ye.tokens,X));break}case"text":{ae+=X.text(ye.text);break}default:{var xe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(xe);return}else throw new Error(xe)}}return ae},W}(),je=B.merge,z=B.checkSanitizeDeprecation,ee=B.escape,ve=y.getDefaults,Le=y.changeDefaults,He=y.defaults;function Ue(W,ie,ce){if(typeof W=="undefined"||W===null)throw new Error("marked(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");if(typeof ie=="function"&&(ce=ie,ie=null),ie=je({},Ue.defaults,ie||{}),z(ie),ce){var j=ie.highlight,X;try{X=ne.lex(W,ie)}catch(ze){return ce(ze)}var ae=function(xe){var Ne;if(!xe)try{Ne=Ee.parse(X,ie)}catch(Ge){xe=Ge}return ie.highlight=j,xe?ce(xe):ce(null,Ne)};if(!j||j.length<3||(delete ie.highlight,!X.length))return ae();var he=0;Ue.walkTokens(X,function(ze){ze.type==="code"&&(he++,setTimeout(function(){j(ze.text,ze.lang,function(xe,Ne){if(xe)return ae(xe);Ne!=null&&Ne!==ze.text&&(ze.text=Ne,ze.escaped=!0),he--,he===0&&ae()})},0))}),he===0&&ae();return}try{var ye=ne.lex(W,ie);return ie.walkTokens&&Ue.walkTokens(ye,ie.walkTokens),Ee.parse(ye,ie)}catch(ze){if(ze.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+ee(ze.message+"",!0)+"</pre>";throw ze}}Ue.options=Ue.setOptions=function(W){return je(Ue.defaults,W),Le(Ue.defaults),Ue},Ue.getDefaults=ve,Ue.defaults=He,Ue.use=function(W){var ie=je({},W);if(W.renderer&&function(){var j=Ue.defaults.renderer||new Oe,X=function(ye){var ze=j[ye];j[ye]=function(){for(var xe=arguments.length,Ne=new Array(xe),Ge=0;Ge<xe;Ge++)Ne[Ge]=arguments[Ge];var nt=W.renderer[ye].apply(j,Ne);return nt===!1&&(nt=ze.apply(j,Ne)),nt}};for(var ae in W.renderer)X(ae);ie.renderer=j}(),W.tokenizer&&function(){var j=Ue.defaults.tokenizer||new L,X=function(ye){var ze=j[ye];j[ye]=function(){for(var xe=arguments.length,Ne=new Array(xe),Ge=0;Ge<xe;Ge++)Ne[Ge]=arguments[Ge];var nt=W.tokenizer[ye].apply(j,Ne);return nt===!1&&(nt=ze.apply(j,Ne)),nt}};for(var ae in W.tokenizer)X(ae);ie.tokenizer=j}(),W.walkTokens){var ce=Ue.defaults.walkTokens;ie.walkTokens=function(j){W.walkTokens(j),ce&&ce(j)}}Ue.setOptions(ie)},Ue.walkTokens=function(W,ie){for(var ce=A(W),j;!(j=ce()).done;){var X=j.value;switch(ie(X),X.type){case"table":{for(var ae=A(X.tokens.header),he;!(he=ae()).done;){var ye=he.value;Ue.walkTokens(ye,ie)}for(var ze=A(X.tokens.cells),xe;!(xe=ze()).done;)for(var Ne=xe.value,Ge=A(Ne),nt;!(nt=Ge()).done;){var dt=nt.value;Ue.walkTokens(dt,ie)}break}case"list":{Ue.walkTokens(X.items,ie);break}default:X.tokens&&Ue.walkTokens(X.tokens,ie)}}},Ue.parseInline=function(W,ie){if(typeof W=="undefined"||W===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");ie=je({},Ue.defaults,ie||{}),z(ie);try{var ce=ne.lexInline(W,ie);return ie.walkTokens&&Ue.walkTokens(ce,ie.walkTokens),Ee.parseInline(ce,ie)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+ee(j.message+"",!0)+"</pre>";throw j}},Ue.Parser=Ee,Ue.parser=Ee.parse,Ue.Renderer=Oe,Ue.TextRenderer=me,Ue.Lexer=ne,Ue.lexer=ne.lex,Ue.Tokenizer=L,Ue.Slugger=Ce,Ue.parse=Ue;var Xe=Ue;return Xe}),define(we[81],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(y,D,S){return Math.min(Math.max(y,D),S)}e.clamp=w;function I(y,D){return(D+y%D)%D}e.rot=I;class A{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=A;class T{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";(function(){function Y(A){const T=[];typeof A=="number"&&T.push("code/timeOrigin",A);function y(S){T.push(S,Date.now())}function D(){const S=[];for(let C=0;C<T.length;C+=2)S.push({name:T[C],startTime:T[C+1]});return S}return{mark:y,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const y of performance.getEntriesByType("mark"))T.push({name:y.name,startTime:Math.round(A+y.startTime)});return T}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function w(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=w(I))})(),define(we[21],_e([0,1]),function(Y,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let A=!1,T=!1,y=!1,D=!1,S=!1,C=!1,i=!1,P,d=I,h,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode!="undefined"?a=e.globals.vscode.process:typeof process!="undefined"&&(a=process);const p=typeof((w=a==null?void 0:a.versions)===null||w===void 0?void 0:w.electron)=="string"&&a.type==="renderer";if(e.isElectronSandboxed=p&&(a==null?void 0:a.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=a==null?void 0:a.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!p)r=navigator.userAgent,A=r.indexOf("Windows")>=0,T=r.indexOf("Macintosh")>=0,i=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=r.indexOf("Linux")>=0,C=!0,P=navigator.language,d=P;else if(typeof a=="object"){A=a.platform==="win32",T=a.platform==="darwin",y=a.platform==="linux",D=y&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,P=I,d=I;const o=a.env.VSCODE_NLS_CONFIG;if(o)try{const s=JSON.parse(o),c=s.availableLanguages["*"];P=s.locale,d=c||I,h=s._translationsConfigFile}catch(s){}S=!0}else console.error("Unable to resolve platform.");var m;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function E(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let f=0;T?f=1:A?f=3:y&&(f=2),e.isWindows=A,e.isMacintosh=T,e.isLinux=y,e.isLinuxSnap=D,e.isNative=S,e.isWeb=C,e.isIOS=i,e.platform=f,e.userAgent=r,e.language=d;var l;(function(o){function s(){return e.language}o.value=s;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=c;function v(){return e.language==="en"}o.isDefault=v})(l=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",k=>{if(k.data&&k.data.vscodeSetImmediateId)for(let g=0,_=c.length;g<_;g++){const R=c[g];if(R.id===k.data.vscodeSetImmediateId){c.splice(g,1),R.callback();return}}});let v=0;return k=>{const g=++v;c.push({id:g,callback:k}),e.globals.postMessage({vscodeSetImmediateId:g},"*")}}if(typeof(a==null?void 0:a.nextTick)=="function")return a.nextTick.bind(a);const s=Promise.resolve();return c=>s.then(c)}();var b;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(b=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||i?2:A?1:3;let t=!0,n=!1;function u(){if(!n){n=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=u}),define(we[46],_e([0,1,21]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof w.globals.vscode!="undefined"){const A=w.globals.vscode.process;I={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(T){return(0,w.setImmediate)(T)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:I={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},nextTick(A){return(0,w.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(we[13],_e([0,1,46]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,A=97,T=90,y=122,D=46,S=47,C=92,i=58,P=63;class d extends Error{constructor(l,b,t){let n;typeof b=="string"&&b.indexOf("not ")===0?(n="must not be",b=b.replace(/^not /,"")):n="must be";const u=l.indexOf(".")!==-1?"property":"argument";let o=`The "${l}" ${u} ${n} of type ${b}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function h(f,l){if(typeof f!="string")throw new d(l,"string",f)}function r(f){return f===S||f===C}function a(f){return f===S}function p(f){return f>=I&&f<=T||f>=A&&f<=y}function m(f,l,b,t){let n="",u=0,o=-1,s=0,c=0;for(let v=0;v<=f.length;++v){if(v<f.length)c=f.charCodeAt(v);else{if(t(c))break;c=S}if(t(c)){if(!(o===v-1||s===1))if(s===2){if(n.length<2||u!==2||n.charCodeAt(n.length-1)!==D||n.charCodeAt(n.length-2)!==D){if(n.length>2){const k=n.lastIndexOf(b);k===-1?(n="",u=0):(n=n.slice(0,k),u=n.length-1-n.lastIndexOf(b)),o=v,s=0;continue}else if(n.length!==0){n="",u=0,o=v,s=0;continue}}l&&(n+=n.length>0?`${b}..`:"..",u=2)}else n.length>0?n+=`${b}${f.slice(o+1,v)}`:n=f.slice(o+1,v),u=v-o-1;o=v,s=0}else c===D&&s!==-1?++s:s=-1}return n}function E(f,l){if(l===null||typeof l!="object")throw new d("pathObject","Object",l);const b=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return b?b===l.root?`${b}${t}`:`${b}${f}${t}`:t}e.win32={resolve(...f){let l="",b="",t=!1;for(let n=f.length-1;n>=-1;n--){let u;if(n>=0){if(u=f[n],h(u,"path"),u.length===0)continue}else l.length===0?u=w.cwd():(u=w.env[`=${l}`]||w.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==l.toLowerCase()&&u.charCodeAt(2)===C)&&(u=`${l}\\`));const o=u.length;let s=0,c="",v=!1;const k=u.charCodeAt(0);if(o===1)r(k)&&(s=1,v=!0);else if(r(k))if(v=!0,r(u.charCodeAt(1))){let g=2,_=g;for(;g<o&&!r(u.charCodeAt(g));)g++;if(g<o&&g!==_){const R=u.slice(_,g);for(_=g;g<o&&r(u.charCodeAt(g));)g++;if(g<o&&g!==_){for(_=g;g<o&&!r(u.charCodeAt(g));)g++;(g===o||g!==_)&&(c=`\\\\${R}\\${u.slice(_,g)}`,s=g)}}}else s=1;else p(k)&&u.charCodeAt(1)===i&&(c=u.slice(0,2),s=2,o>2&&r(u.charCodeAt(2))&&(v=!0,s=3));if(c.length>0)if(l.length>0){if(c.toLowerCase()!==l.toLowerCase())continue}else l=c;if(t){if(l.length>0)break}else if(b=`${u.slice(s)}\\${b}`,t=v,v&&l.length>0)break}return b=m(b,!t,"\\",r),t?`${l}\\${b}`:`${l}${b}`||"."},normalize(f){h(f,"path");const l=f.length;if(l===0)return".";let b=0,t,n=!1;const u=f.charCodeAt(0);if(l===1)return a(u)?"\\":f;if(r(u))if(n=!0,r(f.charCodeAt(1))){let s=2,c=s;for(;s<l&&!r(f.charCodeAt(s));)s++;if(s<l&&s!==c){const v=f.slice(c,s);for(c=s;s<l&&r(f.charCodeAt(s));)s++;if(s<l&&s!==c){for(c=s;s<l&&!r(f.charCodeAt(s));)s++;if(s===l)return`\\\\${v}\\${f.slice(c)}\\`;s!==c&&(t=`\\\\${v}\\${f.slice(c,s)}`,b=s)}}}else b=1;else p(u)&&f.charCodeAt(1)===i&&(t=f.slice(0,2),b=2,l>2&&r(f.charCodeAt(2))&&(n=!0,b=3));let o=b<l?m(f.slice(b),!n,"\\",r):"";return o.length===0&&!n&&(o="."),o.length>0&&r(f.charCodeAt(l-1))&&(o+="\\"),t===void 0?n?`\\${o}`:o:n?`${t}\\${o}`:`${t}${o}`},isAbsolute(f){h(f,"path");const l=f.length;if(l===0)return!1;const b=f.charCodeAt(0);return r(b)||l>2&&p(b)&&f.charCodeAt(1)===i&&r(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let l,b;for(let u=0;u<f.length;++u){const o=f[u];h(o,"path"),o.length>0&&(l===void 0?l=b=o:l+=`\\${o}`)}if(l===void 0)return".";let t=!0,n=0;if(typeof b=="string"&&r(b.charCodeAt(0))){++n;const u=b.length;u>1&&r(b.charCodeAt(1))&&(++n,u>2&&(r(b.charCodeAt(2))?++n:t=!1))}if(t){for(;n<l.length&&r(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.win32.normalize(l)},relative(f,l){if(h(f,"from"),h(l,"to"),f===l)return"";const b=e.win32.resolve(f),t=e.win32.resolve(l);if(b===t||(f=b.toLowerCase(),l=t.toLowerCase(),f===l))return"";let n=0;for(;n<f.length&&f.charCodeAt(n)===C;)n++;let u=f.length;for(;u-1>n&&f.charCodeAt(u-1)===C;)u--;const o=u-n;let s=0;for(;s<l.length&&l.charCodeAt(s)===C;)s++;let c=l.length;for(;c-1>s&&l.charCodeAt(c-1)===C;)c--;const v=c-s,k=o<v?o:v;let g=-1,_=0;for(;_<k;_++){const B=f.charCodeAt(n+_);if(B!==l.charCodeAt(s+_))break;B===C&&(g=_)}if(_!==k){if(g===-1)return t}else{if(v>k){if(l.charCodeAt(s+_)===C)return t.slice(s+_+1);if(_===2)return t.slice(s+_)}o>k&&(f.charCodeAt(n+_)===C?g=_:_===2&&(g=3)),g===-1&&(g=0)}let R="";for(_=n+g+1;_<=u;++_)(_===u||f.charCodeAt(_)===C)&&(R+=R.length===0?"..":"\\..");return s+=g,R.length>0?`${R}${t.slice(s,c)}`:(t.charCodeAt(s)===C&&++s,t.slice(s,c))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const l=e.win32.resolve(f);if(l.length<=2)return f;if(l.charCodeAt(0)===C){if(l.charCodeAt(1)===C){const b=l.charCodeAt(2);if(b!==P&&b!==D)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(p(l.charCodeAt(0))&&l.charCodeAt(1)===i&&l.charCodeAt(2)===C)return`\\\\?\\${l}`;return f},dirname(f){h(f,"path");const l=f.length;if(l===0)return".";let b=-1,t=0;const n=f.charCodeAt(0);if(l===1)return r(n)?f:".";if(r(n)){if(b=t=1,r(f.charCodeAt(1))){let s=2,c=s;for(;s<l&&!r(f.charCodeAt(s));)s++;if(s<l&&s!==c){for(c=s;s<l&&r(f.charCodeAt(s));)s++;if(s<l&&s!==c){for(c=s;s<l&&!r(f.charCodeAt(s));)s++;if(s===l)return f;s!==c&&(b=t=s+1)}}}}else p(n)&&f.charCodeAt(1)===i&&(b=l>2&&r(f.charCodeAt(2))?3:2,t=b);let u=-1,o=!0;for(let s=l-1;s>=t;--s)if(r(f.charCodeAt(s))){if(!o){u=s;break}}else o=!1;if(u===-1){if(b===-1)return".";u=b}return f.slice(0,u)},basename(f,l){l!==void 0&&h(l,"ext"),h(f,"path");let b=0,t=-1,n=!0,u;if(f.length>=2&&p(f.charCodeAt(0))&&f.charCodeAt(1)===i&&(b=2),l!==void 0&&l.length>0&&l.length<=f.length){if(l===f)return"";let o=l.length-1,s=-1;for(u=f.length-1;u>=b;--u){const c=f.charCodeAt(u);if(r(c)){if(!n){b=u+1;break}}else s===-1&&(n=!1,s=u+1),o>=0&&(c===l.charCodeAt(o)?--o==-1&&(t=u):(o=-1,t=s))}return b===t?t=s:t===-1&&(t=f.length),f.slice(b,t)}for(u=f.length-1;u>=b;--u)if(r(f.charCodeAt(u))){if(!n){b=u+1;break}}else t===-1&&(n=!1,t=u+1);return t===-1?"":f.slice(b,t)},extname(f){h(f,"path");let l=0,b=-1,t=0,n=-1,u=!0,o=0;f.length>=2&&f.charCodeAt(1)===i&&p(f.charCodeAt(0))&&(l=t=2);for(let s=f.length-1;s>=l;--s){const c=f.charCodeAt(s);if(r(c)){if(!u){t=s+1;break}continue}n===-1&&(u=!1,n=s+1),c===D?b===-1?b=s:o!==1&&(o=1):b!==-1&&(o=-1)}return b===-1||n===-1||o===0||o===1&&b===n-1&&b===t+1?"":f.slice(b,n)},format:E.bind(null,"\\"),parse(f){h(f,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return l;const b=f.length;let t=0,n=f.charCodeAt(0);if(b===1)return r(n)?(l.root=l.dir=f,l):(l.base=l.name=f,l);if(r(n)){if(t=1,r(f.charCodeAt(1))){let g=2,_=g;for(;g<b&&!r(f.charCodeAt(g));)g++;if(g<b&&g!==_){for(_=g;g<b&&r(f.charCodeAt(g));)g++;if(g<b&&g!==_){for(_=g;g<b&&!r(f.charCodeAt(g));)g++;g===b?t=g:g!==_&&(t=g+1)}}}}else if(p(n)&&f.charCodeAt(1)===i){if(b<=2)return l.root=l.dir=f,l;if(t=2,r(f.charCodeAt(2))){if(b===3)return l.root=l.dir=f,l;t=3}}t>0&&(l.root=f.slice(0,t));let u=-1,o=t,s=-1,c=!0,v=f.length-1,k=0;for(;v>=t;--v){if(n=f.charCodeAt(v),r(n)){if(!c){o=v+1;break}continue}s===-1&&(c=!1,s=v+1),n===D?u===-1?u=v:k!==1&&(k=1):u!==-1&&(k=-1)}return s!==-1&&(u===-1||k===0||k===1&&u===s-1&&u===o+1?l.base=l.name=f.slice(o,s):(l.name=f.slice(o,u),l.base=f.slice(o,s),l.ext=f.slice(u,s))),o>0&&o!==t?l.dir=f.slice(0,o-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let l="",b=!1;for(let t=f.length-1;t>=-1&&!b;t--){const n=t>=0?f[t]:w.cwd();h(n,"path"),n.length!==0&&(l=`${n}/${l}`,b=n.charCodeAt(0)===S)}return l=m(l,!b,"/",a),b?`/${l}`:l.length>0?l:"."},normalize(f){if(h(f,"path"),f.length===0)return".";const l=f.charCodeAt(0)===S,b=f.charCodeAt(f.length-1)===S;return f=m(f,!l,"/",a),f.length===0?l?"/":b?"./":".":(b&&(f+="/"),l?`/${f}`:f)},isAbsolute(f){return h(f,"path"),f.length>0&&f.charCodeAt(0)===S},join(...f){if(f.length===0)return".";let l;for(let b=0;b<f.length;++b){const t=f[b];h(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(f,l){if(h(f,"from"),h(l,"to"),f===l||(f=e.posix.resolve(f),l=e.posix.resolve(l),f===l))return"";const b=1,t=f.length,n=t-b,u=1,o=l.length-u,s=n<o?n:o;let c=-1,v=0;for(;v<s;v++){const g=f.charCodeAt(b+v);if(g!==l.charCodeAt(u+v))break;g===S&&(c=v)}if(v===s)if(o>s){if(l.charCodeAt(u+v)===S)return l.slice(u+v+1);if(v===0)return l.slice(u+v)}else n>s&&(f.charCodeAt(b+v)===S?c=v:v===0&&(c=0));let k="";for(v=b+c+1;v<=t;++v)(v===t||f.charCodeAt(v)===S)&&(k+=k.length===0?"..":"/..");return`${k}${l.slice(u+c)}`},toNamespacedPath(f){return f},dirname(f){if(h(f,"path"),f.length===0)return".";const l=f.charCodeAt(0)===S;let b=-1,t=!0;for(let n=f.length-1;n>=1;--n)if(f.charCodeAt(n)===S){if(!t){b=n;break}}else t=!1;return b===-1?l?"/":".":l&&b===1?"//":f.slice(0,b)},basename(f,l){l!==void 0&&h(l,"ext"),h(f,"path");let b=0,t=-1,n=!0,u;if(l!==void 0&&l.length>0&&l.length<=f.length){if(l===f)return"";let o=l.length-1,s=-1;for(u=f.length-1;u>=0;--u){const c=f.charCodeAt(u);if(c===S){if(!n){b=u+1;break}}else s===-1&&(n=!1,s=u+1),o>=0&&(c===l.charCodeAt(o)?--o==-1&&(t=u):(o=-1,t=s))}return b===t?t=s:t===-1&&(t=f.length),f.slice(b,t)}for(u=f.length-1;u>=0;--u)if(f.charCodeAt(u)===S){if(!n){b=u+1;break}}else t===-1&&(n=!1,t=u+1);return t===-1?"":f.slice(b,t)},extname(f){h(f,"path");let l=-1,b=0,t=-1,n=!0,u=0;for(let o=f.length-1;o>=0;--o){const s=f.charCodeAt(o);if(s===S){if(!n){b=o+1;break}continue}t===-1&&(n=!1,t=o+1),s===D?l===-1?l=o:u!==1&&(u=1):l!==-1&&(u=-1)}return l===-1||t===-1||u===0||u===1&&l===t-1&&l===b+1?"":f.slice(l,t)},format:E.bind(null,"/"),parse(f){h(f,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return l;const b=f.charCodeAt(0)===S;let t;b?(l.root="/",t=1):t=0;let n=-1,u=0,o=-1,s=!0,c=f.length-1,v=0;for(;c>=t;--c){const k=f.charCodeAt(c);if(k===S){if(!s){u=c+1;break}continue}o===-1&&(s=!1,o=c+1),k===D?n===-1?n=c:v!==1&&(v=1):n!==-1&&(v=-1)}if(o!==-1){const k=u===0&&b?1:u;n===-1||v===0||v===1&&n===o-1&&n===u+1?l.base=l.name=f.slice(k,o):(l.name=f.slice(k,n),l.base=f.slice(k,o),l.ext=f.slice(n,o))}return u>0?l.dir=f.slice(0,u-1):b&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[55],_e([0,1,21]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=w.globals.performance&&typeof w.globals.performance.now=="function";class A{constructor(y){this._highResolution=I&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new A(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=A}),define(we[3],_e([0,1,12,53,6,45,55]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(m){m.None=()=>A.Disposable.None;function E(V){return(H,te=null,$)=>{let F=!1,L;return L=V(M=>{if(!F)return L?L.dispose():F=!0,H.call(te,M)},null,$),F&&L.dispose(),L}}m.once=E;function f(V,H){return o((te,$=null,F)=>V(L=>te.call($,H(L)),null,F))}m.map=f;function l(V,H){return o((te,$=null,F)=>V(L=>{H(L),te.call($,L)},null,F))}m.forEach=l;function b(V,H){return o((te,$=null,F)=>V(L=>H(L)&&te.call($,L),null,F))}m.filter=b;function t(V){return V}m.signal=t;function n(...V){return(H,te=null,$)=>(0,A.combinedDisposable)(...V.map(F=>F(L=>H.call(te,L),null,$)))}m.any=n;function u(V,H,te){let $=te;return f(V,F=>($=H($,F),$))}m.reduce=u;function o(V){let H;const te=new d({onFirstListenerAdd(){H=V(te.fire,te)},onLastListenerRemove(){H.dispose()}});return te.event}m.snapshot=o;function s(V,H,te=100,$=!1,F){let L,M,U,G=0;const J=new d({leakWarningThreshold:F,onFirstListenerAdd(){L=V(re=>{G++,M=H(M,re),$&&!U&&(J.fire(M),M=void 0),clearTimeout(U),U=setTimeout(()=>{const pe=M;M=void 0,U=void 0,(!$||G>1)&&J.fire(pe),G=0},te)})},onLastListenerRemove(){L.dispose()}});return J.event}m.debounce=s;function c(V){const H=new Date().getTime();return f(E(V),te=>new Date().getTime()-H)}m.stopwatch=c;function v(V){let H=!0,te;return b(V,$=>{const F=H||$!==te;return H=!1,te=$,F})}m.latch=v;function k(V,H=!1,te=[]){let $=te.slice(),F=V(U=>{$?$.push(U):M.fire(U)});const L=()=>{$&&$.forEach(U=>M.fire(U)),$=null},M=new d({onFirstListenerAdd(){F||(F=V(U=>M.fire(U)))},onFirstListenerDidAdd(){$&&(H?setTimeout(L):L())},onLastListenerRemove(){F&&F.dispose(),F=null}});return M.event}m.buffer=k;class g{constructor(H){this.event=H}map(H){return new g(f(this.event,H))}forEach(H){return new g(l(this.event,H))}filter(H){return new g(b(this.event,H))}reduce(H,te){return new g(u(this.event,H,te))}latch(){return new g(v(this.event))}debounce(H,te=100,$=!1,F){return new g(s(this.event,H,te,$,F))}on(H,te,$){return this.event(H,te,$)}once(H,te,$){return E(this.event)(H,te,$)}}function _(V){return new g(V)}m.chain=_;function R(V,H,te=$=>$){const $=(...U)=>M.fire(te(...U)),F=()=>V.on(H,$),L=()=>V.removeListener(H,$),M=new d({onFirstListenerAdd:F,onLastListenerRemove:L});return M.event}m.fromNodeEventEmitter=R;function B(V,H,te=$=>$){const $=(...U)=>M.fire(te(...U)),F=()=>V.addEventListener(H,$),L=()=>V.removeEventListener(H,$),M=new d({onFirstListenerAdd:F,onLastListenerRemove:L});return M.event}m.fromDOMEventEmitter=B;function Q(V){const H=new d;let te=!1;return V.then(void 0,()=>null).then(()=>{te?H.fire(void 0):setTimeout(()=>H.fire(void 0),0)}),te=!0,H.event}m.fromPromise=Q;function ge(V){return new Promise(H=>E(V)(H))}m.toPromise=ge})(D=e.Event||(e.Event={}));class S{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${S._idPool++}`}start(E){this._stopWatch=new y.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let C=-1;function i(m){const E=C;return C=m,{dispose(){C=E}}}e.setGlobalLeakWarningThreshold=i;class P{constructor(E,f=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let f=C;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),!(f<=0||E<f)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),b=this._stacks.get(l)||0;if(this._stacks.set(l,b+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let t,n=0;for(const[u,o]of this._stacks)(!t||n<o)&&(t=u,n=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class d{constructor(E){var f;this._disposed=!1,this._options=E,this._leakageMon=C>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((f=this._options)===null||f===void 0?void 0:f._profName)?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(E,f,l)=>{var b;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(f?[E,f]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,f);const u=(b=this._leakageMon)===null||b===void 0?void 0:b.check(this._listeners.size);let o;return o={dispose:()=>{u&&u(),o.dispose=d._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof A.DisposableStore?l.add(o):Array.isArray(l)&&l.push(o),o}),this._event}fire(E){var f,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let b of this._listeners)this._deliveryQueue.push([b,E]);for((f=this._perfMon)===null||f===void 0||f.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[b,t]=this._deliveryQueue.shift();try{typeof b=="function"?b.call(void 0,t):b[0].call(b[1],t)}catch(n){(0,w.onUnexpectedError)(n)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var E,f,l;(E=this._listeners)===null||E===void 0||E.clear(),(f=this._deliveryQueue)===null||f===void 0||f.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=d,d._noop=function(){};class h extends d{constructor(E){super(E);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=h;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const f={event:E,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const l=()=>{this.hasListeners&&this.unhook(f);const b=this.events.indexOf(f);this.events.splice(b,1)};return(0,A.toDisposable)((0,I.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(f=>this.emitter.fire(f))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class a{constructor(){this.buffers=[]}wrapEvent(E){return(f,l,b)=>E(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>f.call(l,t)):f.call(l,t)},void 0,b)}bufferEvents(E){const f=[];this.buffers.push(f);const l=E();return this.buffers.pop(),f.forEach(b=>b()),l}}e.EventBufferer=a;class p{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=A.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(we[20],_e([0,1,3]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(D,S){const C=setTimeout(D.bind(S),0);return{dispose(){clearTimeout(C)}}});var A;(function(D){function S(C){return C===D.None||C===D.Cancelled||C instanceof T?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}D.isCancellationToken=S,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(A=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=A.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=y}),define(we[36],_e([0,1,3]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(P){const d=this._icons.get(P.id);d?P.description?d.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new I;e.iconRegistry=A;function T(i,P){return new D(i,P)}e.registerCodicon=T;function y(i){return i?i.replace(/\$\((.*?)\)/g,(P,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=y;class D{constructor(P,d,h){this.id=P,this.definition=d,this.description=h,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function S(i,P){const d=["codicon","codicon-"+i];return P&&d.push("codicon-modifier-"+P),d}e.getClassNamesArray=S;var C;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function d(a){if(a instanceof D)return["codicon","codicon-"+a.id];const p=P.exec(a.id);if(!p)return d(D.error);let[,m,E]=p;const f=["codicon","codicon-"+m];return E&&f.push("codicon-modifier-"+E.substr(1)),f}i.asClassNameArray=d;function h(a){return d(a).join(" ")}i.asClassName=h;function r(a){return"."+d(a).join(".")}i.asCSSSelector=r})(C=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(we[109],_e([0,1,12,6]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(f){const l=f;return l?[l.on,l.pause,l.resume,l.destroy].every(b=>typeof b=="function"):!1}e.isReadableStream=A;function T(f){const l=f;return l?A(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=T;function y(f,l){return new D(f,l)}e.newWriteableStream=y;class D{constructor(l,b){this.reducer=l,this.options=b,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){var b;if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof((b=this.options)===null||b===void 0?void 0:b.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(b=>b(l))}emitError(l){this.listeners.error.length===0?(0,w.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(b=>b(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,b){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(b),this.resume();break;case"end":this.listeners.end.push(b),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(b),this.state.flowing&&this.flowErrors();break}}removeListener(l,b){if(!this.state.destroyed){let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(b);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const b=[...this.pendingWritePromises];this.pendingWritePromises.length=0,b.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(f,l){const b=[];let t;for(;(t=f.read())!==null;)b.push(t);return l(b)}e.consumeReadable=S;function C(f,l,b){const t=[];let n;for(;(n=f.read())!==null&&t.length<b;)t.push(n);return n===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const u=n;return n=void 0,u}return f.read()}}}e.peekReadable=C;function i(f,l){return new Promise((b,t)=>{const n=[];P(f,{onData:u=>{l&&n.push(u)},onError:u=>{l?t(u):b(void 0)},onEnd:()=>{b(l?l(n):void 0)}})})}e.consumeStream=i;function P(f,l){f.on("error",b=>l.onError(b)),f.on("end",()=>l.onEnd()),f.on("data",b=>l.onData(b))}e.listenStream=P;function d(f,l){return new Promise((b,t)=>{const n=new I.DisposableStore,u=[],o=v=>{if(u.push(v),u.length>l)return n.dispose(),f.pause(),b({stream:f,buffer:u,ended:!1})},s=v=>t(v),c=()=>b({stream:f,buffer:u,ended:!0});n.add((0,I.toDisposable)(()=>f.removeListener("error",s))),f.on("error",s),n.add((0,I.toDisposable)(()=>f.removeListener("end",c))),f.on("end",c),n.add((0,I.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=d;function h(f,l){const b=y(l);return b.end(f),b}e.toStream=h;function r(){const f=y(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=r;function a(f){let l=!1;return{read:()=>l?null:(l=!0,f)}}e.toReadable=a;function p(f,l,b){const t=y(b);return P(f,{onData:n=>t.write(l.data(n)),onError:n=>t.error(l.error?l.error(n):n),onEnd:()=>t.end()}),t}e.transform=p;function m(f,l,b){let t=!1;return{read:()=>{const n=l.read();return t?n:(t=!0,n!==null?b([f,n]):f)}}}e.prefixedReadable=m;function E(f,l,b){let t=!1;const n=y(b);return P(l,{onData:u=>t?n.write(u):(t=!0,n.write(b([f,u]))),onError:u=>n.error(u),onEnd:()=>{t||(t=!0,n.write(f)),n.end()}}),n}e.prefixedStream=E}),define(we[8],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function w(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=w;const I=/{(\d+)}/g;function A(W,...ie){return ie.length===0?W:W.replace(I,function(ce,j){const X=parseInt(j,10);return isNaN(X)||X<0||X>=ie.length?ce:ie[X]})}e.format=A;function T(W){return W.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=T;function y(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function D(W,ie){let ce=0;const j=ie.charCodeAt(0);for(let X=W.length-1;X>=0;X--)W.charCodeAt(X)===j&&ce++;return ce}e.count=D;function S(W,ie,ce="\u2026"){return W.length<=ie?W:`${W.substr(0,ie)}${ce}`}e.truncate=S;function C(W,ie=" "){const ce=i(W,ie);return P(ce,ie)}e.trim=C;function i(W,ie){if(!W||!ie)return W;const ce=ie.length;if(ce===0||W.length===0)return W;let j=0;for(;W.indexOf(ie,j)===j;)j=j+ce;return W.substring(j)}e.ltrim=i;function P(W,ie){if(!W||!ie)return W;const ce=ie.length,j=W.length;if(ce===0||j===0)return W;let X=j,ae=-1;for(;ae=W.lastIndexOf(ie,X-1),!(ae===-1||ae+ce!==X);){if(ae===0)return"";X=ae}return W.substring(0,X)}e.rtrim=P;function d(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function h(W){return W.replace(/\*/g,"")}e.stripWildcards=h;function r(W,ie,ce={}){if(!W)throw new Error("Cannot create regex from empty string");ie||(W=y(W)),ce.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let j="";return ce.global&&(j+="g"),ce.matchCase||(j+="i"),ce.multiline&&(j+="m"),ce.unicode&&(j+="u"),new RegExp(W,j)}e.createRegExp=r;function a(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function p(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function m(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=m;function E(W){return W.split(/\r\n|\r|\n/)}e.splitLines=E;function f(W){for(let ie=0,ce=W.length;ie<ce;ie++){const j=W.charCodeAt(ie);if(j!==32&&j!==9)return ie}return-1}e.firstNonWhitespaceIndex=f;function l(W,ie=0,ce=W.length){for(let j=ie;j<ce;j++){const X=W.charCodeAt(j);if(X!==32&&X!==9)return W.substring(ie,j)}return W.substring(ie,ce)}e.getLeadingWhitespace=l;function b(W,ie=W.length-1){for(let ce=ie;ce>=0;ce--){const j=W.charCodeAt(ce);if(j!==32&&j!==9)return ce}return-1}e.lastNonWhitespaceIndex=b;function t(W,ie){return W<ie?-1:W>ie?1:0}e.compare=t;function n(W,ie,ce=0,j=W.length,X=0,ae=ie.length){for(;ce<j&&X<ae;ce++,X++){let ze=W.charCodeAt(ce),xe=ie.charCodeAt(X);if(ze<xe)return-1;if(ze>xe)return 1}const he=j-ce,ye=ae-X;return he<ye?-1:he>ye?1:0}e.compareSubstring=n;function u(W,ie){return o(W,ie,0,W.length,0,ie.length)}e.compareIgnoreCase=u;function o(W,ie,ce=0,j=W.length,X=0,ae=ie.length){for(;ce<j&&X<ae;ce++,X++){let ze=W.charCodeAt(ce),xe=ie.charCodeAt(X);if(ze!==xe){const Ne=ze-xe;if(!(Ne===32&&c(xe))&&!(Ne===-32&&c(ze)))return s(ze)&&s(xe)?Ne:n(W.toLowerCase(),ie.toLowerCase(),ce,j,X,ae)}}const he=j-ce,ye=ae-X;return he<ye?-1:he>ye?1:0}e.compareSubstringIgnoreCase=o;function s(W){return W>=97&&W<=122}e.isLowerAsciiLetter=s;function c(W){return W>=65&&W<=90}e.isUpperAsciiLetter=c;function v(W){return s(W)||c(W)}function k(W,ie){return W.length===ie.length&&g(W,ie)}e.equalsIgnoreCase=k;function g(W,ie,ce=W.length){for(let j=0;j<ce;j++){const X=W.charCodeAt(j),ae=ie.charCodeAt(j);if(X!==ae){if(v(X)&&v(ae)){const he=Math.abs(X-ae);if(he!==0&&he!==32)return!1}else if(String.fromCharCode(X).toLowerCase()!==String.fromCharCode(ae).toLowerCase())return!1}}return!0}function _(W,ie){const ce=ie.length;return ie.length>W.length?!1:g(W,ie,ce)}e.startsWithIgnoreCase=_;function R(W,ie){let ce,j=Math.min(W.length,ie.length);for(ce=0;ce<j;ce++)if(W.charCodeAt(ce)!==ie.charCodeAt(ce))return ce;return j}e.commonPrefixLength=R;function B(W,ie){let ce,j=Math.min(W.length,ie.length);const X=W.length-1,ae=ie.length-1;for(ce=0;ce<j;ce++)if(W.charCodeAt(X-ce)!==ie.charCodeAt(ae-ce))return ce;return j}e.commonSuffixLength=B;function Q(W){return 55296<=W&&W<=56319}e.isHighSurrogate=Q;function ge(W){return 56320<=W&&W<=57343}e.isLowSurrogate=ge;function V(W,ie){return(W-55296<<10)+(ie-56320)+65536}e.computeCodePoint=V;function H(W,ie,ce){const j=W.charCodeAt(ce);if(Q(j)&&ce+1<ie){const X=W.charCodeAt(ce+1);if(ge(X))return V(j,X)}return j}e.getNextCodePoint=H;function te(W,ie){const ce=W.charCodeAt(ie-1);if(ge(ce)&&ie>1){const j=W.charCodeAt(ie-2);if(Q(j))return V(j,ce)}return ce}function $(W,ie){const ce=Ue.getInstance(),j=ie,X=W.length,ae=H(W,X,ie);ie+=ae>=65536?2:1;let he=ce.getGraphemeBreakType(ae);for(;ie<X;){const ye=H(W,X,ie),ze=ce.getGraphemeBreakType(ye);if(Le(he,ze))break;ie+=ye>=65536?2:1,he=ze}return ie-j}e.nextCharLength=$;function F(W,ie){const ce=Ue.getInstance(),j=ie,X=te(W,ie);ie-=X>=65536?2:1;let ae=ce.getGraphemeBreakType(X);for(;ie>0;){const he=te(W,ie),ye=ce.getGraphemeBreakType(he);if(Le(ye,ae))break;ie-=he>=65536?2:1,ae=ye}return j-ie}e.prevCharLength=F;function L(W,ie){const ce=Ue.getInstance(),j=W.length,X=ie,ae=H(W,j,ie),he=ce.getGraphemeBreakType(ae);ie+=ae>=65536?2:1;let ye=he;for(;ie<j;){const xe=H(W,j,ie),Ne=ce.getGraphemeBreakType(xe);if(Le(ye,Ne))break;ie+=xe>=65536?2:1,ye=Ne}const ze=ie;for(ie=X,ye=he;ie>0;){const xe=te(W,ie),Ne=ce.getGraphemeBreakType(xe);if(Le(Ne,ye))break;ie-=xe>=65536?2:1,ye=Ne}return[ie,ze]}function M(W,ie){return ie>0&&ge(W.charCodeAt(ie))?L(W,ie-1):L(W,ie)}e.getCharContainingOffset=M;function U(W){const ie=W.length;let ce=0,j=0;for(;j<ie;){const he=H(W,ie,j);j+=he>=65536?2:1,he<128?ce+=1:he<2048?ce+=2:he<65536?ce+=3:ce+=4}const X=new Uint8Array(ce);j=0;let ae=0;for(;j<ie;){const he=H(W,ie,j);j+=he>=65536?2:1,he<128?X[ae++]=he:he<2048?(X[ae++]=192|(he&1984)>>>6,X[ae++]=128|(he&63)>>>0):he<65536?(X[ae++]=224|(he&61440)>>>12,X[ae++]=128|(he&4032)>>>6,X[ae++]=128|(he&63)>>>0):(X[ae++]=240|(he&1835008)>>>18,X[ae++]=128|(he&258048)>>>12,X[ae++]=128|(he&4032)>>>6,X[ae++]=128|(he&63)>>>0)}return X}e.encodeUTF8=U;function G(W){const ie=W.byteLength,ce=[];let j=0;for(;j<ie;){const X=W[j];let ae;if(X>=240&&j+3<ie?ae=(W[j++]&7)<<18>>>0|(W[j++]&63)<<12>>>0|(W[j++]&63)<<6>>>0|(W[j++]&63)<<0>>>0:X>=224&&j+2<ie?ae=(W[j++]&15)<<12>>>0|(W[j++]&63)<<6>>>0|(W[j++]&63)<<0>>>0:X>=192&&j+1<ie?ae=(W[j++]&31)<<6>>>0|(W[j++]&63)<<0>>>0:ae=W[j++],ae>=0&&ae<=55295||ae>=57344&&ae<=65535)ce.push(String.fromCharCode(ae));else if(ae>=65536&&ae<=1114111){const he=ae-65536,ye=55296+((he&1047552)>>>10),ze=56320+((he&1023)>>>0);ce.push(String.fromCharCode(ye)),ce.push(String.fromCharCode(ze))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=G;const J=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function re(W){return J.test(W)}e.containsRTL=re;const pe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Te(W){return pe.test(W)}e.containsEmoji=Te;const Be=/^[\t\n\r\x20-\x7E]*$/;function Ae(W){return Be.test(W)}e.isBasicASCII=Ae,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=We;function x(W){for(let ie=0,ce=W.length;ie<ce;ie++)if(q(W.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=x;function q(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=q;function ne(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=ne;function le(W,ie){if(W.length<ie)return W;const ce=/\b/g;let j=0;for(;ce.test(W)&&!(W.length-ce.lastIndex<ie);)j=ce.lastIndex,ce.lastIndex+=1;return W.substring(j).replace(/^\s/,"")}e.lcut=le;const fe=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function me(W){return W&&(W=W.replace(fe,""),W=W.replace(Se,""),W=W.replace(Oe,"")),W}e.removeAnsiEscapeCodes=me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Pe(W){return Ce(W)?W.substr(1):W}e.stripUTF8BOM=Pe;function $e(W,ie){if(!W||!ie||W.length<ie.length)return!1;const ce=ie.length,j=W.toLowerCase();let X=0,ae=-1;for(;X<ce;){const he=j.indexOf(ie[X],ae+1);if(he<0)return!1;ae=he,X++}return!0}e.fuzzyContains=$e;function Ee(W,ie=!1){return W?(ie&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Ee;function je(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=je;function z(W,ie=1){if(ie===0)return"";let ce=-1;do ce=W.indexOf(`
`,ce+1),ie--;while(ie>0&&ce>=0);return ce===-1?W:(W[ce-1]==="\r"&&ce--,W.substr(0,ce))}e.getNLines=z;function ee(W){const ie=90-65+1;return W=W%(2*ie),W<ie?String.fromCharCode(97+W):String.fromCharCode(65+W-ie)}e.singleLetterHash=ee;function ve(W){return Ue.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=ve;function Le(W,ie){return W===0?ie!==5&&ie!==7:W===2&&ie===3?!1:W===4||W===2||W===3||ie===4||ie===2||ie===3?!0:!(W===8&&(ie===8||ie===9||ie===11||ie===12)||(W===11||W===9)&&(ie===9||ie===10)||(W===12||W===10)&&ie===10||ie===5||ie===13||ie===7||W===1||W===13&&ie===14||W===6&&ie===6)}e.breakBetweenGraphemeBreakType=Le;var He;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=Xe()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ce=this._data,j=ce.length/3;let X=1;for(;X<=j;)if(ie<ce[3*X])X=2*X;else if(ie>ce[3*X+1])X=2*X+1;else return ce[3*X+2];return 0}}Ue._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(we[24],_e([0,1,8,109]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let D,S;class C{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return A?new C(Buffer.allocUnsafe(v)):new C(new Uint8Array(v))}static wrap(v){return A&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new C(v)}static fromString(v,k){return!((k==null?void 0:k.dontUseNodeBuffer)||!1)&&A?new C(Buffer.from(v)):T?(D||(D=new TextEncoder),new C(D.encode(v))):new C(w.encodeUTF8(v))}static concat(v,k){if(typeof k=="undefined"){k=0;for(let R=0,B=v.length;R<B;R++)k+=v[R].byteLength}const g=C.alloc(k);let _=0;for(let R=0,B=v.length;R<B;R++){const Q=v[R];g.set(Q,_),_+=Q.byteLength}return g}toString(){return A?this.buffer.toString():y?(S||(S=new TextDecoder),S.decode(this.buffer)):w.decodeUTF8(this.buffer)}slice(v,k){return new C(this.buffer.subarray(v,k))}set(v,k){v instanceof C?this.buffer.set(v.buffer,k):this.buffer.set(v,k)}readUInt32BE(v){return d(this.buffer,v)}writeUInt32BE(v,k){h(this.buffer,v,k)}readUInt32LE(v){return r(this.buffer,v)}writeUInt32LE(v,k){a(this.buffer,v,k)}readUInt8(v){return p(this.buffer,v)}writeUInt8(v,k){m(this.buffer,v,k)}}e.VSBuffer=C;function i(c,v){return c[v+0]<<0>>>0|c[v+1]<<8>>>0}e.readUInt16LE=i;function P(c,v,k){c[k+0]=v&255,v=v>>>8,c[k+1]=v&255}e.writeUInt16LE=P;function d(c,v){return c[v]*2**24+c[v+1]*2**16+c[v+2]*2**8+c[v+3]}e.readUInt32BE=d;function h(c,v,k){c[k+3]=v,v=v>>>8,c[k+2]=v,v=v>>>8,c[k+1]=v,v=v>>>8,c[k]=v}e.writeUInt32BE=h;function r(c,v){return c[v+0]<<0>>>0|c[v+1]<<8>>>0|c[v+2]<<16>>>0|c[v+3]<<24>>>0}e.readUInt32LE=r;function a(c,v,k){c[k+0]=v&255,v=v>>>8,c[k+1]=v&255,v=v>>>8,c[k+2]=v&255,v=v>>>8,c[k+3]=v&255}e.writeUInt32LE=a;function p(c,v){return c[v]}e.readUInt8=p;function m(c,v,k){c[k]=v}e.writeUInt8=m;function E(c){return I.consumeReadable(c,v=>C.concat(v))}e.readableToBuffer=E;function f(c){return I.toReadable(c)}e.bufferToReadable=f;function l(c){return I.consumeStream(c,v=>C.concat(v))}e.streamToBuffer=l;async function b(c){return c.ended?C.concat(c.buffer):C.concat([...c.buffer,await l(c.stream)])}e.bufferedStreamToBuffer=b;function t(c){return I.toStream(c,v=>C.concat(v))}e.bufferToStream=t;function n(c){return I.transform(c,{data:v=>typeof v=="string"?C.fromString(v):C.wrap(v)},v=>C.concat(v))}e.streamToBufferReadableStream=n;function u(c){return I.newWriteableStream(v=>C.concat(v),c)}e.newWriteableBufferStream=u;function o(c,v){return I.prefixedReadable(c,v,k=>C.concat(k))}e.prefixedBufferReadable=o;function s(c,v){return I.prefixedStream(c,v,k=>C.concat(k))}e.prefixedBufferStream=s}),define(we[56],_e([0,1,8]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(m){return A(m,0)}e.hash=I;function A(m,E){switch(typeof m){case"object":return m===null?T(349,E):Array.isArray(m)?S(m,E):C(m,E);case"string":return D(m,E);case"boolean":return y(m,E);case"number":return T(m,E);case"undefined":return T(937,E);default:return T(617,E)}}e.doHash=A;function T(m,E){return(E<<5)-E+m|0}function y(m,E){return T(m?433:863,E)}function D(m,E){E=T(149417,E);for(let f=0,l=m.length;f<l;f++)E=T(m.charCodeAt(f),E);return E}e.stringHash=D;function S(m,E){return E=T(104579,E),m.reduce((f,l)=>A(l,f),E)}function C(m,E){return E=T(181387,E),Object.keys(m).sort().reduce((f,l)=>(f=D(l,f),A(m[l],f)),E)}class i{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=A(E,this._value),this._value}}e.Hasher=i;var P;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function d(m,E,f=32){const l=f-E,b=~((1<<l)-1);return(m<<E|(b&m)>>>l)>>>0}function h(m,E=0,f=m.byteLength,l=0){for(let b=0;b<f;b++)m[E+b]=l}function r(m,E,f="0"){for(;m.length<E;)m=f+m;return m}function a(m,E=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(f=>f.toString(16).padStart(2,"0")).join(""):r((m>>>0).toString(16),E/4)}e.toHexString=a;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const f=E.length;if(f!==0){const l=this._buff;let b=this._buffLen,t=this._leftoverHighSurrogate,n,u;for(t!==0?(n=t,u=-1,t=0):(n=E.charCodeAt(0),u=0);;){let o=n;if(w.isHighSurrogate(n))if(u+1<f){const s=E.charCodeAt(u+1);w.isLowSurrogate(s)?(u++,o=w.computeCodePoint(n,s)):o=65533}else{t=n;break}else w.isLowSurrogate(n)&&(o=65533);if(b=this._push(l,b,o),u++,u<f)n=E.charCodeAt(u);else break}this._buffLen=b,this._leftoverHighSurrogate=t}}_push(E,f,l){return l<128?E[f++]=l:l<2048?(E[f++]=192|(l&1984)>>>6,E[f++]=128|(l&63)>>>0):l<65536?(E[f++]=224|(l&61440)>>>12,E[f++]=128|(l&4032)>>>6,E[f++]=128|(l&63)>>>0):(E[f++]=240|(l&1835008)>>>18,E[f++]=128|(l&258048)>>>12,E[f++]=128|(l&4032)>>>6,E[f++]=128|(l&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),a(this._h0)+a(this._h1)+a(this._h2)+a(this._h3)+a(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=p._bigBlock32,f=this._buffDV;for(let v=0;v<64;v+=4)E.setUint32(v,f.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)E.setUint32(v,d(E.getUint32(v-12,!1)^E.getUint32(v-32,!1)^E.getUint32(v-56,!1)^E.getUint32(v-64,!1),1),!1);let l=this._h0,b=this._h1,t=this._h2,n=this._h3,u=this._h4,o,s,c;for(let v=0;v<80;v++)v<20?(o=b&t|~b&n,s=1518500249):v<40?(o=b^t^n,s=1859775393):v<60?(o=b&t|b&n|t&n,s=2400959708):(o=b^t^n,s=3395469782),c=d(l,5)+o+u+s+E.getUint32(v*4,!1)&4294967295,u=n,n=t,t=d(b,30),b=l,l=c;this._h0=this._h0+l&4294967295,this._h1=this._h1+b&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+u&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[47],_e([0,1,8]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(I||(I={})),function(A){const T="error",y="warning",D="warn",S="info",C="ignore";function i(d){return d?w.equalsIgnoreCase(T,d)?A.Error:w.equalsIgnoreCase(y,d)||w.equalsIgnoreCase(D,d)?A.Warning:w.equalsIgnoreCase(S,d)?A.Info:A.Ignore:A.Ignore}A.fromValue=i;function P(d){switch(d){case A.Error:return T;case A.Warning:return y;case A.Info:return S;default:return C}}A.toString=P}(I||(I={})),e.default=I}),define(we[10],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(v){return Array.isArray(v)}e.isArray=w;function I(v){return typeof v=="string"}e.isString=I;function A(v){return Array.isArray(v)&&v.every(k=>I(k))}e.isStringArray=A;function T(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.isObject=T;function y(v){return typeof v=="number"&&!isNaN(v)}e.isNumber=y;function D(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.isIterable=D;function S(v){return v===!0||v===!1}e.isBoolean=S;function C(v){return typeof v=="undefined"}e.isUndefined=C;function i(v){return!P(v)}e.isDefined=i;function P(v){return C(v)||v===null}e.isUndefinedOrNull=P;function d(v,k){if(!v)throw new Error(k?`Unexpected type, expected '${k}'`:"Unexpected type")}e.assertType=d;function h(v){if(P(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.assertIsDefined=h;function r(...v){const k=[];for(let g=0;g<v.length;g++){const _=v[g];if(P(_))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);k.push(_)}return k}e.assertAllDefined=r;const a=Object.prototype.hasOwnProperty;function p(v){if(!T(v))return!1;for(let k in v)if(a.call(v,k))return!1;return!0}e.isEmptyObject=p;function m(v){return typeof v=="function"}e.isFunction=m;function E(...v){return v.length>0&&v.every(m)}e.areFunctions=E;function f(v,k){const g=Math.min(v.length,k.length);for(let _=0;_<g;_++)l(v[_],k[_])}e.validateConstraints=f;function l(v,k){if(I(k)){if(typeof v!==k)throw new Error(`argument does not match constraint: typeof ${k}`)}else if(m(k)){try{if(v instanceof k)return}catch(g){}if(!P(v)&&v.constructor===k||k.length===1&&k.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function b(v){let k=[],g=Object.getPrototypeOf(v);for(;Object.prototype!==g;)k=k.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return k}e.getAllPropertyNames=b;function t(v){const k=[];for(const g of b(v))typeof v[g]=="function"&&k.push(g);return k}e.getAllMethodNames=t;function n(v,k){const g=R=>function(){const B=Array.prototype.slice.call(arguments,0);return k(R,B)};let _={};for(const R of v)_[R]=g(R);return _}e.createProxyObject=n;function u(v){return v===null?void 0:v}e.withNullAsUndefined=u;function o(v){return typeof v=="undefined"?null:v}e.withUndefinedAsNull=o;function s(v){return class{constructor(){return new Proxy({},{get(k,g){if(k[g])return k[g];throw new Error(`Not Implemented: ${v}->${String(g)}`)}})}}}e.NotImplementedProxy=s;function c(v){throw new Error("Unreachable")}e.assertNever=c}),define(we[37],_e([0,1,21,8,13,10]),function(Y,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function D(n){return n.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=D;function S(n,u=A.posix.sep){if(!n)return"";const o=n.length,s=n.charCodeAt(0);if(y(s)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let v=3;const k=v;for(;v<o&&!y(n.charCodeAt(v));v++);if(k!==v&&!y(n.charCodeAt(v+1))){for(v+=1;v<o;v++)if(y(n.charCodeAt(v)))return n.slice(0,v+1).replace(/[\\/]/g,u)}}return u}else if(p(s)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+u:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<o;c++)if(y(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=S;function C(n){if(!w.isWindows||!n||n.length<5)return!1;let u=n.charCodeAt(0);if(u!==92||(u=n.charCodeAt(1),u!==92))return!1;let o=2;const s=o;for(;o<n.length&&(u=n.charCodeAt(o),u!==92);o++);return!(s===o||(u=n.charCodeAt(o+1),isNaN(u)||u===92))}e.isUNC=C;const i=/[\\/:\*\?"<>\|]/g,P=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,u=w.isWindows){const o=u?i:P;return!(!n||n.length===0||/^\s+$/.test(n)||(o.lastIndex=0,o.test(n))||u&&d.test(n)||n==="."||n===".."||u&&n[n.length-1]==="."||u&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function r(n,u,o){const s=n===u;return!o||s?s:!n||!u?!1:(0,I.equalsIgnoreCase)(n,u)}e.isEqual=r;function a(n,u,o,s=A.sep){if(n===u)return!0;if(!n||!u||u.length>n.length)return!1;if(o){if(!(0,I.startsWithIgnoreCase)(n,u))return!1;if(u.length===n.length)return!0;let v=u.length;return u.charAt(u.length-1)===s&&v--,n.charAt(v)===s}return u.charAt(u.length-1)!==s&&(u+=s),n.indexOf(u)===0}e.isEqualOrParent=a;function p(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=p;function m(n,u){return w.isWindows&&n.endsWith(":")&&(n+=A.sep),(0,A.isAbsolute)(n)||(n=(0,A.join)(u,n)),n=(0,A.normalize)(n),w.isWindows?(n=(0,I.rtrim)(n,A.sep),n.endsWith(":")&&(n+=A.sep)):(n=(0,I.rtrim)(n,A.sep),n||(n=A.sep)),n}e.sanitizeFilePath=m;function E(n){const u=(0,A.normalize)(n);return w.isWindows?n.length>3?!1:f(u)&&(n.length===2||u.charCodeAt(2)===92):u===A.posix.sep}e.isRootOrDriveLetter=E;function f(n){return w.isWindows?p(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function l(n){return f(n)?n[0]:void 0}e.getDriveLetter=l;function b(n,u,o){return u.length>n.length?-1:n===u?0:(o&&(n=n.toLowerCase(),u=u.toLowerCase()),n.indexOf(u))}e.indexOfPath=b;function t(n){const u=n.split(":");let o,s,c;if(u.forEach(v=>{const k=Number(v);(0,T.isNumber)(k)?s===void 0?s=k:c===void 0&&(c=k):o=o?[o,v].join(":"):v}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:s!==void 0?s:void 0,column:c!==void 0?c:s!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(we[23],_e([0,1,10]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const p=Array.isArray(a)?[]:{};return Object.keys(a).forEach(m=>{a[m]&&typeof a[m]=="object"?p[m]=I(a[m]):p[m]=a[m]}),p}e.deepClone=I;function A(a){if(!a||typeof a!="object")return a;const p=[a];for(;p.length>0;){const m=p.shift();Object.freeze(m);for(const E in m)if(T.call(m,E)){const f=m[E];typeof f=="object"&&!Object.isFrozen(f)&&p.push(f)}}return a}e.deepFreeze=A;const T=Object.prototype.hasOwnProperty;function y(a,p){return D(a,p,new Set)}e.cloneAndChange=y;function D(a,p,m){if((0,w.isUndefinedOrNull)(a))return a;const E=p(a);if(typeof E!="undefined")return E;if((0,w.isArray)(a)){const f=[];for(const l of a)f.push(D(l,p,m));return f}if((0,w.isObject)(a)){if(m.has(a))throw new Error("Cannot clone recursive data-structure");m.add(a);const f={};for(let l in a)T.call(a,l)&&(f[l]=D(a[l],p,m));return m.delete(a),f}return a}function S(a,p,m=!0){return(0,w.isObject)(a)?((0,w.isObject)(p)&&Object.keys(p).forEach(E=>{E in a?m&&((0,w.isObject)(a[E])&&(0,w.isObject)(p[E])?S(a[E],p[E],m):a[E]=p[E]):a[E]=p[E]}),a):p}e.mixin=S;function C(a,p){if(a===p)return!0;if(a==null||p===null||p===void 0||typeof a!=typeof p||typeof a!="object"||Array.isArray(a)!==Array.isArray(p))return!1;let m,E;if(Array.isArray(a)){if(a.length!==p.length)return!1;for(m=0;m<a.length;m++)if(!C(a[m],p[m]))return!1}else{const f=[];for(E in a)f.push(E);f.sort();const l=[];for(E in p)l.push(E);if(l.sort(),!C(f,l))return!1;for(m=0;m<f.length;m++)if(!C(a[f[m]],p[f[m]]))return!1}return!0}e.equals=C;function i(a){const p=new Set;return JSON.stringify(a,(m,E)=>{if((0,w.isObject)(E)||Array.isArray(E)){if(p.has(E))return"[Circular]";p.add(E)}return E})}e.safeStringify=i;function P(a,p,m){const E=p(a);return typeof E=="undefined"?m:E}e.getOrDefault=P;function d(a,p){const m=Object.create(null);return!a||!p||Object.keys(p).forEach(f=>{const l=a[f],b=p[f];C(l,b)||(m[f]=b)}),m}e.distinct=d;function h(a,p){const m=p.toLowerCase(),E=Object.keys(a).find(f=>f.toLowerCase()===m);return E?a[E]:a[p]}e.getCaseInsensitive=h;function r(a,p){const m=Object.create(null);for(const E of Object.keys(a))p(E,a[E])&&(m[E]=a[E]);return m}e.filter=r}),define(we[82],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var w;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(w=e.Constants||(e.Constants={}));function I(T){return T<0?0:T>255?255:T|0}e.toUint8=I;function A(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=A}),define(we[2],_e([0,1,21,13]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,T=/^\//,y=/^\/\//;function D(u,o){if(!u.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!A.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!T.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(u,o){return!u&&!o?"file":u}function C(u,o){switch(u){case"https":case"http":case"file":o?o[0]!==P&&(o=P+o):o=P;break}return o}const i="",P="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(o,s,c,v,k,g=!1){typeof o=="object"?(this.scheme=o.scheme||i,this.authority=o.authority||i,this.path=o.path||i,this.query=o.query||i,this.fragment=o.fragment||i):(this.scheme=S(o,g),this.authority=s||i,this.path=C(this.scheme,c||i),this.query=v||i,this.fragment=k||i,D(this,g))}static isUri(o){return o instanceof h?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return f(this,!1)}with(o){if(!o)return this;let{scheme:s,authority:c,path:v,query:k,fragment:g}=o;return s===void 0?s=this.scheme:s===null&&(s=i),c===void 0?c=this.authority:c===null&&(c=i),v===void 0?v=this.path:v===null&&(v=i),k===void 0?k=this.query:k===null&&(k=i),g===void 0?g=this.fragment:g===null&&(g=i),s===this.scheme&&c===this.authority&&v===this.path&&k===this.query&&g===this.fragment?this:new a(s,c,v,k,g)}static parse(o,s=!1){const c=d.exec(o);return c?new a(c[2]||i,n(c[4]||i),n(c[5]||i),n(c[7]||i),n(c[9]||i),s):new a(i,i,i,i,i)}static file(o){let s=i;if(w.isWindows&&(o=o.replace(/\\/g,P)),o[0]===P&&o[1]===P){const c=o.indexOf(P,2);c===-1?(s=o.substring(2),o=P):(s=o.substring(2,c),o=o.substring(c)||P)}return new a("file",s,o,i,i)}static from(o){return new a(o.scheme,o.authority,o.path,o.query,o.fragment)}static joinPath(o,...s){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return w.isWindows&&o.scheme==="file"?c=h.file(I.win32.join(f(o,!0),...s)).path:c=I.posix.join(o.path,...s),o.with({path:c})}toString(o=!1){return l(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof h)return o;{const s=new a(o);return s._formatted=o.external,s._fsPath=o._sep===r?o.fsPath:null,s}}else return o}}e.URI=h;const r=w.isWindows?1:void 0;class a extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(o=!1){return o?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=r),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(u,o){let s,c=-1;for(let v=0;v<u.length;v++){const k=u.charCodeAt(v);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||o&&k===47)c!==-1&&(s+=encodeURIComponent(u.substring(c,v)),c=-1),s!==void 0&&(s+=u.charAt(v));else{s===void 0&&(s=u.substr(0,v));const g=p[k];g!==void 0?(c!==-1&&(s+=encodeURIComponent(u.substring(c,v)),c=-1),s+=g):c===-1&&(c=v)}}return c!==-1&&(s+=encodeURIComponent(u.substring(c))),s!==void 0?s:u}function E(u){let o;for(let s=0;s<u.length;s++){const c=u.charCodeAt(s);c===35||c===63?(o===void 0&&(o=u.substr(0,s)),o+=p[c]):o!==void 0&&(o+=u[s])}return o!==void 0?o:u}function f(u,o){let s;return u.authority&&u.path.length>1&&u.scheme==="file"?s=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?o?s=u.path.substr(1):s=u.path[1].toLowerCase()+u.path.substr(2):s=u.path,w.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function l(u,o){const s=o?E:m;let c="",{scheme:v,authority:k,path:g,query:_,fragment:R}=u;if(v&&(c+=v,c+=":"),(k||v==="file")&&(c+=P,c+=P),k){let B=k.indexOf("@");if(B!==-1){const Q=k.substr(0,B);k=k.substr(B+1),B=Q.indexOf(":"),B===-1?c+=s(Q,!1):(c+=s(Q.substr(0,B),!1),c+=":",c+=s(Q.substr(B+1),!1)),c+="@"}k=k.toLowerCase(),B=k.indexOf(":"),B===-1?c+=s(k,!1):(c+=s(k.substr(0,B),!1),c+=k.substr(B))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const B=g.charCodeAt(1);B>=65&&B<=90&&(g=`/${String.fromCharCode(B+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const B=g.charCodeAt(0);B>=65&&B<=90&&(g=`${String.fromCharCode(B+32)}:${g.substr(2)}`)}c+=s(g,!0)}return _&&(c+="?",c+=s(_,!1)),R&&(c+="#",c+=o?R:m(R,!1)),c}function b(u){try{return decodeURIComponent(u)}catch(o){return u.length>3?u.substr(0,3)+b(u.substr(3)):u}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(u){return u.match(t)?u.replace(t,o=>b(o)):u}});var tt=this&&this.__classPrivateFieldSet||function(Y,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Y,w):A?A.value=w:e.set(Y,w),w},Me=this&&this.__classPrivateFieldGet||function(Y,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Y):I?I.value:e.get(Y)};define(we[22],_e([0,1,2,8]),function(Y,e,w,I){"use strict";var A,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,n,u){let o=t.get(n);return o===void 0&&(o=u,t.set(n,o)),o}e.getOrSet=D;function S(t){const n=[];return t.forEach((u,o)=>{n.push(`${o} => ${u}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=S;function C(t){const n=[];return t.forEach(u=>{n.push(u)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=C;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const u=n.charCodeAt(0),o=this._value.charCodeAt(this._pos);return u-o}value(){return this._value[this._pos]}}e.StringIterator=i;class P{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class d{constructor(n=!0,u=!0){this._splitOnBackslash=n,this._caseSensitive=u}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const u=this._value.charCodeAt(this._to);if(u===47||this._splitOnBackslash&&u===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class r{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,I.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class p{constructor(n){this._iter=n}static forUris(n=()=>!1){return new p(new r(n))}static forPaths(){return new p(new d)}static forStrings(){return new p(new i)}static forConfigKeys(){return new p(new P)}clear(){this._root=void 0}set(n,u){const o=this._iter.reset(n);let s;for(this._root||(this._root=new a,this._root.segment=o.value()),s=this._root;;){const v=o.cmp(s.segment);if(v>0)s.left||(s.left=new a,s.left.segment=o.value()),s=s.left;else if(v<0)s.right||(s.right=new a,s.right.segment=o.value()),s=s.right;else if(o.hasNext())o.next(),s.mid||(s.mid=new a,s.mid.segment=o.value()),s=s.mid;else break}const c=s.value;return s.value=u,s.key=n,c}get(n){var u;return(u=this._getNode(n))===null||u===void 0?void 0:u.value}_getNode(n){const u=this._iter.reset(n);let o=this._root;for(;o;){const s=u.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(u.hasNext())u.next(),o=o.mid;else break}return o}has(n){const u=this._getNode(n);return!((u==null?void 0:u.value)===void 0&&(u==null?void 0:u.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,u){const o=this._iter.reset(n),s=[];let c=this._root;for(;c;){const v=o.cmp(c.segment);if(v>0)s.push([1,c]),c=c.left;else if(v<0)s.push([-1,c]),c=c.right;else if(o.hasNext())o.next(),s.push([0,c]),c=c.mid;else{for(u?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;s.length>0&&c.isEmpty();){let[k,g]=s.pop();switch(k){case 1:g.left=void 0;break;case 0:g.mid=void 0;break;case-1:g.right=void 0;break}c=g}break}}}findSubstr(n){const u=this._iter.reset(n);let o=this._root,s;for(;o;){const c=u.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(u.hasNext())u.next(),s=o.value||s,o=o.mid;else break}return o&&o.value||s}findSuperstr(n){const u=this._iter.reset(n);let o=this._root;for(;o;){const s=u.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(u.hasNext())u.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(n){for(const[u,o]of this)n(o,u)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=p;class m{constructor(n,u){this[A]="ResourceMap",n instanceof m?(this.map=new Map(n.map),this.toKey=u!=null?u:m.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:m.defaultToKey)}set(n,u){return this.map.set(this.toKey(n),u),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,u){typeof u!="undefined"&&(n=n.bind(u));for(let[o,s]of this.map)n(s,w.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield w.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[w.URI.parse(n[0]),n[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[w.URI.parse(n[0]),n[1]]}}e.ResourceMap=m,m.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class f{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,u=0){const o=this._map.get(n);if(!!o)return u!==0&&this.touch(o,u),o.value}set(n,u,o=0){let s=this._map.get(n);if(s)s.value=u,o!==0&&this.touch(s,o);else{switch(s={key:n,value:u,next:void 0,previous:void 0},o){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(n,s),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const u=this._map.get(n);if(!!u)return this._map.delete(n),this.removeItem(u),this._size--,u.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,u){const o=this._state;let s=this._head;for(;s;){if(u?n.bind(u)(s.value,s.key,this):n(s.value,s.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const n=this,u=this._state;let o=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.key,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return s}values(){const n=this,u=this._state;let o=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.value,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return s}entries(){const n=this,u=this._state;let o=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:[o.key,o.value],done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return s}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let u=this._head,o=this.size;for(;u&&o>n;)this._map.delete(u.key),u=u.next,o--;this._head=u,this._size=o,u&&(u.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const u=n.next,o=n.previous;if(!u||!o)throw new Error("Invalid list");u.previous=o,o.next=u}n.next=void 0,n.previous=void 0,this._state++}touch(n,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(n===this._head)return;const o=n.next,s=n.previous;n===this._tail?(s.next=void 0,this._tail=s):(o.previous=s,s.next=o),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(u===2){if(n===this._tail)return;const o=n.next,s=n.previous;n===this._head?(o.previous=void 0,this._head=o):(o.previous=s,s.next=o),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((u,o)=>{n.push([o,u])}),n}fromJSON(n){this.clear();for(const[u,o]of n)this.set(u,o)}}e.LinkedMap=f;class l extends f{constructor(n,u=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,u=2){return super.get(n,u)}peek(n){return super.get(n,0)}set(n,u){return super.set(n,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class b{constructor(n){y.set(this,void 0),tt(this,y,n,"f")}get size(){return Me(this,y,"f").size}forEach(n,u){Me(this,y,"f").forEach(n,u)}get(n){return Me(this,y,"f").get(n)}has(n){return Me(this,y,"f").has(n)}entries(){return Me(this,y,"f").entries()}keys(){return Me(this,y,"f").keys()}values(){return Me(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Me(this,y,"f").entries()}}e.ReadonlyMapView=b}),define(we[110],_e([0,1,22,8]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...me){return function(Ce,Pe){for(let $e=0,Ee=me.length;$e<Ee;$e++){const je=me[$e](Ce,Pe);if(je)return je}return null}}e.or=A,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(me,Ce,Pe){if(!Pe||Pe.length<Ce.length)return null;let $e;return me?$e=I.startsWithIgnoreCase(Pe,Ce):$e=Pe.indexOf(Ce)===0,$e?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function y(me,Ce){const Pe=Ce.toLowerCase().indexOf(me.toLowerCase());return Pe===-1?null:[{start:Pe,end:Pe+me.length}]}e.matchesContiguousSubString=y;function D(me,Ce){return S(me.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=D;function S(me,Ce,Pe,$e){if(Pe===me.length)return[];if($e===Ce.length)return null;if(me[Pe]===Ce[$e]){let Ee=null;return(Ee=S(me,Ce,Pe+1,$e+1))?m({start:$e,end:$e+1},Ee):null}return S(me,Ce,Pe,$e+1)}function C(me){return 97<=me&&me<=122}function i(me){return 65<=me&&me<=90}e.isUpper=i;function P(me){return 48<=me&&me<=57}function d(me){return me===32||me===9||me===10||me===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(me=>h.add(me.charCodeAt(0)));function r(me){return d(me)||h.has(me)}function a(me,Ce){return me===Ce||r(me)&&r(Ce)}function p(me){return C(me)||i(me)||P(me)}function m(me,Ce){return Ce.length===0?Ce=[me]:me.end===Ce[0].start?Ce[0].start=me.start:Ce.unshift(me),Ce}function E(me,Ce){for(let Pe=Ce;Pe<me.length;Pe++){const $e=me.charCodeAt(Pe);if(i($e)||P($e)||Pe>0&&!p(me.charCodeAt(Pe-1)))return Pe}return me.length}function f(me,Ce,Pe,$e){if(Pe===me.length)return[];if($e===Ce.length)return null;if(me[Pe]!==Ce[$e].toLowerCase())return null;{let Ee=null,je=$e+1;for(Ee=f(me,Ce,Pe+1,$e+1);!Ee&&(je=E(Ce,je))<Ce.length;)Ee=f(me,Ce,Pe+1,je),je++;return Ee===null?null:m({start:$e,end:$e+1},Ee)}}function l(me){let Ce=0,Pe=0,$e=0,Ee=0,je=0;for(let He=0;He<me.length;He++)je=me.charCodeAt(He),i(je)&&Ce++,C(je)&&Pe++,p(je)&&$e++,P(je)&&Ee++;const z=Ce/me.length,ee=Pe/me.length,ve=$e/me.length,Le=Ee/me.length;return{upperPercent:z,lowerPercent:ee,alphaPercent:ve,numericPercent:Le}}function b(me){const{upperPercent:Ce,lowerPercent:Pe}=me;return Pe===0&&Ce>.6}function t(me){const{upperPercent:Ce,lowerPercent:Pe,alphaPercent:$e,numericPercent:Ee}=me;return Pe>.2&&Ce<.8&&$e>.6&&Ee<.2}function n(me){let Ce=0,Pe=0,$e=0,Ee=0;for(let je=0;je<me.length;je++)$e=me.charCodeAt(je),i($e)&&Ce++,C($e)&&Pe++,d($e)&&Ee++;return(Ce===0||Pe===0)&&Ee===0?me.length<=30:Ce<=5}function u(me,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!n(me)||Ce.length>60)return null;const Pe=l(Ce);if(!t(Pe)){if(!b(Pe))return null;Ce=Ce.toLowerCase()}let $e=null,Ee=0;for(me=me.toLowerCase();Ee<Ce.length&&($e=f(me,Ce,0,Ee))===null;)Ee=E(Ce,Ee+1);return $e}e.matchesCamelCase=u;function o(me,Ce,Pe=!1){if(!Ce||Ce.length===0)return null;let $e=null,Ee=0;for(me=me.toLowerCase(),Ce=Ce.toLowerCase();Ee<Ce.length&&($e=s(me,Ce,0,Ee,Pe))===null;)Ee=c(Ce,Ee+1);return $e}e.matchesWords=o;function s(me,Ce,Pe,$e,Ee){if(Pe===me.length)return[];if($e===Ce.length)return null;if(a(me.charCodeAt(Pe),Ce.charCodeAt($e))){let je=null,z=$e+1;if(je=s(me,Ce,Pe+1,$e+1,Ee),!Ee)for(;!je&&(z=c(Ce,z))<Ce.length;)je=s(me,Ce,Pe+1,z,Ee),z++;return je===null?null:m({start:$e,end:$e+1},je)}else return null}function c(me,Ce){for(let Pe=Ce;Pe<me.length;Pe++)if(r(me.charCodeAt(Pe))||Pe>0&&r(me.charCodeAt(Pe-1)))return Pe;return me.length}const v=A(e.matchesPrefix,u,y),k=A(e.matchesPrefix,u,D),g=new w.LRUCache(1e4);function _(me,Ce,Pe=!1){if(typeof me!="string"||typeof Ce!="string")return null;let $e=g.get(me);$e||($e=new RegExp(I.convertSimple2RegExpPattern(me),"i"),g.set(me,$e));const Ee=$e.exec(Ce);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:Pe?k(me,Ce):v(me,Ce)}e.matchesFuzzy=_;function R(me,Ce){const Pe=x(me,me.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Pe?Q(Pe):null}e.matchesFuzzy2=R;function B(me,Ce,Pe,$e,Ee,je){const z=Math.min(13,me.length);for(;Pe<z;Pe++){const ee=x(me,Ce,Pe,$e,Ee,je,!1);if(ee)return ee}return[0,je]}e.anyScore=B;function Q(me){if(typeof me=="undefined")return[];const Ce=[],Pe=me[1];for(let $e=me.length-1;$e>1;$e--){const Ee=me[$e]+Pe,je=Ce[Ce.length-1];je&&je.end===Ee?je.end=Ee+1:Ce.push({start:Ee,end:Ee+1})}return Ce}e.createMatches=Q;const ge=128;function V(){const me=[],Ce=[];for(let Pe=0;Pe<=ge;Pe++)Ce[Pe]=0;for(let Pe=0;Pe<=ge;Pe++)me.push(Ce.slice(0));return me}function H(me){const Ce=[];for(let Pe=0;Pe<=me;Pe++)Ce[Pe]=0;return Ce}const te=H(2*ge),$=H(2*ge),F=V(),L=V(),M=V(),U=!1;function G(me,Ce,Pe,$e,Ee){function je(ee,ve,Le=" "){for(;ee.length<ve;)ee=Le+ee;return ee}let z=` |   |${$e.split("").map(ee=>je(ee,3)).join("|")}
`;for(let ee=0;ee<=Pe;ee++)ee===0?z+=" |":z+=`${Ce[ee-1]}|`,z+=me[ee].slice(0,Ee+1).map(ve=>je(ve.toString(),3)).join("|")+`
`;return z}function J(me,Ce,Pe,$e){me=me.substr(Ce),Pe=Pe.substr($e),console.log(G(L,me,me.length,Pe,Pe.length)),console.log(G(M,me,me.length,Pe,Pe.length)),console.log(G(F,me,me.length,Pe,Pe.length))}function re(me,Ce){if(Ce<0||Ce>=me.length)return!1;const Pe=me.codePointAt(Ce);switch(Pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Pe)}}function pe(me,Ce){if(Ce<0||Ce>=me.length)return!1;switch(me.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Te(me,Ce,Pe){return Ce[me]!==Pe[me]}function Be(me,Ce,Pe,$e,Ee,je,z=!1){for(;Ce<Pe&&Ee<je;)me[Ce]===$e[Ee]&&(z&&(te[Ce]=Ee),Ce+=1),Ee+=1;return Ce===Pe}e.isPatternInWord=Be;var Ae;(function(me){me[me.Diag=1]="Diag",me[me.Left=2]="Left",me[me.LeftLeft=3]="LeftLeft"})(Ae||(Ae={}));var We;(function(me){me.Default=[-100,0];function Ce(Pe){return!Pe||Pe.length===2&&Pe[0]===-100&&Pe[1]===0}me.isDefault=Ce})(We=e.FuzzyScore||(e.FuzzyScore={}));function x(me,Ce,Pe,$e,Ee,je,z){const ee=me.length>ge?ge:me.length,ve=$e.length>ge?ge:$e.length;if(!(Pe>=ee||je>=ve||ee-Pe>ve-je)&&!!Be(Ce,Pe,ee,Ee,je,ve,!0)){q(ee,ve,Pe,je,Ce,Ee);let Le=1,He=1,Ue=Pe,Xe=je;const W=[!1];for(Le=1,Ue=Pe;Ue<ee;Le++,Ue++){const ae=te[Ue],he=$[Ue],ye=Ue+1<ee?$[Ue+1]:ve;for(He=ae-je+1,Xe=ae;Xe<ye;He++,Xe++){let ze=Number.MIN_SAFE_INTEGER,xe=!1;Xe<=he&&(ze=ne(me,Ce,Ue,Pe,$e,Ee,Xe,ve,je,F[Le-1][He-1]===0,W));let Ne=0;ze!==Number.MAX_SAFE_INTEGER&&(xe=!0,Ne=ze+L[Le-1][He-1]);const Ge=Xe>ae,nt=Ge?L[Le][He-1]+(F[Le][He-1]>0?-5:0):0,dt=Xe>ae+1&&F[Le][He-1]>0,it=dt?L[Le][He-2]+(F[Le][He-2]>0?-5:0):0;if(dt&&(!Ge||it>=nt)&&(!xe||it>=Ne))L[Le][He]=it,M[Le][He]=3,F[Le][He]=0;else if(Ge&&(!xe||nt>=Ne))L[Le][He]=nt,M[Le][He]=2,F[Le][He]=0;else if(xe)L[Le][He]=Ne,M[Le][He]=1,F[Le][He]=F[Le-1][He-1]+1;else throw new Error("not possible")}}if(U&&J(me,Pe,$e,je),!(!W[0]&&!z)){Le--,He--;const ie=[L[Le][He],je];let ce=0,j=0;for(;Le>=1;){let ae=He;do{const he=M[Le][ae];if(he===3)ae=ae-2;else if(he===2)ae=ae-1;else break}while(ae>=1);ce>1&&Ce[Pe+Le-1]===Ee[je+He-1]&&!Te(ae+je-1,$e,Ee)&&ce+1>F[Le][ae]&&(ae=He),ae===He?ce++:ce=1,j||(j=ae),Le--,He=ae-1,ie.push(He)}ve===ee&&(ie[0]+=2);const X=j-ee;return ie[0]-=X,ie}}}e.fuzzyScore=x;function q(me,Ce,Pe,$e,Ee,je){let z=me-1,ee=Ce-1;for(;z>=Pe&&ee>=$e;)Ee[z]===je[ee]&&($[z]=ee,z--),ee--}function ne(me,Ce,Pe,$e,Ee,je,z,ee,ve,Le,He){if(Ce[Pe]!==je[z])return Number.MIN_SAFE_INTEGER;let Ue=1,Xe=!1;return z===Pe-$e?Ue=me[Pe]===Ee[z]?7:5:Te(z,Ee,je)&&(z===0||!Te(z-1,Ee,je))?(Ue=me[Pe]===Ee[z]?7:5,Xe=!0):re(je,z)&&(z===0||!re(je,z-1))?Ue=5:(re(je,z-1)||pe(je,z-1))&&(Ue=5,Xe=!0),Ue>1&&Pe===$e&&(He[0]=!0),Xe||(Xe=Te(z,Ee,je)||re(je,z-1)||pe(je,z-1)),Pe===$e?z>ve&&(Ue-=Xe?3:5):Le?Ue+=Xe?2:0:Ue+=Xe?0:1,z+1===ee&&(Ue-=Xe?3:5),Ue}function le(me,Ce,Pe,$e,Ee,je,z){return Se(me,Ce,Pe,$e,Ee,je,!0,z)}e.fuzzyScoreGracefulAggressive=le;function fe(me,Ce,Pe,$e,Ee,je,z){return Se(me,Ce,Pe,$e,Ee,je,!1,z)}e.fuzzyScoreGraceful=fe;function Se(me,Ce,Pe,$e,Ee,je,z,ee){let ve=x(me,Ce,Pe,$e,Ee,je,ee);if(ve&&!z)return ve;if(me.length>=3){const Le=Math.min(7,me.length-1);for(let He=Pe+1;He<Le;He++){const Ue=Oe(me,He);if(Ue){const Xe=x(Ue,Ue.toLowerCase(),Pe,$e,Ee,je,ee);Xe&&(Xe[0]-=3,(!ve||Xe[0]>ve[0])&&(ve=Xe))}}}return ve}function Oe(me,Ce){if(!(Ce+1>=me.length)){const Pe=me[Ce],$e=me[Ce+1];if(Pe!==$e)return me.slice(0,Ce)+$e+Pe+me.slice(Ce+2)}}}),define(we[111],_e([0,1,36,110,8]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${T.source}`,"g");function D(a){return a.replace(y,(p,m)=>m?p:`\\${p}`)}e.escapeIcons=D;const S=new RegExp(`\\\\${T.source}`,"g");function C(a){return a.replace(S,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=C;const i=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function P(a){return a.indexOf(e.iconStartMarker)===-1?a:a.replace(i,(p,m,E,f)=>E?p:m||f||"")}e.stripIcons=P;function d(a){const p=a.indexOf(e.iconStartMarker);return p===-1?{text:a}:h(a,p)}e.parseLabelWithIcons=d;function h(a,p){const m=[];let E="";function f(c){if(c){E+=c;for(const v of c)m.push(t)}}let l=-1,b="",t=0,n,u,o=p;const s=a.length;for(f(a.substr(0,p));o<s;)n=a[o],u=a[o+1],n===e.iconStartMarker[0]&&u===e.iconStartMarker[1]?(l=o,f(b),b=e.iconStartMarker,o++):n===")"&&l!==-1?(t+=o-l+1,l=-1,b=""):l!==-1?/^[a-z0-9\-]$/i.test(n)?b+=n:(f(b),l=-1,b=""):f(n),o++;return f(b),{text:E,iconOffsets:m}}function r(a,p,m=!1){const{text:E,iconOffsets:f}=p;if(!f||f.length===0)return(0,I.matchesFuzzy)(a,E,m);const l=(0,A.ltrim)(E," "),b=E.length-l.length,t=(0,I.matchesFuzzy)(a,l,m);if(t)for(const n of t){const u=f[n.start+b]+b;n.start+=u,n.end+=u}return t}e.matchesFuzzyIconAware=r}),define(we[83],_e([0,1,15,111,12]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(a="",p=!1){var m,E;if(this.value=a,typeof this.value!="string")throw(0,A.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1):(this.isTrusted=(m=p.isTrusted)!==null&&m!==void 0?m:void 0,this.supportThemeIcons=(E=p.supportThemeIcons)!==null&&E!==void 0?E:!1)}appendText(a,p=0){return this.value+=P(this.supportThemeIcons?(0,I.escapeIcons)(a):a).replace(/([ \t]+)/g,(m,E)=>"&nbsp;".repeat(E.length)).replace(/^>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,p){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=y;function D(r){return S(r)?!r.value:Array.isArray(r)?r.every(D):!0}e.isEmptyMarkdownString=D;function S(r){return r instanceof y?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=S;function C(r,a){return!r&&!a?!0:!r||!a?!1:Array.isArray(r)&&Array.isArray(a)?(0,w.equals)(r,a,i):S(r)&&S(a)?i(r,a):!1}e.markedStringsEquals=C;function i(r,a){return r===a?!0:!r||!a?!1:r.value===a.value&&r.isTrusted===a.isTrusted&&r.supportThemeIcons===a.supportThemeIcons}function P(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function d(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function h(r){const a=[],p=r.split("|").map(E=>E.trim());r=p[0];const m=p[1];if(m){const E=/height=(\d+)/.exec(m),f=/width=(\d+)/.exec(m),l=E?E[1]:"",b=f?f[1]:"",t=isFinite(parseInt(b)),n=isFinite(parseInt(l));t&&a.push(`width="${b}"`),n&&a.push(`height="${l}"`)}return{href:r,dimensions:a}}e.parseHrefAndDimensions=h}),define(we[57],_e([0,1,24,8,2]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(C){return JSON.stringify(C,D)}e.stringify=T;function y(C){let i=JSON.parse(C);return i=S(i),i}e.parse=y;function D(C,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,I.regExpFlags)(i)}:i}function S(C,i=0){if(!C||i>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return A.URI.revive(C);case 2:return new RegExp(C.source,C.flags)}if(C instanceof w.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let P=0;P<C.length;++P)C[P]=S(C[P],i+1);else for(const P in C)Object.hasOwnProperty.call(C,P)&&(C[P]=S(C[P],i+1))}return C}e.revive=S}),define(we[19],_e([0,1,2,21]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(A=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,C,i){this._hosts[S]=C,this._ports[S]=i}setConnectionToken(S,C){this._connectionTokens[S]=C}rewrite(S){if(this._delegate)return this._delegate(S);const C=S.authority;let i=this._hosts[C];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const P=this._ports[C],d=this._connectionTokens[C];let h=`path=${encodeURIComponent(S.path)}`;return typeof d=="string"&&(h+=`&tkn=${encodeURIComponent(d)}`),w.URI.from({scheme:I.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${i}:${P}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new T;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,C,i){const P=this.toUri(S,C);return P.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(P):I.isNative&&(i||I.isPreferringBrowserCodeLoad)&&P.scheme===A.file?P.with({scheme:A.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(S,C){const i=this.toUri(S,C);return i.scheme===A.vscodeFileResource?i.with({scheme:A.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(S,C){return w.URI.isUri(S)?S:w.URI.parse(C.toUrl(S))}}e.FileAccess=new y}),define(we[25],_e([0,1,37,13,2,8,19,21]),function(Y,e,w,I,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(h){return(0,A.uriToFsPath)(h,!0)}e.originalFSPath=S;class C{constructor(r){this._ignorePathCasing=r}compare(r,a,p=!1){return r===a?0:(0,T.compare)(this.getComparisonKey(r,p),this.getComparisonKey(a,p))}isEqual(r,a,p=!1){return r===a?!0:!r||!a?!1:this.getComparisonKey(r,p)===this.getComparisonKey(a,p)}getComparisonKey(r,a=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,a,p=!1){if(r.scheme===a.scheme){if(r.scheme===y.Schemas.file)return w.isEqualOrParent(S(r),S(a),this._ignorePathCasing(r))&&r.query===a.query&&(p||r.fragment===a.fragment);if((0,e.isEqualAuthority)(r.authority,a.authority))return w.isEqualOrParent(r.path,a.path,this._ignorePathCasing(r),"/")&&r.query===a.query&&(p||r.fragment===a.fragment)}return!1}joinPath(r,...a){return A.URI.joinPath(r,...a)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return I.posix.basename(r.path)}extname(r){return I.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let a;return r.scheme===y.Schemas.file?a=A.URI.file(I.dirname(S(r))).path:(a=I.posix.dirname(r.path),r.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),a="/")),r.with({path:a})}normalizePath(r){if(!r.path.length)return r;let a;return r.scheme===y.Schemas.file?a=A.URI.file(I.normalize(S(r))).path:a=I.posix.normalize(r.path),r.with({path:a})}relativePath(r,a){if(!(r.scheme!==a.scheme||!(0,e.isEqualAuthority)(r.authority,a.authority))){if(r.scheme===y.Schemas.file){const E=I.relative(S(r),S(a));return D.isWindows?w.toSlashes(E):E}let p=r.path||"/",m=a.path||"/";if(this._ignorePathCasing(r)){let E=0;for(const f=Math.min(p.length,m.length);E<f&&!(p.charCodeAt(E)!==m.charCodeAt(E)&&p.charAt(E).toLowerCase()!==m.charAt(E).toLowerCase());E++);p=m.substr(0,E)+p.substr(E)}return I.posix.relative(p,m)}}resolvePath(r,a){if(r.scheme===y.Schemas.file){const p=A.URI.file(I.resolve(S(r),a));return r.with({authority:p.authority,path:p.path})}return a.indexOf("/")===-1&&(a=w.toSlashes(a),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a)),r.with({path:I.posix.resolve(r.path,a)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,a){return r===a||(0,T.equalsIgnoreCase)(r,a)}hasTrailingPathSeparator(r,a=I.sep){if(r.scheme===y.Schemas.file){const p=S(r);return p.length>w.getRoot(p).length&&p[p.length-1]===a}else{const p=r.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,a=I.sep){return(0,e.hasTrailingPathSeparator)(r,a)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,a=I.sep){let p=!1;if(r.scheme===y.Schemas.file){const m=S(r);p=m!==void 0&&m.length===w.getRoot(m).length&&m[m.length-1]===a}else{a="/";const m=r.path;p=m.length===1&&m.charCodeAt(m.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(r,a)?r.with({path:r.path+"/"}):r}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(h=>h.scheme===y.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new C(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(h,r){const a=[];for(let p=0;p<h.length;p++){const m=r(h[p]);h.some((E,f)=>f===p?!1:(0,e.isEqualOrParent)(m,r(E)))||a.push(h[p])}return a}e.distinctParents=i;var P;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function r(a){const p=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(f=>{const[l,b]=f.split(":");l&&b&&p.set(l,b)});const E=a.path.substring(0,a.path.indexOf(";"));return E&&p.set(h.META_DATA_MIME,E),p}h.parseMetaData=r})(P=e.DataUri||(e.DataUri={}));function d(h,r,a){if(r){let p=h.path;return p&&p[0]!==I.posix.sep&&(p=I.posix.sep+p),h.with({scheme:a,authority:r,path:p})}return h.with({scheme:a})}e.toLocalResource=d}),define(we[11],_e([0,1,20,12,3,6,45,25]),function(Y,e,w,I,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(L){return!!L&&typeof L.then=="function"}e.isThenable=S;function C(L){const M=new w.CancellationTokenSource,U=L(M.token),G=new Promise((J,re)=>{M.token.onCancellationRequested(()=>{re((0,I.canceled)())}),Promise.resolve(U).then(pe=>{M.dispose(),J(pe)},pe=>{M.dispose(),re(pe)})});return new class{cancel(){M.cancel()}then(J,re){return G.then(J,re)}catch(J){return this.then(void 0,J)}finally(J){return G.finally(J)}}}e.createCancelablePromise=C;function i(L,M,U){return Promise.race([L,new Promise(G=>M.onCancellationRequested(()=>G(U)))])}e.raceCancellation=i;async function P(L){let M=-1;const U=L.map((J,re)=>J.then(pe=>(M=re,pe))),G=await Promise.race(U);return L.forEach((J,re)=>{re!==M&&J.cancel()}),G}e.raceCancellablePromises=P;function d(L,M,U){let G;const J=setTimeout(()=>{G==null||G(void 0),U==null||U()},M);return Promise.race([L.finally(()=>clearTimeout(J)),new Promise(re=>G=re)])}e.raceTimeout=d;function h(L){return new Promise((M,U)=>{const G=L();S(G)?G.then(M,U):M(G)})}e.asPromise=h;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(U,U).then(G)})}return new Promise((U,G)=>{this.queuedPromise.then(U,G)})}return this.activePromise=M(),new Promise((U,G)=>{this.activePromise.then(J=>{this.activePromise=null,U(J)},J=>{this.activePromise=null,G(J)})})}}e.Throttler=r;class a{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=a;class p{constructor(){this.promiseMap=new Map}queue(M,U){var G;const re=((G=this.promiseMap.get(M))!==null&&G!==void 0?G:Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(M)===re&&this.promiseMap.delete(M)});return this.promiseMap.set(M,re),re}}e.SequencerByKey=p;class m{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,U=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,J)=>{this.doResolve=G,this.doReject=J}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class E{constructor(M){this.delayer=new m(M),this.throttler=new r}trigger(M,U){return this.delayer.trigger(()=>this.throttler.queue(M),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class f{constructor(){this._isOpen=!1,this._promise=new Promise((M,U)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;class l extends f{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function b(L,M){return M?new Promise((U,G)=>{const J=setTimeout(U,L);M.onCancellationRequested(()=>{clearTimeout(J),G((0,I.canceled)())})}):C(U=>b(L,U))}e.timeout=b;function t(L,M=0){const U=setTimeout(L,M);return(0,T.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=t;function n(L){return L.then(void 0,M=>{})}e.ignoreErrors=n;function u(L){const M=[];let U=0;const G=L.length;function J(){return U<G?L[U++]():null}function re(pe){pe!=null&&M.push(pe);const Te=J();return Te?Te.then(re):Promise.resolve(M)}return Promise.resolve(null).then(re)}e.sequence=u;function o(L,M=G=>!!G,U=null){let G=0;const J=L.length,re=()=>{if(G>=J)return Promise.resolve(U);const pe=L[G++];return Promise.resolve(pe()).then(Be=>M(Be)?Promise.resolve(Be):re())};return re()}e.first=o;function s(L,M=G=>!!G,U=null){if(L.length===0)return Promise.resolve(U);let G=L.length;const J=()=>{var re,pe;G=-1;for(const Te of L)(pe=(re=Te).cancel)===null||pe===void 0||pe.call(re)};return new Promise((re,pe)=>{for(const Te of L)Te.then(Be=>{--G>=0&&M(Be)?(J(),re(Be)):G===0&&re(U)}).catch(Be=>{--G>=0&&(J(),pe(Be))})})}e.firstParallel=s;class c{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((U,G)=>{this.outstandingPromises.push({factory:M,c:U,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const U=M.factory();U.then(M.c,M.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class v extends c{constructor(){super(1)}}e.Queue=v;class k{constructor(){this.queues=new Map}queueFor(M,U=D.extUri){const G=U.getComparisonKey(M);let J=this.queues.get(G);return J||(J=new v,A.Event.once(J.onFinished)(()=>{J==null||J.dispose(),this.queues.delete(G)}),this.queues.set(G,J)),J}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=k;class g{constructor(M,U){this._token=-1,typeof M=="function"&&typeof U=="number"&&this.setIfNotSet(M,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},U)}setIfNotSet(M,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},U))}}e.TimeoutTimer=g;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,U){this.cancel(),this._token=setInterval(()=>{M()},U)}}e.IntervalTimer=_;class R{constructor(M,U){this.timeoutToken=-1,this.runner=M,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class B extends R{constructor(M,U){super(M,U);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const L=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const U=setTimeout(()=>M(L));let G=!1;return{dispose(){G||(G=!0,clearTimeout(U))}}}}else e.runWhenIdle=(L,M)=>{const U=requestIdleCallback(L,typeof M=="number"?{timeout:M}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(U))}}}}();class Q{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=Q;async function ge(L,M,U){let G;for(let J=0;J<U;J++)try{return await L()}catch(re){G=re,await b(M)}throw G}e.retry=ge;class V{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,U,G){return this._pending={taskId:M,cancel:()=>G==null?void 0:G(),promise:U},U.then(()=>this.donePending(M),()=>this.donePending(M)),U}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let U,G;const J=new Promise((re,pe)=>{U=re,G=pe});this._next={run:M,promise:J,promiseResolve:U,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=V;class H{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class te{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,U)=>{this.completeCallback=M,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(U=>{this.completeCallback(M),this.resolved=!0,U()})}error(M){return new Promise(U=>{this.errorCallback(M),this.rejected=!0,U()})}cancel(){new Promise(M=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=te;class $ extends A.Emitter{async fireAsync(M,U,G){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const J of this._listeners)this._asyncDeliveryQueue.push([J,M]);for(;this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[J,re]=this._asyncDeliveryQueue.shift(),pe=[],Te=Object.assign(Object.assign({},re),{waitUntil:Be=>{if(Object.isFrozen(pe))throw new Error("waitUntil can NOT be called asynchronous");G&&(Be=G(Be,typeof J=="function"?J:J[0])),pe.push(Be)}});try{typeof J=="function"?J.call(void 0,Te):J[0].call(J[1],Te)}catch(Be){(0,I.onUnexpectedError)(Be);continue}Object.freeze(pe),await F.settled(pe).catch(Be=>(0,I.onUnexpectedError)(Be))}}}}e.AsyncEmitter=$;var F;(function(L){async function M(re){return typeof Promise.allSettled=="function"?U(re):G(re)}L.allSettled=M;async function U(re){return Promise.allSettled(re)}async function G(re){return Promise.all(re.map(pe=>pe.then(Te=>({status:"fulfilled",value:Te}),Te=>({status:"rejected",reason:Te}))))}async function J(re){let pe;const Te=await Promise.all(re.map(Be=>Be.then(Ae=>Ae,Ae=>{pe||(pe=Ae)})));if(typeof pe!="undefined")throw pe;return Te}L.settled=J})(F=e.Promises||(e.Promises={}))}),define(we[112],_e([0,1,13,11]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const A=new I.IdleValue(()=>{const l=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:l,collatorIsNumeric:l.resolvedOptions().numeric}}),T=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(l,b,t=!1){const n=l||"",u=b||"",o=A.value.collator.compare(n,u);return A.value.collatorIsNumeric&&o===0&&n!==u?n<u?-1:1:o}e.compareFileNames=D;function S(l,b){const t=T.value.collator;return l=l||"",b=b||"",a(t,l,b)}e.compareFileNamesDefault=S;function C(l,b,t=!1){t||(l=l&&l.toLowerCase(),b=b&&b.toLowerCase());const[n,u]=h(l),[o,s]=h(b);return n!==o?n<o?-1:1:u===s?0:u<s?-1:1}e.noIntlCompareFileNames=C;function i(l,b){const[t,n]=h(l),[u,o]=h(b);let s=A.value.collator.compare(n,o);if(s===0){if(A.value.collatorIsNumeric&&n!==o)return n<o?-1:1;if(s=A.value.collator.compare(t,u),A.value.collatorIsNumeric&&s===0&&t!==u)return t<u?-1:1}return s}e.compareFileExtensions=i;function P(l,b){l=l||"",b=b||"";const t=r(l),n=r(b),u=T.value.collator,o=y.value.collator;let s;return s=a(o,t,n),s!==0?s:a(u,l,b)}e.compareFileExtensionsDefault=P;const d=/^(.*?)(\.([^.]*))?$/;function h(l,b=!1){const t=l?d.exec(l):[];let n=[t&&t[1]||"",t&&t[3]||""];return b&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function r(l){const b=l?d.exec(l):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function a(l,b,t){let n=l.compare(b,t);return n!==0?n:b.length!==t.length?b.length<t.length?-1:1:0}function p(l,b,t=!1){return t||(l=l&&l.toLowerCase(),b=b&&b.toLowerCase()),l===b?0:l<b?-1:1}function m(l,b,t=!1){const n=l.split(w.sep),u=b.split(w.sep),o=n.length-1,s=u.length-1;let c,v;for(let k=0;;k++){if(c=o===k,v=s===k,c&&v)return D(n[k],u[k],t);if(c)return-1;if(v)return 1;const g=p(n[k],u[k],t);if(g!==0)return g}}e.comparePaths=m;function E(l,b,t){const n=l.toLowerCase(),u=b.toLowerCase(),o=f(l,b,t);if(o)return o;const s=n.endsWith(t),c=u.endsWith(t);if(s!==c)return s?-1:1;const v=D(n,u);return v!==0?v:n.localeCompare(u)}e.compareAnything=E;function f(l,b,t){const n=l.toLowerCase(),u=b.toLowerCase(),o=n.startsWith(t),s=u.startsWith(t);if(o!==s)return o?-1:1;if(o&&s){if(n.length<u.length)return-1;if(n.length>u.length)return 1}return 0}e.compareByPrefix=f}),define(we[28],_e([0,1,8,37,13,22,11]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const S="**",C="/",i="[/\\\\]",P="[^/\\\\]",d=/\//g;function h(U){switch(U){case 0:return"";case 1:return`${P}*?`;default:return`(?:${i}|${P}+${i}|${i}${P}+)*?`}}function r(U,G){if(!U)return[];const J=[];let re=!1,pe=!1,Te="";for(const Be of U){switch(Be){case G:if(!re&&!pe){J.push(Te),Te="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}Te+=Be}return Te&&J.push(Te),J}e.splitGlobAware=r;function a(U){if(!U)return"";let G="";const J=r(U,C);if(J.every(re=>re===S))G=".*";else{let re=!1;J.forEach((pe,Te)=>{if(pe===S){re||(G+=h(2),re=!0);return}let Be=!1,Ae="",We=!1,x="";for(const q of pe){if(q!=="}"&&Be){Ae+=q;continue}if(We&&(q!=="]"||!x)){let ne;q==="-"?ne=q:(q==="^"||q==="!")&&!x?ne="^":q===C?ne="":ne=w.escapeRegExpCharacters(q),x+=ne;continue}switch(q){case"{":Be=!0;continue;case"[":We=!0;continue;case"}":G+=`(?:${r(Ae,",").map(fe=>a(fe)).join("|")})`,Be=!1,Ae="";break;case"]":G+="["+x+"]",We=!1,x="";break;case"?":G+=P;continue;case"*":G+=h(1);continue;default:G+=w.escapeRegExpCharacters(q)}}Te<J.length-1&&(J[Te+1]!==S||Te+2<J.length)&&(G+=i),re=!1})}return G}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},u=function(){return null};function o(U,G){if(!U)return u;let J;typeof U!="string"?J=U.pattern:J=U,J=J.trim();const re=`${J}_${!!G.trimForExclusions}`;let pe=t.get(re);if(pe)return s(pe,U);let Te;if(p.test(J)){const Be=J.substr(4);pe=function(Ae,We){return typeof Ae=="string"&&Ae.endsWith(Be)?J:null}}else(Te=m.exec(c(J,G)))?pe=v(Te[1],J):(G.trimForExclusions?f:E).test(J)?pe=k(J,G):(Te=l.exec(c(J,G)))?pe=g(Te[1].substr(1),J,!0):(Te=b.exec(c(J,G)))?pe=g(Te[1],J,!1):pe=_(J);return t.set(re,pe),s(pe,U)}function s(U,G){return typeof G=="string"?U:function(J,re){return I.isEqualOrParent(J,G.base)?U(A.relative(G.base,J),re):null}}function c(U,G){return G.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function v(U,G){const J=`/${U}`,re=`\\${U}`,pe=function(Be,Ae){return typeof Be!="string"?null:Ae?Ae===U?G:null:Be===U||Be.endsWith(J)||Be.endsWith(re)?G:null},Te=[U];return pe.basenames=Te,pe.patterns=[G],pe.allBasenames=Te,pe}function k(U,G){const J=M(U.slice(1,-1).split(",").map(Ae=>o(Ae,G)).filter(Ae=>Ae!==u),U),re=J.length;if(!re)return u;if(re===1)return J[0];const pe=function(Ae,We){for(let x=0,q=J.length;x<q;x++)if(J[x](Ae,We))return U;return null},Te=J.find(Ae=>!!Ae.allBasenames);Te&&(pe.allBasenames=Te.allBasenames);const Be=J.reduce((Ae,We)=>We.allPaths?Ae.concat(We.allPaths):Ae,[]);return Be.length&&(pe.allPaths=Be),pe}function g(U,G,J){const re=A.sep===A.posix.sep,pe=re?U:U.replace(d,A.sep),Te=A.sep+pe,Be=A.posix.sep+U,Ae=J?function(We,x){return typeof We=="string"&&(We===pe||We.endsWith(Te)||!re&&(We===U||We.endsWith(Be)))?G:null}:function(We,x){return typeof We=="string"&&(We===pe||!re&&We===U)?G:null};return Ae.allPaths=[(J?"*/":"./")+U],Ae}function _(U){try{const G=new RegExp(`^${a(U)}$`);return function(J){return G.lastIndex=0,typeof J=="string"&&G.test(J)?U:null}}catch(G){return u}}function R(U,G,J){return!U||typeof G!="string"?!1:B(U)(G,void 0,J)}e.match=R;function B(U,G={}){if(!U)return n;if(typeof U=="string"||H(U)){const J=o(U,G);if(J===u)return n;const re=function(pe,Te){return!!J(pe,Te)};return J.allBasenames&&(re.allBasenames=J.allBasenames),J.allPaths&&(re.allPaths=J.allPaths),re}return F(U,G)}e.parse=B;function Q(U){if(!!U){let G;return J=>(G||(G=(U()||Promise.resolve([])).then(re=>re?V(re):{})),G.then(re=>!!re[J]))}}e.hasSiblingPromiseFn=Q;function ge(U){if(!!U){let G;return J=>{if(!G){const re=U();G=re?V(re):{}}return!!G[J]}}}e.hasSiblingFn=ge;function V(U){const G={};for(const J of U)G[J]=!0;return G}function H(U){const G=U;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=H;function te(U){return U.allBasenames||[]}e.getBasenameTerms=te;function $(U){return U.allPaths||[]}e.getPathTerms=$;function F(U,G){const J=M(Object.getOwnPropertyNames(U).map(Ae=>L(Ae,U[Ae],G)).filter(Ae=>Ae!==u)),re=J.length;if(!re)return u;if(!J.some(Ae=>!!Ae.requiresSiblings)){if(re===1)return J[0];const Ae=function(q,ne){for(let le=0,fe=J.length;le<fe;le++){const Se=J[le](q,ne);if(Se)return Se}return null},We=J.find(q=>!!q.allBasenames);We&&(Ae.allBasenames=We.allBasenames);const x=J.reduce((q,ne)=>ne.allPaths?q.concat(ne.allPaths):q,[]);return x.length&&(Ae.allPaths=x),Ae}const pe=function(Ae,We,x){let q;for(let ne=0,le=J.length;ne<le;ne++){const fe=J[ne];fe.requiresSiblings&&x&&(We||(We=A.basename(Ae)),q||(q=We.substr(0,We.length-A.extname(Ae).length)));const Se=fe(Ae,We,q,x);if(Se)return Se}return null},Te=J.find(Ae=>!!Ae.allBasenames);Te&&(pe.allBasenames=Te.allBasenames);const Be=J.reduce((Ae,We)=>We.allPaths?Ae.concat(We.allPaths):Ae,[]);return Be.length&&(pe.allPaths=Be),pe}function L(U,G,J){if(G===!1)return u;const re=o(U,J);if(re===u)return u;if(typeof G=="boolean")return re;if(G){const pe=G.when;if(typeof pe=="string"){const Te=(Be,Ae,We,x)=>{if(!x||!re(Be,Ae))return null;const q=pe.replace("$(basename)",We),ne=x(q);return(0,y.isThenable)(ne)?ne.then(le=>le?U:null):ne?U:null};return Te.requiresSiblings=!0,Te}}return re}function M(U,G){const J=U.filter(Ae=>!!Ae.basenames);if(J.length<2)return U;const re=J.reduce((Ae,We)=>{const x=We.basenames;return x?Ae.concat(x):Ae},[]);let pe;if(G){pe=[];for(let Ae=0,We=re.length;Ae<We;Ae++)pe.push(G)}else pe=J.reduce((Ae,We)=>{const x=We.patterns;return x?Ae.concat(x):Ae},[]);const Te=function(Ae,We){if(typeof Ae!="string")return null;if(!We){let q;for(q=Ae.length;q>0;q--){const ne=Ae.charCodeAt(q-1);if(ne===47||ne===92)break}We=Ae.substr(q)}const x=re.indexOf(We);return x!==-1?pe[x]:null};Te.basenames=re,Te.patterns=pe,Te.allBasenames=re;const Be=U.filter(Ae=>!Ae.basenames);return Be.push(Te),Be}}),define(we[58],_e([0,1,2,13,8,19,21,25,37]),function(Y,e,w,I,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(o,s,c){if(typeof o=="string"&&(o=w.URI.file(o)),c){const k=c.getWorkspaceFolder(o);if(k){const g=c.getWorkspace().folders.length>1;let _;if((0,D.isEqual)(k.uri,o)?_="":_=(0,D.relativePath)(k.uri,o),g){const R=k.name?k.name:(0,D.basename)(k.uri);_=_?R+" \u2022 "+_:R}return _}}if(o.scheme!==T.Schemas.file&&o.scheme!==T.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,S.hasDriveLetter)(o.fsPath))return(0,I.normalize)(P(o.fsPath));let v=(0,I.normalize)(o.fsPath);return!y.isWindows&&(s==null?void 0:s.userHome)&&(v=h(v,s.userHome.fsPath)),v}e.getPathLabel=C;function i(o){if(!!o){typeof o=="string"&&(o=w.URI.file(o));const s=(0,D.basename)(o)||(o.scheme===T.Schemas.file?o.fsPath:o.path);return y.isWindows&&(0,S.isRootOrDriveLetter)(s)?P(s):s}}e.getBaseLabel=i;function P(o){return(0,S.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=P;let d=Object.create(null);function h(o,s){if(y.isWindows||!o||!s)return o;let c=d.original===s?d.normalized:void 0;return c||(c=`${(0,A.rtrim)(s,I.posix.sep)}${I.posix.sep}`,d={original:s,normalized:c}),(y.isLinux?o.startsWith(c):(0,A.startsWithIgnoreCase)(o,c))&&(o=`~/${o.substr(c.length)}`),o}e.tildify=h;function r(o,s){return o.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=r;const a="\u2026",p="\\\\",m="~";function E(o,s=I.sep){const c=new Array(o.length);let v=!1;for(let k=0;k<o.length;k++){let g=o[k];if(g===""){c[k]=`.${s}`;continue}if(!g){c[k]=g;continue}v=!0;let _="";g.indexOf(p)===0?(_=g.substr(0,g.indexOf(p)+p.length),g=g.substr(g.indexOf(p)+p.length)):g.indexOf(s)===0?(_=g.substr(0,g.indexOf(s)+s.length),g=g.substr(g.indexOf(s)+s.length)):g.indexOf(m)===0&&(_=g.substr(0,g.indexOf(m)+m.length),g=g.substr(g.indexOf(m)+m.length));const R=g.split(s);for(let B=1;v&&B<=R.length;B++)for(let Q=R.length-B;v&&Q>=0;Q--){v=!1;let ge=R.slice(Q,Q+B).join(s);for(let V=0;!v&&V<o.length;V++)if(V!==k&&o[V]&&o[V].indexOf(ge)>-1){const H=Q+B===R.length,te=Q>0&&o[V].indexOf(s)>-1?s+ge:ge,$=o[V].endsWith(te);v=!H||$}if(!v){let V="";(R[0].endsWith(":")||_!=="")&&(Q===1&&(Q=0,B++,ge=R[0]+s+ge),Q>0&&(V=R[0]+s),V=_+V),Q>0&&(V=V+a+s),V=V+ge,Q+B<R.length&&(V=V+s+a),c[k]=V}}v&&(c[k]=g)}return c}e.shorten=E;var f;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function l(o,s=Object.create(null)){const c=[];let v=!1,k="";for(const g of o)if(g==="$"||v&&g==="{")k&&c.push({value:k,type:f.TEXT}),k="",v=!0;else if(g==="}"&&v){const _=s[k];if(typeof _=="string")_.length&&c.push({value:_,type:f.VARIABLE});else if(_){const R=c[c.length-1];(!R||R.type!==f.SEPARATOR)&&c.push({value:_.label,type:f.SEPARATOR})}k="",v=!1}else k+=g;return k&&!v&&c.push({value:k,type:f.TEXT}),c.filter((g,_)=>{if(g.type===f.SEPARATOR){const R=c[_-1],B=c[_+1];return[R,B].every(Q=>Q&&(Q.type===f.VARIABLE||Q.type===f.TEXT)&&Q.value.length>0)}return!0}).map(g=>g.value).join("")}e.template=l;function b(o,s){return y.isMacintosh||s?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):o.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=b;function t(o,s){return y.isMacintosh||s?o.replace(/\(&&\w\)|&&/g,""):y.isWindows?o.replace(/&&|&/g,c=>c==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=n;function u(o){const s=o.indexOf("/")!==-1?I.posix:I.win32,c=s.basename(o),v=s.dirname(o);return c.length?{name:c,parentPath:v}:{name:v,parentPath:""}}e.splitName=u}),define(we[113],_e([0,1,2]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(i){return i.toJSON()}class A{constructor(P){this._uriTransformer=P}transformIncoming(P){const d=this._uriTransformer.transformIncoming(P);return d===P?P:I(w.URI.from(d))}transformOutgoing(P){const d=this._uriTransformer.transformOutgoing(P);return d===P?P:I(w.URI.from(d))}transformOutgoingURI(P){const d=this._uriTransformer.transformOutgoing(P);return d===P?P:w.URI.from(d)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,P,d){if(!i||d>200)return null;if(typeof i=="object"){if(i instanceof w.URI)return P.transformOutgoing(i);for(let h in i)if(Object.hasOwnProperty.call(i,h)){const r=T(i[h],P,d+1);r!==null&&(i[h]=r)}}return null}function y(i,P){const d=T(i,P,0);return d===null?i:d}e.transformOutgoingURIs=y;function D(i,P,d,h){if(!i||h>200)return null;if(typeof i=="object"){if(i.$mid===1)return d?w.URI.revive(P.transformIncoming(i)):P.transformIncoming(i);for(let r in i)if(Object.hasOwnProperty.call(i,r)){const a=D(i[r],P,d,h+1);a!==null&&(i[r]=a)}}return null}function S(i,P){const d=D(i,P,!1,0);return d===null?i:d}e.transformIncomingURIs=S;function C(i,P){const d=D(i,P,!0,0);return d===null?i:d}e.transformAndReviveIncomingURIs=C}),define(we[31],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(S){return w.test(S)}e.isUUID=I;const A=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(S){for(let C=0;C<S.length;C++)S[C]=Math.floor(Math.random()*256);return S};function D(){y(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,C="";return C+=T[A[S++]],C+=T[A[S++]],C+=T[A[S++]],C+=T[A[S++]],C+="-",C+=T[A[S++]],C+=T[A[S++]],C+="-",C+=T[A[S++]],C+=T[A[S++]],C+="-",C+=T[A[S++]],C+=T[A[S++]],C+="-",C+=T[A[S++]],C+=T[A[S++]],C+=T[A[S++]],C+=T[A[S++]],C+=T[A[S++]],C+=T[A[S++]],C}e.generateUuid=D}),define(we[84],_e([0,1,82]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(D){let S=(0,w.toUint8)(D);this._defaultValue=S,this._asciiMap=I._createAsciiMap(S),this._map=new Map}static _createAsciiMap(D){let S=new Uint8Array(256);for(let C=0;C<256;C++)S[C]=D;return S}set(D,S){let C=(0,w.toUint8)(S);D>=0&&D<256?this._asciiMap[D]=C:this._map.set(D,C)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=I;var A;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(A||(A={}));class T{constructor(){this._actual=new I(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=T}),define(we[114],_e([0,1,84]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class A extends w.CharacterClassifier{constructor(D){super(0);for(let S=0,C=D.length;S<C;S++)this.set(D.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=A;function T(y){let D={};return S=>(D.hasOwnProperty(S)||(D[S]=y(S)),D[S])}e.getMapForWordSeparators=T(y=>new A(y))}),define(we[38],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class w{constructor(A,T){this.lineNumber=A,this.column=T}with(A=this.lineNumber,T=this.column){return A===this.lineNumber&&T===this.column?this:new w(A,T)}delta(A=0,T=0){return this.with(this.lineNumber+A,this.column+T)}equals(A){return w.equals(this,A)}static equals(A,T){return!A&&!T?!0:!!A&&!!T&&A.lineNumber===T.lineNumber&&A.column===T.column}isBefore(A){return w.isBefore(this,A)}static isBefore(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<T.column}isBeforeOrEqual(A){return w.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<=T.column}static compare(A,T){let y=A.lineNumber|0,D=T.lineNumber|0;if(y===D){let S=A.column|0,C=T.column|0;return S-C}return y-D}clone(){return new w(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new w(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}e.Position=w}),define(we[32],_e([0,1,38]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(T,y,D,S){T>D||T===D&&y>S?(this.startLineNumber=D,this.startColumn=S,this.endLineNumber=T,this.endColumn=y):(this.startLineNumber=T,this.startColumn=y,this.endLineNumber=D,this.endColumn=S)}isEmpty(){return I.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return I.containsPosition(this,T)}static containsPosition(T,y){return!(y.lineNumber<T.startLineNumber||y.lineNumber>T.endLineNumber||y.lineNumber===T.startLineNumber&&y.column<T.startColumn||y.lineNumber===T.endLineNumber&&y.column>T.endColumn)}containsRange(T){return I.containsRange(this,T)}static containsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>T.endColumn)}strictContainsRange(T){return I.strictContainsRange(this,T)}static strictContainsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<=T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>=T.endColumn)}plusRange(T){return I.plusRange(this,T)}static plusRange(T,y){let D,S,C,i;return y.startLineNumber<T.startLineNumber?(D=y.startLineNumber,S=y.startColumn):y.startLineNumber===T.startLineNumber?(D=y.startLineNumber,S=Math.min(y.startColumn,T.startColumn)):(D=T.startLineNumber,S=T.startColumn),y.endLineNumber>T.endLineNumber?(C=y.endLineNumber,i=y.endColumn):y.endLineNumber===T.endLineNumber?(C=y.endLineNumber,i=Math.max(y.endColumn,T.endColumn)):(C=T.endLineNumber,i=T.endColumn),new I(D,S,C,i)}intersectRanges(T){return I.intersectRanges(this,T)}static intersectRanges(T,y){let D=T.startLineNumber,S=T.startColumn,C=T.endLineNumber,i=T.endColumn,P=y.startLineNumber,d=y.startColumn,h=y.endLineNumber,r=y.endColumn;return D<P?(D=P,S=d):D===P&&(S=Math.max(S,d)),C>h?(C=h,i=r):C===h&&(i=Math.min(i,r)),D>C||D===C&&S>i?null:new I(D,S,C,i)}equalsRange(T){return I.equalsRange(this,T)}static equalsRange(T,y){return!!T&&!!y&&T.startLineNumber===y.startLineNumber&&T.startColumn===y.startColumn&&T.endLineNumber===y.endLineNumber&&T.endColumn===y.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(T){return new w.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(T){return new w.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,y){return new I(this.startLineNumber,this.startColumn,T,y)}setStartPosition(T,y){return new I(T,y,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(T){return new I(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,y=T){return new I(T.lineNumber,T.column,y.lineNumber,y.column)}static lift(T){return T?new I(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn)}static areIntersecting(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,y){if(T&&y){const C=T.startLineNumber|0,i=y.startLineNumber|0;if(C===i){const P=T.startColumn|0,d=y.startColumn|0;if(P===d){const h=T.endLineNumber|0,r=y.endLineNumber|0;if(h===r){const a=T.endColumn|0,p=y.endColumn|0;return a-p}return h-r}return P-d}return C-i}return(T?1:0)-(y?1:0)}static compareRangesUsingEnds(T,y){return T.endLineNumber===y.endLineNumber?T.endColumn===y.endColumn?T.startLineNumber===y.startLineNumber?T.startColumn-y.startColumn:T.startLineNumber-y.startLineNumber:T.endColumn-y.endColumn:T.endLineNumber-y.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=I}),define(we[115],_e([0,1,38,32]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var A;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(A=e.SelectionDirection||(e.SelectionDirection={}));class T extends I.Range{constructor(D,S,C,i){super(D,S,C,i);this.selectionStartLineNumber=D,this.selectionStartColumn=S,this.positionLineNumber=C,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return T.selectionsEqual(this,D)}static selectionsEqual(D,S){return D.selectionStartLineNumber===S.selectionStartLineNumber&&D.selectionStartColumn===S.selectionStartColumn&&D.positionLineNumber===S.positionLineNumber&&D.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,S){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,D,S):new T(D,S,this.startLineNumber,this.startColumn)}getPosition(){return new w.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,S){return this.getDirection()===0?new T(D,S,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,D,S)}static fromPositions(D,S=D){return new T(D.lineNumber,D.column,S.lineNumber,S.column)}static liftSelection(D){return new T(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,S){if(D&&!S||!D&&S)return!1;if(!D&&!S)return!0;if(D.length!==S.length)return!1;for(let C=0,i=D.length;C<i;C++)if(!this.selectionsEqual(D[C],S[C]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,S,C,i,P){return P===0?new T(D,S,C,i):new T(C,i,D,S)}}e.Selection=T}),define(we[85],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var w;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(w=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(r){this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace)}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class S{constructor(r,a){this.range=r,this.matches=a}}e.FindMatch=S;var C;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(i=e.ModelConstants||(e.ModelConstants={}));class P{constructor(r,a,p,m,E,f){this.identifier=r,this.range=a,this.text=p,this.forceMoveMarkers=m,this.isAutoWhitespaceEdit=E,this._isTracked=f}}e.ValidAnnotatedEditOperation=P;class d{constructor(r,a,p){this.reverseEdits=r,this.changes=a,this.trimAutoWhitespaceLineNumbers=p}}e.ApplyEditsResult=d}),define(we[116],_e([0,1,8,114,38,32,85]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class S{constructor(f,l,b,t){this.searchString=f,this.isRegex=l,this.matchCase=b,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let f;this.isRegex?f=C(this.searchString):f=this.searchString.indexOf(`
`)>=0;let l=null;try{l=w.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:f,global:!0,unicode:!0})}catch(t){return null}if(!l)return null;let b=!this.isRegex&&!f;return b&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(b=this.matchCase),new i(l,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,b?this.searchString:null)}}e.SearchParams=S;function C(E){if(!E||E.length===0)return!1;for(let f=0,l=E.length;f<l;f++)if(E.charCodeAt(f)===92){if(f++,f>=l)break;const t=E.charCodeAt(f);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class i{constructor(f,l,b){this.regex=f,this.wordSeparators=l,this.simpleSearch=b}}e.SearchData=i;function P(E,f,l){if(!l)return new y.FindMatch(E,null);let b=[];for(let t=0,n=f.length;t<n;t++)b[t]=f[t];return new y.FindMatch(E,b)}e.createFindMatch=P;class d{constructor(f){let l=[],b=0;for(let t=0,n=f.length;t<n;t++)f.charCodeAt(t)===10&&(l[b++]=t);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(f){const l=this._lineFeedsOffsets;let b=0,t=l.length-1;if(t===-1||f<=l[0])return 0;for(;b<t;){const n=b+((t-b)/2>>0);l[n]>=f?t=n-1:l[n+1]>=f?(b=n,t=n):b=n+1}return b+1}}class h{static findMatches(f,l,b,t,n){const u=l.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(f,b,new m(u.wordSeparators,u.regex),t,n):this._doFindMatchesLineByLine(f,b,u,t,n):[]}static _getMultilineMatchRange(f,l,b,t,n,u){let o,s=0;t?(s=t.findLineFeedCountBeforeOffset(n),o=l+n+s):o=l+n;let c;if(t){let _=t.findLineFeedCountBeforeOffset(n+u.length)-s;c=o+u.length+_}else c=o+u.length;const v=f.getPositionAt(o),k=f.getPositionAt(c);return new T.Range(v.lineNumber,v.column,k.lineNumber,k.column)}static _doFindMatchesMultiline(f,l,b,t,n){const u=f.getOffsetAt(l.getStartPosition()),o=f.getValueInRange(l,1),s=f.getEOL()===`\r
`?new d(o):null,c=[];let v=0,k;for(b.reset(0);k=b.next(o);)if(c[v++]=P(this._getMultilineMatchRange(f,u,o,s,k.index,k[0]),k,t),v>=n)return c;return c}static _doFindMatchesLineByLine(f,l,b,t,n){const u=[];let o=0;if(l.startLineNumber===l.endLineNumber){const c=f.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return o=this._findMatchesInLine(b,c,l.startLineNumber,l.startColumn-1,o,u,t,n),u}const s=f.getLineContent(l.startLineNumber).substring(l.startColumn-1);o=this._findMatchesInLine(b,s,l.startLineNumber,l.startColumn-1,o,u,t,n);for(let c=l.startLineNumber+1;c<l.endLineNumber&&o<n;c++)o=this._findMatchesInLine(b,f.getLineContent(c),c,0,o,u,t,n);if(o<n){const c=f.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);o=this._findMatchesInLine(b,c,l.endLineNumber,0,o,u,t,n)}return u}static _findMatchesInLine(f,l,b,t,n,u,o,s){const c=f.wordSeparators;if(!o&&f.simpleSearch){const g=f.simpleSearch,_=g.length,R=l.length;let B=-_;for(;(B=l.indexOf(g,B+_))!==-1;)if((!c||p(c,l,R,B,_))&&(u[n++]=new y.FindMatch(new T.Range(b,B+1+t,b,B+1+_+t),null),n>=s))return n;return n}const v=new m(f.wordSeparators,f.regex);let k;v.reset(0);do if(k=v.next(l),k&&(u[n++]=P(new T.Range(b,k.index+1+t,b,k.index+1+k[0].length+t),k,o),n>=s))return n;while(k);return n}static findNextMatch(f,l,b,t){const n=l.parseSearchRequest();if(!n)return null;const u=new m(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(f,b,u,t):this._doFindNextMatchLineByLine(f,b,u,t)}static _doFindNextMatchMultiline(f,l,b,t){const n=new A.Position(l.lineNumber,1),u=f.getOffsetAt(n),o=f.getLineCount(),s=f.getValueInRange(new T.Range(n.lineNumber,n.column,o,f.getLineMaxColumn(o)),1),c=f.getEOL()===`\r
`?new d(s):null;b.reset(l.column-1);let v=b.next(s);return v?P(this._getMultilineMatchRange(f,u,s,c,v.index,v[0]),v,t):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(f,new A.Position(1,1),b,t):null}static _doFindNextMatchLineByLine(f,l,b,t){const n=f.getLineCount(),u=l.lineNumber,o=f.getLineContent(u),s=this._findFirstMatchInLine(b,o,u,l.column,t);if(s)return s;for(let c=1;c<=n;c++){const v=(u+c-1)%n,k=f.getLineContent(v+1),g=this._findFirstMatchInLine(b,k,v+1,1,t);if(g)return g}return null}static _findFirstMatchInLine(f,l,b,t,n){f.reset(t-1);const u=f.next(l);return u?P(new T.Range(b,u.index+1,b,u.index+1+u[0].length),u,n):null}static findPreviousMatch(f,l,b,t){const n=l.parseSearchRequest();if(!n)return null;const u=new m(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(f,b,u,t):this._doFindPreviousMatchLineByLine(f,b,u,t)}static _doFindPreviousMatchMultiline(f,l,b,t){const n=this._doFindMatchesMultiline(f,new T.Range(1,1,l.lineNumber,l.column),b,t,10*D);if(n.length>0)return n[n.length-1];const u=f.getLineCount();return l.lineNumber!==u||l.column!==f.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(f,new A.Position(u,f.getLineMaxColumn(u)),b,t):null}static _doFindPreviousMatchLineByLine(f,l,b,t){const n=f.getLineCount(),u=l.lineNumber,o=f.getLineContent(u).substring(0,l.column-1),s=this._findLastMatchInLine(b,o,u,t);if(s)return s;for(let c=1;c<=n;c++){const v=(n+u-c-1)%n,k=f.getLineContent(v+1),g=this._findLastMatchInLine(b,k,v+1,t);if(g)return g}return null}static _findLastMatchInLine(f,l,b,t){let n=null,u;for(f.reset(0);u=f.next(l);)n=P(new T.Range(b,u.index+1,b,u.index+1+u[0].length),u,t);return n}}e.TextModelSearch=h;function r(E,f,l,b,t){if(b===0)return!0;const n=f.charCodeAt(b-1);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const u=f.charCodeAt(b);if(E.get(u)!==0)return!0}return!1}function a(E,f,l,b,t){if(b+t===l)return!0;const n=f.charCodeAt(b+t);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const u=f.charCodeAt(b+t-1);if(E.get(u)!==0)return!0}return!1}function p(E,f,l,b,t){return r(E,f,l,b,t)&&a(E,f,l,b,t)}e.isValidMatch=p;class m{constructor(f,l){this._wordSeparators=f,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(f){this._searchRegex.lastIndex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(f){const l=f.length;let b;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(b=this._searchRegex.exec(f),!b))return null;const t=b.index,n=b[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){w.getNextCodePoint(f,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||p(this._wordSeparators,f,l,t,n))return b}while(b);return null}}e.Searcher=m}),define(we[86],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function w(D=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)D.indexOf(C)>=0||(S+="\\"+C);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=w();function I(D){let S=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)S=D;else{let C="g";D.ignoreCase&&(C+="i"),D.multiline&&(C+="m"),D.unicode&&(C+="u"),S=new RegExp(D.source,C)}return S.lastIndex=0,S}e.ensureValidWordDefinition=I;const A={maxLen:1e3,windowSize:15,timeBudget:150};function T(D,S,C,i,P=A){if(C.length>P.maxLen){let p=D-P.maxLen/2;return p<0?p=0:i+=p,C=C.substring(p,D+P.maxLen/2),T(D,S,C,i,P)}const d=Date.now(),h=D-1-i;let r=-1,a=null;for(let p=1;!(Date.now()-d>=P.timeBudget);p++){const m=h-P.windowSize*p;S.lastIndex=Math.max(0,m);const E=y(S,C,h,r);if(!E&&a||(a=E,m<=0))break;r=m}if(a){let p={word:a[0],startColumn:i+1+a.index,endColumn:i+1+a.index+a[0].length};return S.lastIndex=0,p}return null}e.getWordAtText=T;function y(D,S,C,i){let P;for(;P=D.exec(S);){const d=P.index||0;if(d<=C&&D.lastIndex>=C)return P;if(i>0&&d>i)return null}return null}}),define(we[117],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var w;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(w=e.IndentAction||(e.IndentAction={}));class I{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let S=0,C=D.notIn.length;S<C;S++)switch(D.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=I;class A{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of D)T(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),T(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),T(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),T(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&T(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=A;function T(y,D,S){y.has(D)?y.get(D).push(S):y.set(D,[S])}}),define(we[59],_e([0,1,28,13]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function A(T,y,D,S){if(Array.isArray(T)){let C=0;for(const i of T){const P=A(i,y,D,S);if(P===10)return P;P>C&&(C=P)}return C}else{if(typeof T=="string")return S?T==="*"?5:T===D?10:0:0;if(T){const{language:C,pattern:i,scheme:P,hasAccessToAllModels:d}=T;if(!S&&!d)return 0;let h=0;if(P)if(P===y.scheme)h=10;else if(P==="*")h=5;else return 0;if(C)if(C===D)h=10;else if(C==="*")h=Math.max(h,5);else return 0;if(i){let r;if(typeof i=="string"?r=i:r=Object.assign(Object.assign({},i),{base:(0,I.normalize)(i.base)}),r===y.fsPath||(0,w.match)(r,y.fsPath))h=10;else return 0}return h}else return 0}}e.score=A}),define(we[118],_e([0,1,84]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class A{constructor(r,a,p){const m=new Uint8Array(r*a);for(let E=0,f=r*a;E<f;E++)m[E]=p;this._data=m,this.rows=r,this.cols=a}get(r,a){return this._data[r*this.cols+a]}set(r,a,p){this._data[r*this.cols+a]=p}}e.Uint8Matrix=A;class T{constructor(r){let a=0,p=0;for(let E=0,f=r.length;E<f;E++){let[l,b,t]=r[E];b>a&&(a=b),l>p&&(p=l),t>p&&(p=t)}a++,p++;let m=new A(p,a,0);for(let E=0,f=r.length;E<f;E++){let[l,b,t]=r[E];m.set(l,b,t)}this._states=m,this._maxCharCode=a}nextState(r,a){return a<0||a>=this._maxCharCode?0:this._states.get(r,a)}}e.StateMachine=T;let y=null;function D(){return y===null&&(y=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var S;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let C=null;function i(){if(C===null){C=new w.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<h.length;a++)C.set(h.charCodeAt(a),1);const r=".,;";for(let a=0;a<r.length;a++)C.set(r.charCodeAt(a),2)}return C}class P{static _createLink(r,a,p,m,E){let f=E-1;do{const l=a.charCodeAt(f);if(r.get(l)!==2)break;f--}while(f>m);if(m>0){const l=a.charCodeAt(m-1),b=a.charCodeAt(f);(l===40&&b===41||l===91&&b===93||l===123&&b===125)&&f--}return{range:{startLineNumber:p,startColumn:m+1,endLineNumber:p,endColumn:f+2},url:a.substring(m,f+1)}}static computeLinks(r,a=D()){const p=i();let m=[];for(let E=1,f=r.getLineCount();E<=f;E++){const l=r.getLineContent(E),b=l.length;let t=0,n=0,u=0,o=1,s=!1,c=!1,v=!1,k=!1;for(;t<b;){let g=!1;const _=l.charCodeAt(t);if(o===13){let R;switch(_){case 40:s=!0,R=0;break;case 41:R=s?0:1;break;case 91:v=!0,c=!0,R=0;break;case 93:v=!1,R=c?0:1;break;case 123:k=!0,R=0;break;case 125:R=k?0:1;break;case 39:R=u===34||u===96?0:1;break;case 34:R=u===39||u===96?0:1;break;case 96:R=u===39||u===34?0:1;break;case 42:R=u===42?1:0;break;case 124:R=u===124?1:0;break;case 32:R=v?0:1;break;default:R=p.get(_)}R===1&&(m.push(P._createLink(p,l,E,n,t)),g=!0)}else if(o===12){let R;_===91?(c=!0,R=0):R=p.get(_),R===1?g=!0:o=13}else o=a.nextState(o,_),o===0&&(g=!0);g&&(o=1,s=!1,c=!1,k=!1,n=t+1,u=_),t++}o===13&&m.push(P._createLink(p,l,E,n,b))}return m}}e.LinkComputer=P;function d(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:P.computeLinks(h)}e.computeLinks=d}),define(we[119],_e([0,1,3,6]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class A{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new w.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,D){return this._map.set(y,D),this.fire([y]),(0,I.toDisposable)(()=>{this._map.get(y)===D&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,D){let S=null,C=!1;return this._promises.set(y,D.then(i=>{this._promises.delete(y),!(C||!i)&&(S=this.register(y,i))})),(0,I.toDisposable)(()=>{C=!0,S&&S.dispose()})}getPromise(y){const D=this.get(y);if(D)return Promise.resolve(D);const S=this._promises.get(y);return S?S.then(C=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=A}),define(we[87],_e([0,1,24,21]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var A;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(A||(A={}));function T(P){for(let d=0,h=P.length;d<h;d+=4){const r=P[d+0],a=P[d+1],p=P[d+2],m=P[d+3];P[d+0]=m,P[d+1]=p,P[d+2]=a,P[d+3]=r}}function y(P){const d=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return I.isLittleEndian()||T(d),w.VSBuffer.wrap(d)}function D(P){const d=P.buffer;if(I.isLittleEndian()||T(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const h=new Uint8Array(d.byteLength);return h.set(d),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function S(P){const d=new Uint32Array(C(P));let h=0;if(d[h++]=P.id,P.type==="full")d[h++]=1,d[h++]=P.data.length,d.set(P.data,h),h+=P.data.length;else{d[h++]=2,d[h++]=P.deltas.length;for(const r of P.deltas)d[h++]=r.start,d[h++]=r.deleteCount,r.data?(d[h++]=r.data.length,d.set(r.data,h),h+=r.data.length):d[h++]=0}return y(d)}e.encodeSemanticTokensDto=S;function C(P){let d=0;if(d+=1+1,P.type==="full")d+=1+P.data.length;else{d+=1,d+=(1+1+1)*P.deltas.length;for(const h of P.deltas)h.data&&(d+=h.data.length)}return d}function i(P){const d=D(P);let h=0;const r=d[h++];if(d[h++]===1){const E=d[h++],f=d.subarray(h,h+E);return h+=E,{id:r,type:"full",data:f}}const p=d[h++];let m=[];for(let E=0;E<p;E++){const f=d[h++],l=d[h++],b=d[h++];let t;b>0&&(t=d.subarray(h,h+b),h+=b),m[E]={start:f,deleteCount:l,data:t}}return{id:r,type:"delta",deltas:m}}e.decodeSemanticTokensDto=i}),define(we[88],_e([0,1,82]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(y,D){this.index=y,this.remainder=D}}e.PrefixSumIndexOfResult=I;class A{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,D){y=(0,w.toUint32)(y);const S=this.values,C=this.prefixSum,i=D.length;return i===0?!1:(this.values=new Uint32Array(S.length+i),this.values.set(S.subarray(0,y),0),this.values.set(S.subarray(y),y+i),this.values.set(D,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,D){return y=(0,w.toUint32)(y),D=(0,w.toUint32)(D),this.values[y]===D?!1:(this.values[y]=D,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,D){y=(0,w.toUint32)(y),D=(0,w.toUint32)(D);const S=this.values,C=this.prefixSum;if(y>=S.length)return!1;let i=S.length-y;return D>=i&&(D=i),D===0?!1:(this.values=new Uint32Array(S.length-D),this.values.set(S.subarray(0,y),0),this.values.set(S.subarray(y+D),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,w.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),y>=this.values.length&&(y=this.values.length-1);for(let S=D;S<=y;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let D=0,S=this.values.length-1,C=0,i=0,P=0;for(;D<=S;)if(C=D+(S-D)/2|0,i=this.prefixSum[C],P=i-this.values[C],y<P)S=C-1;else if(y>=i)D=C+1;else break;return new I(C,y-P)}}e.PrefixSumComputer=A}),define(we[120],_e([0,1,8,38,88]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(D,S,C,i){this._uri=D,this._lines=S,this._eol=C,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const S=D.changes;for(const C of S)this._acceptDeleteRange(C.range),this._acceptInsertText(new I.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,S=this._lines.length,C=new Uint32Array(S);for(let i=0;i<S;i++)C[i]=this._lines[i].length+D;this._lineStarts=new A.PrefixSumComputer(C)}}_setLineText(D,S){this._lines[D]=S,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,S){if(S.length!==0){let C=(0,w.splitLines)(S);if(C.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}C[C.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]);let i=new Uint32Array(C.length-1);for(let P=1;P<C.length;P++)this._lines.splice(D.lineNumber+P-1,0,C[P]),i[P-1]=C[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,i)}}}e.MirrorTextModel=T}),define(we[121],_e([16,17]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(we[60],_e([0,1,121,10,15]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(C,i){return i&&(C.stack||C.stacktrace)?w.localize(0,null,D(C),y(C.stack)||y(C.stacktrace)):D(C)}function y(C){return Array.isArray(C)?C.join(`
`):C}function D(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?w.localize(1,null,C.message):C.message||w.localize(2,null)}function S(C=null,i=!1){if(!C)return w.localize(3,null);if(Array.isArray(C)){const P=A.coalesce(C),d=S(P[0],i);return P.length>1?w.localize(4,null,d,P.length):d}if(I.isString(C))return C;if(C.detail){const P=C.detail;if(P.error)return T(P.error,i);if(P.exception)return T(P.exception,i)}return C.stack?T(C,i):C.message?C.message:w.localize(5,null)}e.toErrorMessage=S}),define(we[122],_e([16,17]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(we[123],_e([0,1,122,21,86]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ee){this._values=ee}hasChanged(ee){return this._values[ee]}}e.ConfigurationChangedEvent=y;class D{constructor(){this._values=[]}_read(ee){return this._values[ee]}get(ee){return this._values[ee]}_write(ee,ve){this._values[ee]=ve}}e.ValidatedEditorOptions=D;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class C{constructor(ee,ve,Le,He){this.id=ee,this.name=ve,this.defaultValue=Le,this.schema=He}compute(ee,ve,Le){return Le}}class i{constructor(ee,ve=null){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(ee){return this.defaultValue}}class P{constructor(ee,ve,Le,He){this.id=ee,this.name=ve,this.defaultValue=Le,this.schema=He}validate(ee){return typeof ee=="undefined"?this.defaultValue:ee}compute(ee,ve,Le){return Le}}function d(z,ee){return typeof z=="undefined"?ee:z==="false"?!1:Boolean(z)}e.boolean=d;class h extends P{constructor(ee,ve,Le,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Le),super(ee,ve,Le,He)}validate(ee){return d(ee,this.defaultValue)}}class r extends P{constructor(ee,ve,Le,He,Ue,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=Le,Xe.minimum=He,Xe.maximum=Ue),super(ee,ve,Le,Xe),this.minimum=He,this.maximum=Ue}static clampedInt(ee,ve,Le,He){if(typeof ee=="undefined")return ve;let Ue=parseInt(ee,10);return isNaN(Ue)?ve:(Ue=Math.max(Le,Ue),Ue=Math.min(He,Ue),Ue|0)}validate(ee){return r.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}class a extends P{constructor(ee,ve,Le,He,Ue){typeof Ue!="undefined"&&(Ue.type="number",Ue.default=Le),super(ee,ve,Le,Ue),this.validationFn=He}static clamp(ee,ve,Le){return ee<ve?ve:ee>Le?Le:ee}static float(ee,ve){if(typeof ee=="number")return ee;if(typeof ee=="undefined")return ve;const Le=parseFloat(ee);return isNaN(Le)?ve:Le}validate(ee){return this.validationFn(a.float(ee,this.defaultValue))}}class p extends P{static string(ee,ve){return typeof ee!="string"?ve:ee}constructor(ee,ve,Le,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Le),super(ee,ve,Le,He)}validate(ee){return p.string(ee,this.defaultValue)}}function m(z,ee,ve){return typeof z!="string"||ve.indexOf(z)===-1?ee:z}e.stringSet=m;class E extends P{constructor(ee,ve,Le,He,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.enum=He,Ue.default=Le),super(ee,ve,Le,Ue),this._allowedValues=He}validate(ee){return m(ee,this.defaultValue,this._allowedValues)}}class f extends C{constructor(ee,ve,Le,He,Ue,Xe,W=void 0){typeof W!="undefined"&&(W.type="string",W.enum=Ue,W.default=He),super(ee,ve,Le,W),this._allowedValues=Ue,this._convert=Xe}validate(ee){return typeof ee!="string"?this.defaultValue:this._allowedValues.indexOf(ee)===-1?this.defaultValue:this._convert(ee)}}function l(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class b extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",description:w.localize(3,null)})}validate(ee){switch(ee){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ee,ve,Le){return Le===0?ee.accessibilitySupport:Le}}class t extends C{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:w.localize(5,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{insertSpace:d(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(o=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function s(z){switch(z){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=s;function c(z){switch(z){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class v extends i{constructor(){super(123,[62,31])}compute(ee,ve,Le){const He=["monaco-editor"];return ve.get(31)&&He.push(ve.get(31)),ee.extraEditorClassName&&He.push(ee.extraEditorClassName),ve.get(62)==="default"?He.push("mouse-default"):ve.get(62)==="copy"&&He.push("mouse-copy"),ve.get(97)&&He.push("showUnused"),ve.get(121)&&He.push("showDeprecated"),He.join(" ")}}class k extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(ee,ve,Le){return Le&&ee.emptySelectionClipboard}}class g extends C{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ee.seedSearchStringFromSelection,description:w.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[w.localize(9,null),w.localize(10,null),w.localize(11,null)],description:w.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:w.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:w.localize(14,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:w.localize(15,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{cursorMoveOnType:d(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:d(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":m(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ve.loop,this.defaultValue.loop)}}}class _ extends C{constructor(){super(41,"fontLigatures",_.OFF,{anyOf:[{type:"boolean",description:w.localize(16,null)},{type:"string",description:w.localize(17,null)}],description:w.localize(18,null),default:!1})}validate(ee){return typeof ee=="undefined"?this.defaultValue:typeof ee=="string"?ee==="false"?_.OFF:ee==="true"?_.ON:ee:Boolean(ee)?_.ON:_.OFF}}e.EditorFontLigatures=_,_.OFF='"liga" off, "calt" off',_.ON='"liga" on, "calt" on';class R extends i{constructor(){super(40)}compute(ee,ve,Le){return ee.fontInfo}}class B extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(19,null)})}validate(ee){let ve=a.float(ee,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(ve,6,100)}compute(ee,ve,Le){return ee.fontInfo.fontSize}}class Q extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Q.MINIMUM_VALUE,maximum:Q.MAXIMUM_VALUE,errorMessage:w.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Q.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(21,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(r.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,Q.MINIMUM_VALUE,Q.MAXIMUM_VALUE))}}Q.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],Q.MINIMUM_VALUE=1,Q.MAXIMUM_VALUE=1e3;class ge extends C{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[w.localize(22,null),w.localize(23,null),w.localize(24,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:w.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:w.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:w.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:w.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:w.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:Le,description:w.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:Le,description:w.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:Le,description:w.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:Le,description:w.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:Le,description:w.localize(35,null)}})}validate(ee){var ve,Le,He,Ue,Xe;if(!ee||typeof ee!="object")return this.defaultValue;const W=ee;return{multiple:m(W.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=W.multipleDefinitions)!==null&&ve!==void 0?ve:m(W.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Le=W.multipleTypeDefinitions)!==null&&Le!==void 0?Le:m(W.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=W.multipleDeclarations)!==null&&He!==void 0?He:m(W.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ue=W.multipleImplementations)!==null&&Ue!==void 0?Ue:m(W.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=W.multipleReferences)!==null&&Xe!==void 0?Xe:m(W.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(W.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(W.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(W.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(W.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(W.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class V extends C{constructor(){const ee={enabled:!0,delay:300,sticky:!0};super(50,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:w.localize(36,null)},"editor.hover.delay":{type:"number",default:ee.delay,description:w.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:w.localize(38,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{enabled:d(ve.enabled,this.defaultValue.enabled),delay:r.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:d(ve.sticky,this.defaultValue.sticky)}}}var H;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(H=e.RenderMinimap||(e.RenderMinimap={}));class te extends i{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(ee,ve,Le){return te.computeLayout(ve,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio})}static computeContainedMinimapLineCount(ee){const ve=ee.height/ee.lineHeight,Le=ee.scrollBeyondLastLine?ve-1:0,He=(ee.viewLineCount+Le)/(ee.pixelRatio*ee.height),Ue=Math.floor(ee.viewLineCount/He);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Le,desiredRatio:He,minimapLineCount:Ue}}static _computeMinimapLayout(ee,ve){const Le=ee.outerWidth,He=ee.outerHeight,Ue=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ue*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Xe=ve.stableMinimapLayoutInput,W=Xe&&ee.outerHeight===Xe.outerHeight&&ee.lineHeight===Xe.lineHeight&&ee.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&ee.pixelRatio===Xe.pixelRatio&&ee.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&ee.minimap.enabled===Xe.minimap.enabled&&ee.minimap.side===Xe.minimap.side&&ee.minimap.size===Xe.minimap.size&&ee.minimap.showSlider===Xe.minimap.showSlider&&ee.minimap.renderCharacters===Xe.minimap.renderCharacters&&ee.minimap.maxColumn===Xe.minimap.maxColumn&&ee.minimap.scale===Xe.minimap.scale&&ee.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&ee.isViewportWrapping===Xe.isViewportWrapping,ie=ee.lineHeight,ce=ee.typicalHalfwidthCharacterWidth,j=ee.scrollBeyondLastLine,X=ee.minimap.renderCharacters;let ae=Ue>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const he=ee.minimap.maxColumn,ye=ee.minimap.size,ze=ee.minimap.side,xe=ee.verticalScrollbarWidth,Ne=ee.viewLineCount,Ge=ee.remainingWidth,nt=ee.isViewportWrapping,dt=X?2:3;let it=Math.floor(Ue*He);const Je=it/Ue;let mt=!1,bt=!1,be=dt*ae,de=ae/Ue,oe=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:Ye,desiredRatio:ot,minimapLineCount:ft}=te.computeContainedMinimapLineCount({viewLineCount:Ne,scrollBeyondLastLine:j,height:He,lineHeight:ie,pixelRatio:Ue});if(Ne/ft>1)mt=!0,bt=!0,ae=1,be=1,de=ae/Ue;else{let Et=!1,vt=ae+1;if(ye==="fit"){const kt=Math.ceil((Ne+Ye)*be);nt&&W&&Ge<=ve.stableFitRemainingWidth?(Et=!0,vt=ve.stableFitMaxMinimapScale):(Et=kt>it,nt&&Et?(ve.stableMinimapLayoutInput=ee,ve.stableFitRemainingWidth=Ge):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(ye==="fill"||Et){mt=!0;const kt=ae;be=Math.min(ie*Ue,Math.max(1,Math.floor(1/ot))),ae=Math.min(vt,Math.max(1,Math.floor(be/dt))),ae>kt&&(oe=Math.min(2,ae/kt)),de=ae/Ue/oe,it=Math.ceil(Math.max(ht,Ne+Ye)*be),nt&&Et&&(ve.stableFitMaxMinimapScale=ae)}}}const K=Math.floor(he*de),Re=Math.min(K,Math.max(0,Math.floor((Ge-xe-2)*de/(ce+de)))+e.MINIMAP_GUTTER_WIDTH);let Ie=Math.floor(Ue*Re);const Qe=Ie/Ue;Ie=Math.floor(Ie*oe);const Ze=X?1:2,ut=ze==="left"?0:Le-Re-xe;return{renderMinimap:Ze,minimapLeft:ut,minimapWidth:Re,minimapHeightIsEditorHeight:mt,minimapIsSampling:bt,minimapScale:ae,minimapLineHeight:be,minimapCanvasInnerWidth:Ie,minimapCanvasInnerHeight:it,minimapCanvasOuterWidth:Qe,minimapCanvasOuterHeight:Je}}static computeLayout(ee,ve){const Le=ve.outerWidth|0,He=ve.outerHeight|0,Ue=ve.lineHeight|0,Xe=ve.lineNumbersDigitCount|0,W=ve.typicalHalfwidthCharacterWidth,ie=ve.maxDigitWidth,ce=ve.pixelRatio,j=ve.viewLineCount,X=ee.get(118),ae=X==="inherit"?ee.get(117):X,he=ae==="inherit"?ee.get(113):ae,ye=ee.get(116),ze=ee.get(2),xe=ve.isDominatedByLongLines,Ne=ee.get(46),Ge=ee.get(56).renderType!==0,nt=ee.get(57),dt=ee.get(91),it=ee.get(61),Je=ee.get(89),mt=Je.verticalScrollbarSize,bt=Je.verticalHasArrows,be=Je.arrowSize,de=Je.horizontalScrollbarSize,oe=ee.get(54),K=ee.get(35);let Re;if(typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)){const _t=parseFloat(oe.substr(0,oe.length-2));Re=r.clampedInt(_t*W,0,0,1e3)}else Re=r.clampedInt(oe,0,0,1e3);K&&(Re+=16);let Ie=0;if(Ge){const _t=Math.max(Xe,nt);Ie=Math.round(_t*ie)}let Qe=0;Ne&&(Qe=Ue);let Ze=0,ut=Ze+Qe,ht=ut+Ie,Ye=ht+Re;const ot=Le-Qe-Ie-Re;let ft=!1,at=!1,Et=-1;ze!==2&&(ae==="inherit"&&xe?(ft=!0,at=!0):he==="on"||he==="bounded"?at=!0:he==="wordWrapColumn"&&(Et=ye));const vt=te._computeMinimapLayout({outerWidth:Le,outerHeight:He,lineHeight:Ue,typicalHalfwidthCharacterWidth:W,pixelRatio:ce,scrollBeyondLastLine:dt,minimap:it,verticalScrollbarWidth:mt,viewLineCount:j,remainingWidth:ot,isViewportWrapping:at},ve.memory||new S);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Ze+=vt.minimapWidth,ut+=vt.minimapWidth,ht+=vt.minimapWidth,Ye+=vt.minimapWidth);const kt=ot-vt.minimapWidth,At=Math.max(1,Math.floor((kt-mt-2)/W)),Tt=bt?be:0;return at&&(Et=Math.max(1,At),he==="bounded"&&(Et=Math.min(Et,ye))),{width:Le,height:He,glyphMarginLeft:Ze,glyphMarginWidth:Qe,lineNumbersLeft:ut,lineNumbersWidth:Ie,decorationsLeft:ht,decorationsWidth:Re,contentLeft:Ye,contentWidth:kt,minimap:vt,viewportColumn:At,isWordWrapMinified:ft,isViewportWrapping:at,wrappingColumn:Et,verticalScrollbarWidth:mt,horizontalScrollbarHeight:de,overviewRuler:{top:Tt,width:mt,height:He-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=te;class $ extends C{constructor(){const ee={enabled:!0};super(53,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"boolean",default:ee.enabled,description:w.localize(39,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:d(ee.enabled,this.defaultValue.enabled)}}}class F extends C{constructor(){const ee={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"boolean",default:ee.enabled,description:w.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,description:w.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,description:w.localize(42,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{enabled:d(ve.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class L extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:w.localize(43,null)})}compute(ee,ve,Le){return ee.fontInfo.lineHeight}}class M extends C{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:w.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(45,null),w.localize(46,null),w.localize(47,null)],default:ee.size,description:w.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:w.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:w.localize(50,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:w.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:w.localize(53,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{enabled:d(ve.enabled,this.defaultValue.enabled),size:m(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(ve.side,this.defaultValue.side,["right","left"]),showSlider:m(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ve.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(ve.scale,1,1,3),maxColumn:r.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function U(z){return z==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends C{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(55,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{top:r.clampedInt(ve.top,0,0,1e3),bottom:r.clampedInt(ve.bottom,0,0,1e3)}}}class J extends C{constructor(){const ee={enabled:!0,cycle:!1};super(72,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:w.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:w.localize(57,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{enabled:d(ve.enabled,this.defaultValue.enabled),cycle:d(ve.cycle,this.defaultValue.cycle)}}}class re extends i{constructor(){super(124)}compute(ee,ve,Le){return ee.pixelRatio}}class pe extends C{constructor(){const ee={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ee,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ee.strings,description:w.localize(58,null)},comments:{type:"boolean",default:ee.comments,description:w.localize(59,null)},other:{type:"boolean",default:ee.other,description:w.localize(60,null)}}}],default:ee,description:w.localize(61,null)});this.defaultValue=ee}validate(ee){if(typeof ee=="boolean")return ee;if(ee&&typeof ee=="object"){const ve=ee,Le={other:d(ve.other,this.defaultValue.other),comments:d(ve.comments,this.defaultValue.comments),strings:d(ve.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var Te;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(Te=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Be extends C{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(62,null),w.localize(63,null),w.localize(64,null),w.localize(65,null)],default:"on",description:w.localize(66,null)})}validate(ee){let ve=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof ee!="undefined"&&(typeof ee=="function"?(ve=4,Le=ee):ee==="interval"?ve=3:ee==="relative"?ve=2:ee==="on"?ve=1:ve=0),{renderType:ve,renderFn:Le}}}function Ae(z){const ee=z.get(84);return ee==="editable"?z.get(77):ee!=="on"}e.filterValidationDecorations=Ae;class We extends C{constructor(){const ee=[],ve={type:"number",description:w.localize(67,null)};super(88,"rulers",ee,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:w.localize(68,null),format:"color-hex"}}}]},default:ee,description:w.localize(69,null)})}validate(ee){if(Array.isArray(ee)){let ve=[];for(let Le of ee)if(typeof Le=="number")ve.push({column:r.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const He=Le;ve.push({column:r.clampedInt(He.column,0,0,1e4),color:He.color})}return ve.sort((Le,He)=>Le.column-He.column),ve}return this.defaultValue}}function x(z,ee){if(typeof z!="string")return ee;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends C{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee,Le=r.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=r.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:x(ve.vertical,this.defaultValue.vertical),horizontal:x(ve.horizontal,this.defaultValue.horizontal),useShadows:d(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:r.clampedInt(ve.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:He,verticalSliderSize:r.clampedInt(ve.verticalSliderSize,He,0,1e3),scrollByPage:d(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class ne extends C{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(70,null),w.localize(71,null)],default:ee.insertMode,description:w.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:w.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:w.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:w.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:w.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:w.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:w.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:w.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(109,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{insertMode:m(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(ve.showIcons,this.defaultValue.showIcons),showStatusBar:d(ve.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:d(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ve.showMethods,this.defaultValue.showMethods),showFunctions:d(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ve.showConstructors,this.defaultValue.showConstructors),showFields:d(ve.showFields,this.defaultValue.showFields),showVariables:d(ve.showVariables,this.defaultValue.showVariables),showClasses:d(ve.showClasses,this.defaultValue.showClasses),showStructs:d(ve.showStructs,this.defaultValue.showStructs),showInterfaces:d(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ve.showModules,this.defaultValue.showModules),showProperties:d(ve.showProperties,this.defaultValue.showProperties),showEvents:d(ve.showEvents,this.defaultValue.showEvents),showOperators:d(ve.showOperators,this.defaultValue.showOperators),showUnits:d(ve.showUnits,this.defaultValue.showUnits),showValues:d(ve.showValues,this.defaultValue.showValues),showConstants:d(ve.showConstants,this.defaultValue.showConstants),showEnums:d(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ve.showKeywords,this.defaultValue.showKeywords),showWords:d(ve.showWords,this.defaultValue.showWords),showColors:d(ve.showColors,this.defaultValue.showColors),showFiles:d(ve.showFiles,this.defaultValue.showFiles),showReferences:d(ve.showReferences,this.defaultValue.showReferences),showFolders:d(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ve.showSnippets,this.defaultValue.showSnippets),showUsers:d(ve.showUsers,this.defaultValue.showUsers),showIssues:d(ve.showIssues,this.defaultValue.showIssues)}}}class le extends C{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(110,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class fe extends i{constructor(){super(125,[77])}compute(ee,ve,Le){return ve.get(77)?!0:ee.tabFocusMode}}var Se;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(Se=e.WrappingIndent||(e.WrappingIndent={}));function Oe(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class me extends i{constructor(){super(127,[126])}compute(ee,ve,Le){const He=ve.get(126);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Pe:I.isLinux?$e:Ce,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(z){return e.editorOptionsRegistry[z.id]=z,z}var je;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.codeLens=12]="codeLens",z[z.codeLensFontFamily=13]="codeLensFontFamily",z[z.codeLensFontSize=14]="codeLensFontSize",z[z.colorDecorators=15]="colorDecorators",z[z.columnSelection=16]="columnSelection",z[z.comments=17]="comments",z[z.contextmenu=18]="contextmenu",z[z.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",z[z.cursorBlinking=20]="cursorBlinking",z[z.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",z[z.cursorStyle=22]="cursorStyle",z[z.cursorSurroundingLines=23]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",z[z.cursorWidth=25]="cursorWidth",z[z.disableLayerHinting=26]="disableLayerHinting",z[z.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",z[z.domReadOnly=28]="domReadOnly",z[z.dragAndDrop=29]="dragAndDrop",z[z.emptySelectionClipboard=30]="emptySelectionClipboard",z[z.extraEditorClassName=31]="extraEditorClassName",z[z.fastScrollSensitivity=32]="fastScrollSensitivity",z[z.find=33]="find",z[z.fixedOverflowWidgets=34]="fixedOverflowWidgets",z[z.folding=35]="folding",z[z.foldingStrategy=36]="foldingStrategy",z[z.foldingHighlight=37]="foldingHighlight",z[z.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=39]="fontFamily",z[z.fontInfo=40]="fontInfo",z[z.fontLigatures=41]="fontLigatures",z[z.fontSize=42]="fontSize",z[z.fontWeight=43]="fontWeight",z[z.formatOnPaste=44]="formatOnPaste",z[z.formatOnType=45]="formatOnType",z[z.glyphMargin=46]="glyphMargin",z[z.gotoLocation=47]="gotoLocation",z[z.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",z[z.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",z[z.hover=50]="hover",z[z.inDiffEditor=51]="inDiffEditor",z[z.letterSpacing=52]="letterSpacing",z[z.lightbulb=53]="lightbulb",z[z.lineDecorationsWidth=54]="lineDecorationsWidth",z[z.lineHeight=55]="lineHeight",z[z.lineNumbers=56]="lineNumbers",z[z.lineNumbersMinChars=57]="lineNumbersMinChars",z[z.linkedEditing=58]="linkedEditing",z[z.links=59]="links",z[z.matchBrackets=60]="matchBrackets",z[z.minimap=61]="minimap",z[z.mouseStyle=62]="mouseStyle",z[z.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=64]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",z[z.multiCursorModifier=66]="multiCursorModifier",z[z.multiCursorPaste=67]="multiCursorPaste",z[z.occurrencesHighlight=68]="occurrencesHighlight",z[z.overviewRulerBorder=69]="overviewRulerBorder",z[z.overviewRulerLanes=70]="overviewRulerLanes",z[z.padding=71]="padding",z[z.parameterHints=72]="parameterHints",z[z.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",z[z.quickSuggestions=75]="quickSuggestions",z[z.quickSuggestionsDelay=76]="quickSuggestionsDelay",z[z.readOnly=77]="readOnly",z[z.renameOnType=78]="renameOnType",z[z.renderControlCharacters=79]="renderControlCharacters",z[z.renderIndentGuides=80]="renderIndentGuides",z[z.renderFinalNewline=81]="renderFinalNewline",z[z.renderLineHighlight=82]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=84]="renderValidationDecorations",z[z.renderWhitespace=85]="renderWhitespace",z[z.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",z[z.roundedSelection=87]="roundedSelection",z[z.rulers=88]="rulers",z[z.scrollbar=89]="scrollbar",z[z.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=91]="scrollBeyondLastLine",z[z.scrollPredominantAxis=92]="scrollPredominantAxis",z[z.selectionClipboard=93]="selectionClipboard",z[z.selectionHighlight=94]="selectionHighlight",z[z.selectOnLineNumbers=95]="selectOnLineNumbers",z[z.showFoldingControls=96]="showFoldingControls",z[z.showUnused=97]="showUnused",z[z.snippetSuggestions=98]="snippetSuggestions",z[z.smartSelect=99]="smartSelect",z[z.smoothScrolling=100]="smoothScrolling",z[z.stickyTabStops=101]="stickyTabStops",z[z.stopRenderingLineAfter=102]="stopRenderingLineAfter",z[z.suggest=103]="suggest",z[z.suggestFontSize=104]="suggestFontSize",z[z.suggestLineHeight=105]="suggestLineHeight",z[z.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",z[z.suggestSelection=107]="suggestSelection",z[z.tabCompletion=108]="tabCompletion",z[z.tabIndex=109]="tabIndex",z[z.unusualLineTerminators=110]="unusualLineTerminators",z[z.useTabStops=111]="useTabStops",z[z.wordSeparators=112]="wordSeparators",z[z.wordWrap=113]="wordWrap",z[z.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=116]="wordWrapColumn",z[z.wordWrapOverride1=117]="wordWrapOverride1",z[z.wordWrapOverride2=118]="wordWrapOverride2",z[z.wrappingIndent=119]="wrappingIndent",z[z.wrappingStrategy=120]="wrappingStrategy",z[z.showDeprecated=121]="showDeprecated",z[z.inlayHints=122]="inlayHints",z[z.editorClassName=123]="editorClassName",z[z.pixelRatio=124]="pixelRatio",z[z.tabFocusMode=125]="tabFocusMode",z[z.layoutInfo=126]="layoutInfo",z[z.wrappingInfo=127]="wrappingInfo"})(je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(111,null)})),acceptSuggestionOnEnter:Ee(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(112,null),""],markdownDescription:w.localize(113,null)})),accessibilitySupport:Ee(new b),accessibilityPageSize:Ee(new r(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(114,null)})),ariaLabel:Ee(new p(4,"ariaLabel",w.localize(115,null))),autoClosingBrackets:Ee(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(116,null),w.localize(117,null),""],description:w.localize(118,null)})),autoClosingDelete:Ee(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(119,null),""],description:w.localize(120,null)})),autoClosingOvertype:Ee(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(121,null),""],description:w.localize(122,null)})),autoClosingQuotes:Ee(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(123,null),w.localize(124,null),""],description:w.localize(125,null)})),autoIndent:Ee(new f(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[w.localize(126,null),w.localize(127,null),w.localize(128,null),w.localize(129,null),w.localize(130,null)],description:w.localize(131,null)})),automaticLayout:Ee(new h(10,"automaticLayout",!1)),autoSurround:Ee(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(132,null),w.localize(133,null),w.localize(134,null),""],description:w.localize(135,null)})),stickyTabStops:Ee(new h(101,"stickyTabStops",!1,{description:w.localize(136,null)})),codeLens:Ee(new h(12,"codeLens",!0,{description:w.localize(137,null)})),codeLensFontFamily:Ee(new p(13,"codeLensFontFamily","",{description:w.localize(138,null)})),codeLensFontSize:Ee(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:w.localize(139,null)})),colorDecorators:Ee(new h(15,"colorDecorators",!0,{description:w.localize(140,null)})),columnSelection:Ee(new h(16,"columnSelection",!1,{description:w.localize(141,null)})),comments:Ee(new t),contextmenu:Ee(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new h(19,"copyWithSyntaxHighlighting",!0,{description:w.localize(142,null)})),cursorBlinking:Ee(new f(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:w.localize(143,null)})),cursorSmoothCaretAnimation:Ee(new h(21,"cursorSmoothCaretAnimation",!1,{description:w.localize(144,null)})),cursorStyle:Ee(new f(22,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:w.localize(145,null)})),cursorSurroundingLines:Ee(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(146,null)})),cursorSurroundingLinesStyle:Ee(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(147,null),w.localize(148,null)],description:w.localize(149,null)})),cursorWidth:Ee(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(150,null)})),disableLayerHinting:Ee(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new h(28,"domReadOnly",!1)),dragAndDrop:Ee(new h(29,"dragAndDrop",!0,{description:w.localize(151,null)})),emptySelectionClipboard:Ee(new k),extraEditorClassName:Ee(new p(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new a(32,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:w.localize(152,null)})),find:Ee(new g),fixedOverflowWidgets:Ee(new h(34,"fixedOverflowWidgets",!1)),folding:Ee(new h(35,"folding",!0,{description:w.localize(153,null)})),foldingStrategy:Ee(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(154,null),w.localize(155,null)],description:w.localize(156,null)})),foldingHighlight:Ee(new h(37,"foldingHighlight",!0,{description:w.localize(157,null)})),unfoldOnClickAfterEndOfLine:Ee(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(158,null)})),fontFamily:Ee(new p(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(159,null)})),fontInfo:Ee(new R),fontLigatures2:Ee(new _),fontSize:Ee(new B),fontWeight:Ee(new Q),formatOnPaste:Ee(new h(44,"formatOnPaste",!1,{description:w.localize(160,null)})),formatOnType:Ee(new h(45,"formatOnType",!1,{description:w.localize(161,null)})),glyphMargin:Ee(new h(46,"glyphMargin",!0,{description:w.localize(162,null)})),gotoLocation:Ee(new ge),hideCursorInOverviewRuler:Ee(new h(48,"hideCursorInOverviewRuler",!1,{description:w.localize(163,null)})),highlightActiveIndentGuide:Ee(new h(49,"highlightActiveIndentGuide",!0,{description:w.localize(164,null)})),hover:Ee(new V),inDiffEditor:Ee(new h(51,"inDiffEditor",!1)),letterSpacing:Ee(new a(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>a.clamp(z,-5,20),{description:w.localize(165,null)})),lightbulb:Ee(new $),lineDecorationsWidth:Ee(new P(54,"lineDecorationsWidth",10)),lineHeight:Ee(new L),lineNumbers:Ee(new Be),lineNumbersMinChars:Ee(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new h(58,"linkedEditing",!1,{description:w.localize(166,null)})),links:Ee(new h(59,"links",!0,{description:w.localize(167,null)})),matchBrackets:Ee(new E(60,"matchBrackets","always",["always","near","never"],{description:w.localize(168,null)})),minimap:Ee(new M),mouseStyle:Ee(new E(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new a(63,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:w.localize(169,null)})),mouseWheelZoom:Ee(new h(64,"mouseWheelZoom",!1,{markdownDescription:w.localize(170,null)})),multiCursorMergeOverlapping:Ee(new h(65,"multiCursorMergeOverlapping",!0,{description:w.localize(171,null)})),multiCursorModifier:Ee(new f(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],U,{markdownEnumDescriptions:[w.localize(172,null),w.localize(173,null)],markdownDescription:w.localize(174,null)})),multiCursorPaste:Ee(new E(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(175,null),w.localize(176,null)],markdownDescription:w.localize(177,null)})),occurrencesHighlight:Ee(new h(68,"occurrencesHighlight",!0,{description:w.localize(178,null)})),overviewRulerBorder:Ee(new h(69,"overviewRulerBorder",!0,{description:w.localize(179,null)})),overviewRulerLanes:Ee(new r(70,"overviewRulerLanes",3,0,3)),padding:Ee(new G),parameterHints:Ee(new J),peekWidgetDefaultFocus:Ee(new E(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(180,null),w.localize(181,null)],description:w.localize(182,null)})),definitionLinkOpensInPeek:Ee(new h(74,"definitionLinkOpensInPeek",!1,{description:w.localize(183,null)})),quickSuggestions:Ee(new pe),quickSuggestionsDelay:Ee(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(184,null)})),readOnly:Ee(new h(77,"readOnly",!1)),renameOnType:Ee(new h(78,"renameOnType",!1,{description:w.localize(185,null),markdownDeprecationMessage:w.localize(186,null)})),renderControlCharacters:Ee(new h(79,"renderControlCharacters",!1,{description:w.localize(187,null)})),renderIndentGuides:Ee(new h(80,"renderIndentGuides",!0,{description:w.localize(188,null)})),renderFinalNewline:Ee(new h(81,"renderFinalNewline",!0,{description:w.localize(189,null)})),renderLineHighlight:Ee(new E(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(190,null)],description:w.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Ee(new h(83,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(192,null)})),renderValidationDecorations:Ee(new E(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new E(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(193,null),w.localize(194,null),w.localize(195,null),""],description:w.localize(196,null)})),revealHorizontalRightPadding:Ee(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new h(87,"roundedSelection",!0,{description:w.localize(197,null)})),rulers:Ee(new We),scrollbar:Ee(new q),scrollBeyondLastColumn:Ee(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:w.localize(198,null)})),scrollBeyondLastLine:Ee(new h(91,"scrollBeyondLastLine",!0,{description:w.localize(199,null)})),scrollPredominantAxis:Ee(new h(92,"scrollPredominantAxis",!0,{description:w.localize(200,null)})),selectionClipboard:Ee(new h(93,"selectionClipboard",!0,{description:w.localize(201,null),included:I.isLinux})),selectionHighlight:Ee(new h(94,"selectionHighlight",!0,{description:w.localize(202,null)})),selectOnLineNumbers:Ee(new h(95,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new E(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[w.localize(203,null),w.localize(204,null)],description:w.localize(205,null)})),showUnused:Ee(new h(97,"showUnused",!0,{description:w.localize(206,null)})),showDeprecated:Ee(new h(121,"showDeprecated",!0,{description:w.localize(207,null)})),inlayHints:Ee(new F),snippetSuggestions:Ee(new E(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(208,null),w.localize(209,null),w.localize(210,null),w.localize(211,null)],description:w.localize(212,null)})),smartSelect:Ee(new le),smoothScrolling:Ee(new h(100,"smoothScrolling",!1,{description:w.localize(213,null)})),stopRenderingLineAfter:Ee(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new ne),suggestFontSize:Ee(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(214,null)})),suggestLineHeight:Ee(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(215,null)})),suggestOnTriggerCharacters:Ee(new h(106,"suggestOnTriggerCharacters",!0,{description:w.localize(216,null)})),suggestSelection:Ee(new E(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(217,null),w.localize(218,null),w.localize(219,null)],description:w.localize(220,null)})),tabCompletion:Ee(new E(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(221,null),w.localize(222,null),w.localize(223,null)],description:w.localize(224,null)})),tabIndex:Ee(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new E(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(225,null),w.localize(226,null),w.localize(227,null)],description:w.localize(228,null)})),useTabStops:Ee(new h(111,"useTabStops",!0,{description:w.localize(229,null)})),wordSeparators:Ee(new p(112,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:w.localize(230,null)})),wordWrap:Ee(new E(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(231,null),w.localize(232,null),w.localize(233,null),w.localize(234,null)],description:w.localize(235,null)})),wordWrapBreakAfterCharacters:Ee(new p(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new p(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new r(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(236,null)})),wordWrapOverride1:Ee(new E(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new E(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new f(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[w.localize(237,null),w.localize(238,null),w.localize(239,null),w.localize(240,null)],description:w.localize(241,null)})),wrappingStrategy:Ee(new E(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[w.localize(242,null),w.localize(243,null)],description:w.localize(244,null)})),editorClassName:Ee(new v),pixelRatio:Ee(new re),tabFocusMode:Ee(new fe),layoutInfo:Ee(new te),wrappingInfo:Ee(new me)}}),define(we[124],_e([16,17]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[125],_e([16,17]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[126],_e([16,17]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(we[127],_e([16,17]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(we[128],_e([16,17]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(we[129],_e([16,17]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(we[130],_e([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHost.api.impl",e)}),define(we[131],_e([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[132],_e([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[133],_e([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(we[134],_e([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[135],_e([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[136],_e([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[137],_e([16,17]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[138],_e([16,17]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(we[139],_e([16,17]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[140],_e([16,17]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[141],_e([16,17]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[142],_e([16,17]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[143],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var w;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(w=e.EditorActivation||(e.EditorActivation={}));var I;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var A;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[144],_e([0,1,125]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(P){return P=P.trim(),P==="*"||I.test(P)}e.isValidVersionStr=A;function T(P){if(!A(P))return null;if(P=P.trim(),P==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=P.match(I);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=T;function y(P){if(!P)return null;let d=P.majorBase,h=P.majorMustEqual,r=P.minorBase,a=P.minorMustEqual,p=P.patchBase,m=P.patchMustEqual;return P.hasCaret&&(d===0||(a=!1),m=!1),{majorBase:d,majorMustEqual:h,minorBase:r,minorMustEqual:a,patchBase:p,patchMustEqual:m,isMinimum:P.hasGreaterEquals}}e.normalizeVersion=y;function D(P,d){let h;typeof P=="string"?h=y(T(P)):h=P;let r;if(typeof d=="string"?r=y(T(d)):r=d,!h||!r)return!1;let a=h.majorBase,p=h.minorBase,m=h.patchBase,E=r.majorBase,f=r.minorBase,l=r.patchBase,b=r.majorMustEqual,t=r.minorMustEqual,n=r.patchMustEqual;return r.isMinimum?a>E?!0:a<E?!1:p>f?!0:p<f?!1:m>=l:(a===1&&E===0&&(!b||!t||!n)&&(E=1,f=0,l=0,b=!0,t=!1,n=!1),a<E?!1:a>E?!b:p<f?!1:p>f?!t:m<l?!1:m>l?!n:!0)}e.isValidVersion=D;function S(P,d,h){return d.isBuiltin||typeof d.main=="undefined"?!0:i(P,d.engines.vscode,h)}e.isValidExtensionVersion=S;function C(P,d){return P==="*"||i(d,P)}e.isEngineValid=C;function i(P,d,h=[]){let r=y(T(d));if(!r)return h.push(w.localize(0,null,d)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return h.push(w.localize(1,null,d)),!1}else if(!r.majorMustEqual)return h.push(w.localize(2,null,d)),!1;return D(P,r)?!0:(h.push(w.localize(3,null,P,d)),!1)}e.isVersionValid=i}),define(we[89],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class w{constructor(T,y=[],D=!1){this.ctor=T,this.staticArguments=y,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=w;const I=(A,...T)=>new w(A,T);e.createSyncDescriptor=I}),define(we[61],_e([0,1,89]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function A(y,D,S){D instanceof w.SyncDescriptor||(D=new w.SyncDescriptor(D,[],S)),I.push([y,D])}e.registerSingleton=A;function T(){return I}e.getSingletonServiceDescriptors=T}),define(we[145],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=w;class I{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let y of this._nodes.values())y.outgoing.size===0&&T.push(y);return T}insertEdge(T,y){const D=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(y);D.outgoing.set(this._hashFn(y),S),S.incoming.set(this._hashFn(T),D)}removeNode(T){const y=this._hashFn(T);this._nodes.delete(y);for(let D of this._nodes.values())D.outgoing.delete(y),D.incoming.delete(y)}lookupOrInsertNode(T){const y=this._hashFn(T);let D=this._nodes.get(y);return D||(D=new w(T),this._nodes.set(y,D)),D}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[y,D]of this._nodes)T.push(`${y}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,y]of this._nodes){const D=new Set([T]),S=this._findCycle(y,D);if(S)return S}}_findCycle(T,y){for(let[D,S]of T.outgoing){if(y.has(D))return[...y,D].join(" -> ");y.add(D);const C=this._findCycle(S,y);if(C)return C;y.delete(D)}}}e.Graph=I}),define(we[4],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(C){return C[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(w=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function I(D,S,C,i){S[w.DI_TARGET]===S?S[w.DI_DEPENDENCIES].push({id:D,index:C,optional:i}):(S[w.DI_DEPENDENCIES]=[{id:D,index:C,optional:i}],S[w.DI_TARGET]=S)}function A(D){if(w.serviceIds.has(D))return w.serviceIds.get(D);const S=function(C,i,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(S,C,P,!1)};return S.toString=()=>D,w.serviceIds.set(D,S),S}e.createDecorator=A;function T(D){return D}e.refineServiceDecorator=T;function y(D){return function(S,C,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(D,S,i,!0)}}e.optional=y}),define(we[146],_e([0,1,4]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,w.createDecorator)("modelService");function I(A){return!A.isTooLargeForSyncing()&&!A.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(we[147],_e([0,1,3,56,6,22,81,59,146]),function(Y,e,w,I,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(C):!!d.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new w.Emitter}get onDidChange(){return this._onDidChange.event}register(h,r){let a={selector:h,provider:r,_score:-1,_time:this._clock++};return this._entries.push(a),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,A.toDisposable)(()=>{if(a){let p=this._entries.indexOf(a);p>=0&&(this._entries.splice(p,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),a=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const r=[];for(let a of this._entries)a._score>0&&r.push(a.provider);return r}ordered(h){const r=[];return this._orderedForEach(h,a=>r.push(a.provider)),r}orderedGroups(h){const r=[];let a,p;return this._orderedForEach(h,m=>{a&&p===m._score?a.push(m.provider):(p=m._score,a=[m.provider],r.push(a))}),r}_orderedForEach(h,r){if(!!h){this._updateScores(h);for(const a of this._entries)a._score>0&&r(a)}}_updateScores(h){let r={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let a of this._entries)if(a._score=(0,D.score)(a.selector,h.uri,h.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(h)),C(a.selector)&&a._score>0){for(let p of this._entries)p._score=0;a._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(h,r){return h._score<r._score?1:h._score>r._score?-1:h._time<r._time?1:h._time>r._time?-1:0}}e.LanguageFeatureRegistry=i;class P{constructor(h,r,a=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=r,this.max=a,this._cache=new T.LRUCache(50,.7)}_key(h){return h.id+(0,I.hash)(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const r=this._key(h),a=this._cache.get(r);return this._clamp(a==null?void 0:a.value)}update(h,r){const a=this._key(h);let p=this._cache.get(a);return p||(p=new y.MovingAverage,this._cache.set(a,p)),p.update(r),this.get(h)}}e.LanguageFeatureRequestDelays=P}),define(we[62],_e([0,1,2,32,147,119,36]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class S{constructor(_,R){this.language=_,this.id=R}}e.LanguageIdentifier=S;var C;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var i;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var P;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&1792)>>>8}static getFontStyle(_){return(_&14336)>>>11}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){let R=this.getForeground(_),B="mtk"+R,Q=this.getFontStyle(_);return Q&1&&(B+=" mtki"),Q&2&&(B+=" mtkb"),Q&4&&(B+=" mtku"),B}static getInlineStyleFromMetadata(_,R){const B=this.getForeground(_),Q=this.getFontStyle(_);let ge=`color: ${R[B]};`;return Q&1&&(ge+="font-style: italic;"),Q&2&&(ge+="font-weight: bold;"),Q&4&&(ge+="text-decoration: underline;"),ge}}e.TokenMetadata=h;var r;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(_){const R=g[_];let B=R&&y.iconRegistry.get(R);return B||(console.info("No codicon found for CompletionItemKind "+_),B=y.Codicon.symbolProperty),B.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(_,R){let B=g[_];return typeof B=="undefined"&&!R&&(B=9),B}}();var a;(function(g){g[g.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function b(g){return g&&w.URI.isUri(g.uri)&&I.Range.isIRange(g.range)&&(I.Range.isIRange(g.originSelectionRange)||I.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=b;var t;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(g){g[g.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var u;(function(g){const _=new Map;_.set("file",0),_.set("module",1),_.set("namespace",2),_.set("package",3),_.set("class",4),_.set("method",5),_.set("property",6),_.set("field",7),_.set("constructor",8),_.set("enum",9),_.set("interface",10),_.set("function",11),_.set("variable",12),_.set("constant",13),_.set("string",14),_.set("number",15),_.set("boolean",16),_.set("array",17),_.set("object",18),_.set("key",19),_.set("null",20),_.set("enum-member",21),_.set("struct",22),_.set("event",23),_.set("operator",24),_.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function B(V){return _.get(V)}g.fromString=B;function Q(V){return R.get(V)}g.toString=Q;function ge(V,H){const te=R.get(V);let $=te&&y.iconRegistry.get("symbol-"+te);return $||(console.info("No codicon found for SymbolKind "+V),$=y.Codicon.symbolProperty),`${H?"inline":"block"} ${$.classNames}`}g.toCssClassName=ge})(u=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(_){this.value=_}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var s;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var v;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(v=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new A.LanguageFeatureRegistry,e.RenameProviderRegistry=new A.LanguageFeatureRegistry,e.CompletionProviderRegistry=new A.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new A.LanguageFeatureRegistry,e.HoverProviderRegistry=new A.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new A.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new A.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new A.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new A.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new A.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new A.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.LinkProviderRegistry=new A.LanguageFeatureRegistry,e.ColorProviderRegistry=new A.LanguageFeatureRegistry,e.SelectionRangeRegistry=new A.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var k;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(k=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[148],_e([0,1,6,10,4,3,45,43]),function(Y,e,w,I,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,A.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(S,C){if(!S)throw new Error("invalid command");if(typeof S=="string"){if(!C)throw new Error("invalid command");return this.registerCommand({id:S,handler:C})}if(S.description){const r=[];for(let p of S.description.args)r.push(p.constraint);const a=S.handler;S.handler=function(p,...m){return(0,I.validateConstraints)(m,r),a(p,...m)}}const{id:i}=S;let P=this._commands.get(i);P||(P=new y.LinkedList,this._commands.set(i,P));let d=P.unshift(S),h=(0,w.toDisposable)(()=>{d();const r=this._commands.get(i);(r==null?void 0:r.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),h}registerCommandAlias(S,C){return e.CommandsRegistry.registerCommand(S,(i,...P)=>i.get(e.ICommandService).executeCommand(C,...P))}getCommand(S){const C=this._commands.get(S);if(!(!C||C.isEmpty()))return D.Iterable.first(C)}getCommands(){const S=new Map;for(const C of this._commands.keys()){const i=this.getCommand(C);i&&S.set(C,i)}return S}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>w.Disposable.None,onDidExecuteCommand:()=>w.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(we[63],_e([0,1,8,4,21]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=A.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",A.isMacintosh),y.set("isLinux",A.isLinux),y.set("isWindows",A.isWindows),y.set("isWeb",A.isWeb),y.set("isMacNative",A.isMacintosh&&!A.isWeb),y.set("isEdge",T.indexOf("Edg/")>=0),y.set("isFirefox",T.indexOf("Firefox")>=0),y.set("isChrome",T.indexOf("Chrome")>=0),y.set("isSafari",T.indexOf("Safari")>=0),y.set("isIPad",T.indexOf("iPad")>=0);const D=Object.prototype.hasOwnProperty;var S;(function(g){g[g.False=0]="False",g[g.True=1]="True",g[g.Defined=2]="Defined",g[g.Not=3]="Not",g[g.Equals=4]="Equals",g[g.NotEquals=5]="NotEquals",g[g.And=6]="And",g[g.Regex=7]="Regex",g[g.NotRegex=8]="NotRegex",g[g.Or=9]="Or",g[g.In=10]="In",g[g.NotIn=11]="NotIn",g[g.Greater=12]="Greater",g[g.GreaterEquals=13]="GreaterEquals",g[g.Smaller=14]="Smaller",g[g.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return P.INSTANCE}static true(){return d.INSTANCE}static has(_){return h.create(_)}static equals(_,R){return r.create(_,R)}static notEquals(_,R){return m.create(_,R)}static regex(_,R){return n.create(_,R)}static in(_,R){return a.create(_,R)}static not(_){return E.create(_)}static and(..._){return o.create(_)}static or(..._){return s.create(_)}static greater(_,R){return f.create(_,R)}static less(_,R){return b.create(_,R)}static deserialize(_,R=!1){if(!!_)return this._deserializeOrExpression(_,R)}static _deserializeOrExpression(_,R){let B=_.split("||");return s.create(B.map(Q=>this._deserializeAndExpression(Q,R)))}static _deserializeAndExpression(_,R){let B=_.split("&&");return o.create(B.map(Q=>this._deserializeOne(Q,R)))}static _deserializeOne(_,R){if(_=_.trim(),_.indexOf("!=")>=0){let B=_.split("!=");return m.create(B[0].trim(),this._deserializeValue(B[1],R))}if(_.indexOf("==")>=0){let B=_.split("==");return r.create(B[0].trim(),this._deserializeValue(B[1],R))}if(_.indexOf("=~")>=0){let B=_.split("=~");return n.create(B[0].trim(),this._deserializeRegexValue(B[1],R))}if(_.indexOf(" in ")>=0){let B=_.split(" in ");return a.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const B=_.split(">=");return l.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const B=_.split(">");return f.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const B=_.split("<=");return t.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const B=_.split("<");return b.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(_)?E.create(_.substr(1).trim()):h.create(_)}static _deserializeValue(_,R){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;let B=/^'([^']*)'$/.exec(_);return B?B[1].trim():_}static _deserializeRegexValue(_,R){if((0,w.isFalsyOrWhitespace)(_)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let B=_.indexOf("/"),Q=_.lastIndexOf("/");if(B===Q||B<0){if(R)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}let ge=_.slice(B+1,Q),V=_[Q+1]==="i"?"i":"";try{return new RegExp(ge,V)}catch(H){if(R)throw new Error(`bad regexp-value '${_}', parse error: ${H}`);return console.warn(`bad regexp-value '${_}', parse error: ${H}`),null}}}e.ContextKeyExpr=C;function i(g,_){return g.cmp(_)}class P{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class d{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class h{constructor(_){this.key=_,this.type=2}static create(_){const R=y.get(_);return typeof R=="boolean"?R?d.INSTANCE:P.INSTANCE:new h(_)}cmp(_){return _.type!==this.type?this.type-_.type:v(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=h;class r{constructor(_,R){this.key=_,this.value=R,this.type=4}static create(_,R){if(typeof R=="boolean")return R?h.create(_):E.create(_);const B=y.get(_);return typeof B=="boolean"?R===(B?"true":"false")?d.INSTANCE:P.INSTANCE:new r(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:k(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class a{constructor(_,R){this.key=_,this.valueKey=R,this.type=10}static create(_,R){return new a(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:k(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}evaluate(_){const R=_.getValue(this.valueKey),B=_.getValue(this.key);return Array.isArray(R)?R.indexOf(B)>=0:typeof B=="string"&&typeof R=="object"&&R!==null?D.call(R,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}e.ContextKeyInExpr=a;class p{constructor(_){this._actual=_,this.type=11}static create(_){return new p(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new p(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class m{constructor(_,R){this.key=_,this.value=R,this.type=5}static create(_,R){if(typeof R=="boolean")return R?E.create(_):h.create(_);const B=y.get(_);return typeof B=="boolean"?R===(B?"true":"false")?P.INSTANCE:d.INSTANCE:new m(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:k(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=m;class E{constructor(_){this.key=_,this.type=3}static create(_){const R=y.get(_);return typeof R=="boolean"?R?P.INSTANCE:d.INSTANCE:new E(_)}cmp(_){return _.type!==this.type?this.type-_.type:v(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=E;class f{constructor(_,R){this.key=_,this.value=R,this.type=12}static create(_,R){return new f(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:k(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=f;class l{constructor(_,R){this.key=_,this.value=R,this.type=13}static create(_,R){return new l(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:k(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class b{constructor(_,R){this.key=_,this.value=R,this.type=14}static create(_,R){return new b(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:k(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=b;class t{constructor(_,R){this.key=_,this.value=R,this.type=15}static create(_,R){return new t(_,R)}cmp(_){return _.type!==this.type?this.type-_.type:k(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(_,R){this.key=_,this.regexp=R,this.type=7}static create(_,R){return new n(_,R)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const R=this.regexp?this.regexp.source:"",B=_.regexp?_.regexp.source:"";return R<B?-1:R>B?1:0}equals(_){if(_.type===this.type){const R=this.regexp?this.regexp.source:"",B=_.regexp?_.regexp.source:"";return this.key===_.key&&R===B}return!1}evaluate(_){let R=_.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return u.create(this)}}e.ContextKeyRegexExpr=n;class u{constructor(_){this._actual=_,this.type=8}static create(_){return new u(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new u(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=u;class o{constructor(_){this.expr=_,this.type=6}static create(_){return o._normalizeArr(_)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let R=0,B=this.expr.length;R<B;R++){const Q=i(this.expr[R],_.expr[R]);if(Q!==0)return Q}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let R=0,B=this.expr.length;R<B;R++)if(!this.expr[R].equals(_.expr[R]))return!1;return!0}return!1}evaluate(_){for(let R=0,B=this.expr.length;R<B;R++)if(!this.expr[R].evaluate(_))return!1;return!0}static _normalizeArr(_){const R=[];let B=!1;for(const Q of _)if(!!Q){if(Q.type===1){B=!0;continue}if(Q.type===0)return P.INSTANCE;if(Q.type===6){R.push(...Q.expr);continue}R.push(Q)}if(R.length===0&&B)return d.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(i);R.length>1;){const Q=R[R.length-1];if(Q.type!==9)break;R.pop();const ge=R.pop(),V=s.create(Q.expr.map(H=>o.create([H,ge])));V&&(R.push(V),R.sort(i))}return R.length===1?R[0]:new o(R)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(let R of this.expr)_.push(...R.keys());return _}map(_){return new o(this.expr.map(R=>R.map(_)))}negate(){let _=[];for(let R of this.expr)_.push(R.negate());return s.create(_)}}e.ContextKeyAndExpr=o;class s{constructor(_){this.expr=_,this.type=9}static create(_){const R=s._normalizeArr(_);if(R.length!==0)return R.length===1?R[0]:new s(R)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let R=0,B=this.expr.length;R<B;R++){const Q=i(this.expr[R],_.expr[R]);if(Q!==0)return Q}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let R=0,B=this.expr.length;R<B;R++)if(!this.expr[R].equals(_.expr[R]))return!1;return!0}return!1}evaluate(_){for(let R=0,B=this.expr.length;R<B;R++)if(this.expr[R].evaluate(_))return!0;return!1}static _normalizeArr(_){let R=[],B=!1;if(_){for(let Q=0,ge=_.length;Q<ge;Q++){const V=_[Q];if(!!V){if(V.type===0){B=!0;continue}if(V.type===1)return[d.INSTANCE];if(V.type===9){R=R.concat(V.expr);continue}R.push(V)}}if(R.length===0&&B)return[P.INSTANCE];R.sort(i)}return R}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(let R of this.expr)_.push(...R.keys());return _}map(_){return new s(this.expr.map(R=>R.map(_)))}negate(){let _=[];for(let B of this.expr)_.push(B.negate());const R=B=>B.type===9?B.expr:[B];for(;_.length>1;){const B=_.shift(),Q=_.shift(),ge=[];for(const V of R(B))for(const H of R(Q))ge.push(C.and(V,H));_.unshift(C.or(...ge))}return _[0]}}e.ContextKeyOrExpr=s;class c extends h{constructor(_,R,B){super(_);this._defaultValue=R,typeof B=="object"?c._info.push(Object.assign(Object.assign({},B),{key:_})):B!==!0&&c._info.push({key:_,description:B,type:R!=null?typeof R:void 0})}static all(){return c._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(_){return C.equals(this.key,_)}notEqualsTo(_){return C.notEquals(this.key,_)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(g,_){return g<_?-1:g>_?1:0}function k(g,_,R,B){return g<R?-1:g>R?1:_<B?-1:_>B?1:0}}),define(we[149],_e([0,1,4]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(we[26],_e([0,1,8,4]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(C){C[C.System=0]="System",C[C.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class y{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,P){if(typeof i=="undefined"||i===null)return typeof P=="undefined"||P===null;if(typeof P=="undefined"||P===null)return!1;if(typeof i=="string"||typeof P=="string"){let d=typeof i=="string"?i:i.value,h=typeof P=="string"?P:P.value;return w.equalsIgnoreCase(d,h)}return i._lower===P._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=y;function D(C){return C.contributes&&C.contributes.localizations?C.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function S(C){return C.contributes&&C.contributes.authentication?C.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[150],_e([0,1,8,26]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(h,r){return h.uuid&&r.uuid?h.uuid===r.uuid:h.id===r.id?!0:(0,w.compareIgnoreCase)(h.id,r.id)===0}e.areSameExtensions=A;class T{constructor(r,a){this.version=a,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof T?A(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=T;function y(h,r){return`${h}.${r}`}e.getExtensionId=y;function D(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function S(h,r){return D(y(h,r))}e.getGalleryExtensionId=S;function C(h,r){const a=[],p=m=>{for(const E of a)if(E.some(f=>A(r(f),r(m))))return E;return null};for(const m of h){const E=p(m);E?E.push(m):a.push([m])}return a}e.groupByExtension=C;function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function P(h){return Object.assign({id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0)},h.telemetryData)}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function d(h){const r=new Set;for(const a of h)a.malicious&&r.add(a.id.id);return r}e.getMaliciousExtensionsSet=d}),define(we[64],_e([0,1,126,13,2,4,8,10,22]),function(Y,e,w,I,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function C(V){return V.create===!0}e.isFileOpenForWriteOptions=C;var i;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var P;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(P=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=d;function h(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=h;function r(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function a(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=a;var p;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(H,te){super(H);this.code=te}}e.FileSystemProviderError=m;function E(V,H){const te=new m(V.toString(),H);return l(te,H),te}e.createFileSystemProviderError=E;function f(V){return V||E((0,w.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=f;function l(V,H){return V.name=H?`${H} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=l;function b(V){if(!V)return p.Unknown;if(V instanceof m)return V.code;const H=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!H)return p.Unknown;switch(H[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=b;function t(V){if(V instanceof v)return V.fileOperationResult;switch(b(V)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class u{constructor(H,te,$){this.resource=H,this.operation=te,this.target=$}isOperation(H){return this.operation===H}}e.FileOperationEvent=u;var o;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class s{constructor(H,te){this.ignorePathCasing=te,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=H;for(const $ of H)switch($.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set($.resource,$);break}}contains(H,...te){return this.doContains(H,{includeChildren:!1},...te)}affects(H,...te){return this.doContains(H,{includeChildren:!0},...te)}doContains(H,te,...$){var F,L,M,U,G,J;if(!H)return!1;const re=$.length>0;return!!((!re||$.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(H))||te.includeChildren&&((L=this.added)===null||L===void 0?void 0:L.findSuperstr(H)))||(!re||$.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(H))||te.includeChildren&&((U=this.updated)===null||U===void 0?void 0:U.findSuperstr(H)))||(!re||$.includes(2))&&(((G=this.deleted)===null||G===void 0?void 0:G.findSubstr(H))||te.includeChildren&&((J=this.deleted)===null||J===void 0?void 0:J.findSuperstr(H))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(H){const te=[],$=H===1?this.added:H===0?this.updated:this.deleted;if($)for(const[,F]of $)te.push(F);return te}filter(H){return new s(this.changes.filter(te=>H(te)),this.ignorePathCasing)}}e.FileChangesEvent=s;function c(V,H,te){return!V||!H||V===H||H.length>V.length?!1:(H.charAt(H.length-1)!==I.sep&&(H+=I.sep),te?(0,y.startsWithIgnoreCase)(V,H):V.indexOf(H)===0)}e.isParent=c;class v extends Error{constructor(H,te,$){super(H);this.fileOperationResult=te,this.options=$}static isFileOperationError(H){return H instanceof Error&&!(0,D.isUndefinedOrNull)(H.fileOperationResult)}}e.FileOperationError=v;var k;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(k=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var g;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(g=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function _(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=_;async function R(V,H){if(!H.canHandleResource(A.URI.from({scheme:V.scheme})))return new Promise(te=>{const $=H.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===V.scheme&&F.added&&($.dispose(),te())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(H){return(0,D.isNumber)(H)||(H=0),H<B.KB?(0,w.localize)(1,null,H.toFixed(0)):H<B.MB?(0,w.localize)(2,null,(H/B.KB).toFixed(2)):H<B.GB?(0,w.localize)(3,null,(H/B.MB).toFixed(2)):H<B.TB?(0,w.localize)(4,null,(H/B.GB).toFixed(2)):(0,w.localize)(5,null,(H/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var Q;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(Q=e.Arch||(e.Arch={}));function ge(V){return{maxFileSize:V===0?300*B.MB:16*B.GB,maxHeapSize:V===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=ge}),define(we[65],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...A){this._entries=new Map;for(let[T,y]of A)this.set(T,y)}set(A,T){const y=this._entries.get(A);return this._entries.set(A,T),y}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=w}),define(we[151],_e([0,1,12,145,89,4,65,11]),function(Y,e,w,I,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class C extends Error{constructor(r){var a;super("cyclic dependency between services");this.message=(a=r.findCycleSlow())!==null&&a!==void 0?a:`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class i{constructor(r=new y.ServiceCollection,a=!1,p){this._activeInstantiations=new Set,this._services=r,this._strict=a,this._parent=p,this._services.set(T.IInstantiationService,this)}createChild(r){return new i(r,this._strict,this)}invokeFunction(r,...a){let p=d.traceInvocation(r),m=!1;try{return r({get:(f,l)=>{if(m)throw(0,w.illegalState)("service accessor is only valid during the invocation of its target method");const b=this._getOrCreateServiceInstance(f,p);if(!b&&l!==T.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return b}},...a)}finally{m=!0,p.stop()}}createInstance(r,...a){let p,m;return r instanceof A.SyncDescriptor?(p=d.traceCreation(r.ctor),m=this._createInstance(r.ctor,r.staticArguments.concat(a),p)):(p=d.traceCreation(r),m=this._createInstance(r,a,p)),p.stop(),m}_createInstance(r,a=[],p){let m=T._util.getServiceDependencies(r).sort((l,b)=>l.index-b.index),E=[];for(const l of m){let b=this._getOrCreateServiceInstance(l.id,p);if(!b&&this._strict&&!l.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${l.id}.`);E.push(b)}let f=m.length>0?m[0].index:a.length;if(a.length!==f){console.warn(`[createInstance] First service dependency of ${r.name} at position ${f+1} conflicts with ${a.length} static arguments`);let l=f-a.length;l>0?a=a.concat(new Array(l)):a=a.slice(0,f)}return new r(...[...a,...E])}_setServiceInstance(r,a){if(this._services.get(r)instanceof A.SyncDescriptor)this._services.set(r,a);else if(this._parent)this._parent._setServiceInstance(r,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let a=this._services.get(r);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):a}_getOrCreateServiceInstance(r,a){let p=this._getServiceInstanceOrDescriptor(r);return p instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,p,a.branch(r,!0)):(a.branch(r,!1),p)}_safeCreateAndCacheServiceInstance(r,a,p){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,a,p)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,a,p){const m=new I.Graph(l=>l.id.toString());let E=0;const f=[{id:r,desc:a,_trace:p}];for(;f.length;){const l=f.pop();if(m.lookupOrInsertNode(l),E++>1e3)throw new C(m);for(let b of T._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(b.id);if(!t&&!b.optional&&console.warn(`[createInstance] ${r} depends on ${b.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const n={id:b.id,desc:t,_trace:l._trace.branch(b.id,!0)};m.insertEdge(l,n),f.push(n)}}}for(;;){const l=m.roots();if(l.length===0){if(!m.isEmpty())throw new C(m);break}for(const{data:b}of l){if(this._getServiceInstanceOrDescriptor(b.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(b.id,b.desc.ctor,b.desc.staticArguments,b.desc.supportsDelayedInstantiation,b._trace);this._setServiceInstance(b.id,n)}m.removeNode(b)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,a,p=[],m,E){if(this._services.get(r)instanceof A.SyncDescriptor)return this._createServiceInstance(a,p,m,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,a,p,m,E);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(r,a=[],p,m){if(p){const E=new D.IdleValue(()=>this._createInstance(r,a,m));return new Proxy(Object.create(null),{get(f,l){if(l in f)return f[l];let b=E.value,t=b[l];return typeof t!="function"||(t=t.bind(b),f[l]=t),t},set(f,l,b){return E.value[l]=b,!0}})}else return this._createInstance(r,a,m)}}e.InstantiationService=i;var P;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(P||(P={}));class d{constructor(r,a){this.type=r,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return S?new d(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(r){return S?new d(0,r.name):d._None}branch(r,a){let p=new d(2,r.toString());return this._dep.push([r,a,p]),p}stop(){let r=Date.now()-this._start;d._totals+=r;let a=!1;function p(E,f){let l=[],b=new Array(E+1).join("	");for(const[t,n,u]of f._dep)if(n&&u){a=!0,l.push(`${b}CREATES -> ${t}`);let o=p(E+1,u);o&&l.push(o)}else l.push(`${b}uses -> ${t}`);return l.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(r>2||a)&&console.log(m.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(we[18],_e([0,1,4,6,21,3,60]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function D(){return new Date().toISOString()}var S;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class C extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class i extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(S.Error))if(t instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=t.stack,this.log(S.Error,this.format(u))}else this.log(S.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let u=0;u<t.length;u++){let o=t[u];if(typeof o=="object")try{o=JSON.stringify(o)}catch(s){}n+=(u>0?" ":"")+o}return n}}e.AbstractMessageLogger=i;class P extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...n){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}debug(t,...n){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}info(t,...n){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}warn(t,...n){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...n):console.warn(`[main ${D()}]`,t,...n))}error(t,...n){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...n):console.error(`[main ${D()}]`,t,...n))}critical(t,...n){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...n):console.error(`[main ${D()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class d extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class h extends C{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class r extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const u of this.logServices)u.trace(t,...n)}debug(t,...n){for(const u of this.logServices)u.debug(t,...n)}info(t,...n){for(const u of this.logServices)u.info(t,...n)}warn(t,...n){for(const u of this.logServices)u.warn(t,...n)}error(t,...n){for(const u of this.logServices)u.error(t,...n)}critical(t,...n){for(const u of this.logServices)u.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class a extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=a;class p extends I.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(u=>{this.logLevel=u,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(u))}))}createLogger(t,n){let u=this.loggers.get(t.toString());return u||(u=this.doCreateLogger(t,(n==null?void 0:n.always)?S.Trace:this.logLevel,n),this.loggers.set(t.toString(),u),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(u)),u}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class m{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=m;function E(b){if(b.verbose)return S.Trace;if(typeof b.logLevel=="string"){const t=f(b.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function f(b){switch(b){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=f;function l(b){switch(b){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=l}),define(we[90],_e([0,1,4,127,47]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var y;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function C(r,a){return a-r}S.compare=C;const i=Object.create(null);i[S.Error]=(0,I.localize)(0,null),i[S.Warning]=(0,I.localize)(1,null),i[S.Info]=(0,I.localize)(2,null);function P(r){return i[r]||""}S.toString=P;function d(r){switch(r){case A.default.Error:return S.Error;case A.default.Warning:return S.Warning;case A.default.Info:return S.Info;case A.default.Ignore:return S.Hint}}S.fromSeverity=d;function h(r){switch(r){case S.Error:return A.default.Error;case S.Warning:return A.default.Warning;case S.Info:return A.default.Info;case S.Hint:return A.default.Ignore}}S.toSeverity=h}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(S){const C="";function i(d){return P(d,!0)}S.makeKey=i;function P(d,h){let r=[C];return d.source?r.push(d.source.replace("\xA6","\\\xA6")):r.push(C),d.code?typeof d.code=="string"?r.push(d.code.replace("\xA6","\\\xA6")):r.push(d.code.value.replace("\xA6","\\\xA6")):r.push(C),d.severity!==void 0&&d.severity!==null?r.push(y.toString(d.severity)):r.push(C),d.message&&h?r.push(d.message.replace("\xA6","\\\xA6")):r.push(C),d.startLineNumber!==void 0&&d.startLineNumber!==null?r.push(d.startLineNumber.toString()):r.push(C),d.startColumn!==void 0&&d.startColumn!==null?r.push(d.startColumn.toString()):r.push(C),d.endLineNumber!==void 0&&d.endLineNumber!==null?r.push(d.endLineNumber.toString()):r.push(C),d.endColumn!==void 0&&d.endColumn!==null?r.push(d.endColumn.toString()):r.push(C),r.push(C),r.join("\xA6")}S.makeKeyOptionalMessage=P})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(we[152],_e([0,1,47,4,3]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=w.default,e.INotificationService=(0,I.createDecorator)("notificationService");var T;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new S,this.onDidClose=A.Event.None,this.onDidChangeVisibility=A.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=D;class S{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=S});var Ve=this&&this.__decorate||function(Y,e,w,I){var A=arguments.length,T=A<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,w):I,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Y,e,w,I);else for(var D=Y.length-1;D>=0;D--)(y=Y[D])&&(T=(A<3?y(T):A>3?y(e,w,T):y(e,w))||T);return A>3&&T&&Object.defineProperty(e,w,T),T},qe=this&&this.__param||function(Y,e){return function(w,I){e(w,I,Y)}};define(we[153],_e([0,1,4,20,6,11]),function(Y,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,w.createDecorator)("progressService");var y;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let S=class extends A.Disposable{constructor(P,d){super();this.deferred=new T.DeferredPromise,d.withProgress(P,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,A.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};S=Ve([qe(1,e.IProgressService)],S),e.UnmanagedProgress=S;class C extends A.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new A.DisposableStore)}start(P){this.stop();const d=++this.currentOperationId,h=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,A.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,A.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,A.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:h.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,w.createDecorator)("editorProgressService")}),define(we[29],_e([0,1,10,42]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(y,D){I.ok(w.isString(y)),I.ok(w.isObject(D)),I.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,D)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new A}),define(we[91],_e([0,1,29,3]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class T{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,C){this.schemasById[A(S)]=C,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new T;w.Registry.add(e.Extensions.JSONContribution,y)}),define(we[66],_e([0,1,124,3,29,10,91]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=A.Registry.as(y.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:w.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,E=!0){this.registerConfigurations([m],E)}registerConfigurations(m,E=!0){const f=[];m.forEach(l=>{f.push(...this.validateAndRegisterProperties(l,E,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterConfigurations(m){const E=[],f=l=>{if(l.properties)for(const b in l.properties)E.push(b),delete this.configurationProperties[b],this.removeFromSchema(b,l.properties[b]);l.allOf&&l.allOf.forEach(b=>f(b))};for(const l of m){f(l);const b=this.configurationContributors.indexOf(l);b!==-1&&this.configurationContributors.splice(b,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(m){const E=[],f=[];for(const l of m)for(const b in l)if(E.push(b),e.OVERRIDE_PROPERTY_PATTERN.test(b)){this.defaultValues[b]=Object.assign(Object.assign({},this.defaultValues[b]||{}),l[b]);const t={type:"object",default:this.defaultValues[b],description:w.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId};f.push(P(b)),this.configurationProperties[b]=t,this.defaultLanguageConfigurationOverridesNode.properties[b]=t}else{this.defaultValues[b]=l[b];const t=this.configurationProperties[b];t&&(this.updatePropertyDefaultValue(b,t),this.updateSchema(b,t))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(m){const E=[];for(const f of m)for(const l in f)if(E.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const b=this.configurationProperties[l];b&&(this.updatePropertyDefaultValue(l,b),this.updateSchema(l,b))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const E of m)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,E=!0,f,l=3){var b;l=T.isUndefinedOrNull(m.scope)?l:m.scope;let t=[],n=m.properties;if(n)for(let o in n){if(E&&r(o)){delete n[o];continue}const s=n[o];if(this.updatePropertyDefaultValue(o,s),e.OVERRIDE_PROPERTY_PATTERN.test(o)?s.scope=void 0:(s.scope=T.isUndefinedOrNull(s.scope)?l:s.scope,s.restricted=T.isUndefinedOrNull(s.restricted)?!!((b=f==null?void 0:f.restrictedConfigurations)===null||b===void 0?void 0:b.includes(o)):s.restricted),n[o].hasOwnProperty("included")&&!n[o].included){this.excludedConfigurationProperties[o]=n[o],delete n[o];continue}else this.configurationProperties[o]=n[o];!n[o].deprecationMessage&&n[o].markdownDeprecationMessage&&(n[o].deprecationMessage=n[o].markdownDeprecationMessage),t.push(o)}let u=m.allOf;if(u)for(let o of u)t.push(...this.validateAndRegisterProperties(o,E,f,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const E=f=>{let l=f.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let b=f.allOf;b&&b.forEach(E)};E(m)}updateSchema(m,E){switch(e.allSettings.properties[m]=E,E.scope){case 1:e.applicationSettings.properties[m]=E;break;case 2:e.machineSettings.properties[m]=E;break;case 6:e.machineOverridableSettings.properties[m]=E;break;case 3:e.windowSettings.properties[m]=E;break;case 4:e.resourceSettings.properties[m]=E;break;case 5:e.resourceSettings.properties[m]=E,this.resourceLanguageSettingsSchema.properties[m]=E;break}}removeFromSchema(m,E){switch(delete e.allSettings.properties[m],E.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const E=`[${m}]`,f={type:"object",description:w.localize(2,null),errorMessage:w.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,f),e.allSettings.properties[E]=f,e.applicationSettings.properties[E]=f,e.machineSettings.properties[E]=f,e.machineOverridableSettings.properties[E]=f,e.windowSettings.properties[E]=f,e.resourceSettings.properties[E]=f}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,E){let f=this.defaultValues[m];T.isUndefined(f)&&(f=E.default),T.isUndefined(f)&&(f=d(E.type)),E.default=f}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function P(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=P;function d(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const h=new C;A.Registry.add(e.Extensions.Configuration,h);function r(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?w.localize(5,null,p):h.getConfigurationProperties()[p]!==void 0?w.localize(6,null,p):null:w.localize(4,null)}e.validateProperty=r;function a(){const p=[],m=h.getConfigurationProperties();for(const E of Object.keys(m))p.push([E,m[E].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=a}),define(we[92],_e([0,1,23,10,2,29,4,66]),function(Y,e,w,I,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function S(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationOverrides=S;var C;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function P(n,u){const o=u?n?u.keys.filter(R=>n.keys.indexOf(R)===-1):[...u.keys]:[],s=n?u?n.keys.filter(R=>u.keys.indexOf(R)===-1):[...n.keys]:[],c=[];if(u&&n){for(const R of n.keys)if(u.keys.indexOf(R)!==-1){const B=m(n.contents,R),Q=m(u.contents,R);w.equals(B,Q)||c.push(R)}}const v=[],k=R=>{const B={};for(const Q of R)for(const ge of Q.identifiers)B[b(ge)]=Q;return B},g=u?k(u.overrides):{},_=n?k(n.overrides):{};if(Object.keys(g).length)for(const R of o){const B=g[R];B&&v.push([(0,D.overrideIdentifierFromKey)(R),B.keys])}if(Object.keys(_).length)for(const R of s){const B=_[R];B&&v.push([(0,D.overrideIdentifierFromKey)(R),B.keys])}if(Object.keys(g).length&&Object.keys(_).length)for(const R of c){const B=_[R],Q=g[R];if(B&&Q){const ge=P({contents:B.contents,keys:B.keys,overrides:[]},{contents:Q.contents,keys:Q.keys,overrides:[]});v.push([(0,D.overrideIdentifierFromKey)(R),[...ge.added,...ge.removed,...ge.updated]])}}return{added:o,removed:s,updated:c,overrides:v}}e.compare=P;function d(n,u){const o=[];for(const s of Object.keys(n))if(D.OVERRIDE_PROPERTY_PATTERN.test(s)){const c={};for(const v in n[s])c[v]=n[s][v];o.push({identifiers:[(0,D.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(c),contents:h(c,u)})}return o}e.toOverrides=d;function h(n,u){const o=Object.create(null);for(let s in n)r(o,s,n[s],u);return o}e.toValuesTree=h;function r(n,u,o,s){const c=u.split("."),v=c.pop();let k=n;for(let g=0;g<c.length;g++){let _=c[g],R=k[_];switch(typeof R){case"undefined":R=k[_]=Object.create(null);break;case"object":break;default:s(`Ignoring ${u} as ${c.slice(0,g+1).join(".")} is ${JSON.stringify(R)}`);return}k=R}if(typeof k=="object"&&k!==null)try{k[v]=o}catch(g){s(`Ignoring ${u} as ${c.join(".")} is ${JSON.stringify(k)}`)}else s(`Ignoring ${u} as ${c.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=r;function a(n,u){const o=u.split(".");p(n,o)}e.removeFromValueTree=a;function p(n,u){const o=u.shift();if(u.length===0){delete n[o];return}if(Object.keys(n).indexOf(o)!==-1){const s=n[o];typeof s=="object"&&!Array.isArray(s)&&(p(s,u),Object.keys(s).length===0&&delete n[o])}}function m(n,u,o){function s(k,g){let _=k;for(const R of g){if(typeof _!="object"||_===null)return;_=_[R]}return _}const c=u.split("."),v=s(n,c);return typeof v=="undefined"?o:v}e.getConfigurationValue=m;function E(n,u,o){Object.keys(u).forEach(s=>{s!=="__proto__"&&(s in n?I.isObject(n[s])&&I.isObject(u[s])?E(n[s],u[s],o):o&&(n[s]=u[s]):n[s]=u[s])})}e.merge=E;function f(){const n=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=f;function l(){const n=Object.create(null),u=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let o in u){let s=u[o].default;r(n,o,s,c=>console.error(`Conflict in default settings: ${c}`))}return n}e.getDefaultValues=l;function b(n){return`[${n}]`}e.keyFromOverrideIdentifier=b;function t(n,u,o){const s=n.inspect(u),c=n.inspect(o);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:s.defaultValue}e.getMigratedSettingValue=t}),define(we[154],_e([0,1,44,22,15,10,23,2,66,92,29,6,3]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},n=[],u=[]){this._contents=t,this._keys=n,this._overrides=u,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,C.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const u=this.getContentsForOverrideIdentifer(n);return u?t?(0,C.getConfigurationValue)(u,t):u:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let u={};for(const o of A.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[o],c=n[o];c&&(typeof s=="object"&&typeof c=="object"?(s=y.deepClone(s),this.mergeContents(s,c)):s=c),u[o]=s}return new h(u,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),u=y.deepClone(this.overrides),o=[...this.keys];for(const s of t){this.mergeContents(n,s.contents);for(const c of s.overrides){const[v]=u.filter(k=>A.equals(k.identifiers,c.identifiers));v?this.mergeContents(v.contents,c.contents):u.push(y.deepClone(c))}for(const c of s.keys)o.indexOf(c)===-1&&o.push(c)}return new h(n,o,u)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const u of Object.keys(n)){if(u in t&&T.isObject(t[u])&&T.isObject(n[u])){this.mergeContents(t[u],n[u]);continue}t[u]=y.deepClone(n[u])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,C.addToValueTree)(this.contents,t,n,u=>{throw new Error(u)})}removeValue(t){this.removeKey(t)&&(0,C.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let u=0;u<n;u++)t.indexOf(this.keys[u])===0&&(n=u);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=h;class r extends h{constructor(){const t=(0,C.getDefaultValues)(),n=(0,C.getConfigurationKeys)(),u=[];for(const o of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(o)&&u.push({identifiers:[(0,S.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,C.toValuesTree)(t[o],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,n,u)}}e.DefaultConfigurationModel=r;class a{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const u=this.doParseContent(t);this.parseRaw(u,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:u,keys:o,overrides:s,restricted:c}=this.doParseRaw(t,n);this._configurationModel=new h(u,o,s),this._restrictedConfigurations=c||[]}doParseContent(t){let n={},u=null,o=[],s=[],c=[];function v(g){Array.isArray(o)?o.push(g):u&&(o[u]=g)}let k={onObjectBegin:()=>{let g={};v(g),s.push(o),o=g,u=null},onObjectProperty:g=>{u=g},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{let g=[];v(g),s.push(o),o=g,u=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:v,onError:(g,_,R)=>{c.push({error:g,offset:_,length:R})}};if(t)try{w.visit(t,k),n=o[0]||{}}catch(g){console.error(`Error while parsing settings file ${this._name}: ${g}`),this._parseErrors=[g]}return n}doParseRaw(t,n){const u=i.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,u,!0,n);t=o.raw;const s=(0,C.toValuesTree)(t,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),c=Object.keys(t),v=(0,C.toOverrides)(t,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:s,keys:c,overrides:v,restricted:o.restricted}}filter(t,n,u,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.skipRestricted))return{raw:t,restricted:[]};const s={},c=[];for(let v in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(v)&&u){const k=this.filter(t[v],n,!1,o);s[v]=k.raw,c.push(...k.restricted)}else{const k=n[v],g=k?typeof k.scope!="undefined"?k.scope:3:void 0;(k==null?void 0:k.restricted)&&c.push(v),(g===void 0||o.scopes===void 0||o.scopes.includes(g))&&(o.skipRestricted&&(k==null?void 0:k.restricted)||(s[v]=t[v]))}return{raw:s,restricted:c}}}e.ConfigurationModelParser=a;class p extends P.Disposable{constructor(t,n,u,o){super();this.userSettingsResource=t,this.scopes=n,this.fileService=o,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class m{constructor(t,n,u=new h,o=new h,s=new I.ResourceMap,c=new h,v=new I.ResourceMap,k=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=u,this._workspaceConfiguration=o,this._folderConfigurations=s,this._memoryConfiguration=c,this._memoryConfigurationByResource=v,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,n,u){return this.getConsolidateConfigurationModel(n,u).getValue(t)}updateValue(t,n,u={}){let o;u.resource?(o=this._memoryConfigurationByResource.get(u.resource),o||(o=new h,this._memoryConfigurationByResource.set(u.resource,o))):o=this._memoryConfiguration,n===void 0?o.removeValue(t):o.setValue(t,n),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,u){const o=this.getConsolidateConfigurationModel(n,u),s=this.getFolderConfigurationModelForResource(n.resource,u),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,v=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),k=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),g=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=u?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,B=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,Q=n.overrideIdentifier?c.override(n.overrideIdentifier).getValue(t):c.getValue(t),ge=o.getValue(t),V=A.distinct(A.flatten(o.overrides.map(H=>H.identifiers))).filter(H=>o.getOverrideValue(t,H)!==void 0);return{defaultValue:v,userValue:k,userLocalValue:g,userRemoteValue:_,workspaceValue:R,workspaceFolderValue:B,memoryValue:Q,value:ge,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:g!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:s==null?void 0:s.freeze().getValue(t),override:n.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:Q!==void 0?{value:c.getValue(t),override:n.overrideIdentifier?c.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const u=n.filter(o=>S.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const s=(0,S.overrideIdentifierFromKey)(o),c=this._defaultConfiguration.getKeysForOverrideIdentifier(s),v=t.getKeysForOverrideIdentifier(s),k=[...v.filter(g=>c.indexOf(g)===-1),...c.filter(g=>v.indexOf(g)===-1),...c.filter(g=>!y.equals(this._defaultConfiguration.override(s).getValue(g),t.override(s).getValue(g)))];return[s,k]});return this.updateDefaultConfiguration(t),{keys:n,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:u,removed:o,overrides:s}=(0,C.compare)(this.localUserConfiguration,t),c=[...n,...u,...o];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:u,removed:o,overrides:s}=(0,C.compare)(this.remoteUserConfiguration,t);let c=[...n,...u,...o];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:u,removed:o,overrides:s}=(0,C.compare)(this.workspaceConfiguration,t);let c=[...n,...u,...o];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(t,n){const u=this.folderConfigurations.get(t),{added:o,updated:s,removed:c,overrides:v}=(0,C.compare)(u,n);let k=[...o,...s,...c];return(k.length||!u)&&this.updateFolderConfiguration(t,n),{keys:k,overrides:v}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:u,updated:o,removed:s,overrides:c}=(0,C.compare)(n,void 0);return{keys:[...u,...o,...s],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let u=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?u.override(t.overrideIdentifier):u}getConsolidatedConfigurationModelForResource({resource:t},n){let u=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const o=n.getFolder(t);o&&(u=this.getFolderConsolidatedConfiguration(o.uri)||u);const s=this._memoryConfigurationByResource.get(t);s&&(u=u.merge(s))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const u=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(n=u.merge(o),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=u}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const u=n.getFolder(t);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:u,overrides:o,keys:s}=this._folderConfigurations.get(n);return t.push([n,{contents:u,overrides:o,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(u=>t.add(u))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>n.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>n.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>n.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),u=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((c,v)=>(c.set(D.URI.revive(v[0]),this.parseConfigurationModel(v[1])),c),new I.ResourceMap);return new m(n,u,new h,o,s,new h,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=m;function E(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const t=new Set,n=new Map;for(const o of b)o.keys.forEach(s=>t.add(s)),o.overrides.forEach(([s,c])=>{const v=(0,I.getOrSet)(n,s,new Set);c.forEach(k=>v.add(k))});const u=[];return n.forEach((o,s)=>u.push([s,[...o.values()]])),{keys:[...t.values()],overrides:u}}e.mergeChanges=E;class f{constructor(t,n,u,o){this.change=t,this.previous=n,this.currentConfiguraiton=u,this.currentWorkspace=o,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(v=>s.add(v)),t.overrides.forEach(([,v])=>v.forEach(k=>s.add(k))),this.affectedKeys=[...s.values()];const c=new h;this.affectedKeys.forEach(v=>c.setValue(v,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var u;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(u=this.previous)===null||u===void 0?void 0:u.workspace):void 0,s=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let u=(0,C.toValuesTree)({[n]:!0},()=>{}),o;for(;typeof u=="object"&&(o=Object.keys(u)[0]);){if(t=t[o],!t)return!1;u=u[o]}return!0}}e.ConfigurationChangeEvent=f;class l extends f{constructor(t,n,u,o){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=u,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=l}),define(we[67],_e([0,1,4]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var I;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(I=e.RemoteTrustOption||(e.RemoteTrustOption={}));var A;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(D,S=A.Unknown,C){super(D);this._message=D,this._code=S,this._detail=C,this.isHandled=S===A.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(D){return D instanceof T&&D._code===A.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof T&&D._code===A.NoResolverFound}static isHandled(D){return D instanceof T&&D.isHandled}}e.RemoteAuthorityResolverError=T}),define(we[93],_e([0,1,19]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function I(S){return S.scheme===w.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=I;function A(S){if(!!S){const C=S.indexOf("+");return C<0?S:S.substr(0,C)}}e.getRemoteName=A;function T(S){return S.scheme!==w.Schemas.file&&S.scheme!==w.Schemas.vscodeRemote}function y(S){if(S.folders.length)return S.folders.every(C=>T(C.uri))?S.folders[0].uri:void 0;if(S.configuration&&T(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=y;function D(S){var C;return(C=y(S))===null||C===void 0?void 0:C.scheme}e.getVirtualWorkspaceScheme=D}),define(we[155],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class w{constructor(A){this._callback=A,this._terminalBufferMap=new Map}dispose(){for(const A of this._terminalBufferMap.values())A.dispose()}startBuffering(A,T,y=5){let D;return D=T(S=>{const C=typeof S=="string"?S:S.data;let i=this._terminalBufferMap.get(A);if(i){i.data.push(C);return}const P=setTimeout(()=>this.flushBuffer(A),y);i={data:[C],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(A),D.dispose()}},this._terminalBufferMap.set(A,i)}),D}stopBuffering(A){const T=this._terminalBufferMap.get(A);T&&T.dispose()}flushBuffer(A){const T=this._terminalBufferMap.get(A);T&&(this._terminalBufferMap.delete(A),this._callback(A,T.data.join("")))}}e.TerminalDataBufferer=w}),define(we[156],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(we[157],_e([0,1,4,6,29,3,156,36]),function(Y,e,w,I,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,w.createDecorator)("themeService");var S;(function(p){function m(E){return E&&typeof E=="object"&&typeof E.id=="string"}p.isThemeColor=m})(S=e.ThemeColor||(e.ThemeColor={}));function C(p){return{id:p}}e.themeColorFromId=C;var i;(function(p){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||S.isThemeColor(t.color))}p.isThemeIcon=m;const E=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function f(t){const n=E.exec(t);if(!!n){let[,u]=n;return{id:u}}}p.fromString=f;function l(t,n){let u=t.id;const o=u.lastIndexOf("~");return o!==-1&&(u=u.substring(0,o)),n&&(u=`${u}~${n}`),{id:u}}p.modify=l;function b(t,n){var u,o;return t.id===n.id&&((u=t.color)===null||u===void 0?void 0:u.id)===((o=n.color)===null||o===void 0?void 0:o.id)}p.isEqual=b,p.asClassNameArray=D.CSSIcon.asClassNameArray,p.asClassName=D.CSSIcon.asClassName,p.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function P(p){switch(p){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,I.toDisposable)(()=>{const E=this.themingParticipants.indexOf(m);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new d;A.Registry.add(e.Extensions.ThemingContribution,h);function r(p){return h.onColorThemeChange(p)}e.registerThemingParticipant=r;class a extends I.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,E){let f=this.theme.getColor(m);return f&&E&&(f=E(f,this.theme)),f?f.toString():null}}e.Themable=a}),define(we[158],_e([0,1,29,157,3,128,91,11,36]),function(Y,e,w,I,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class C{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${S.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,E,f,l){const b=this.iconsById[m];if(b){if(f&&!b.description){b.description=f,this.iconSchema.properties[m].markdownDescription=`${f} $(${m})`;const u=this.iconReferenceSchema.enum.indexOf(m);u!==-1&&(this.iconReferenceSchema.enumDescriptions[u]=f),this._onDidChange.fire()}return b}let t={id:m,description:f,defaults:E,deprecationMessage:l};this.iconsById[m]=t;let n={$ref:"#/definitions/icons"};return l&&(n.deprecationMessage=l),f&&(n.markdownDescription=`${f}: $(${m})`),this.iconSchema.properties[m]=n,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(f||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const E=this.iconReferenceSchema.enum.indexOf(m);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,E){const f=this.iconFontsById[m];if(f)return f;let l={id:m,definition:E};return this.iconFontsById[m]=l,this._onDidChange.fire(),l}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFonts(){return Object.keys(this.iconFontsById).map(m=>this.iconFontsById[m])}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(b,t)=>b.id.localeCompare(t.id),E=b=>{for(;I.ThemeIcon.isThemeIcon(b.defaults);)b=this.iconsById[b.defaults.id];return`codicon codicon-${b?b.id:""}`};let f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(b=>this.iconsById[b]);for(const b of l.filter(t=>!!t.description).sort(m))f.push(`|<i class="${E(b)}"></i>|${b.id}|${I.ThemeIcon.isThemeIcon(b.defaults)?b.defaults.id:b.id}|${b.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const b of l.filter(t=>!I.ThemeIcon.isThemeIcon(t.defaults)).sort(m))f.push(`|<i class="${E(b)}"></i>|${b.id}|`);return f.join(`
`)}}const i=new C;w.Registry.add(e.Extensions.IconContribution,i);function P(p,m,E,f){return i.registerIcon(p,m,E,f)}e.registerIcon=P;function d(){return i}e.getIconRegistry=d;function h(){for(const p of S.iconRegistry.all)i.registerIcon(p.id,p.definition,p.description);S.iconRegistry.onDidRegister(p=>i.registerIcon(p.id,p.definition,p.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let r=w.Registry.as(y.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,i.getIconSchema());const a=new D.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.widgetClose=P("widget-close",S.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=P("goto-previous-location",S.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=P("goto-next-location",S.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=I.ThemeIcon.modify(S.Codicon.sync,"spin")}),define(we[48],_e([0,1,2,25,4,22]),function(Y,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var y;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function D(d){const h=d;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=D;function S(d){const h=d;return!!(h&&typeof h=="object"&&w.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=S;class C{constructor(h,r,a,p){this._id=h,this._configuration=a,this._ignorePathCasing=p,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class i{constructor(h,r){this.raw=r,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,I.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function P(d){return new i({uri:d,index:0,name:(0,I.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=P}),define(we[159],_e([0,1,4,129,48,2,21,13,25,107,44,19,58,37,93]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const a=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(te){return(typeof te=="string"?(0,D.extname)(te):(0,S.extname)(te))===a}e.hasWorkspaceFileExtension=p,e.IWorkspacesService=(0,w.createDecorator)("workspacesService");function m(te){return te.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function E(te){return te.hasOwnProperty("folderUri")}e.isRecentFolder=E;function f(te){return te.hasOwnProperty("fileUri")}e.isRecentFile=f;function l(te){const $=te;return typeof($==null?void 0:$.id)=="string"&&T.URI.isUri($.uri)}e.isSingleFolderWorkspaceIdentifier=l;function b(te){if(te.configuration)return{id:te.id,configPath:te.configuration};if(te.folders.length===1)return{id:te.id,uri:te.folders[0].uri}}e.toWorkspaceIdentifier=b;function t(te){const $=te;return typeof($==null?void 0:$.id)=="string"&&T.URI.isUri($.configPath)}e.isWorkspaceIdentifier=t;function n(te){const $=te;if($==null?void 0:$.uri)return{id:$.id,uri:T.URI.revive($.uri)};const F=te;if(F==null?void 0:F.configPath)return{id:F.id,configPath:T.URI.revive(F.configPath)};if(te==null?void 0:te.id)return{id:te.id}}e.reviveIdentifier=n;function u(te,$){return S.extUriBiasedIgnorePathCase.isEqualOrParent(te,$.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function o(te){return s(te)||c(te)}e.isStoredWorkspaceFolder=o;function s(te){const $=te;return typeof($==null?void 0:$.path)=="string"&&(!$.name||typeof $.name=="string")}e.isRawFileWorkspaceFolder=s;function c(te){const $=te;return typeof($==null?void 0:$.uri)=="string"&&(!$.name||typeof $.name=="string")}e.isRawUriWorkspaceFolder=c;function v(te,$,F,L,M=!y.isWindows,U){if(te.scheme!==L.scheme)return{name:F,uri:te.toString(!0)};let G=$?void 0:U.relativePath(L,te);if(G!==void 0)G.length===0?G=".":y.isWindows&&te.scheme===P.Schemas.file&&!M&&(G=G.replace(/\//g,"\\"));else if(te.scheme===P.Schemas.file)G=te.fsPath,y.isWindows&&(G=(0,d.normalizeDriveLetter)(G),M&&(G=(0,h.toSlashes)(G)));else{if(!U.isEqualAuthority(te.authority,L.authority))return{name:F,uri:te.toString(!0)};G=te.path}return{name:F,path:G}}e.getStoredWorkspaceFolder=v;function k(te,$,F){let L=[],M=new Set;const U=F.dirname($);for(let G of te){let J;if(s(G))G.path&&(J=F.resolvePath(U,G.path));else if(c(G))try{J=T.URI.parse(G.uri),J.path[0]!=="/"&&(J=J.with({path:"/"+J.path}))}catch(re){console.warn(re)}if(J){let re=F.getComparisonKey(J);if(!M.has(re)){M.add(re);const pe=G.name||F.basenameOrAuthority(J);L.push(new A.WorkspaceFolder({uri:J,name:pe,index:L.length},G))}}}return L}e.toWorkspaceFolders=k;function g(te,$,F,L,M){let U=_($,te);const G=M.dirname($),J=M.dirname(L),re=[],pe=R(U.folders);for(const We of U.folders){const x=s(We)?M.resolvePath(G,We.path):T.URI.parse(We.uri);let q;F?q=!1:q=!s(We)||(0,D.isAbsolute)(We.path),re.push(v(x,q,We.name,J,pe,M))}const Te={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Be=C.setProperty(te,["folders"],re,Te);let Ae=C.applyEdits(te,Be);return U.remoteAuthority===(0,r.getRemoteAuthority)(L)&&(Ae=C.applyEdits(Ae,C.removeProperty(Ae,["remoteAuthority"],Te))),Ae}e.rewriteWorkspaceFileForNewLocation=g;function _(te,$){let F=i.parse($);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(L=>o(L));else throw new Error(`${te} looks like an invalid workspace file.`);return F}function R(te){return y.isWindows?te.some($=>s($)&&$.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function B(te){return te.workspace&&typeof te.workspace=="object"&&typeof te.workspace.id=="string"&&typeof te.workspace.configPath=="string"}function Q(te){return typeof te.folderUri=="string"}function ge(te){return typeof te.fileUri=="string"}function V(te,$){const F={workspaces:[],files:[]};if(te){const L=function(U,G){for(let J=0;J<U.length;J++)try{G(U[J],J)}catch(re){$.warn(`Error restoring recent entry ${JSON.stringify(U[J])}: ${re.toString()}. Skip entry.`)}},M=te;if(Array.isArray(M.entries))L(M.entries,U=>{const G=U.label,J=U.remoteAuthority;B(U)?F.workspaces.push({label:G,remoteAuthority:J,workspace:{id:U.workspace.id,configPath:T.URI.parse(U.workspace.configPath)}}):Q(U)?F.workspaces.push({label:G,remoteAuthority:J,folderUri:T.URI.parse(U.folderUri)}):ge(U)&&F.files.push({label:G,remoteAuthority:J,fileUri:T.URI.parse(U.fileUri)})});else{const U=te;Array.isArray(U.workspaces3)&&L(U.workspaces3,(G,J)=>{const re=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[J]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?F.workspaces.push({label:re,workspace:{id:G.id,configPath:T.URI.parse(G.configURIPath)}}):typeof G=="string"&&F.workspaces.push({label:re,folderUri:T.URI.parse(G)})}),Array.isArray(U.files2)&&L(U.files2,(G,J)=>{const re=Array.isArray(U.fileLabels)&&U.fileLabels[J]||void 0;typeof G=="string"&&F.files.push({label:re,fileUri:T.URI.parse(G)})})}}return F}e.restoreRecentlyOpened=V;function H(te){const $={entries:[]};for(const F of te.workspaces)E(F)?$.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):$.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of te.files)$.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return $}e.toStoreData=H}),define(we[68],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class w{constructor(A){this.id=A,this._data=new Map,this._idPool=1}add(A){const T=this._idPool++;return this._data.set(T,A),this.logDebugInfo(),T}get(A,T){return this._data.has(A)?this._data.get(A)[T]:void 0}delete(A){this._data.delete(A),this.logDebugInfo()}logDebugInfo(){!w.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=w,w.enableDebugLogging=!1}),define(we[160],_e([0,1,2,3]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class A{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(D=>({name:D.name,group:D.group,resource:w.URI.revive(D.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(we[49],_e([0,1,19,4]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(w.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,D){D===null?this._providerInfo.delete(y):this._providerInfo.set(y,D)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(we[27],_e([0,1,4]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(we[161],_e([0,1,11]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(y,D,S){this._deferredPromises=new Map,this._id=y,this._shared=D,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new w.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of C.values())i.complete()}catch(i){for(const P of C.values())P.error(i)}})()},0)}get whenReady(){return this._init}get(y,D){let S=this._value[y];return typeof S=="undefined"&&(S=D),S}update(y,D){this._value[y]=D;let S=this._deferredPromises.get(y);if(S!==void 0)return S.p;const C=new w.DeferredPromise;return this._deferredPromises.set(y,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class A extends I{constructor(y,D){super(y.identifier.value,!0,D);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=A}),define(we[14],_e([0,1,4]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class I{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=I});var tt=this&&this.__classPrivateFieldSet||function(Y,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Y,w):A?A.value=w:e.set(Y,w),w},Me=this&&this.__classPrivateFieldGet||function(Y,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Y):I?I.value:e.get(Y)};define(we[162],_e([0,1,26,3]),function(Y,e,w,I){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(D,S){A.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=w.ExtensionIdentifier.toKey(D.identifier),tt(this,A,S,"f"),Me(this,A,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(D){return Me(this,A,"f").get(this._id,D)}store(D,S){return Me(this,A,"f").store(this._id,D,S)}delete(D){return Me(this,A,"f").delete(this._id,D)}}e.ExtensionSecrets=T,A=new WeakMap}),define(we[94],_e([0,1,4,3]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class A{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=A,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(we[69],_e([0,1,3]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var I;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(I=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const A=new WeakMap,T=y=>{let D=A.get(y);return D||(D={children:new Map,bus:new w.Emitter},A.set(y,D)),D};e.getPrivateApiFor=T}),define(we[70],_e([0,1,4,3,14]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(D){function S(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}D.fromApiTunnel=S;function C(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}D.fromServiceTunnel=C})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,w.createDecorator)("IExtHostTunnelService");let y=class{constructor(S){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,C){return{dispose:()=>{}}}async $providePortAttributes(S,C,i,P,d){return[]}async $forwardPort(S,C){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=Ve([qe(0,A.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var tt=this&&this.__classPrivateFieldSet||function(Y,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Y,w):A?A.value=w:e.set(Y,w),w},Me=this&&this.__classPrivateFieldGet||function(Y,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Y):I?I.value:e.get(Y)},Qt=this&&this.__rest||function(Y,e){var w={};for(var I in Y)Object.prototype.hasOwnProperty.call(Y,I)&&e.indexOf(I)<0&&(w[I]=Y[I]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(Y);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(Y,I[A])&&(w[I[A]]=Y[I[A]]);return w};define(we[7],_e([0,1,15,12,83,22,8,10,2,31,64,67,69]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d){"use strict";var h,r,a,p,m,E,f,l,b,t,n,u,o,s,c,v;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let g=a=class{constructor(O){h.set(this,void 0),tt(this,h,O,"f")}static from(...O){let se=O;return new a(function(){if(se){for(const De of se)De&&typeof De.dispose=="function"&&De.dispose();se=void 0}})}dispose(){typeof Me(this,h,"f")=="function"&&(Me(this,h,"f").call(this),tt(this,h,void 0,"f"))}};h=new WeakMap,g=a=Ve([k],g),e.Disposable=g;let _=p=class{constructor(O,se){if(O<0)throw(0,I.illegalArgument)("line must be non-negative");if(se<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=O,this._character=se}static Min(...O){if(O.length===0)throw new TypeError;let se=O[0];for(let De=1;De<O.length;De++){const Ke=O[De];Ke.isBefore(se)&&(se=Ke)}return se}static Max(...O){if(O.length===0)throw new TypeError;let se=O[0];for(let De=1;De<O.length;De++){const Ke=O[De];Ke.isAfter(se)&&(se=Ke)}return se}static isPosition(O){if(!O)return!1;if(O instanceof p)return!0;let{line:se,character:De}=O;return typeof se=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,se=0){if(O===null||se===null)throw(0,I.illegalArgument)();let De;return typeof O=="undefined"?De=0:typeof O=="number"?De=O:(De=typeof O.lineDelta=="number"?O.lineDelta:0,se=typeof O.characterDelta=="number"?O.characterDelta:0),De===0&&se===0?this:new p(this.line+De,this.character+se)}with(O,se=this.character){if(O===null||se===null)throw(0,I.illegalArgument)();let De;return typeof O=="undefined"?De=this.line:typeof O=="number"?De=O:(De=typeof O.line=="number"?O.line:this.line,se=typeof O.character=="number"?O.character:this.character),De===this.line&&se===this.character?this:new p(De,se)}toJSON(){return{line:this.line,character:this.character}}};_=p=Ve([k],_),e.Position=_;let R=m=class{constructor(O,se,De,Ke){let et,st;if(typeof O=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ke=="number"?(et=new _(O,se),st=new _(De,Ke)):O instanceof _&&se instanceof _&&(et=O,st=se),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(O){return O instanceof m?!0:O?_.isPosition(O.start)&&_.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof m?this.contains(O._start)&&this.contains(O._end):O instanceof _?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const se=_.Max(O.start,this._start),De=_.Min(O.end,this._end);if(!se.isAfter(De))return new m(se,De)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const se=_.Min(O.start,this._start),De=_.Max(O.end,this.end);return new m(se,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,se=this.end){if(O===null||se===null)throw(0,I.illegalArgument)();let De;return O?_.isPosition(O)?De=O:(De=O.start||this.start,se=O.end||this.end):De=this.start,De.isEqual(this._start)&&se.isEqual(this.end)?this:new m(De,se)}toJSON(){return[this.start,this.end]}};R=m=Ve([k],R),e.Range=R;let B=E=class extends R{constructor(O,se,De,Ke){let et,st;if(typeof O=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ke=="number"?(et=new _(O,se),st=new _(De,Ke)):O instanceof _&&se instanceof _&&(et=O,st=se),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(O){return O instanceof E?!0:O?R.isRange(O)&&_.isPosition(O.anchor)&&_.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};B=E=Ve([k],B),e.Selection=B;class Q{constructor(O,se,De){if(typeof O!="string"||O.length===0)throw(0,I.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,I.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,I.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(se),this.connectionToken=De}}e.ResolvedAuthority=Q;class ge extends Error{constructor(O,se=P.RemoteAuthorityResolverErrorCode.Unknown,De){super(O);this._message=O,this._code=se,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ge.prototype)}static NotAvailable(O,se){return new ge(O,P.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(O){return new ge(O,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ge;var V;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var H;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(H=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let te=f=class{constructor(O,se){this._range=O,this._newText=se}static isTextEdit(O){return O instanceof f?!0:O?R.isRange(O)&&typeof O.newText=="string":!1}static replace(O,se){return new f(O,se)}static insert(O,se){return f.replace(new R(O,O),se)}static delete(O){return f.replace(O,"")}static setEndOfLine(O){const se=new f(new R(new _(0,0),new _(0,0)),"");return se.newEol=O,se}get range(){return this._range}set range(O){if(O&&!R.isRange(O))throw(0,I.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,I.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,I.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};te=f=Ve([k],te),e.TextEdit=te;var $;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellOutput=4]="CellOutput",N[N.CellReplace=5]="CellReplace",N[N.CellOutputItem=6]="CellOutputItem"})($=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,se,De,Ke){this._edits.push({_type:1,from:O,to:se,options:De,metadata:Ke})}createFile(O,se,De){this._edits.push({_type:1,from:void 0,to:O,options:se,metadata:De})}deleteFile(O,se,De){this._edits.push({_type:1,from:O,to:void 0,options:se,metadata:De})}replaceNotebookMetadata(O,se,De){this._edits.push({_type:3,metadata:De,uri:O,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(O,se,De,Ke,et){let st,ct,yt=[],Ct;if($t.isNotebookRange(se)&&Lt.isNotebookCellDataArray(De)&&!Lt.isNotebookCellDataArray(Ke)?(st=se.start,ct=se.end,yt=De,Ct=Ke):typeof se=="number"&&typeof De=="number"&&Lt.isNotebookCellDataArray(Ke)&&(st=se,ct=De,yt=Ke,Ct=et),st===void 0||ct===void 0)throw new Error("Invalid arguments");(st!==ct||yt.length>0)&&this._edits.push({_type:5,uri:O,index:st,count:ct-st,cells:yt,metadata:Ct})}replaceNotebookCellMetadata(O,se,De,Ke){this._edits.push({_type:3,metadata:Ke,uri:O,edit:{editType:8,index:se,metadata:De}})}replace(O,se,De,Ke){this._edits.push({_type:2,uri:O,edit:new te(se,De),metadata:Ke})}insert(O,se,De,Ke){this.replace(O,new R(se,se),De,Ke)}delete(O,se,De){this.replace(O,se,"",De)}has(O){return this._edits.some(se=>se._type===2&&se.uri.toString()===O.toString())}set(O,se){if(se)for(const De of se)De&&this._edits.push({_type:2,uri:O,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ke=this._edits[De];Ke._type===2&&Ke.uri.toString()===O.toString()&&(this._edits[De]=void 0)}(0,w.coalesceInPlace)(this._edits)}}get(O){const se=[];for(let De of this._edits)De._type===2&&De.uri.toString()===O.toString()&&se.push(De.edit);return se}entries(){const O=new T.ResourceMap;for(let se of this._edits)if(se._type===2){let De=O.get(se.uri);De||(De=[se.uri,[]],O.set(se.uri,De)),De[1].push(se.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=Ve([k],F),e.WorkspaceEdit=F;let L=l=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof l?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=l._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,se=this._tabstop++){if(typeof O=="function"){const De=new l;De._tabstop=this._tabstop,O(De),this._tabstop=De._tabstop,O=De.value}else O=l._escape(O);return this.value+="${",this.value+=se,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,se=this._tabstop++){const De=O.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(O,se){if(typeof se=="function"){const De=new l;De._tabstop=this._tabstop,se(De),this._tabstop=De._tabstop,se=De.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,se&&(this.value+=":",this.value+=se),this.value+="}",this}};L=l=Ve([k],L),e.SnippetString=L;var M;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(M=e.DiagnosticTag||(e.DiagnosticTag={}));var U;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(U=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=b=class{constructor(O,se){if(this.uri=O,se)if(se instanceof R)this.range=se;else if(se instanceof _)this.range=new R(se,se);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof b?!0:O?R.isRange(O.range)&&S.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=b=Ve([k],G),e.Location=G;let J=class{constructor(O,se){this.location=O,this.message=se}static is(O){return O?typeof O.message=="string"&&O.location&&R.isRange(O.location.range)&&S.URI.isUri(O.location.uri):!1}static isEqual(O,se){return O===se?!0:!O||!se?!1:O.message===se.message&&O.location.range.isEqual(se.location.range)&&O.location.uri.toString()===se.location.uri.toString()}};J=Ve([k],J),e.DiagnosticRelatedInformation=J;let re=class{constructor(O,se,De=U.Error){if(!R.isRange(O))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=O,this.message=se,this.severity=De}toJSON(){return{severity:U[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,se){return O===se?!0:!O||!se?!1:O.message===se.message&&O.severity===se.severity&&O.code===se.code&&O.severity===se.severity&&O.source===se.source&&O.range.isEqual(se.range)&&(0,w.equals)(O.tags,se.tags)&&(0,w.equals)(O.relatedInformation,se.relatedInformation,J.isEqual)}};re=Ve([k],re),e.Diagnostic=re;let pe=class{constructor(O,se){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:(0,A.isMarkdownString)(O)?this.contents=[O]:this.contents=[O],this.range=se}};pe=Ve([k],pe),e.Hover=pe;var Te;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Te=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Be=class{constructor(O,se=Te.Text){this.range=O,this.kind=se}toJSON(){return{range:this.range,kind:Te[this.kind]}}};Be=Ve([k],Be),e.DocumentHighlight=Be;var Ae;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(Ae=e.SymbolKind||(e.SymbolKind={}));var We;(function(N){N[N.Deprecated=1]="Deprecated"})(We=e.SymbolTag||(e.SymbolTag={}));let x=t=class{constructor(O,se,De,Ke,et){this.name=O,this.kind=se,this.containerName=et,typeof De=="string"&&(this.containerName=De),Ke instanceof G?this.location=Ke:De instanceof R&&(this.location=new G(Ke,De)),t.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};x=t=Ve([k],x),e.SymbolInformation=x;let q=n=class{constructor(O,se,De,Ke,et){this.name=O,this.detail=se,this.kind=De,this.range=Ke,this.selectionRange=et,this.children=[],n.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(n.validate)}};q=n=Ve([k],q),e.DocumentSymbol=q;var ne;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ne=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(O,se){this.title=O,this.kind=se}};le=Ve([k],le),e.CodeAction=le;let fe=u=class{constructor(O){this.value=O}append(O){return new u(this.value?this.value+u.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+u.sep)}};fe.sep=".",fe=u=Ve([k],fe),e.CodeActionKind=fe,fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll");let Se=class{constructor(O,se){if(this.range=O,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Se=Ve([k],Se),e.SelectionRange=Se;class Oe{constructor(O,se,De,Ke,et,st){this.kind=O,this.name=se,this.detail=De,this.uri=Ke,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=Oe;class me{constructor(O,se){this.fromRanges=se,this.from=O}}e.CallHierarchyIncomingCall=me;class Ce{constructor(O,se){this.fromRanges=se,this.to=O}}e.CallHierarchyOutgoingCall=Ce;let Pe=class{constructor(O,se){this.range=O,this.command=se}get isResolved(){return!!this.command}};Pe=Ve([k],Pe),e.CodeLens=Pe;let $e=o=class{constructor(O,se=!1){r.set(this,void 0),tt(this,r,new A.MarkdownString(O,{supportThemeIcons:se}),"f")}static isMarkdownString(O){return O instanceof o?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Me(this,r,"f").value}set value(O){Me(this,r,"f").value=O}get isTrusted(){return Me(this,r,"f").isTrusted}set isTrusted(O){Me(this,r,"f").isTrusted=O}get supportThemeIcons(){return Me(this,r,"f").supportThemeIcons}appendText(O){return Me(this,r,"f").appendText(O),this}appendMarkdown(O){return Me(this,r,"f").appendMarkdown(O),this}appendCodeblock(O,se){return Me(this,r,"f").appendCodeblock(se!=null?se:"",O),this}};r=new WeakMap,$e=o=Ve([k],$e),e.MarkdownString=$e;let Ee=class{constructor(O,se){this.label=O,this.documentation=se}};Ee=Ve([k],Ee),e.ParameterInformation=Ee;let je=class{constructor(O,se){this.label=O,this.documentation=se,this.parameters=[]}};je=Ve([k],je),e.SignatureInformation=je;let z=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};z=Ve([k],z),e.SignatureHelp=z;var ee;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(ee=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ve;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(ve=e.InlayHintKind||(e.InlayHintKind={}));let Le=class{constructor(O,se,De){this.text=O,this.position=se,this.kind=De}};Le=Ve([k],Le),e.InlayHint=Le;var He;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(N){N[N.Deprecated=1]="Deprecated"})(Xe=e.CompletionItemTag||(e.CompletionItemTag={}));let W=class{constructor(O,se){this.label=O,this.kind=se}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};W=Ve([k],W),e.CompletionItem=W;let ie=class{constructor(O=[],se=!1){this.items=O,this.isIncomplete=se}};ie=Ve([k],ie),e.CompletionList=ie;var ce;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(ce=e.ViewColumn||(e.ViewColumn={}));var j;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(j=e.StatusBarAlignment||(e.StatusBarAlignment={}));var X;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ae;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var he;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(he=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ye;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ze;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ze=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(se){switch(se){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let xe=class{constructor(O,se){if(se&&!S.URI.isUri(se))throw(0,I.illegalArgument)("target");if(!R.isRange(O)||O.isEmpty)throw(0,I.illegalArgument)("range");this.range=O,this.target=se}};xe=Ve([k],xe),e.DocumentLink=xe;let Ne=class{constructor(O,se,De,Ke){this.red=O,this.green=se,this.blue=De,this.alpha=Ke}};Ne=Ve([k],Ne),e.Color=Ne;let Ge=class{constructor(O,se){if(se&&!(se instanceof Ne))throw(0,I.illegalArgument)("color");if(!R.isRange(O)||O.isEmpty)throw(0,I.illegalArgument)("range");this.range=O,this.color=se}};Ge=Ve([k],Ge),e.ColorInformation=Ge;let nt=class{constructor(O){if(!O||typeof O!="string")throw(0,I.illegalArgument)("label");this.label=O}};nt=Ve([k],nt),e.ColorPresentation=nt;var dt;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var it;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Je;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Je=e.TaskRevealKind||(e.TaskRevealKind={}));var mt;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(mt=e.TaskPanelKind||(e.TaskPanelKind={}));let bt=s=class{constructor(O,se){if(typeof O!="string"||typeof se!="string")throw(0,I.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};bt.Clean=new s("clean","Clean"),bt.Build=new s("build","Build"),bt.Rebuild=new s("rebuild","Rebuild"),bt.Test=new s("test","Test"),bt=s=Ve([k],bt),e.TaskGroup=bt;function be(N){let O="";for(let se=0;se<N.length;se++)O+=N[se].replace(/,/g,",,")+",";return O}let de=class{constructor(O,se,De){if(typeof O!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=O,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=De):this._options=se)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,I.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let se of this._args)O.push(se);return be(O)}};de=Ve([k],de),e.ProcessExecution=de;let oe=class{constructor(O,se,De){if(this._args=[],Array.isArray(se)){if(!O)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,I.illegalArgument)("command");this._command=O,this._args=se,this._options=De}else{if(typeof O!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=O,this._options=se}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,I.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)O.push(typeof se=="string"?se:se.value);return be(O)}};oe=Ve([k],oe),e.ShellExecution=oe;var K;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(K=e.ShellQuoting||(e.ShellQuoting={}));var Re;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(Re=e.TaskScope||(e.TaskScope={}));class Ie{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,C.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=Ie;let Qe=c=class{constructor(O,se,De,Ke,et,st){this.__deprecated=!1,this._definition=this.definition=O;let ct;typeof se=="string"?(this._name=this.name=se,this._source=this.source=De,this.execution=Ke,ct=et,this.__deprecated=!0):se===Re.Global||se===Re.Workspace?(this.target=se,this._name=this.name=De,this._source=this.source=Ke,this.execution=et,ct=st):(this.target=se,this._name=this.name=De,this._source=this.source=Ke,this.execution=et,ct=st),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof de?this._definition={type:c.ProcessType,id:this._execution.computeId()}:this._execution instanceof oe?this._definition={type:c.ShellType,id:this._execution.computeId()}:this._execution instanceof Ie?this._definition={type:c.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:c.EmptyType,id:(0,C.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const se=this._definition.type;(c.EmptyType===se||c.ProcessType===se||c.ShellType===se||c.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};Qe.ExtensionCallbackType="customExecution",Qe.ProcessType="process",Qe.ShellType="shell",Qe.EmptyType="$empty",Qe=c=Ve([k],Qe),e.Task=Qe;var Ze;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(Ze=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(O,se=ht.None){this.collapsibleState=se,S.URI.isUri(O)?this.resourceUri=O:this.label=O}};ut=Ve([k],ut),e.TreeItem=ut;var ht;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ye=class{constructor(O,se){this.id=O,this.color=se}};Ye=Ve([k],Ye),e.ThemeIcon=Ye,Ye.File=new Ye("file"),Ye.Folder=new Ye("folder");let ot=class{constructor(O){this.id=O}};ot=Ve([k],ot),e.ThemeColor=ot;var ft;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let at=class{constructor(O,se){if(typeof O!="string"&&(!O||!S.URI.isUri(O)&&!S.URI.isUri(O.uri)))throw(0,I.illegalArgument)("base");if(typeof se!="string")throw(0,I.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=S.URI.file(O),this.base=O):S.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=se}};at=Ve([k],at),e.RelativePattern=at;let Et=class{constructor(O,se,De,Ke){this.enabled=typeof O=="boolean"?O:!0,typeof se=="string"&&(this.condition=se),typeof De=="string"&&(this.hitCondition=De),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,C.generateUuid)()),this._id}};Et=Ve([k],Et),e.Breakpoint=Et;let vt=class extends Et{constructor(O,se,De,Ke,et){super(se,De,Ke,et);if(O===null)throw(0,I.illegalArgument)("location");this.location=O}};vt=Ve([k],vt),e.SourceBreakpoint=vt;let kt=class extends Et{constructor(O,se,De,Ke,et){super(se,De,Ke,et);this.functionName=O}};kt=Ve([k],kt),e.FunctionBreakpoint=kt;let At=class extends Et{constructor(O,se,De,Ke,et,st,ct){super(Ke,et,st,ct);if(!se)throw(0,I.illegalArgument)("dataId");this.label=O,this.dataId=se,this.canPersist=De}};At=Ve([k],At),e.DataBreakpoint=At;let Tt=class{constructor(O,se,De){this.command=O,this.args=se||[],this.options=De}};Tt=Ve([k],Tt),e.DebugAdapterExecutable=Tt;let _t=class{constructor(O,se){this.port=O,this.host=se}};_t=Ve([k],_t),e.DebugAdapterServer=_t;let Yt=class{constructor(O){this.path=O}};Yt=Ve([k],Yt),e.DebugAdapterNamedPipeServer=Yt;let Jt=class{constructor(O){this.implementation=O}};Jt=Ve([k],Jt),e.DebugAdapterInlineImplementation=Jt;let gt=class{constructor(O,se){this.range=O,this.expression=se}};gt=Ve([k],gt),e.EvaluatableExpression=gt;let Xt=class{constructor(O,se){this.range=O,this.text=se}};Xt=Ve([k],Xt),e.InlineValueText=Xt;let St=class{constructor(O,se,De=!0){this.range=O,this.variableName=se,this.caseSensitiveLookup=De}};St=Ve([k],St),e.InlineValueVariableLookup=St;let jt=class{constructor(O,se){this.range=O,this.expression=se}};jt=Ve([k],jt),e.InlineValueEvaluatableExpression=jt;let Zt=class{constructor(O,se){this.frameId=O,this.stoppedLocation=se}};Zt=Ve([k],Zt),e.InlineValueContext=Zt;var qt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let lt=v=class extends Error{constructor(O,se=i.FileSystemProviderErrorCode.Unknown,De){var Ke;super(S.URI.isUri(O)?O.toString(!0):O);this.code=(Ke=De==null?void 0:De.name)!==null&&Ke!==void 0?Ke:"Unknown",(0,i.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(O){return new v(O,i.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(O){return new v(O,i.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(O){return new v(O,i.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(O){return new v(O,i.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(O){return new v(O,i.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(O){return new v(O,i.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}};lt=v=Ve([k],lt),e.FileSystemError=lt;let en=class{constructor(O,se,De){this.start=O,this.end=se,this.kind=De}};en=Ve([k],en),e.FoldingRange=en;var Rt;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(Rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Bt;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(Bt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var dn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(dn=e.CommentMode||(e.CommentMode={}));class _n{constructor(O,se=[]){this.tokenTypes=O,this.tokenModifiers=se}}e.SemanticTokensLegend=_n;function hn(N){return typeof N=="undefined"||(0,D.isStringArray)(N)}class tn{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let se=0,De=O.tokenTypes.length;se<De;se++)this._tokenTypeStrToInt.set(O.tokenTypes[se],se);for(let se=0,De=O.tokenModifiers.length;se<De;se++)this._tokenModifierStrToInt.set(O.tokenModifiers[se],se)}}push(O,se,De,Ke,et){if(typeof O=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(O,se,De,Ke,et);if(R.isRange(O)&&typeof se=="string"&&hn(De))return this._push(O,se,De);throw(0,I.illegalArgument)()}_push(O,se,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ke=O.start.line,et=O.start.character,st=O.end.character-O.start.character,ct=this._tokenTypeStrToInt.get(se);let yt=0;if(De)for(const Ct of De){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(Ct);yt|=1<<It>>>0}this._pushEncoded(Ke,et,st,ct,yt)}_pushEncoded(O,se,De,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Ct=0,It=0;for(let Pt=0;Pt<yt;Pt++){let Mt=this._data[5*Pt],un=this._data[5*Pt+1];Mt===0?(Mt=Ct,un+=It):Mt+=Ct,this._data[5*Pt]=Mt,this._data[5*Pt+1]=un,Ct=Mt,It=un}}let st=O,ct=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=O,this._prevChar=se}static _sortAndDeltaEncode(O){let se=[];const De=O.length/5|0;for(let ct=0;ct<De;ct++)se[ct]=ct;se.sort((ct,yt)=>{const Ct=O[5*ct],It=O[5*yt];if(Ct===It){const Pt=O[5*ct+1],Mt=O[5*yt+1];return Pt-Mt}return Ct-It});const Ke=new Uint32Array(O.length);let et=0,st=0;for(let ct=0;ct<De;ct++){const yt=5*se[ct],Ct=O[yt+0],It=O[yt+1],Pt=O[yt+2],Mt=O[yt+3],un=O[yt+4],Tn=Ct-et,Mn=Tn===0?It-st:It,cn=5*ct;Ke[cn+0]=Tn,Ke[cn+1]=Mn,Ke[cn+2]=Pt,Ke[cn+3]=Mt,Ke[cn+4]=un,et=Ct,st=It}return Ke}build(O){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),O):new Kt(tn._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=tn;class Kt{constructor(O,se){this.resultId=se,this.data=O}}e.SemanticTokens=Kt;class Nt{constructor(O,se,De){this.start=O,this.deleteCount=se,this.data=De}}e.SemanticTokensEdit=Nt;class En{constructor(O,se){this.resultId=se,this.edits=O}}e.SemanticTokensEdits=En;var nn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(nn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var rn;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(rn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new Ye("arrow-left")},Gt=Ve([k],Gt),e.QuickInputButtons=Gt;var yn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(yn=e.ExtensionKind||(e.ExtensionKind={}));class Ft{constructor(O,se,De){this.badge=O,this.tooltip=se,this.color=De}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Ft;let sn=class{constructor(O){this.kind=O}};sn=Ve([k],sn),e.ColorTheme=sn;var Sn;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(Sn=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(O,se){if(O<0)throw(0,I.illegalArgument)("start must be positive");if(se<0)throw(0,I.illegalArgument)("end must be positive");O<=se?(this._start=O,this._end=se):(this._start=se,this._end=O)}static isNotebookRange(O){return O instanceof $t?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let se=this._start,De=this._end;return O.start!==void 0&&(se=O.start),O.end!==void 0&&(De=O.end),se===this._start&&De===this._end?this:new $t(se,De)}}e.NotebookRange=$t;class on{constructor(O,se){typeof O=="object"?Object.assign(this,O):(this.inputCollapsed=O,this.outputCollapsed=se)}with(O){let{inputCollapsed:se,outputCollapsed:De}=O,Ke=Qt(O,["inputCollapsed","outputCollapsed"]);return se===void 0?se=this.inputCollapsed:se===null&&(se=void 0),De===void 0?De=this.outputCollapsed:De===null&&(De=void 0),se===this.inputCollapsed&&De===this.outputCollapsed&&Object.keys(Ke).length===0?this:new on(Object.assign({inputCollapsed:se,outputCollapsed:De},Ke))}}e.NotebookCellMetadata=on;class Ut{constructor(O={}){Object.assign(this,O)}with(O){return new Ut(O)}}e.NotebookDocumentMetadata=Ut;class Lt{constructor(O,se,De,Ke,et,st){this.kind=O,this.source=se,this.language=De,this.outputs=Ke!=null?Ke:[],this.metadata=et,this.latestExecutionSummary=st}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(se=>Lt.isNotebookCellData(se))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Lt;class fn{constructor(O,se){this.cells=O,this.metadata=se!=null?se:new Ut}}e.NotebookData=fn;class Wt{constructor(O,se,De){if(this.mime=O,this.value=se,this.metadata=De,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(O){return O instanceof Wt}}e.NotebookCellOutputItem=Wt;class Fe{constructor(O,se,De){this.outputs=O,typeof se=="string"?(this.id=se,this.metadata=De):(this.id=(0,C.generateUuid)(),this.metadata=se!=null?se:De)}}e.NotebookCellOutput=Fe;var an;(function(N){N[N.Markdown=1]="Markdown",N[N.Code=2]="Code"})(an=e.NotebookCellKind||(e.NotebookCellKind={}));var ln;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(ln=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(pt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Dn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Dn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Cn{constructor(O,se,De,Ke,et,st){this.text=O,this.alignment=se,this.command=De,this.tooltip=Ke,this.priority=et,this.accessibilityInformation=st}}e.NotebookCellStatusBarItem=Cn;var mn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(mn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class gn{constructor(O,se=[]){this.uri=O,this.provides=typeof se=="string"?[se]:se}}e.NotebookKernelPreload=gn;let Ht=class{constructor(O,se){this.label=O,this.timestamp=se}};Ht=Ve([k],Ht),e.TimelineItem=Ht;var kn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(kn=e.ExtensionMode||(e.ExtensionMode={}));var In;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(In=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Pn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Pn=e.StandardTokenType||(e.StandardTokenType={}));class pn{constructor(O,se){this.ranges=O,this.wordPattern=se}}e.LinkedEditingRanges=pn;var An;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(An=e.TestResultState||(e.TestResultState={}));var vn;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information",N[N.Hint=3]="Hint"})(vn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var bn;(function(N){N[N.Pending=0]="Pending",N[N.Resolved=1]="Resolved"})(bn=e.TestItemStatus||(e.TestItemStatus={}));const xt=(N,O,se,De)=>{let Ke=se;return{enumerable:!0,configurable:!1,get(){return Ke},set(et){De(Ke,et)||(Ke=et,N.bus.fire([3,O,et]))}}},zt=(N,O)=>N===O,Z=(N,O)=>N===O?!0:!N||!O?!1:N.isEqual(O);class ue{constructor(O,se,De,Ke){this.label=se,this.data=Ke;const et=(0,d.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:O,enumerable:!0,writable:!1},uri:{value:De,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new T.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:xt(et,"range",void 0,Z),description:xt(et,"description",void 0,zt),runnable:xt(et,"runnable",!0,zt),debuggable:xt(et,"debuggable",!0,zt),status:xt(et,"status",bn.Resolved,zt),error:xt(et,"error",void 0,zt)})}invalidate(){(0,d.getPrivateApiFor)(this).bus.fire([2])}dispose(){const O=(0,d.getPrivateApiFor)(this);O.parent&&(0,d.getPrivateApiFor)(O.parent).children.delete(this.id),O.bus.fire([1])}addChild(O){if(!(O instanceof ue))throw new Error("Test child must be created through vscode.test.createTestItem()");const se=(0,d.getPrivateApiFor)(this);if(se.children.has(O.id))throw new Error(`Attempted to insert a duplicate test item ID ${O.id}`);se.children.set(O.id,O),se.bus.fire([0,O])}}e.TestItemImpl=ue;class ke{constructor(O){this.message=O,this.severity=vn.Error}static diff(O,se,De){const Ke=new ke(O);return Ke.expectedOutput=se,Ke.actualOutput=De,Ke}}e.TestMessage=ke;var rt;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(rt=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var wt;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(wt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Dt;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore"})(Dt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(we[95],_e([0,1,42,19,8,120,86,7,15]),function(Y,e,w,I,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function i(r,a){a?C.set(r,a):C.delete(r)}e.setWordDefinitionFor=i;function P(r){return C.get(r)}e.getWordDefinitionFor=P;class d extends T.MirrorTextModel{constructor(a,p,m,E,f,l,b,t){super(p,m,E,f);this._proxy=a,this._languageId=l,this._isDirty=b,this._notebook=t,this._isDisposed=!1}dispose(){(0,w.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,S.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===I.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},get notebook(){return a._notebook},save(){return a._save()},getText(p){return p?a._getTextInRange(p):a.getText()},get eol(){return a._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(p){return a._lineAt(p)},offsetAt(p){return a._offsetAt(p)},positionAt(p){return a._positionAt(p)},validateRange(p){return a._validateRange(p)},validatePosition(p){return a._validatePosition(p)},getWordRangeAtPosition(p,m){return a._getWordRangeAtPosition(p,m)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,w.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,w.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const p=this._validateRange(a);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const m=this._eol,E=p.start.line,f=p.end.line,l=[];l.push(this._lines[E].substring(p.start.character));for(let b=E+1;b<f;b++)l.push(this._lines[b]);return l.push(this._lines[f].substring(0,p.end.character)),l.join(m)}_lineAt(a){let p;if(a instanceof D.Position?p=a.line:typeof a=="number"&&(p=a),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new h(p,this._lines[p],p===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(a),m=this._lines[p.index].length;return new D.Position(p.index,Math.min(p.remainder,m))}_validateRange(a){if(!(a instanceof D.Range))throw new Error("Invalid argument");const p=this._validatePosition(a.start),m=this._validatePosition(a.end);return p===a.start&&m===a.end?a:new D.Range(p.line,p.character,m.line,m.character)}_validatePosition(a){if(!(a instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:p,character:m}=a,E=!1;if(p<0)p=0,m=0,E=!0;else if(p>=this._lines.length)p=this._lines.length-1,m=this._lines[p].length,E=!0;else{const f=this._lines[p].length;m<0?(m=0,E=!0):m>f&&(m=f,E=!0)}return E?new D.Position(p,m):a}_getWordRangeAtPosition(a,p){const m=this._validatePosition(a);if(!p)p=P(this._languageId);else if((0,A.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const E=(0,y.getWordAtText)(m.character+1,(0,y.ensureValidWordDefinition)(p),this._lines[m.line],0);if(E)return new D.Range(m.line,E.startColumn-1,m.line,E.endColumn-1)}}e.ExtHostDocumentData=d;class h{constructor(a,p,m){this._line=a,this._text=p,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(we[163],_e([0,1,7,3,88,6,59,22,2,31]),function(Y,e,w,I,A,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(d,h,r,a){this._notebook=r,this._selector=a,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(m=>{const E=this._cellUris.get(m.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=m=>{m===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(m=>p(m.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const d=[],h=[];for(const r of this._notebook.getCells())r.kind===w.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),d.push(r.document.getText().length+1),h.push(r.document.lineCount));this._cellLengths=new A.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new A.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(d){var h,r;if(!d){let f="";for(const l of this._cells)f+=l.document.getText()+`
`;return f=f.slice(0,-1),f}if(d.isEmpty)return"";const a=this.locationAt(d.start),p=this.locationAt(d.end),m=this._cells[(h=this._cellUris.get(a.uri))!==null&&h!==void 0?h:-1],E=this._cells[(r=this._cellUris.get(p.uri))!==null&&r!==void 0?r:-1];if(!m||!E)return"";if(m===E)return m.document.getText(new w.Range(a.range.start,p.range.end));{const f=m.document.getText(new w.Range(a.range.start,new w.Position(m.document.lineCount,0))),l=E.document.getText(new w.Range(new w.Position(0,0),p.range.end));return f+`
`+l}}offsetAt(d){const h=this._cellLines.getIndexOf(d.line),r=this._cellLengths.getAccumulatedValue(h.index-1),a=this._cells[h.index].document.offsetAt(d.with(h.remainder));return r+a}positionAt(d){if(typeof d=="number"){const r=this._cellLengths.getIndexOf(d),a=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(a)}const h=this._cellUris.get(d.uri);if(h!==void 0){const r=this._cellLines.getAccumulatedValue(h-1);return new w.Position(r+d.range.start.line,d.range.start.character)}return new w.Position(0,0)}locationAt(d){w.Range.isRange(d)||(d=new w.Range(d,d));const h=this._cellLines.getIndexOf(d.start.line);let r=h;d.isEmpty||(r=this._cellLines.getIndexOf(d.end.line));const a=new w.Position(h.remainder,d.start.character),p=new w.Position(r.remainder,d.end.character),m=new w.Range(a,p),E=this._cells[h.index];return new w.Location(E.document.uri,E.document.validateRange(m))}contains(d){return this._cellUris.has(d)}validateRange(d){const h=this.validatePosition(d.start),r=this.validatePosition(d.end);return d.with(h,r)}validatePosition(d){const h=this._cellLines.getIndexOf(d.line),r=new w.Position(h.remainder,d.character),a=this._cells[h.index].document.validatePosition(r),p=this._cellLines.getAccumulatedValue(h.index-1);return new w.Position(p+a.line,a.character)}}e.ExtHostNotebookConcatDocument=i}),define(we[164],_e([0,1,7,14,3]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(D){this._actual=new w.ColorTheme(w.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new A.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let S=D==="light"?w.ColorThemeKind.Light:D==="dark"?w.ColorThemeKind.Dark:w.ColorThemeKind.HighContrast;this._actual=new w.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Ve([qe(0,I.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(we[71],_e([0,1,4]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,w.createDecorator)("IURITransformerService");class I{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=I}),define(we[165],_e([0,1,24]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(S){let C=this.buffers.indexOf(S);return C<0&&(C=this.buffers.length,this.buffers.push(S)),C}}function A(D,S){if(S.serializeBuffersForPostMessage){const C=new I,i=(h,r)=>{if(r instanceof ArrayBuffer){const a=C.add(r);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(r)){const a=T(r);if(a){const p=C.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:a,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},P=JSON.stringify(D,i),d=C.buffers.map(h=>{const r=new Uint8Array(h);return w.VSBuffer.wrap(r)});return{message:P,buffers:d}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=A;function T(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(D,S){const C=S.map(d=>{const h=new ArrayBuffer(d.byteLength);return new Uint8Array(h).set(d.buffer),h}),i=S.length?(d,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const r=h,{index:a}=r,p=C[a];if(r.view)switch(r.view.type){case 1:return new Int8Array(p,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return h}:void 0;return{message:JSON.parse(D,i),arrayBuffers:C}}e.deserializeWebviewMessage=y}),define(we[72],_e([0,1,2]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(T,y,D){const S=T.webviewResourceRoot.replace("{{resource}}",D.scheme+A(D)).replace("{{uuid}}",y);return w.URI.parse(S)}e.asWebviewUri=I;function A(T){return T.toString().replace(/^\S+?:/,"")}}),define(we[166],_e([0,1,3,6,72,31]),function(Y,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(S,C,i){this._proxy=S,this._editors=C,this._initData=i,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const P=C.getVisibleTextEditors();for(const d of this._insets.values())P.indexOf(d.editor)<0&&d.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,C,i,P,d){let h;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===S){h=l;break}if(!h)throw new Error("not a visible editor");const r=this,a=this._handlePool++,p=new w.Emitter,m=new w.Emitter,E=new class{constructor(){this._uuid=(0,T.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,A.asWebviewUri)(r._initData,this._uuid,l)}get cspSource(){return r._initData.webviewCspSource}set options(l){this._options=l,r._proxy.$setOptions(a,l)}get options(){return this._options}set html(l){this._html=l,r._proxy.$setHtml(a,l)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(l){return r._proxy.$postMessage(a,l)}},f=new class{constructor(){this.editor=S,this.line=C,this.height=i,this.webview=E,this.onDidDispose=m.event}dispose(){r._insets.has(a)&&(r._insets.delete(a),r._proxy.$disposeEditorInset(a),m.fire(),m.dispose(),p.dispose())}};return this._proxy.$createEditorInset(a,h.id,h.value.document.uri,C+1,i,P||{},d.identifier,d.extensionLocation),this._insets.set(a,{editor:S,inset:f,onDidReceiveMessage:p}),f}$onDidDispose(S){const C=this._insets.get(S);C&&C.inset.dispose()}$onDidReceiveMessage(S,C){const i=this._insets.get(S);i&&i.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=y}),define(we[167],_e([0,1,3,63,138,4,6,22,29,15,51,23,36,158]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",d.Codicon.window,(0,A.localize)(0,null));var r;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var a;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel"})(a=e.ViewContainerLocation||(e.ViewContainerLocation={}));function p(s){switch(s){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=p;function m(s){return`viewContainer.${s}.enabled`}e.getEnabledViewContainerContextKey=m;class E extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new w.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new w.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,C.flatten)([...this.viewContainers.values()])}registerViewContainer(c,v,k){var g;const _=this.get(c.id);if(_)return _;const R=c;return R.openCommandActionDescriptor=(k==null?void 0:k.donotRegisterOpenCommand)?void 0:(g=R.openCommandActionDescriptor)!==null&&g!==void 0?g:{id:R.id},(0,D.getOrSet)(this.viewContainers,v,[]).push(R),(k==null?void 0:k.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:v}),R}deregisterViewContainer(c){for(const v of this.viewContainers.keys()){const k=this.viewContainers.get(v),g=k==null?void 0:k.indexOf(c);if(g!==-1){k==null||k.splice(g,1),k.length===0&&this.viewContainers.delete(v),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:v});return}}}get(c){return this.all.filter(v=>v.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(v=>this.getViewContainers(v).filter(k=>(k==null?void 0:k.id)===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(v=>this.getViewContainerLocation(v)===c)}}S.Registry.add(r.ViewContainersRegistry,new E);var f;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(f=e.ViewContentGroups||(e.ViewContentGroups={}));function l(s,c){var v,k,g,_;const R=(v=s.group)!==null&&v!==void 0?v:f.More,B=(k=c.group)!==null&&k!==void 0?k:f.More;return R!==B?R.localeCompare(B):((g=s.order)!==null&&g!==void 0?g:5)-((_=c.order)!==null&&_!==void 0?_:5)}class b extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new w.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new w.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new w.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new w.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(c,v){this.registerViews2([{views:c,viewContainer:v}])}registerViews2(c){c.forEach(({views:v,viewContainer:k})=>this.addViews(v,k)),this._onViewsRegistered.fire(c)}deregisterViews(c,v){const k=this.removeViews(c,v);k.length&&this._onViewsDeregistered.fire({views:k,viewContainer:v})}moveViews(c,v){for(const k of this._views.keys())if(k!==v){const g=this.removeViews(c,k);g.length&&(this.addViews(g,v),this._onDidChangeContainer.fire({views:g,from:k,to:v}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const v of this._viewContainers){const k=(this._views.get(v)||[]).filter(g=>g.id===c)[0];if(k)return k}return null}getViewContainer(c){for(const v of this._viewContainers)if((this._views.get(v)||[]).filter(g=>g.id===c)[0])return v;return null}registerViewWelcomeContent(c,v){return this._viewWelcomeContents.add(c,v),this._onDidChangeViewWelcomeContent.fire(c),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,v),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,v){const k=new Map;for(const[g,_]of v)this._viewWelcomeContents.add(c,_),k.set(g,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(c,_),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),k}getViewWelcomeContent(c){const v=[];return this._viewWelcomeContents.forEach(c,k=>v.push(k)),v.sort(l)}addViews(c,v){let k=this._views.get(v);k||(k=[],this._views.set(v,k),this._viewContainers.push(v));for(const g of c){if(this.getView(g.id)!==null)throw new Error((0,A.localize)(1,null,g.id));k.push(g)}}removeViews(c,v){const k=this._views.get(v);if(!k)return[];const g=[],_=[];for(const R of k)c.includes(R)?g.push(R):_.push(R);return g.length&&(_.length?this._views.set(v,_):(this._views.delete(v),this._viewContainers.splice(this._viewContainers.indexOf(v),1))),g}}S.Registry.add(r.ViewsRegistry,new b),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,A.localize)(2,null));function t(s){return`view.${s}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var u;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(u=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(c,v){this.resolved=!1,this._hasResolve=!1,(0,P.mixin)(this,c),this._hasResolve=!!v,this.resolve=async k=>{var g,_;if(v&&!this.resolved){const R=await v(k);R&&(this.tooltip=(g=this.tooltip)!==null&&g!==void 0?g:R.tooltip,this.command=(_=this.command)!==null&&_!==void 0?_:R.command)}k.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o}),define(we[168],_e([0,1,2,148,159,18,149,167]),function(Y,e,w,I,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function S(a){return(p,...m)=>a(p.get(I.ICommandService),...m)}class C{static execute(p,m){const E={forceReuseWindow:m&&m.reuseWindow,remoteAuthority:m&&m.remoteAuthority};return p.executeCommand("_files.newWindow",E)}}e.NewWindowAPICommand=C,C.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:C.ID,handler:S(C.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(a,p){return a.get(A.IWorkspacesService).removeRecentlyOpened([p])});class i{static execute(p,m){return typeof m=="string"?m=m.match(/^[^:/?#]+:\/\//)?w.URI.parse(m):w.URI.file(m):m=w.URI.revive(m),p.executeCommand("_workbench.removeFromRecentlyOpened",m)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(i.ID,S(i.execute));class P{static execute(p,m){const E=typeof m=="string"?{extensionId:m}:m;return p.executeCommand("workbench.action.openIssueReporter",E)}}e.OpenIssueReporter=P,P.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(a,p){const m=a.get(A.IWorkspacesService);let E;const f=p.uri,l=p.label,b=p.remoteAuthority;return p.type==="workspace"?E={workspace:await m.getWorkspaceIdentifier(f),label:l,remoteAuthority:b}:p.type==="folder"?E={folderUri:f,label:l,remoteAuthority:b}:E={fileUri:f,label:l,remoteAuthority:b},m.addRecentlyOpened([E])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(a){return a.get(A.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(a,p){const m=a.get(T.ILogService),E=a.get(y.IEnvironmentService);E.isExtensionDevelopment&&!!E.extensionTestsLocationURI&&m.setLevel(p)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(a){return a.get(T.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(a,p){const m=a.get(D.IViewDescriptorService),E=m.getViewContainerById(p.destinationId);if(!!E){for(const f of p.viewIds){const l=m.getViewDescriptorById(f);(l==null?void 0:l.canMoveView)&&m.moveViewsToContainer([l],E,D.ViewVisibilityState.Default)}await a.get(D.IViewsService).openViewContainer(E.id,!0)}});class d{static execute(p,m){return!Array.isArray(m==null?void 0:m.viewIds)||typeof(m==null?void 0:m.destinationId)!="string"?Promise.reject("Invalid arguments"):p.executeCommand("_workbench.action.moveViews",m)}}e.MoveViewsAPICommand=d,d.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:d.ID,handler:S(d.execute),description:{description:"Move Views",args:[]}});class h{static execute(p,m){return p.executeCommand("_workbench.open",m)}}h.ID="vscode.open",I.CommandsRegistry.registerCommand(h.ID,S(h.execute));class r{static execute(p,m,E,f,l){return p.executeCommand("_workbench.diff",[m,E,f])}}r.ID="vscode.diff",I.CommandsRegistry.registerCommand(r.ID,S(r.execute))}),define(we[169],_e([0,1,3,11,139]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new w.Emitter,this._onExit=new w.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,S,C,i){const P={command:D};if(S&&Object.keys(S).length>0&&(P.arguments=S),this.internalSend("request",P),typeof i=="number"){const d=setTimeout(()=>{clearTimeout(d);const h=this.pendingRequests.get(P.seq);if(h){this.pendingRequests.delete(P.seq);const r={type:"response",seq:0,request_seq:P.seq,success:!1,command:D,message:(0,A.localize)(0,null,i,D)};h(r)}},i)}return C&&this.pendingRequests.set(P.seq,C),P.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,S){return D.type!=="event"||S.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,I.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const S=D,C=this.pendingRequests.get(S.request_seq);C&&(this.pendingRequests.delete(S.request_seq),C(S));break}}}internalSend(D,S){S.type=D,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((S,C)=>D.set(C,S)),await(0,I.timeout)(500),D.forEach((S,C)=>{S({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(we[170],_e([0,1,8,2,13,23,19]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function S(n,u,o){return n.replace(D,function(s,c){return u&&c.length>0&&c[0]!=="_"?s:o&&o.hasOwnProperty(c)?o[c]:s})}e.formatPII=S;function C(n){const u={};for(const o of Object.keys(n))o.startsWith("!")||(u[o]=n[o]);return u}e.filterExceptionsFromTelemetry=C;function i(n){return n.configuration.request==="attach"&&!P(n)}e.isSessionAttach=i;function P(n){let u=n.configuration.type;if(!!u)return u==="vslsShare"&&(u=n.configuration.adapterProxy.configuration.type),(0,w.equalsIgnoreCase)(u,"extensionhost")||(0,w.equalsIgnoreCase)(u,"pwa-extensionhost")?n:n.parentSession?P(n.parentSession):void 0}e.getExtensionHostDebugSession=P;function d(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=d;function h(n,u,o){let s,c=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,k=null;for(;k=v.exec(n);){let g=k.index+1,_=g+k[0].length;if(g<=u&&_>=o){s=k[0],c=g;break}}if(s){let g=/\w+/g,_=null;for(;(_=g.exec(s))&&!(_.index+1+c+_[0].length>=o););_&&(s=s.substring(0,g.lastIndex))}return s?{start:c,end:c+s.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(n){return!!(n&&n.match(r))}e.isUri=a;function p(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(a(n.path))return I.URI.parse(n.path);if((0,A.isAbsolute)(n.path))return I.URI.file(n.path)}return n.path}function m(n){if(typeof n.path=="object"){const u=I.URI.revive(n.path);if(u)return u.scheme===y.Schemas.file?u.fsPath:u.toString()}return n.path}function E(n,u){const o=u?p:m,s=(0,T.deepClone)(n);return l(s,(c,v)=>{c&&v&&(v.path=o(v))}),s}e.convertToDAPaths=E;function f(n,u){const o=u?p:m,s=(0,T.deepClone)(n);return l(s,(c,v)=>{!c&&v&&(v.path=o(v))}),s}e.convertToVSCPaths=f;function l(n,u){switch(n.type){case"event":const o=n;switch(o.event){case"output":u(!1,o.body.source);break;case"loadedSource":u(!1,o.body.source);break;case"breakpoint":u(!1,o.body.breakpoint.source);break;default:break}break;case"request":const s=n;switch(s.command){case"setBreakpoints":u(!0,s.arguments.source);break;case"breakpointLocations":u(!0,s.arguments.source);break;case"source":u(!0,s.arguments.source);break;case"gotoTargets":u(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(v=>u(!1,v));break;default:break}break;case"response":const c=n;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(v=>u(!1,v.source));break;case"loadedSources":c.body.sources.forEach(v=>u(!1,v));break;case"scopes":c.body.scopes.forEach(v=>u(!1,v.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(v=>u(!1,v.source));break;case"setBreakpoints":c.body.breakpoints.forEach(v=>u(!1,v.source));break;default:break}break}}function b(n){return n.filter(u=>{var o;return!((o=u.presentation)===null||o===void 0?void 0:o.hidden)}).sort((u,o)=>u.presentation?o.presentation?u.presentation.group?o.presentation.group?u.presentation.group!==o.presentation.group?u.presentation.group.localeCompare(o.presentation.group):t(u.presentation.order,o.presentation.order):-1:o.presentation.group?1:t(u.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=b;function t(n,u){return typeof n!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:n-u}}),define(we[73],_e([0,1,28,19,13,21,63]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(g){g[g.Markdown=1]="Markdown",g[g.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(g){g[g.Running=1]="Running",g[g.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var C;(function(g){g[g.Idle=1]="Idle",g[g.Pending=2]="Pending",g[g.Executing=3]="Executing"})(C=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(g){g[g.WithHardKernelDependency=0]="WithHardKernelDependency",g[g.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",g[g.Pure=2]="Pure",g[g.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var P;(function(g){g[g.ModelChange=1]="ModelChange",g[g.Move=2]="Move",g[g.CellClearOutput=3]="CellClearOutput",g[g.CellsClearOutput=4]="CellsClearOutput",g[g.ChangeLanguage=5]="ChangeLanguage",g[g.Initialize=6]="Initialize",g[g.ChangeCellMetadata=7]="ChangeCellMetadata",g[g.Output=8]="Output",g[g.OutputItem=9]="OutputItem",g[g.ChangeCellContent=10]="ChangeCellContent",g[g.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",g[g.Unknown=12]="Unknown"})(P=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(g){g[g.Handle=0]="Handle",g[g.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(g){g[g.Replace=1]="Replace",g[g.Output=2]="Output",g[g.Metadata=3]="Metadata",g[g.CellLanguage=4]="CellLanguage",g[g.DocumentMetadata=5]="DocumentMetadata",g[g.Move=6]="Move",g[g.OutputItems=7]="OutputItems",g[g.PartialMetadata=8]="PartialMetadata"})(h=e.CellEditType||(e.CellEditType={}));function r(g){const _=a.parse(g);return _?_.notebook.toString():g.toString()}e.getCellUndoRedoComparisonKey=r;var a;(function(g){g.scheme=I.Schemas.vscodeNotebookCell;const _=/^ch(\d{7,})/;function R(V,H){return V.with({scheme:g.scheme,fragment:`ch${H.toString().padStart(7,"0")}${V.scheme!==I.Schemas.file?V.scheme:""}`})}g.generate=R;function B(V){if(V.scheme===g.scheme){const H=_.exec(V.fragment);if(!!H)return{handle:Number(H[1]),notebook:V.with({scheme:V.fragment.substr(H[0].length)||I.Schemas.file,fragment:null})}}}g.parse=B;function Q(V,H){return V.with({scheme:I.Schemas.vscodeNotebookCellMetadata,fragment:`ch${H.toString().padStart(7,"0")}${V.scheme!==I.Schemas.file?V.scheme:""}`})}g.generateCellMetadataUri=Q;function ge(V){if(V.scheme===I.Schemas.vscodeNotebookCellMetadata){const H=_.exec(V.fragment);if(!!H)return{handle:Number(H[1]),notebook:V.with({scheme:V.fragment.substr(H[0].length)||I.Schemas.file,fragment:null})}}}g.parseCellMetadataUri=ge})(a=e.CellUri||(e.CellUri={}));const p=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function m(g){var _,R;return(R=(_=p.get(g))===null||_===void 0?void 0:_.alwaysSecure)!==null&&R!==void 0?R:!1}e.mimeTypeIsAlwaysSecure=m;function E(g){var _,R;return(R=(_=p.get(g))===null||_===void 0?void 0:_.supportedByCore)!==null&&R!==void 0?R:!1}e.mimeTypeSupportedByCore=E;function f(g){var _,R;return(R=(_=p.get(g))===null||_===void 0?void 0:_.mergeable)!==null&&R!==void 0?R:!1}e.mimeTypeIsMergeable=f;function l(g,_){return T.isWindows&&(g=g.replace(/\//g,"\\"),_=_.replace(/\//g,"\\")),w.match(g,_)}function b(g,_,R){let B=0;for(let Q=0;Q<_.length;Q++){if(l(_[Q],g))return B;B++}for(let Q=0;Q<R.length;Q++){if(l(R[Q],g))return B;B++}return B}function t(g,_,R){return g.sort((B,Q)=>b(B,_,R)-b(Q,_,R))}e.sortMimeTypes=t;function n(g,_,R,B=(Q,ge)=>Q===ge){const Q=[];function ge(te,$,F){if(!($===0&&F.length===0)){const L=Q[Q.length-1];L&&L.start+L.deleteCount===te?(L.deleteCount+=$,L.toInsert.push(...F)):Q.push({start:te,deleteCount:$,toInsert:F})}}let V=0,H=0;for(;;){if(V===g.length){ge(V,0,_.slice(H));break}if(H===_.length){ge(V,g.length-V,[]);break}const te=g[V],$=_[H];if(B(te,$)){V+=1,H+=1;continue}R($)?(ge(V,1,[]),V+=1):(ge(V,0,[$]),H+=1)}return Q}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var u;(function(g){g.default="default",g.option="option"})(u=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(g){const _=g;return!!((typeof _.include=="string"||w.isRelativePattern(_.include))&&(typeof _.exclude=="string"||w.isRelativePattern(_.exclude)))}e.isDocumentExcludePattern=o;function s(g,_,R){if(Array.isArray(g.viewType)&&g.viewType.indexOf(_)>=0||g.viewType===_)return!0;if(g.filenamePattern){let B=o(g.filenamePattern)?g.filenamePattern.include:g.filenamePattern,Q=o(g.filenamePattern)?g.filenamePattern.exclude:void 0;if(w.match(B,(0,A.basename)(R.fsPath).toLowerCase()))return!(Q&&w.match(Q,(0,A.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s;class c{constructor(_){this.textModel=_}getElements(){const _=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)_[R]=this.textModel.cells[R].getHashValue();return _}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var v;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(v=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class k{static create(_){return`${k._prefix}/${_}`}static parse(_){if(_.startsWith(k._prefix))return _.substr(k._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=k,k._prefix="notebook/"}),define(we[171],_e([0,1,141,4,63]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new A.RawContextKey("customExecutionSupported",!0,w.localize(0,null)),e.ShellExecutionSupportedContext=new A.RawContextKey("shellExecutionSupported",!1,w.localize(1,null)),e.ProcessExecutionSupportedContext=new A.RawContextKey("processExecutionSupported",!1,w.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[172],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function w(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=w;function I(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=I}),define(we[96],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var w;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(S,C)=>{C.expand!==void 0&&(S.expand=C.expand),C.item!==void 0&&(S.item=S.item?Object.assign(S.item,C.item):C.item)};e.applyTestItemUpdate=I;var A;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.Remove=2]="Remove",S[S.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",S[S.Retire=4]="Retire"})(A=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(S,C)=>`${S}:${C.toString()}`;e.getTestSubscriptionKey=T;class y{add(C){}update(C){}remove(C,i){}complete(){}}e.IncrementalChangeCollector=y;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(C){const i=this.createChangeCollector();for(const P of C)switch(P[0]){case 0:{const d=P[1];if(d.parent){if(this.items.has(d.parent)){const h=this.items.get(d.parent);h.children.add(d.item.extId);const r=this.createItem(d,h);this.items.set(d.item.extId,r),i.add(r)}}else{this.roots.add(d.item.extId);const h=this.createItem(d);this.items.set(d.item.extId,h),i.add(h)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=P[1],h=this.items.get(d.extId);if(!h)break;d.expand!==void 0&&(h.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(h,d),i.update(h);break}case 2:{const d=this.items.get(P[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d.item.extId);const h=[[P[1]]];for(;h.length;)for(const r of h.pop()){const a=this.items.get(r);a&&(h.push(a.children),this.items.delete(r),i.remove(a,a!==d),a.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(P[1]);break;case 3:this.updatePendingRoots(P[1]);break}i.complete()}retireTest(C){}updatePendingRoots(C){this.pendingRootCount+=C}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=D}),define(we[173],_e([0,1,13,46,10,23,21,58,142]),function(Y,e,w,I,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(P,d,h){this._contributedVariables=new Map,this._context=P,this._labelService=d,h&&(this._envVariablesPromise=h.then(r=>this.prepareEnv(r)))}prepareEnv(P){if(y.isWindows){const d=Object.create(null);return Object.keys(P).forEach(h=>{d[h.toLowerCase()]=P[h]}),d}return P}resolveWithEnvironment(P,d,h){return this.recursiveResolve(this.prepareEnv(P),d?d.uri:void 0,h)}async resolveAsync(P,d){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,d)}async resolveAnyBase(P,d,h,r){const a=T.deepClone(d);return y.isWindows&&a.windows?Object.keys(a.windows).forEach(p=>a[p]=a.windows[p]):y.isMacintosh&&a.osx?Object.keys(a.osx).forEach(p=>a[p]=a.osx[p]):y.isLinux&&a.linux&&Object.keys(a.linux).forEach(p=>a[p]=a.linux[p]),delete a.windows,delete a.osx,delete a.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,a,h,r)}async resolveAnyAsync(P,d,h){return this.resolveAnyBase(P,d,h)}async resolveAnyMap(P,d,h){const r=new Map;return{newConfig:await this.resolveAnyBase(P,d,h,r),resolvedVariables:r}}resolveWithInteractionReplace(P,d,h,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,d,h,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,d){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,d)}recursiveResolve(P,d,h,r,a){if(A.isString(h))return this.resolveString(P,d,h,r,a);if(A.isArray(h))return h.map(p=>this.recursiveResolve(P,d,p,r,a));if(A.isObject(h)){let p=Object.create(null);return Object.keys(h).forEach(m=>{const E=this.resolveString(P,d,m,r,a);p[E]=this.recursiveResolve(P,d,h[m],r,a)}),p}return h}resolveString(P,d,h,r,a){return h.replace(C.VARIABLE_REGEXP,(m,E)=>{if(E.includes(C.VARIABLE_LHS))return m;let f=this.evaluateSingleVariable(P,m,E,d,r);return a&&a.set(E,f),f})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,d,h,r,a){let p;const m=h.split(":");m.length>1&&(h=m[0],p=m[1]);const E=()=>{const b=this._context.getFilePath();if(b)return b;throw new Error((0,S.localize)(0,null,d))},f=()=>{const b=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,d,w.basename(b)))},l=()=>{if(p){const b=this._context.getFolderUri(p);if(b)return b;throw new Error((0,S.localize)(2,null,d,p))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,d)):new Error((0,S.localize)(4,null,d))};switch(h){case"env":if(p){if(P){const b=P[y.isWindows?p.toLowerCase():p];if(A.isString(b))return b}return""}throw new Error((0,S.localize)(5,null,d));case"config":if(p){const b=this._context.getConfigurationValue(r,p);if(A.isUndefinedOrNull(b))throw new Error((0,S.localize)(6,null,d,p));if(A.isObject(b))throw new Error((0,S.localize)(7,null,d,p));return b}throw new Error((0,S.localize)(8,null,d));case"command":return this.resolveFromMap(d,p,a,"command");case"input":return this.resolveFromMap(d,p,a,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return r||p?(0,D.normalizeDriveLetter)(this.fsPath(l())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return w.basename(this.fsPath(l()));case"lineNumber":const b=this._context.getLineNumber();if(b)return b;throw new Error((0,S.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,d));case"file":return E();case"fileWorkspaceFolder":return f();case"relativeFile":return r||p?w.relative(this.fsPath(l()),E()):E();case"relativeFileDirname":const n=w.dirname(E());if(r||p){const c=w.relative(this.fsPath(l()),n);return c.length===0?".":c}return n;case"fileDirname":return w.dirname(E());case"fileExtname":return w.extname(E());case"fileBasename":return w.basename(E());case"fileBasenameNoExtension":const u=w.basename(E());return u.slice(0,u.length-w.extname(u).length);case"fileDirnameBasename":return w.basename(w.dirname(E()));case"execPath":const o=this._context.getExecPath();return o||d;case"execInstallFolder":const s=this._context.getAppRoot();return s||d;case"pathSeparator":return w.sep;default:try{const c=p?`${h}:${p}`:h;return this.resolveFromMap(d,c,a,void 0)}catch(c){return d}}}}resolveFromMap(P,d,h,r){if(d&&h){const a=r===void 0?h[d]:h[r+":"+d];if(typeof a=="string")return a;throw new Error((0,S.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[174],_e([0,1,4]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var I;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var A;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var S;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(S=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.EDITOR_OPEN=2]="EDITOR_OPEN",d[d.EDITOR_CLOSE=3]="EDITOR_CLOSE",d[d.EDITOR_MOVE=4]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=6]="EDITOR_LABEL",d[d.EDITOR_PIN=7]="EDITOR_PIN",d[d.EDITOR_STICKY=8]="EDITOR_STICKY",d[d.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function P(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(we[175],_e([0,1,4]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(we[9],_e([0,1,15,83,229,57,23,10,2,32,62,143,90,73,175,7]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var p;(function(be){function de(K){const{selectionStartLineNumber:Re,selectionStartColumn:Ie,positionLineNumber:Qe,positionColumn:Ze}=K,ut=new a.Position(Re-1,Ie-1),ht=new a.Position(Qe-1,Ze-1);return new a.Selection(ut,ht)}be.to=de;function oe(K){const{anchor:Re,active:Ie}=K;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}be.from=oe})(p=e.Selection||(e.Selection={}));var m;(function(be){function de(K){if(!!K){const{start:Re,end:Ie}=K;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}}be.from=de;function oe(K){if(!!K){const{startLineNumber:Re,startColumn:Ie,endLineNumber:Qe,endColumn:Ze}=K;return new a.Range(Re-1,Ie-1,Qe-1,Ze-1)}}be.to=oe})(m=e.Range||(e.Range={}));var E;(function(be){function de(oe){switch(oe){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 4:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}be.to=de})(E=e.TokenType||(e.TokenType={}));var f;(function(be){function de(K){return new a.Position(K.lineNumber-1,K.column-1)}be.to=de;function oe(K){return{lineNumber:K.line+1,column:K.character+1}}be.from=oe})(f=e.Position||(e.Position={}));var l;(function(be){function de(K){switch(K){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}be.from=de;function oe(K){switch(K){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}be.to=oe})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var b;(function(be){function de(K){let Re;return K.code&&((0,D.isString)(K.code)||(0,D.isNumber)(K.code)?Re=String(K.code):Re={value:String(K.code.value),target:K.code.target}),Object.assign(Object.assign({},m.from(K.range)),{message:K.message,source:K.source,code:Re,severity:n.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(t.from),tags:Array.isArray(K.tags)?(0,w.coalesce)(K.tags.map(l.from)):void 0})}be.from=de;function oe(K){var Re;const Ie=new a.Diagnostic(m.to(K),K.message,n.to(K.severity));return Ie.source=K.source,Ie.code=(0,D.isString)(K.code)?K.code:(Re=K.code)===null||Re===void 0?void 0:Re.value,Ie.relatedInformation=K.relatedInformation&&K.relatedInformation.map(t.to),Ie.tags=K.tags&&(0,w.coalesce)(K.tags.map(l.to)),Ie}be.to=oe})(b=e.Diagnostic||(e.Diagnostic={}));var t;(function(be){function de(K){return Object.assign(Object.assign({},m.from(K.location.range)),{message:K.message,resource:K.location.uri})}be.from=de;function oe(K){return new a.DiagnosticRelatedInformation(new a.Location(K.resource,m.to(K)),K.message)}be.to=oe})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(be){function de(K){switch(K){case a.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}be.from=de;function oe(K){switch(K){case d.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}be.to=oe})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var u;(function(be){function de(K){return typeof K=="number"&&K>=a.ViewColumn.One?K-1:K===a.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}be.from=de;function oe(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=oe})(u=e.ViewColumn||(e.ViewColumn={}));function o(be){return typeof be.range!="undefined"}function s(be){return be.length===0?!0:!!o(be[0])}e.isDecorationOptionsArr=s;var c;(function(be){function de(Ze){return Ze.map(be.from)}be.fromMany=de;function oe(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function K(Ze){let ut;if(oe(Ze)){const{language:ft,value:at}=Ze;ut={value:"```"+ft+`
`+at+"\n```\n"}}else a.MarkdownString.isMarkdownString(Ze)?ut={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons}:typeof Ze=="string"?ut={value:Ze}:ut={value:""};const ht=Object.create(null);ut.uris=ht;const Ye=ft=>{try{let at=S.URI.parse(ft,!0);at=at.with({query:Re(at.query,ht)}),ht[ft]=at}catch(at){}return""},ot=new A.Renderer;return ot.link=Ye,ot.image=ft=>Ye(I.parseHrefAndDimensions(ft).href),A(ut.value,{renderer:ot}),ut}be.from=K;function Re(Ze,ut){if(!Ze)return Ze;let ht;try{ht=(0,T.parse)(Ze)}catch(ot){}if(!ht)return Ze;let Ye=!1;return ht=(0,y.cloneAndChange)(ht,ot=>{if(S.URI.isUri(ot)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ft]=ot,Ye=!0,ft}else return}),Ye?JSON.stringify(ht):Ze}function Ie(Ze){const ut=new a.MarkdownString(Ze.value,Ze.supportThemeIcons);return ut.isTrusted=Ze.isTrusted,ut}be.to=Ie;function Qe(Ze){if(!!Ze)return typeof Ze=="string"?Ze:be.from(Ze)}be.fromStrict=Qe})(c=e.MarkdownString||(e.MarkdownString={}));function v(be){return s(be)?be.map(de=>({range:m.from(de.range),hoverMessage:Array.isArray(de.hoverMessage)?c.fromMany(de.hoverMessage):de.hoverMessage?c.from(de.hoverMessage):void 0,renderOptions:de.renderOptions})):be.map(de=>({range:m.from(de)}))}e.fromRangeOrRangeWithMessage=v;function k(be){return typeof be=="undefined"?be:typeof be=="string"?S.URI.file(be):be}e.pathOrURIToURI=k;var g;(function(be){function de(oe){return typeof oe=="undefined"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?k(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}be.from=de})(g=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var _;(function(be){function de(oe){return typeof oe=="undefined"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?k(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?g.from(oe.before):void 0,after:oe.after?g.from(oe.after):void 0}}be.from=de})(_=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(be){function de(oe){if(typeof oe=="undefined")return oe;switch(oe){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=de})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(be){function de(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?R.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?_.from(oe.light):void 0,dark:oe.dark?_.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?k(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?g.from(oe.before):void 0,after:oe.after?g.from(oe.after):void 0}}be.from=de})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Q;(function(be){function de(K){return{text:K.newText,eol:K.newEol&&ee.from(K.newEol),range:m.from(K.range)}}be.from=de;function oe(K){const Re=new a.TextEdit(m.to(K.range),K.text);return Re.newEol=typeof K.eol=="undefined"?void 0:ee.to(K.eol),Re}be.to=oe})(Q=e.TextEdit||(e.TextEdit={}));var ge;(function(be){function de(K,Re,Ie){var Qe,Ze,ut;const ht={edits:[]};if(K instanceof a.WorkspaceEdit)for(let Ye of K._allEntries())if(Ye._type===1)ht.edits.push({_type:1,oldUri:Ye.from,newUri:Ye.to,options:Ye.options,metadata:Ye.metadata});else if(Ye._type===2){const ot=Re==null?void 0:Re.getDocument(Ye.uri);ht.edits.push({_type:2,resource:Ye.uri,edit:Q.from(Ye.edit),modelVersionId:ot==null?void 0:ot.version,metadata:Ye.metadata})}else Ye._type===3?ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:(Qe=Ie==null?void 0:Ie.lookupNotebookDocument(Ye.uri))===null||Qe===void 0?void 0:Qe.apiNotebook.version}):Ye._type===4?(Ye.newOutputs&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:2,index:Ye.index,append:Ye.append,outputs:Ye.newOutputs.map(ze.from)}}),Ye.newMetadata&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:8,index:Ye.index,metadata:Ye.newMetadata}})):Ye._type===5?ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:(Ze=Ie==null?void 0:Ie.lookupNotebookDocument(Ye.uri))===null||Ze===void 0?void 0:Ze.apiNotebook.version,edit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(he.from)}}):Ye._type===6&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:7,outputId:Ye.outputId,items:((ut=Ye.newOutputItems)===null||ut===void 0?void 0:ut.map(ye.from))||[],append:Ye.append}});return ht}be.from=de;function oe(K){const Re=new a.WorkspaceEdit;for(const Ie of K.edits)Ie.edit?Re.replace(S.URI.revive(Ie.resource),m.to(Ie.edit.range),Ie.edit.text):Re.renameFile(S.URI.revive(Ie.oldUri),S.URI.revive(Ie.newUri),Ie.options);return Re}be.to=oe})(ge=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(be){const de=Object.create(null);de[a.SymbolKind.File]=0,de[a.SymbolKind.Module]=1,de[a.SymbolKind.Namespace]=2,de[a.SymbolKind.Package]=3,de[a.SymbolKind.Class]=4,de[a.SymbolKind.Method]=5,de[a.SymbolKind.Property]=6,de[a.SymbolKind.Field]=7,de[a.SymbolKind.Constructor]=8,de[a.SymbolKind.Enum]=9,de[a.SymbolKind.Interface]=10,de[a.SymbolKind.Function]=11,de[a.SymbolKind.Variable]=12,de[a.SymbolKind.Constant]=13,de[a.SymbolKind.String]=14,de[a.SymbolKind.Number]=15,de[a.SymbolKind.Boolean]=16,de[a.SymbolKind.Array]=17,de[a.SymbolKind.Object]=18,de[a.SymbolKind.Key]=19,de[a.SymbolKind.Null]=20,de[a.SymbolKind.EnumMember]=21,de[a.SymbolKind.Struct]=22,de[a.SymbolKind.Event]=23,de[a.SymbolKind.Operator]=24,de[a.SymbolKind.TypeParameter]=25;function oe(Re){return typeof de[Re]=="number"?de[Re]:6}be.from=oe;function K(Re){for(const Ie in de)if(de[Ie]===Re)return Number(Ie);return a.SymbolKind.Property}be.to=K})(V=e.SymbolKind||(e.SymbolKind={}));var H;(function(be){function de(K){switch(K){case a.SymbolTag.Deprecated:return 1}}be.from=de;function oe(K){switch(K){case 1:return a.SymbolTag.Deprecated}}be.to=oe})(H=e.SymbolTag||(e.SymbolTag={}));var te;(function(be){function de(K){return{name:K.name,kind:V.from(K.kind),tags:K.tags&&K.tags.map(H.from),containerName:K.containerName,location:U.from(K.location)}}be.from=de;function oe(K){const Re=new a.SymbolInformation(K.name,V.to(K.kind),K.containerName,U.to(K.location));return Re.tags=K.tags&&K.tags.map(H.to),Re}be.to=oe})(te=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var $;(function(be){function de(K){var Re,Ie;const Qe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:m.from(K.range),selectionRange:m.from(K.selectionRange),kind:V.from(K.kind),tags:(Ie=(Re=K.tags)===null||Re===void 0?void 0:Re.map(H.from))!==null&&Ie!==void 0?Ie:[]};return K.children&&(Qe.children=K.children.map(de)),Qe}be.from=de;function oe(K){const Re=new a.DocumentSymbol(K.name,K.detail,V.to(K.kind),m.to(K.range),m.to(K.selectionRange));return(0,w.isNonEmptyArray)(K.tags)&&(Re.tags=K.tags.map(H.to)),K.children&&(Re.children=K.children.map(oe)),Re}be.to=oe})($=e.DocumentSymbol||(e.DocumentSymbol={}));var F;(function(be){function de(oe){const K=new a.CallHierarchyItem(V.to(oe.kind),oe.name,oe.detail||"",S.URI.revive(oe.uri),m.to(oe.range),m.to(oe.selectionRange));return K._sessionId=oe._sessionId,K._itemId=oe._itemId,K}be.to=de})(F=e.CallHierarchyItem||(e.CallHierarchyItem={}));var L;(function(be){function de(oe){return new a.CallHierarchyIncomingCall(F.to(oe.from),oe.fromRanges.map(K=>m.to(K)))}be.to=de})(L=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(be){function de(oe){return new a.CallHierarchyOutgoingCall(F.to(oe.to),oe.fromRanges.map(K=>m.to(K)))}be.to=de})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var U;(function(be){function de(K){return{range:K.range&&m.from(K.range),uri:K.uri}}be.from=de;function oe(K){return new a.Location(S.URI.revive(K.uri),m.to(K.range))}be.to=oe})(U=e.location||(e.location={}));var G;(function(be){function de(K){const Re=K,Ie=K;return{originSelectionRange:Re.originSelectionRange?m.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Ie.uri,range:m.from(Re.targetRange?Re.targetRange:Ie.range),targetSelectionRange:Re.targetSelectionRange?m.from(Re.targetSelectionRange):void 0}}be.from=de;function oe(K){return{targetUri:S.URI.revive(K.uri),targetRange:m.to(K.range),targetSelectionRange:K.targetSelectionRange?m.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?m.to(K.originSelectionRange):void 0}}be.to=oe})(G=e.DefinitionLink||(e.DefinitionLink={}));var J;(function(be){function de(K){return{range:m.from(K.range),contents:c.fromMany(K.contents)}}be.from=de;function oe(K){return new a.Hover(K.contents.map(c.to),m.to(K.range))}be.to=oe})(J=e.Hover||(e.Hover={}));var re;(function(be){function de(K){return{range:m.from(K.range),expression:K.expression}}be.from=de;function oe(K){return new a.EvaluatableExpression(m.to(K.range),K.expression)}be.to=oe})(re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var pe;(function(be){function de(K){if(K instanceof a.InlineValueText)return{type:"text",range:m.from(K.range),text:K.text};if(K instanceof a.InlineValueVariableLookup)return{type:"variable",range:m.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}be.from=de;function oe(K){switch(K.type){case"text":return{range:m.to(K.range),text:K.text};case"variable":return{range:m.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:m.to(K.range),expression:K.expression}}}be.to=oe})(pe=e.InlineValue||(e.InlineValue={}));var Te;(function(be){function de(K){return{frameId:K.frameId,stoppedLocation:m.from(K.stoppedLocation)}}be.from=de;function oe(K){return new a.InlineValueContext(K.frameId,m.to(K.stoppedLocation))}be.to=oe})(Te=e.InlineValueContext||(e.InlineValueContext={}));var Be;(function(be){function de(K){return{range:m.from(K.range),kind:K.kind}}be.from=de;function oe(K){return new a.DocumentHighlight(m.to(K.range),K.kind)}be.to=oe})(Be=e.DocumentHighlight||(e.DocumentHighlight={}));var Ae;(function(be){function de(oe){switch(oe){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}be.to=de})(Ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var We;(function(be){function de(oe){return{triggerKind:Ae.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}be.to=de})(We=e.CompletionContext||(e.CompletionContext={}));var x;(function(be){function de(K){switch(K){case a.CompletionItemTag.Deprecated:return 1}}be.from=de;function oe(K){switch(K){case 1:return a.CompletionItemTag.Deprecated}}be.to=oe})(x=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(be){const de=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function oe(Ie){var Qe;return(Qe=de.get(Ie))!==null&&Qe!==void 0?Qe:9}be.from=oe;const K=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Re(Ie){var Qe;return(Qe=K.get(Ie))!==null&&Qe!==void 0?Qe:a.CompletionItemKind.Property}be.to=Re})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var ne;(function(be){function de(oe,K){var Re;const Ie=new a.CompletionItem(typeof oe.label=="string"?oe.label:oe.label.name);return typeof oe.label!="string"&&(Ie.label2=oe.label),Ie.insertText=oe.insertText,Ie.kind=q.to(oe.kind),Ie.tags=(Re=oe.tags)===null||Re===void 0?void 0:Re.map(x.to),Ie.detail=oe.detail,Ie.documentation=I.isMarkdownString(oe.documentation)?c.to(oe.documentation):oe.documentation,Ie.sortText=oe.sortText,Ie.filterText=oe.filterText,Ie.preselect=oe.preselect,Ie.commitCharacters=oe.commitCharacters,C.Range.isIRange(oe.range)?Ie.range=m.to(oe.range):typeof oe.range=="object"&&(Ie.range={inserting:m.to(oe.range.insert),replacing:m.to(oe.range.replace)}),Ie.keepWhitespace=typeof oe.insertTextRules=="undefined"?!1:Boolean(oe.insertTextRules&1),typeof oe.insertTextRules!="undefined"&&oe.insertTextRules&4?Ie.insertText=new a.SnippetString(oe.insertText):(Ie.insertText=oe.insertText,Ie.textEdit=Ie.range instanceof a.Range?new a.TextEdit(Ie.range,Ie.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Ie.additionalTextEdits=oe.additionalTextEdits.map(Qe=>Q.to(Qe))),Ie.command=K&&oe.command?K.fromInternal(oe.command):void 0,Ie}be.to=de})(ne=e.CompletionItem||(e.CompletionItem={}));var le;(function(be){function de(K){return{label:K.label,documentation:K.documentation?c.fromStrict(K.documentation):void 0}}be.from=de;function oe(K){return{label:K.label,documentation:I.isMarkdownString(K.documentation)?c.to(K.documentation):K.documentation}}be.to=oe})(le=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(be){function de(K){return{label:K.label,documentation:K.documentation?c.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(le.from):[],activeParameter:K.activeParameter}}be.from=de;function oe(K){return{label:K.label,documentation:I.isMarkdownString(K.documentation)?c.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(le.to):[],activeParameter:K.activeParameter}}be.to=oe})(fe=e.SignatureInformation||(e.SignatureInformation={}));var Se;(function(be){function de(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(fe.from):[]}}be.from=de;function oe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(fe.to):[]}}be.to=oe})(Se=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(be){function de(K){var Re;return{text:K.text,position:f.from(K.position),kind:me.from((Re=K.kind)!==null&&Re!==void 0?Re:a.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}be.from=de;function oe(K){const Re=new a.InlayHint(K.text,f.to(K.position),me.to(K.kind));return Re.whitespaceAfter=K.whitespaceAfter,Re.whitespaceBefore=K.whitespaceBefore,Re}be.to=oe})(Oe=e.InlayHint||(e.InlayHint={}));var me;(function(be){function de(K){return K}be.from=de;function oe(K){return K}be.to=oe})(me=e.InlayHintKind||(e.InlayHintKind={}));var Ce;(function(be){function de(K){return{range:m.from(K.range),url:K.target,tooltip:K.tooltip}}be.from=de;function oe(K){let Re;if(K.url)try{Re=typeof K.url=="string"?S.URI.parse(K.url,!0):S.URI.revive(K.url)}catch(Ie){}return new a.DocumentLink(m.to(K.range),Re)}be.to=oe})(Ce=e.DocumentLink||(e.DocumentLink={}));var Pe;(function(be){function de(K){const Re=new a.ColorPresentation(K.label);return K.textEdit&&(Re.textEdit=Q.to(K.textEdit)),K.additionalTextEdits&&(Re.additionalTextEdits=K.additionalTextEdits.map(Ie=>Q.to(Ie))),Re}be.to=de;function oe(K){return{label:K.label,textEdit:K.textEdit?Q.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Re=>Q.from(Re)):void 0}}be.from=oe})(Pe=e.ColorPresentation||(e.ColorPresentation={}));var $e;(function(be){function de(K){return new a.Color(K[0],K[1],K[2],K[3])}be.to=de;function oe(K){return[K.red,K.green,K.blue,K.alpha]}be.from=oe})($e=e.Color||(e.Color={}));var Ee;(function(be){function de(K){return{range:m.from(K.range)}}be.from=de;function oe(K){return new a.SelectionRange(m.to(K.range))}be.to=oe})(Ee=e.SelectionRange||(e.SelectionRange={}));var je;(function(be){function de(oe){switch(oe){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}be.to=de})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var z;(function(be){function de(K){switch(K){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}be.from=de;function oe(K){switch(K){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}be.to=oe})(z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ee;(function(be){function de(K){if(K===a.EndOfLine.CRLF)return 1;if(K===a.EndOfLine.LF)return 0}be.from=de;function oe(K){if(K===1)return a.EndOfLine.CRLF;if(K===0)return a.EndOfLine.LF}be.to=oe})(ee=e.EndOfLine||(e.EndOfLine={}));var ve;(function(be){function de(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=de})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Le;(function(be){function de(oe){const K={start:oe.start+1,end:oe.end+1};return oe.kind&&(K.kind=He.from(oe.kind)),K}be.from=de})(Le=e.FoldingRange||(e.FoldingRange={}));var He;(function(be){function de(oe){if(oe)switch(oe){case a.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}be.from=de})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ue;(function(be){function de(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?m.from(oe.selection):void 0,override:typeof oe.override=="boolean"?P.EditorOverride.DISABLED:void 0}}be.from=de})(Ue=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(be){function de(K){return K instanceof a.RelativePattern||typeof K=="string"?K:oe(K)?new a.RelativePattern(K.base,K.pattern):K}be.from=de;function oe(K){const Re=K;return Re&&typeof Re.base=="string"&&typeof Re.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var W;(function(be){function de(oe){if(oe){if(Array.isArray(oe))return oe.map(de);if(typeof oe=="string")return oe;{const K=oe;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:Xe.from(K.pattern),exclusive:K.exclusive}}}else return}be.from=de})(W=e.LanguageSelector||(e.LanguageSelector={}));var ie;(function(be){function de(K){return{start:K.start,end:K.end}}be.from=de;function oe(K){return new a.NotebookRange(K.start,K.end)}be.to=oe})(ie=e.NotebookRange||(e.NotebookRange={}));var ce;(function(be){function de(oe){return new a.NotebookCellMetadata().with(Object.assign(Object.assign({},oe),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}be.to=de})(ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var j;(function(be){function de(K){return K}be.from=de;function oe(K){return new a.NotebookDocumentMetadata().with(K)}be.to=oe})(j=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var X;(function(be){function de(K){return{startTime:K.runStartTime,endTime:K.runEndTime,executionOrder:K.executionOrder,success:K.lastRunSuccess}}be.to=de;function oe(K){return{lastRunSuccess:K.success,runStartTime:K.startTime,runEndTime:K.endTime,executionOrder:K.executionOrder}}be.from=oe})(X=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ae;(function(be){function de(K){switch(K){case a.NotebookCellKind.Markdown:return h.CellKind.Markdown;case a.NotebookCellKind.Code:default:return h.CellKind.Code}}be.from=de;function oe(K){switch(K){case h.CellKind.Markdown:return a.NotebookCellKind.Markdown;case h.CellKind.Code:default:return a.NotebookCellKind.Code}}be.to=oe})(ae=e.NotebookCellKind||(e.NotebookCellKind={}));var he;(function(be){function de(K){var Re;return{cellKind:ae.from(K.kind),language:K.language,source:K.source,metadata:Object.assign(Object.assign({},K.metadata),X.from((Re=K.latestExecutionSummary)!==null&&Re!==void 0?Re:{})),outputs:K.outputs?K.outputs.map(ze.from):[]}}be.from=de;function oe(K){return new a.NotebookCellData(ae.to(K.cellKind),K.source,K.language,K.outputs?K.outputs.map(ze.to):void 0,K.metadata?ce.to(K.metadata):void 0)}be.to=oe})(he=e.NotebookCellData||(e.NotebookCellData={}));var ye;(function(be){function de(K){return{mime:K.mime,value:K.value,metadata:K.metadata}}be.from=de;function oe(K){return new a.NotebookCellOutputItem(K.mime,K.value,K.metadata)}be.to=oe})(ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ze;(function(be){function de(K){return{outputId:K.id,outputs:K.outputs.map(ye.from),metadata:K.metadata}}be.from=de;function oe(K){const Re=K.outputs.map(ye.to);return new a.NotebookCellOutput(Re,K.outputId,K.metadata)}be.to=oe})(ze=e.NotebookCellOutput||(e.NotebookCellOutput={}));var xe;(function(be){function de(Ie){if(Ie!=null){if(Ie instanceof a.RelativePattern||typeof Ie=="string")return Ie;if(Re(Ie))return new a.RelativePattern(Ie.base,Ie.pattern);if(K(Ie))return{include:Xe.from(Ie.include)||void 0,exclude:Xe.from(Ie.exclude)||void 0}}}be.from=de;function oe(Ie){return typeof Ie=="string"?Ie:Re(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}be.to=oe;function K(Ie){const Qe=Ie,Ze=Xe.from(Qe.include);if(!(Ze&&Ze instanceof a.RelativePattern||typeof Ze=="string"))return!1;const ut=Xe.from(Qe.exclude);return!!(ut&&ut instanceof a.RelativePattern||typeof ut=="string")}function Re(Ie){const Qe=Ie;return Qe&&typeof Qe.base=="string"&&typeof Qe.pattern=="string"}})(xe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ne;(function(be){function de(oe){return{backgroundColor:oe.backgroundColor,borderColor:oe.borderColor,top:oe.top?g.from(oe.top):void 0}}be.from=de})(Ne=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ge;(function(be){function de(oe,K,Re){const Ie=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ie,Re),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}be.from=de})(Ge=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(be){function de(oe){var K,Re;return{transientOutputs:(K=oe==null?void 0:oe.transientOutputs)!==null&&K!==void 0?K:!1,transientCellMetadata:Object.assign(Object.assign({},oe==null?void 0:oe.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Re=oe==null?void 0:oe.transientDocumentMetadata)!==null&&Re!==void 0?Re:{}}}be.from=de})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var dt;(function(be){function de(K){var Re;return{uri:K.uri,provides:typeof K.provides=="string"?[K.provides]:(Re=K.provides)!==null&&Re!==void 0?Re:[]}}be.from=de;function oe(K){return new a.NotebookKernelPreload(S.URI.revive(K.uri),K.provides)}be.to=oe})(dt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var it;(function(be){function de(K){return{message:c.fromStrict(K.message)||"",severity:K.severity,expectedOutput:K.expectedOutput,actualOutput:K.actualOutput,location:K.location?U.from(K.location):void 0}}be.from=de;function oe(K){const Re=new a.TestMessage(typeof K.message=="string"?K.message:c.to(K.message));return Re.severity=K.severity,Re.actualOutput=K.actualOutput,Re.expectedOutput=K.expectedOutput,Re}be.to=oe})(it=e.TestMessage||(e.TestMessage={}));var Je;(function(be){function de(Ie){var Qe,Ze;return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:m.from(Ie.range)||null,debuggable:(Qe=Ie.debuggable)!==null&&Qe!==void 0?Qe:!1,description:Ie.description||null,runnable:(Ze=Ie.runnable)!==null&&Ze!==void 0?Ze:!0,error:Ie.error&&c.fromStrict(Ie.error)||null}}be.from=de;function oe(Ie){return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:m.from(Ie.range)||null,debuggable:!1,description:Ie.description||null,error:null,runnable:!0}}be.fromResultSnapshot=oe;function K(Ie){return{id:Ie.extId,label:Ie.label,uri:S.URI.revive(Ie.uri),range:m.to(Ie.range||void 0),addChild:()=>{},dispose:()=>{},status:a.TestItemStatus.Pending,data:void 0,debuggable:Ie.debuggable,description:Ie.description||void 0,runnable:Ie.runnable}}be.toPlain=K;function Re(Ie){const Qe=new a.TestItemImpl(Ie.extId,Ie.label,S.URI.revive(Ie.uri),void 0);return Qe.range=m.to(Ie.range||void 0),Qe.debuggable=Ie.debuggable,Qe.description=Ie.description||void 0,Qe.runnable=Ie.runnable,Qe}be.to=Re})(Je=e.TestItem||(e.TestItem={}));var mt;(function(be){const de=(K,Re)=>Object.assign(Object.assign({},Je.toPlain(K.item)),{taskStates:K.tasks.map(Ie=>({state:Ie.state,duration:Ie.duration,messages:Ie.messages.map(it.to)})),children:K.children.map(Ie=>Re.get(Ie)).filter(D.isDefined).map(Ie=>de(Ie,Re))});function oe(K){const Re=[],Ie=new Map;for(const Qe of K.items)Ie.set(Qe.item.extId,Qe),Qe.direct&&Re.push(Qe);return{completedAt:K.completedAt,results:Re.map(Qe=>de(Qe,Ie))}}be.to=oe})(mt=e.TestResults||(e.TestResults={}));var bt;(function(be){function de(oe){switch(oe){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}be.to=de})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(we[176],_e([0,1,2,12,7,9,45]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(C,i,P,d={timeout:1500,errors:3}){this._logService=C,this._documents=i,this._mainThreadBulkEdits=P,this._thresholds=d,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(i,P,d)=>{const r={dispose:this._callbacks.push([i,P,C])};return Array.isArray(d)&&d.push(r),r}}async $participateInSave(C,i){const P=w.URI.revive(C);let d=!1;const h=setTimeout(()=>d=!0,this._thresholds.timeout),r=[];try{for(let a of[...this._callbacks]){if(d)break;const p=this._documents.getDocument(P),m=await this._deliverEventAsyncAndBlameBadListeners(a,{document:p,reason:T.TextDocumentSaveReason.to(i)});r.push(m)}}finally{clearTimeout(h)}return r}_deliverEventAsyncAndBlameBadListeners([C,i,P],d){const h=this._badListeners.get(C);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,C,i,d).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const a=this._badListeners.get(C);this._badListeners.set(C,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,i,P,d){const h=[],r=Date.now(),{document:a,reason:p}=d,{version:m}=a,E=Object.freeze({document:a,reason:p,waitUntil(f){if(Object.isFrozen(h))throw(0,I.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(f))}});try{i.apply(P,[E])}catch(f){return Promise.reject(f)}return Object.freeze(h),new Promise((f,l)=>{const b=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(b),f(t)}).catch(t=>{clearTimeout(b),l(t)})}).then(f=>{const l={edits:[]};for(const b of f)if(Array.isArray(b)&&b.every(t=>t instanceof A.TextEdit))for(const{newText:t,newEol:n,range:u}of b)l.edits.push({_type:2,resource:a.uri,edit:{range:u&&T.Range.from(u),text:t,eol:n&&T.EndOfLine.from(n)}});if(l.edits.length!==0)return m===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(we[177],_e([0,1,3,11,28,2,9,7]),function(Y,e,w,I,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(P,d,h,r,a){this._onDidCreate=new w.Emitter,this._onDidChange=new w.Emitter,this._onDidDelete=new w.Emitter,this._config=0,h&&(this._config+=1),r&&(this._config+=2),a&&(this._config+=4);const p=(0,A.parse)(d),m=P(E=>{if(!h)for(let f of E.created){const l=T.URI.revive(f);p(l.fsPath)&&this._onDidCreate.fire(l)}if(!r)for(let f of E.changed){const l=T.URI.revive(f);p(l.fsPath)&&this._onDidChange.fire(l)}if(!a)for(let f of E.deleted){const l=T.URI.revive(f);p(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,m)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(P,d,h){this._logService=d,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new w.Emitter,this._onDidRenameFile=new w.Emitter,this._onDidCreateFile=new w.Emitter,this._onDidDeleteFile=new w.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,d,h,r){return new S(this._onFileSystemEvent.event,P,d,h,r)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,d){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:d.map(h=>({oldUri:T.URI.revive(h.source),newUri:T.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:d.map(h=>T.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:d.map(h=>T.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,d){return(h,r,a)=>{const p=function(E){h.call(r,E)};return p.extension=P,d.event(p,void 0,a)}}async $onWillRunFileOperation(P,d,h,r){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:d.map(a=>({oldUri:T.URI.revive(a.source),newUri:T.URI.revive(a.target)}))},h,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:d.map(a=>T.URI.revive(a.target))},h,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:d.map(a=>T.URI.revive(a.target))},h,r)}}async _fireWillEvent(P,d,h,r){const a=new Set,p=[];if(await P.fireAsync(d,r,async(E,f)=>{var l;const b=Date.now(),t=await Promise.resolve(E);t instanceof D.WorkspaceEdit&&(p.push(t),a.add((l=f.extension.displayName)!==null&&l!==void 0?l:f.extension.identifier.value)),Date.now()-b>h&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),!r.isCancellationRequested&&p.length!==0){const m={edits:[]};for(let E of p){let{edits:f}=y.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);m.edits=m.edits.concat(f)}return{edit:m,extensionNames:Array.from(a)}}}}e.ExtHostFileSystemEventService=C}),define(we[178],_e([0,1,19,23,2,9,7,73]),function(Y,e,w,I,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(d,h,r,a){this.start=d,this.deletedCount=h,this.deletedItems=r,this.items=a}static asApiEvents(d){return d.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(r=>r.apiCell)}))}}class C{constructor(d,h,r){var a;this._notebook=d,this._extHostDocument=h,this._cellData=r,this.handle=r.handle,this.uri=A.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(a=r.metadata)!==null&&a!==void 0?a:{},this._metadata=T.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=T.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(d,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._cell){const d=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return d._notebook.getCellIndex(d)},notebook:d._notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get latestExecutionSummary(){return d._previousResult}})}return this._cell}setOutputs(d){this._outputs=d.map(T.NotebookCellOutput.to)}setOutputItems(d,h,r){const a=r.map(T.NotebookCellOutputItem.to),p=this._outputs.find(m=>m.id===d);p&&(h||(p.outputs.length=0),p.outputs.push(...a))}setMetadata(d){this._internalMetadata=d,this._metadata=T.NotebookCellMetadata.to(d),this._previousResult=T.NotebookCellPreviousExecutionResult.to(d)}}e.ExtHostCell=C;class i{constructor(d,h,r,a,p,m,E){this._proxy=d,this._textDocumentsAndEditors=h,this._textDocuments=r,this._emitter=a,this._viewType=p,this._metadata=m,this.uri=E,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get viewType(){return d._viewType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===w.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(h){return h=d._validateIndex(h),d._cells[h].apiCell},getCells(h){return(h?d._getCells(h):d._cells).map(a=>a.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=d}disposeBackup(){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=this._metadata.with(d.metadata))}acceptModelChanged(d,h){this._versionId=d.versionId,this._isDirty=h;for(const r of d.rawEvents)r.kind===D.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(r.changes,!0),r.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===D.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===D.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(r.index,r.metadata)}_validateIndex(d){return d=d|0,d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){let h=d.start|0,r=d.end|0;return h<0&&(h=0),r>this._cells.length&&(r=this._cells.length),d.with({start:h,end:r})}_getCells(d){d=this._validateRange(d);const h=[];for(let r=d.start;r<d.end;r++)h.push(this._cells[r]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(d,h){if(!this._disposed){const r=[],a=[],p=[];d.reverse().forEach(m=>{const f=m[2].map(t=>{const n=new C(this,this._textDocumentsAndEditors,t);return h||a.push(C.asModelAddData(this.apiNotebook,t)),n}),l=new S(m[0],m[1],[],f),b=this._cells.splice(m[0],m[1],...f);for(let t of b)p.push(t.uri),l.deletedItems.push(t.apiCell);r.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:p}),h||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(r)}))}}_moveCell(d,h){const r=this._cells.splice(d,1);this._cells.splice(h,0,...r);const a=[new S(d,1,r.map(p=>p.apiCell),[]),new S(h,0,[],r)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(a)}))}_setCellOutputs(d,h){const r=this._cells[d];r.setOutputs(h),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[r.apiCell]}))}_setCellOutputItems(d,h,r,a){const p=this._cells[d];p.setOutputItems(h,r,a),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(d,h){const r=this._cells[d];r.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(r.uri,h)}_changeCellMetadata(d,h){var r;const a=this._cells[d],p=a.internalMetadata,m=a.apiCell.metadata;a.setMetadata(h);const E=a.apiCell.metadata;if((0,I.equals)(m,E)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:a.apiCell})),p.runState!==h.runState){const f=(r=h.runState)!==null&&r!==void 0?r:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,executionState:f}))}}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(h=>h.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(we[179],_e([0,1,7,9]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,S){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:D,metadata:S})}replaceCells(D,S,C){this._throwIfFinalized(),!(D===S&&C.length===0)&&this._collectedEdits.push({editType:1,index:D,count:S-D,cells:C.map(I.NotebookCellData.from)})}}class T{constructor(D,S,C,i,P,d){this.id=D,this._proxy=S,this.notebookData=C,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=P,this._visibleRanges=i,this._viewColumn=d}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},get visibleRanges(){return D._visibleRanges},revealRange(S,C){D._proxy.$tryRevealRange(D.id,I.NotebookRange.from(S),C!=null?C:w.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(S){const C=new A(this.document.version);return S(C),D._applyEdit(C.finalize())},setDecorations(S,C){return D.setDecorations(S,C)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const S=[];let C=-1;for(let i=0;i<D.cellEdits.length;i++){if(C<0){S.push(D.cellEdits[i]),C++;continue}const d=S[C],h=D.cellEdits[i];if(d.editType===1&&h.editType===1&&d.index===h.index){d.cells.push(...D.cellEdits[i].cells),d.count+=D.cellEdits[i].count;continue}S.push(D.cellEdits[i]),C++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,S)}setDecorations(D,S){if(!(S.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return S.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(S),D.key)}}e.ExtHostNotebookEditor=T}),define(we[180],_e([0,1,9,153,133,20,52]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,d,h){const r=this._handles++,{title:a,location:p,cancellable:m}=d,E={label:(0,A.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(r,{location:w.ProgressLocation.from(p),title:a,source:E,cancellable:m},P),this._withProgress(r,h,!!m)}_withProgress(P,d,h){let r;h&&(r=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,r));const a=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),r&&r.dispose()};let p;try{p=d(new C(this._proxy,P),h&&r?r.token:T.CancellationToken.None)}catch(m){throw a(P),m}return p.then(m=>a(P),m=>a(P)),p}$acceptProgressCanceled(P){const d=this._mapHandleToCancellationSource.get(P);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=D;function S(i,P){return i.message=P.message,typeof P.increment=="number"&&(typeof i.increment=="number"?i.increment+=P.increment:i.increment=P.increment),i}class C extends I.Progress{constructor(P,d){super(h=>this.throttledReport(h));this._proxy=P,this._handle=d}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}Ve([(0,y.throttle)(100,(i,P)=>S(i,P),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(we[97],_e([0,1,42,12,54,9,7]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(d,h){const r=D._Keys.nextId();d.$registerTextEditorDecorationType(r,T.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:r,dispose(){d.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=D,D._Keys=new A.IdGenerator("TextEditorDecorationType");class S{constructor(d,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,h){this._throwIfFinalized();let r=null;if(d instanceof y.Position)r=new y.Range(d,d);else if(d instanceof y.Range)r=d;else throw new Error("Unrecognized location");this._pushEdit(r,h,!1)}insert(d,h){this._throwIfFinalized(),this._pushEdit(new y.Range(d,d),h,!0)}delete(d){this._throwIfFinalized();let h=null;if(d instanceof y.Range)h=d;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(d,h,r){const a=this._document.validateRange(d);this._collectedEdits.push({range:a,text:h,forceMoveMarkers:r})}setEndOfLine(d){if(this._throwIfFinalized(),d!==y.EndOfLine.LF&&d!==y.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=S;class C{constructor(d,h,r,a){this._proxy=d,this._id=h,this._accept(r),this._logService=a;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(m){p._setTabSize(m)},get insertSpaces(){return p._insertSpaces},set insertSpaces(m){p._setInsertSpaces(m)},get cursorStyle(){return p._cursorStyle},set cursorStyle(m){p._setCursorStyle(m)},get lineNumbers(){return p._lineNumbers},set lineNumbers(m){p._setLineNumbers(m)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const h=Math.floor(d);return h>0?h:null}if(typeof d=="string"){const h=parseInt(d,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(d){const h=this._validateTabSize(d);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const h=this._validateInsertSpaces(d);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(d)})))}assign(d){const h={};let r=!1;if(typeof d.tabSize!="undefined"){const a=this._validateTabSize(d.tabSize);a==="auto"?(r=!0,h.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,r=!0,h.tabSize=a)}if(typeof d.insertSpaces!="undefined"){const a=this._validateInsertSpaces(d.insertSpaces);a==="auto"?(r=!0,h.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,r=!0,h.insertSpaces=a)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,r=!0,h.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,r=!0,h.lineNumbers=T.TextEditorLineNumbersStyle.from(d.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(d){d.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=C;class i{constructor(d,h,r,a,p,m,E,f){this.id=d,this._proxy=h,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new C(this._proxy,this.id,m,r),this._visibleRanges=E,this._viewColumn=f;const l=this;this.value=Object.freeze({get document(){return a.getValue()},set document(b){throw(0,I.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(b){if(!(b instanceof y.Selection))throw(0,I.illegalArgument)("selection");l._selections=[b],l._trySetSelection()},get selections(){return l._selections},set selections(b){if(!Array.isArray(b)||b.some(t=>!(t instanceof y.Selection)))throw(0,I.illegalArgument)("selections");l._selections=b,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(b){throw(0,I.readonly)("visibleRanges")},get options(){return l._options.value},set options(b){l._disposed||l._options.assign(b)},get viewColumn(){return l._viewColumn},set viewColumn(b){throw(0,I.readonly)("viewColumn")},edit(b,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new S(a.getValue(),t);return b(n),l._applyEdit(n)},insertSnippet(b,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!t||Array.isArray(t)&&t.length===0)u=l._selections.map(o=>T.Range.from(o));else if(t instanceof y.Position){const{lineNumber:o,column:s}=T.Position.from(t);u=[{startLineNumber:o,startColumn:s,endLineNumber:o,endColumn:s}]}else if(t instanceof y.Range)u=[T.Range.from(t)];else{u=[];for(const o of t)if(o instanceof y.Range)u.push(T.Range.from(o));else{const{lineNumber:s,column:c}=T.Position.from(o);u.push({startLineNumber:s,startColumn:c,endLineNumber:s,endColumn:c})}}return h.$tryInsertSnippet(d,b.value,u,n)},setDecorations(b,t){const n=t.length===0;n&&!l._hasDecorationsForKey.has(b.key)||(n?l._hasDecorationsForKey.delete(b.key):l._hasDecorationsForKey.add(b.key),l._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return h.$trySetDecorations(d,b.key,T.fromRangeOrRangeWithMessage(t));{const u=new Array(4*t.length);for(let o=0,s=t.length;o<s;o++){const c=t[o];u[4*o]=c.start.line+1,u[4*o+1]=c.start.character+1,u[4*o+2]=c.end.line+1,u[4*o+3]=c.end.character+1}return h.$trySetDecorationsFast(d,b.key,u)}}))},revealRange(b,t){l._runOnProxy(()=>h.$tryRevealRange(d,T.Range.from(b),t||y.TextEditorRevealType.Default))},show(b){h.$tryShowEditor(d,T.ViewColumn.from(b))},hide(){h.$tryHideEditor(d)}})}dispose(){(0,w.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,w.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,w.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,w.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,w.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const h=d.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const r=h.edits.map(p=>p.range);r.sort((p,m)=>p.end.line===m.end.line?p.end.character===m.end.character?p.start.line===m.start.line?p.start.character-m.start.character:p.start.line-m.start.line:p.end.character-m.end.character:p.end.line-m.end.line);for(let p=0,m=r.length-1;p<m;p++){const E=r[p].end;if(r[p+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=h.edits.map(p=>({range:T.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,a,{setEndOfLine:typeof h.setEndOfLine=="number"?T.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=i}),define(we[181],_e([0,1,136,25,2,3,6,11,7,10,15,9,20]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(p,m){if((0,C.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let E;return Array.isArray(p.highlights)&&(E=p.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),E=E.length?E:void 0),{label:p.label,highlights:E}}}class r{constructor(m,E,f){this._proxy=m,this.commands=E,this.logService=f,this.treeViews=new Map;function l(b){return b&&b.$treeViewId&&b.$treeItemHandle}E.registerArgumentProcessor({processArgument:b=>l(b)?this.convertArgument(b):Array.isArray(b)&&b.length>0?b.map(t=>l(t)?this.convertArgument(t):t):b})}registerTreeDataProvider(m,E,f){const l=this.createTreeView(m,{treeDataProvider:E},f);return{dispose:()=>l.dispose()}}createTreeView(m,E,f){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,canDragAndDrop:!!E.canDragAndDrop}),b=this.createExtHostTreeView(m,E,f);return{get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get message(){return b.message},set message(t){b.message=t},get title(){return b.title},set title(t){b.title=t},get description(){return b.description},set description(t){b.description=t},reveal:(t,n)=>b.reveal(t,n),dispose:async()=>{await l,this.treeViews.delete(m),b.dispose()}}}$getChildren(m,E){const f=this.treeViews.get(m);return f?f.getChildren(E):Promise.reject(new Error((0,w.localize)(0,null,m)))}$setParent(m,E,f){const l=this.treeViews.get(m);return l?l.setParent(E,f):Promise.reject(new Error((0,w.localize)(1,null,m)))}async $hasResolve(m){const E=this.treeViews.get(m);if(!E)throw new Error((0,w.localize)(2,null,m));return E.hasResolve}$resolve(m,E,f){const l=this.treeViews.get(m);if(!l)throw new Error((0,w.localize)(3,null,m));return l.resolveTreeItem(E,f)}$setExpanded(m,E,f){const l=this.treeViews.get(m);if(!l)throw new Error((0,w.localize)(4,null,m));l.setExpanded(E,f)}$setSelection(m,E){const f=this.treeViews.get(m);if(!f)throw new Error((0,w.localize)(5,null,m));f.setSelection(E)}$setVisible(m,E){const f=this.treeViews.get(m);if(!f)throw new Error((0,w.localize)(6,null,m));f.setVisible(E)}createExtHostTreeView(m,E,f){const l=new a(m,E,this._proxy,this.commands.converter,this.logService,f);return this.treeViews.set(m,l),l}convertArgument(m){const E=this.treeViews.get(m.$treeViewId);return E?E.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=r;class a extends y.Disposable{constructor(m,E,f,l,b,t){super();if(this.viewId=m,this.proxy=f,this.commands=l,this.logService=b,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,t.contributes&&t.contributes.views)for(const o in t.contributes.views)for(const s of t.contributes.views[o])s.id===m&&(this._title=s.name);this.dataProvider=E.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let n,u;this._register(T.Event.debounce(this._onDidChangeData.event,(o,s)=>(o||(o={message:!1,elements:[]}),s.element!==!1&&(n||(n=new Promise(c=>u=c),this.refreshPromise=this.refreshPromise.then(()=>n)),o.elements.push(s.element)),s.message&&(o.message=!0),o),200,!0)(({message:o,elements:s})=>{s.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=u;return n=null,this.refresh(s).then(()=>c())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,C.isUndefinedOrNull)(m))}getChildren(m){const E=m?this.getExtensionElement(m):void 0;if(m&&!E)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);const f=this.getChildrenNodes(m);return(f?Promise.resolve(f):this.fetchChildrenNodes(E)).then(l=>l.map(b=>b.item))}getExtensionElement(m){return this.elements.get(m)}reveal(m,E){E=E||{select:!0,focus:!1};const f=(0,C.isUndefinedOrNull)(E.select)?!0:E.select,l=(0,C.isUndefinedOrNull)(E.focus)?!1:E.focus,b=(0,C.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(t=>this.resolveTreeNode(m,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(u=>u.item)},{select:f,focus:l,expand:b})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:f,focus:l,expand:b})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,E){const f=this.getExtensionElement(m);f&&(E?this._onDidExpandElement.fire(Object.freeze({element:f})):this._onDidCollapseElement.fire(Object.freeze({element:f})))}setSelection(m){(0,i.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}setParent(m,E){const f=m.map(b=>this.getExtensionElement(b)).filter(b=>!(0,C.isUndefinedOrNull)(b)),l=this.getExtensionElement(E);return this.dataProvider.setParent&&f&&l?(0,D.asPromise)(()=>this.dataProvider.setParent(f,l)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,E){var f;if(!!this.dataProvider.resolveTreeItem){const l=this.elements.get(m);if(l){const b=this.nodes.get(l);if(b){const t=(f=await this.dataProvider.resolveTreeItem(b.extensionItem,l,E))!==null&&f!==void 0?f:b.extensionItem;return b.item.tooltip=this.getTooltip(t.tooltip),b.item.command=this.getCommand(b.disposableStore,t.command),b.item}}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(E=>E?this.resolveUnknownParentChain(E).then(f=>this.resolveTreeNode(E,f[f.length-1]).then(l=>(f.push(l),f))):Promise.resolve([]))}resolveParent(m){const E=this.nodes.get(m);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,E){const f=this.nodes.get(m);return f?Promise.resolve(f):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(l=>this.createHandle(m,l,E,!0)).then(l=>this.getChildren(E?E.item.handle:void 0).then(()=>{const b=this.getExtensionElement(l);if(b){const t=this.nodes.get(b);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(m){if(m){let E;if(typeof m=="string"){const f=this.getExtensionElement(m);E=f?this.nodes.get(f):void 0}else E=m;return E&&E.children||null}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const E=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const f=m?this.nodes.get(m):void 0,l=await this.dataProvider.getChildren(m);if(E.token.isCancellationRequested)return[];const b=await Promise.all((0,i.coalesce)(l||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,f):null}));return E.token.isCancellationRequested?[]:(0,i.coalesce)(b)}finally{E.dispose()}}refresh(m){if(m.some(f=>!f))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const f=this.getHandlesToRefresh(m);if(f.length)return this.refreshHandles(f)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const E=new Set,f=m.map(b=>this.nodes.get(b));for(const b of f)if(b&&!E.has(b.item.handle)){let t=b;for(;t&&t.parent&&f.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&E.add(b.item.handle)}const l=[];return E.forEach(b=>{const t=this.elements.get(b);if(t){const n=this.nodes.get(t);n&&(!n.parent||!E.has(n.parent.item.handle))&&l.push(b)}}),l}refreshHandles(m){const E={};return Promise.all(m.map(f=>this.refreshNode(f).then(l=>{l&&(E[f]=l.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(m){const E=this.getExtensionElement(m);if(E){const f=this.nodes.get(E);if(f)return this.clearChildren(E),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(l=>{if(l){const b=this.createTreeNode(E,l,f.parent);return this.updateNodeCache(E,b,f,f.parent),f.dispose(),b}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,E,f){const l=this.createTreeNode(m,E,f);if(E.id&&this.elements.has(l.item.handle))throw new Error((0,w.localize)(7,null,E.id));return this.addNodeToCache(m,l),this.addNodeToParentCache(l,f),l}getTooltip(m){return S.MarkdownString.isMarkdownString(m)?P.MarkdownString.from(m):m}getCommand(m,E){return E?this.commands.toInternal(E,m):void 0}createTreeNode(m,E,f){const l=new y.DisposableStore,b=this.createHandle(m,E,f),t=this.getLightIconPath(E);return{item:{handle:b,parentHandle:f?f.item.handle:void 0,label:h(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(l,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:(0,C.isUndefinedOrNull)(E.collapsibleState)?S.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:f,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(m){return m.iconPath instanceof S.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:E,label:f,resourceUri:l},b,t){if(E)return`${a.ID_HANDLE_PREFIX}/${E}`;const n=h(f,this.extension),u=b?b.item.handle:a.LABEL_HANDLE_PREFIX;let o=n?n.label:l?(0,I.basename)(l):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const s=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,c=this.getChildrenNodes(b)||[];let v,k=0;do{if(v=`${u}/${k}:${o}`,t||!this.elements.has(v)||s===v)break;k++}while(k<=c.length);return v}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof S.ThemeIcon))return typeof m.iconPath=="string"||A.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof S.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return A.URI.isUri(m)?m:A.URI.file(m)}addNodeToCache(m,E){this.elements.set(E.item.handle,m),this.nodes.set(m,E)}updateNodeCache(m,E,f,l){this.elements.delete(E.item.handle),this.nodes.delete(m),E.item.handle!==f.item.handle&&this.elements.delete(f.item.handle),this.addNodeToCache(m,E);const b=this.getChildrenNodes(l)||[],t=b.filter(n=>n.item.handle===f.item.handle)[0];t&&b.splice(b.indexOf(t),1,E)}addNodeToParentCache(m,E){E?(E.children||(E.children=[]),E.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const E=this.nodes.get(m);if(E){if(E.children)for(const f of E.children){const l=this.elements.get(f.item.handle);l&&this.clear(l)}E.children=void 0}}else this.clearAll()}clear(m){const E=this.nodes.get(m);if(E){if(E.children)for(const f of E.children){const l=this.elements.get(f.item.handle);l&&this.clear(l)}this.nodes.delete(m),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}a.LABEL_HANDLE_PREFIX="0",a.ID_HANDLE_PREFIX="1"}),define(we[182],_e([0,1,15,11,20,10,69,9,7,96]),function(Y,e,w,I,A,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(p,m){if(m!==void 0){const E=this.testIdsToInternal.get(m),f=E==null?void 0:E.get(p);if(f)return[E,f]}return(0,w.mapFind)(this.testIdsToInternal.values(),E=>{const f=E.get(p);return f&&[E,f]})}createForHierarchy(p=()=>{}){return new r(this.createIdMap(d++),p)}createIdMap(p){const m=new h(p);return this.testIdsToInternal.set(m.id,m),{object:m,dispose:()=>this.testIdsToInternal.delete(m.id)}}}e.OwnedTestCollection=i;var P;(function(a){a[a.Disconnected=0]="Disconnected",a[a.IsChild=1]="IsChild",a[a.IsParent=2]="IsParent",a[a.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));let d=0;class h{constructor(p){this.id=p,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(p){if(this.map.has(p.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${p.item.extId}`);this.map.set(p.item.extId,p),p.parent||this._roots.add(p)}has(p){return this.map.has(p)}delete(p){const m=this.map.get(p);return m?(this.map.delete(p),this._roots.delete(m),!0):!1}get(p){return this.map.get(p)}comparePositions(p,m){const E=typeof p=="string"?this.map.get(p):p,f=typeof m=="string"?this.map.get(m):m;if(!E||!f)return 0;if(E===f)return 3;for(let l=this.map.get(f.parent);l;l=this.map.get(l.parent))if(l===E)return 1;for(let l=this.map.get(E.parent);l;l=this.map.get(l.parent))if(l===f)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=h;class r{constructor(p,m){this.testIdToInternal=p,this.publishDiff=m,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(p,m){this.addItem(p,m,null)}getTestByReference(p){return this.testItemToInternal.get(p)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){const m=this.diff[this.diff.length-1];if(m&&p[0]===1){if(m[0]===1&&m[1].extId===p[1].extId){(0,C.applyTestItemUpdate)(m[1],p[1]);return}if(m[0]===0&&m[1].item.extId===p[1].extId){(0,C.applyTestItemUpdate)(m[1],p[1]);return}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,m){var E;const f=this.testIdToInternal.object.get(p);if(!!f){if((f.expandLevels===void 0||m>f.expandLevels)&&(f.expandLevels=m),f.expand===1){const l=this.refreshChildren(f);return l.isSettled?this.expandChildren(f,m-1):l.p.then(()=>this.expandChildren(f,m-1))}else if(f.expand===3)return((E=f.initialExpand)===null||E===void 0?void 0:E.isSettled)===!1?f.initialExpand.p.then(()=>this.expandChildren(f,m-1)):this.expandChildren(f,m-1)}}dispose(){var p;for(const m of this.testItemToInternal.values())(p=m.discoverCts)===null||p===void 0||p.dispose(!0),(0,y.getPrivateApiFor)(m.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(p,m){const E=p==null?void 0:p.actual.id;switch(m[0]){case 2:this.pushDiff([4,E]);break;case 1:this.removeItem(p);break;case 0:this.addItem(m[1],p.src.controller,p);break;case 3:const[f,l,b]=m;switch(l){case"status":this.updateExpandability(p);break;case"range":this.pushDiff([1,{extId:E,item:{range:D.Range.from(b)}}]);break;case"error":this.pushDiff([1,{extId:E,item:{error:D.MarkdownString.fromStrict(b)||null}}]);break;default:this.pushDiff([1,{extId:E,item:{[l]:b!=null?b:null}}]);break}break;default:(0,T.assertNever)(m[0])}}addItem(p,m,E){if(!(p instanceof S.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${p.id} did not`);if(this.testItemToInternal.has(p))throw new Error(`Attempted to add a single TestItem ${p.id} multiple times to the tree`);if(this.testIdToInternal.object.has(p.id))throw new Error(`Attempted to insert a duplicate test item ID ${p.id}`);const f=E?E.item.extId:null,l=p.resolveHandler?1:0,b=E?E.expandLevels:1,t={controller:m,tree:this.testIdToInternal.object.id},n={actual:p,parent:f,item:D.TestItem.from(p),expandLevels:b?b-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(p,n),this.pushDiff([0,{parent:f,src:t,expand:l,item:n.item}]);const u=(0,y.getPrivateApiFor)(p);u.parent=E==null?void 0:E.actual,u.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const o of u.children.values())this.testItemToInternal.has(o)||this.addItem(o,m,n)}updateExpandability(p){var m;let E;p.actual.resolveHandler?p.actual.status===S.TestItemStatus.Pending?E=p.discoverCts?2:1:((m=p.initialExpand)===null||m===void 0||m.complete(),E=3):E=0,E!==p.expand&&(p.expand=E,this.pushDiff([1,{extId:p.actual.id,expand:E}]),E===1&&p.expandLevels!==void 0&&this.refreshChildren(p))}expandChildren(p,m){if(!(m<0)){const E=[...p.actual.children.values()].map(f=>this.expand(f.id,m)).filter(I.isThenable);if(E.length)return Promise.all(E).then(()=>{})}}refreshChildren(p){if(p.discoverCts&&p.discoverCts.dispose(!0),!p.actual.resolveHandler){const m=new I.DeferredPromise;return m.complete(),m}return p.expand=2,p.discoverCts=new A.CancellationTokenSource,this.pushExpandStateUpdate(p),p.initialExpand=new I.DeferredPromise,p.actual.resolveHandler(p.discoverCts.token),p.initialExpand}pushExpandStateUpdate(p){this.pushDiff([1,{extId:p.actual.id,expand:p.expand}])}removeItem(p){var m;this.pushDiff([2,p.actual.id]);const E=[p];for(;E.length;){const f=E.pop();if(!!f){(m=f.discoverCts)===null||m===void 0||m.dispose(!0),this.testIdToInternal.object.delete(f.item.extId),this.testItemToInternal.delete(f.actual);for(const l of f.actual.children.values())E.push(this.testIdToInternal.object.get(l.id))}}}flushDiff(){const p=this.collectDiff();p.length&&this.publishDiff(p)}}e.SingleUseTestCollection=r}),define(we[183],_e([0,1,26,3,13]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=T;class y{constructor(i){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(w.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(w.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let P of i.activationEvents)P==="onUri"&&(P=`onUri:${w.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(i)}}keepOnly(i){const P=new Set;i.forEach(d=>P.add(w.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>P.has(w.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,P){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const d=y._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(d.map(h=>h.identifier)),P.length>0){const h=new Set;P.forEach(r=>h.add(w.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!h.has(w.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(d)}static _findLoopingExtensions(i){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,m){this.addNode(p),this.addNode(m),this._arcs.has(p)?this._arcs.get(p).push(m):this._arcs.set(p,[m])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,m){const E=P.getArcs(p);for(let f=0;f<E.length;f++)if(!m.has(E[f]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let p of i){const m=w.ExtensionIdentifier.toKey(p.identifier);if(d.set(m,p),p.extensionDependencies)for(let E of p.extensionDependencies){const f=w.ExtensionIdentifier.toKey(E);P.addArc(m,f)}}let h=new Set;P.getNodes().filter(p=>P.getArcs(p).length===0).forEach(p=>h.add(p));let r=P.getNodes().filter(p=>!h.has(p)),a;do{a=!1;for(let p=0;p<r.length;p++){const m=r[p];P.hasOnlyGoodArcs(m,h)&&(r.splice(p,1),p--,h.add(m),a=!0)}}while(a);return r.map(p=>d.get(p))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(w.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const P=this._activationMap.get(i);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const P=this._extensionsMap.get(w.ExtensionIdentifier.toKey(i));return P||void 0}}e.ExtensionDescriptionRegistry=y;var D;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(D||(D={}));function S(C,i){const P=C.isBuiltin?0:C.isUnderDevelopment?2:1,d=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(P!==d)return P-d;const h=A.posix.basename(C.extensionLocation.path),r=A.posix.basename(i.extensionLocation.path);return h<r?-1:h>r?1:0}}),define(we[184],_e([0,1,24]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function T(D){const S=w.VSBuffer.alloc(1);switch(D){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=T;function y(D,S){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=y}),define(we[33],_e([0,1,3,2,4,26,150]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class D{constructor(E){this.dependency=E}}e.MissingExtensionDependency=D;var S;(function(m){m[m.LocalProcess=0]="LocalProcess",m[m.LocalWebWorker=1]="LocalWebWorker",m[m.Remote=2]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(E,f,l,b){this.codeLoadingTime=E,this.activateCallTime=f,this.activateResolvedTime=l,this.activationReason=b}}e.ActivationTimes=C;class i{constructor(E,f){this.description=E,this.value=f}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var P;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function d(m){m.enableProposedApi||h(m)}e.checkProposedApiEnabled=d;function h(m){throw new Error(`[${m.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.throwProposedApiError=h;function r(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation}}e.toExtension=r;function a(m){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(m.identifier.id),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!1,extensionLocation:m.location},m.manifest),{uuid:m.identifier.uuid})}e.toExtensionDescription=a;class p{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,f){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,f,l,b,t){}_onDidActivateExtensionError(E,f){}_onExtensionRuntimeError(E,f){}_onExtensionHostExit(E){}}e.NullExtensionService=p}),define(we[185],_e([0,1,26,33,18]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class y{constructor(r,a,p,m){this.startup=r,this.codeLoadingTime=a,this.activateCallTime=p,this.activateResolvedTime=m}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class D{constructor(r){this._startup=r,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(r,a){return r===-1||a===-1?-1:a-r}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class S{constructor(r,a,p,m,E,f){this.activationFailed=r,this.activationFailedError=a,this.activationTimes=p,this.module=m,this.exports=E,this.subscriptions=f}}e.ActivatedExtension=S;class C extends S{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class i extends S{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class P extends S{constructor(r){super(!0,r,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let d=class{constructor(r,a,p,m,E){this._logService=E,this._registry=r,this._resolvedExtensionsSet=new Set,a.forEach(f=>this._resolvedExtensionsSet.add(w.ExtensionIdentifier.toKey(f))),this._hostExtensionsMap=new Map,p.forEach(f=>this._hostExtensionsMap.set(w.ExtensionIdentifier.toKey(f),f)),this._host=m,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(r){const a=w.ExtensionIdentifier.toKey(r);return this._activatedExtensions.has(a)}getActivatedExtension(r){const a=w.ExtensionIdentifier.toKey(r),p=this._activatedExtensions.get(a);if(!p)throw new Error("Extension `"+r.value+"` is not known or not activated");return p}activateByEvent(r,a){if(this._alreadyActivatedEvents[r])return T;const p=this._registry.getExtensionDescriptionsForActivationEvent(r);return this._activateExtensions(p.map(m=>({id:m.identifier,reason:{startup:a,extensionId:m.identifier,activationEvent:r}}))).then(()=>{this._alreadyActivatedEvents[r]=!0})}activateById(r,a){const p=this._registry.getExtensionDescription(r);if(!p)throw new Error("Extension `"+r+"` is not known");return this._activateExtensions([{id:p.identifier,reason:a}])}_handleActivateRequest(r,a,p){if(this._hostExtensionsMap.has(w.ExtensionIdentifier.toKey(r.id))){a[w.ExtensionIdentifier.toKey(r.id)]=r;return}const m=this._registry.getExtensionDescription(r.id);if(!m){const l=new Error(`Cannot activate unknown extension '${r.id.value}'`);this._host.onExtensionActivationError(r.id,l,new I.MissingExtensionDependency(r.id.value)),this._activatedExtensions.set(w.ExtensionIdentifier.toKey(r.id),new P(l));return}const E=typeof m.extensionDependencies=="undefined"?[]:m.extensionDependencies;let f=!0;for(let l=0,b=E.length;l<b;l++){const t=E[l];if(!this._resolvedExtensionsSet.has(w.ExtensionIdentifier.toKey(t))){const n=this._activatedExtensions.get(w.ExtensionIdentifier.toKey(t));if(!(n&&!n.activationFailed)){if(n&&n.activationFailed){const c=m.displayName||m.identifier.value,v=this._registry.getExtensionDescription(t),k=v&&v.displayName||t,g=new Error(`Cannot activate the '${c}' extension because its dependency '${k}' failed to activate`);g.detail=n.activationFailedError,this._host.onExtensionActivationError(m.identifier,g,null),this._activatedExtensions.set(w.ExtensionIdentifier.toKey(m.identifier),new P(g));return}if(this._hostExtensionsMap.has(w.ExtensionIdentifier.toKey(t))){f=!1,a[w.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(w.ExtensionIdentifier.toKey(t)),reason:r.reason};continue}const u=this._registry.getExtensionDescription(t);if(u){f=!1,a[w.ExtensionIdentifier.toKey(t)]={id:u.identifier,reason:r.reason};continue}const o=m.displayName||m.identifier.value,s=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(m.identifier,s,new I.MissingExtensionDependency(t)),this._activatedExtensions.set(w.ExtensionIdentifier.toKey(m.identifier),new P(s));return}}}f?a[w.ExtensionIdentifier.toKey(m.identifier)]=r:p.push(r)}_activateExtensions(r){if(r.length===0||(r=r.filter(E=>!this._activatedExtensions.has(w.ExtensionIdentifier.toKey(E.id))),r.length===0))return Promise.resolve(void 0);const a=Object.create(null),p=[];for(let E=0,f=r.length;E<f;E++)this._handleActivateRequest(r[E],a,p);for(let E=0,f=p.length;E<f;E++){const l=w.ExtensionIdentifier.toKey(p[E].id);a[l]&&delete a[l]}const m=Object.keys(a).map(E=>a[E]);return p.length===0?Promise.all(m.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(m).then(E=>this._activateExtensions(p))}_activateExtension(r,a){const p=w.ExtensionIdentifier.toKey(r);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const m=this._activatingExtensions.get(p);if(m)return m;const E=this._host.actualActivateExtension(r,a).then(void 0,f=>{const l=new Error;return f&&f.name&&(l.name=f.name),f&&f.message?l.message=`Activating extension '${r.value}' failed: ${f.message}.`:l.message=`Activating extension '${r.value}' failed: ${f}.`,f&&f.stack&&(l.stack=f.stack),this._host.onExtensionActivationError(r,l,null),this._logService.error(`Activating extension ${r.value} failed due to an error:`),this._logService.error(f),new P(f)}).then(f=>{this._activatedExtensions.set(p,f),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,E),E}};d=Ve([qe(4,A.ILogService)],d),e.ExtensionsActivator=d}),define(we[186],_e([0,1,12]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,y)=>{this._actualOk=T,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,w.onUnexpectedError)(T))}then(T,y){return this._ensureActual().then(T,y)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=I}),define(we[98],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class w{constructor(S,C){this.isMain=S,this.sid=C,this.nid=++w.count}}e.ProxyIdentifier=w,w.count=0;const I=[];function A(D){const S=new w(!0,D);return I[S.nid]=S,S}e.createMainContextProxyIdentifier=A;function T(D){const S=new w(!1,D);return I[S.nid]=S,S}e.createExtHostContextProxyIdentifier=T;function y(D){return I[D].sid}e.getStringIdentifierForProxy=y}),define(we[5],_e([0,1,2,98,57]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(l){l[l.Markdown=1]="Markdown",l[l.Code=2]="Code"})(C=e.CellKind||(e.CellKind={}));var i;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={}));var P;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(P=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var d;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(d=e.CandidatePortSource||(e.CandidatePortSource={}));var h;(function(l){l.name="$ident";function b(n,u){return Object.defineProperty(n,l.name,{value:u,enumerable:!0}),n}l.mixin=b;function t(n){return n[l.name]}l.of=t})(h=e.ObjectIdentifier||(e.ObjectIdentifier={}));class r{static mixin(b){return b._id=r._n++,b}}e.IdObject=r,r._n=0;var a;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(m=e.WorkspaceEditType||(e.WorkspaceEditType={}));function E(l){if(l&&l.edits)for(const b of l.edits)typeof b.resource=="object"?b.resource=w.URI.revive(b.resource):(b.newUri=w.URI.revive(b.newUri),b.oldUri=w.URI.revive(b.oldUri)),b.metadata&&b.metadata.iconPath&&(b.metadata=(0,A.revive)(b.metadata));return l}e.reviveWorkspaceEditDto=E;var f;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[74],_e([0,1,5,3,4]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(D){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(w.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,S){return this._proxy.$getPassword(D,S)}store(D,S,C){return this._proxy.$setPassword(D,S,C)}delete(D,S){return this._proxy.$deletePassword(D,S)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,A.createDecorator)("IExtHostSecretState")}),define(we[75],_e([0,1,4,18,5,14]),function(Y,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,w.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(S,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(A.MainContext.MainThreadTelemetry)}report(S,C,i){const P=this.getUsageKey(S,C);this._reportedUsages.has(P)||(this._reportedUsages.add(P),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:S}))}getUsageKey(S,C){return`${S}-${C.identifier.value}`}};y=Ve([qe(0,T.IExtHostRpcService),qe(1,I.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(D,S,C){}})}),define(we[187],_e([0,1,3,5,7,26]),function(Y,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new w.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new w.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(S,C,i,P={}){const d=T.ExtensionIdentifier.toKey(S.identifier),h=this._inFlightRequests.get(d)||[],r=i.sort().join(" ");let a=h.find(p=>p.scopes===r);if(a)return a.result;{const p=this._getSession(S,d,C,i,P);a={scopes:r,result:p},h.push(a),this._inFlightRequests.set(d,h);try{await p}finally{const m=h.findIndex(E=>E.scopes===r);m>-1&&(h.splice(m),this._inFlightRequests.set(d,h))}return p}}async _getSession(S,C,i,P,d={}){await this._proxy.$ensureProvider(i);const h=S.displayName||S.name;return this._proxy.$getSession(i,P,C,h,d)}async removeSession(S,C){const i=this._authenticationProviders.get(S);return i?i.provider.removeSession(C):this._proxy.$removeSession(S,C)}registerAuthenticationProvider(S,C,i,P){var d;if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:C,provider:i,options:P!=null?P:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===S)||this._providers.push({id:S,label:C});const h=i.onDidChangeSessions(r=>{var a,p,m;this._proxy.$sendDidChangeSessions(S,{added:(a=r.added)!==null&&a!==void 0?a:[],changed:(p=r.changed)!==null&&p!==void 0?p:[],removed:(m=r.removed)!==null&&m!==void 0?m:[]})});return this._proxy.$registerAuthenticationProvider(S,C,(d=P==null?void 0:P.supportsMultipleAccounts)!==null&&d!==void 0?d:!1),new A.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(S);const r=this._providers.findIndex(a=>a.id===S);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,C){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,C){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,C){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,C){return this._onDidChangeSessions.fire({provider:{id:S,label:C}}),Promise.resolve()}$onDidChangeAuthenticationProviders(S,C){return S.forEach(i=>{this._providers.some(P=>P.id===i.id)||this._providers.push(i)}),C.forEach(i=>{const P=this._providers.findIndex(d=>d.id===i.id);P>-1&&this._providers.splice(P)}),this._onDidChangeAuthenticationProviders.fire({added:S,removed:C}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(we[188],_e([0,1,5,14,9]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(D,S){this._extHostDocumentsAndEditors=S,this._proxy=D.getProxy(w.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const S=A.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};T=Ve([qe(0,I.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(we[189],_e([0,1,5]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(T){const y=T.getProxy(w.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(D){return y.$writeText(D)}})}}e.ExtHostClipboard=I}),define(we[76],_e([0,1,10,7,9,23,5,15,18,57,32,38,2,6,4,14]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new m(this,u=>{const o=this._apiCommands.get(u);return(o==null?void 0:o.result)===f.Void?o:void 0},n),this._argumentProcessors=[{processArgument(u){return(0,C.revive)(u)}},{processArgument(u){return(0,T.cloneAndChange)(u,function(o){if(i.Range.isIRange(o))return A.Range.to(o);if(P.Position.isIPosition(o))return A.Position.to(o);if(i.Range.isIRange(o.range)&&d.URI.isUri(o.uri))return A.location.to(o);if(!Array.isArray(o))return o})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...u)=>{const o=t.args.map((c,v)=>{if(!c.validate(u[v]))throw new Error(`Invalid argument '${c.name}' when running '${t.id}', received: ${u[v]}`);return c.convert(u[v])}),s=await this.executeCommand(t.internalId,...o);return t.result.convert(s,u,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,u,o,s){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:u,thisArg:o,description:s}),t&&this._proxy.$registerCommand(n),new I.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,u){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const o=(0,T.cloneAndChange)(n,function(s){if(s instanceof I.Position)return A.Position.from(s);if(s instanceof I.Range)return A.Range.from(s);if(s instanceof I.Location)return A.location.from(s);if(I.NotebookRange.isNotebookRange(s))return A.NotebookRange.from(s);if(!Array.isArray(s))return s});try{const s=await this._proxy.$executeCommand(t,o,u);return(0,C.revive)(s)}catch(s){if(s instanceof Error&&s.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw s}}}async _executeContributedCommand(t,n){const u=this._commands.get(t);if(!u)throw new Error("Unknown command");let{callback:o,thisArg:s,description:c}=u;if(c)for(let v=0;v<c.args.length;v++)try{(0,w.validateConstraint)(n[v],c.args[v].constraint)}catch(k){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${c.args[v].name}' - ${c.args[v].description}`)}try{return await o.apply(s,n)}catch(v){if(t===this.converter.delegatingCommandId){const k=this.converter.getActualCommand(...n);k&&(t=k.command)}throw this._logService.error(v,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(u=>this._argumentProcessors.reduce((o,s)=>s.processArgument(o),u)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(u=>u[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,u]of this._commands){let{description:o}=u;o&&(t[n]=o)}return Promise.resolve(t)}};p=Ve([qe(0,a.IExtHostRpcService),qe(1,S.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class m{constructor(t,n,u){this._commands=t,this._lookupApiCommand=n,this._logService=u,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const u={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return u;const o=this._lookupApiCommand(t.command);if(o)u.id=o.internalId,u.arguments=o.args.map((s,c)=>s.convert(t.arguments&&t.arguments[c]));else if((0,D.isNonEmptyArray)(t.arguments)){const s=++this._cachIdPool;this._cache.set(s,t),n.add((0,h.toDisposable)(()=>{this._cache.delete(s),this._logService.trace("CommandsConverter#DISPOSE",s)})),u.$ident=s,u.id=this.delegatingCommandId,u.arguments=[s],this._logService.trace("CommandsConverter#CREATE",t.command,s)}return u}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class E{constructor(t,n,u,o){this.name=t,this.description=n,this.validate=u,this.convert=o}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new E(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",b=>d.URI.isUri(b),b=>b),E.Position=new E("position","A position in a text document",b=>I.Position.isPosition(b),A.Position.from),E.Range=new E("range","A range in a text document",b=>I.Range.isRange(b),A.Range.from),E.Selection=new E("selection","A selection in a text document",b=>I.Selection.isSelection(b),A.Selection.from),E.Number=new E("number","",b=>typeof b=="number",b=>b),E.String=new E("string","",b=>typeof b=="string",b=>b),E.CallHierarchyItem=new E("item","A call hierarchy item",b=>b instanceof I.CallHierarchyItem,A.CallHierarchyItem.to);class f{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=f,f.Void=new f("no result",b=>b);class l{constructor(t,n,u,o,s){this.id=t,this.internalId=n,this.description=u,this.args=o,this.result=s}}e.ApiCommand=l}),define(we[190],_e([0,1,6,9,7,62,76,168,15,87]),function(Y,e,w,I,A,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",d(I.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,a)=>{if(!(0,S.isFalsyOrEmpty)(r)){class p extends A.SymbolInformation{static to(E){const f=new p(E.name,I.SymbolKind.to(E.kind),E.containerName||"",new A.Location(a[0],I.Range.to(E.range)));return f.detail=E.detail,f.range=f.location.range,f.selectionRange=I.Range.to(E.selectionRange),f.children=E.children?E.children.map(p.to):[],f}}return r.map(p.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(I.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",d(I.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",d(I.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(a=>A.Position.isPosition(a)),r=>r.map(I.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(a=>{let p;for(const m of a.reverse())p=new A.SelectionRange(I.Range.to(m),p);return p}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const a=[];if(Array.isArray(r))for(let p of r)a.push(...p[1].map(I.WorkspaceSymbol.to));return a})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(I.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(I.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(I.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return I.WorkspaceEdit.to(r)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(I.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new A.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const a=(0,C.decodeSemanticTokensDto)(r);if(a.type==="full")return new A.SemanticTokens(a.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new A.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const a=(0,C.decodeSemanticTokensDto)(r);if(a.type==="full")return new A.SemanticTokens(a.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,a,p)=>{if(!r)return new A.CompletionList([]);const m=r.suggestions.map(E=>I.CompletionItem.to(E,p));return new A.CompletionList(m,r.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return I.SignatureHelp.to(r)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,a,p)=>d(m=>new A.CodeLens(I.Range.to(m.range),m.command&&p.fromInternal(m.command)))(r))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>A.Range.isRange(r),r=>A.Selection.isSelection(r)?I.Selection.from(r):I.Range.from(r)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,a,p)=>d(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(m.command)}else{const E=new A.CodeAction(m.title,m.kind?new A.CodeActionKind(m.kind):void 0);return m.edit&&(E.edit=I.WorkspaceEdit.to(m.edit)),m.command&&(E.command=p.fromInternal(m.command)),E.isPreferred=m.isPreferred,E}})(r))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(a=>new A.ColorInformation(I.Range.to(a.range),I.Color.to(a.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",r=>r instanceof A.Color,I.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:I.Range.from(r.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(I.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",r=>r.map(I.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",d(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(a=>I.NotebookExclusiveDocumentPattern.to(a))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(I.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[I.ViewColumn.from(r.viewColumn),I.TextEditorOpenOptions.from(r)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[I.ViewColumn.from(r.viewColumn),I.TextEditorOpenOptions.from(r)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[I.ViewColumn.from(r.viewColumn),I.TextEditorOpenOptions.from(r)]).optional()],y.ApiCommandResult.Void)];class P{constructor(a){this._disposables=new w.DisposableStore,this._commands=a}static register(a){return i.forEach(a.registerApiCommand,a),new P(a).registerCommands()}registerCommands(){const a=p=>(...m)=>p(this._commands,...m);this._register(D.RemoveFromRecentlyOpenedAPICommand.ID,a(D.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:p=>typeof p=="string"}]}),this._register(D.OpenIssueReporter.ID,a(D.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:p=>typeof p=="string"||typeof p=="object"&&typeof p.extensionId=="string"}]})}_register(a,p,m){const E=this._commands.registerCommand(!1,a,p,this,m);this._disposables.add(E)}}e.ExtHostApiCommands=P;function d(r){return a=>{if(Array.isArray(a))return a.map(r)}}function h(r){if(!!Array.isArray(r)){const a=[];for(const p of r)T.isLocationLink(p)?a.push(I.DefinitionLink.to(p)):a.push(I.location.to(p));return a}}}),define(we[191],_e([0,1,11,52,3,6,2,62,26,9,7,5]),function(Y,e,w,I,A,T,y,D,S,C,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class d{constructor(l,b,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=l.getProxy(P.MainContext.MainThreadComments),b.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const u=this._commentControllers.get(n.handle);return u||n}else if(n&&n.$mid===7){const u=this._commentControllers.get(n.commentControlHandle);if(!u)return n;const o=u.getCommentThread(n.commentThreadHandle);return o||n}else if(n&&n.$mid===8){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const o=u.getCommentThread(n.thread.commentThreadHandle);return o?{thread:o,text:n.text}:n}else if(n&&n.$mid===9){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const o=u.getCommentThread(n.thread.commentThreadHandle);if(!o)return n;let s=n.commentUniqueId,c=o.getCommentByUniqueId(s);return c||n}else if(n&&n.$mid===10){const u=this._commentControllers.get(n.thread.commentControlHandle);if(!u)return n;const o=u.getCommentThread(n.thread.commentThreadHandle);if(!o)return n;let s=n.text,c=n.commentUniqueId,v=o.getCommentByUniqueId(c);return v?(v.body=s,v):n}return n}})}createCommentController(l,b,t){const n=d.handlePool++,u=new r(l,n,this._proxy,b,t);this._commentControllers.set(u.handle,u);const o=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(l.identifier))||[];return o.push(u),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(l.identifier),o),u}$createCommentThreadTemplate(l,b,t){const n=this._commentControllers.get(l);!n||n.$createCommentThreadTemplate(b,t)}async $updateCommentThreadTemplate(l,b,t){const n=this._commentControllers.get(l);!n||n.$updateCommentThreadTemplate(b,t)}$deleteCommentThread(l,b){const t=this._commentControllers.get(l);t&&t.$deleteCommentThread(b)}$provideCommentingRanges(l,b,t){const n=this._commentControllers.get(l);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const u=this._documents.getDocument(y.URI.revive(b));return(0,w.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(u,t)).then(o=>o?o.map(s=>C.Range.from(s)):void 0)}$toggleReaction(l,b,t,n,u){const o=this._commentControllers.get(l);return!o||!o.reactionHandler?Promise.resolve(void 0):(0,w.asPromise)(()=>{const s=o.getCommentThread(b);if(s){const c=s.getCommentByUniqueId(n.uniqueIdInThread);if(o!==void 0&&c&&o.reactionHandler)return o.reactionHandler(c,m(u))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=d,d.handlePool=0;class h{constructor(l,b,t,n,u,o,s){this._proxy=l,this._commentController=b,this._id=t,this._uri=n,this._range=u,this._comments=o,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new A.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${b.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,C.Range.from(this._range),s),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=o}set threadId(l){this._id=l}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(l){l.isEqual(this._range)||(this._range=l,this.modifications.range=l,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(l){this._canReply!==l&&(this._canReply=l,this.modifications.canReply=l,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(l){this._label=l,this.modifications.label=l,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(l){this._contextValue=l,this.modifications.contextValue=l,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(l){this._comments=l,this.modifications.comments=l,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(l){this._collapseState=l,this.modifications.collapsibleState=l,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const l=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),b={};l("range")&&(b.range=C.Range.from(this._range)),l("label")&&(b.label=this.label),l("contextValue")&&(b.contextValue=this.contextValue),l("comments")&&(b.comments=this._comments.map(t=>a(this,this._commentController,t,this._commentsMap))),l("collapsibleState")&&(b.collapseState=E(this._collapseState)),l("canReply")&&(b.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,b)}}getCommentByUniqueId(l){for(let b of this._commentsMap){let t=b[0],n=b[1];if(l===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(l=>l.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}h._handlePool=0,Ve([(0,I.debounce)(100)],h.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=h;class r{constructor(l,b,t,n,u){this._extension=l,this._handle=b,this._proxy=t,this._id=n,this._label=u,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,u)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(l){this._reactionHandler=l,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this._options}set options(l){this._options=l,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(l,b,t,n){if(typeof l=="string"){const u=new h(this._proxy,this,l,b,t,n,this._extension.identifier);return this._threads.set(u.handle,u),u}else{const u=new h(this._proxy,this,void 0,l,b,t,this._extension.identifier);return this._threads.set(u.handle,u),u}}$createCommentThreadTemplate(l,b){const t=new h(this._proxy,this,void 0,y.URI.revive(l),C.Range.to(b),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(l,b){let t=this._threads.get(l);t&&(t.range=C.Range.to(b))}$deleteCommentThread(l){let b=this._threads.get(l);b&&b.dispose(),this._threads.delete(l)}getCommentThread(l){return this._threads.get(l)}dispose(){this._threads.forEach(l=>{l.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function a(f,l,b,t){let n=t.get(b);n||(n=++f.commentHandle,t.set(b,n));const u=b.author&&b.author.iconPath?b.author.iconPath.toString():void 0;return{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:n,body:C.MarkdownString.from(b.body),userName:b.author.name,userIconPath:u,label:b.label,commentReactions:b.reactions?b.reactions.map(o=>p(o)):void 0}}function p(f){return{label:f.label,iconPath:f.iconPath?C.pathOrURIToURI(f.iconPath):void 0,count:f.count,hasReacted:f.authorHasReacted}}function m(f){return{label:f.label||"",count:f.count||0,iconPath:f.iconPath?y.URI.revive(f.iconPath):"",authorHasReacted:f.hasReacted||!1}}function E(f){if(f!==void 0)switch(f){case i.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(we[99],_e([0,1,2,5,7,4,14,18,15,8,13]),function(Y,e,w,I,A,T,y,D,S,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class wn{constructor(h,r){this._logService=r,this._provider=new Map,this._proxy=h.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,r){const a=wn._handlePool++;this._provider.set(a,{provider:h,extensionId:r}),this._proxy.$registerDecorationProvider(a,r.value);const p=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(a,null);return}let E=(0,S.asArray)(m);if(E.length<=wn._maxEventSize){this._proxy.$onDidChange(a,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,E.length);const f=E.map(t=>({uri:t,rank:(0,C.count)(t.path,"/")})),l=(0,S.groupBy)(f,(t,n)=>t.rank-n.rank||(0,C.compare)(t.uri.path,n.uri.path));let b=[];e:for(let t of l){let n;for(let u of t){let o=(0,i.dirname)(u.uri.path);if(n!==o&&(n=o,b.push(u.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(a,b)});return new A.Disposable(()=>{p==null||p.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(h,r,a){if(!this._provider.has(h))return Object.create(null);const p=Object.create(null),{provider:m,extensionId:E}=this._provider.get(h);return await Promise.all(r.map(async f=>{try{const{uri:l,id:b}=f,t=await Promise.resolve(m.provideFileDecoration(w.URI.revive(l),a));if(!t)return;try{A.FileDecoration.validate(t),p[b]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${E.value}': ${n}`)}}catch(l){this._logService.error(l)}})),p}};P._handlePool=0,P._maxEventSize=250,P=Ve([qe(0,y.IExtHostRpcService),qe(1,D.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(we[192],_e([0,1,131,90,2,5,7,9,3,18,22]),function(Y,e,w,I,A,T,y,D,S,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(r,a,p,m,E){this._name=r,this._owner=a,this._maxDiagnosticsPerFile=p,this._proxy=m,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,a){if(!r){this.clear();return}this._checkDisposed();let p=[];if(A.URI.isUri(r)){if(!a){this.delete(r);return}this._data.set(r,a.slice()),p=[r]}else if(Array.isArray(r)){p=[];let E;r=[...r].sort(P._compareIndexedTuplesByUri);for(const f of r){const[l,b]=f;if((!E||l.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=l,p.push(l),this._data.set(l,[])),b){const t=this._data.get(l);t&&t.push(...b)}else{const t=this._data.get(l);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(p),!!this._proxy){const m=[];for(let E of p){let f=[];const l=this._data.get(E);if(l)if(l.length>this._maxDiagnosticsPerFile){f=[];const b=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of l)if(n.severity===b[t]&&f.push(D.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;f.push({severity:I.MarkerSeverity.Info,message:(0,w.localize)(0,null,l.length-this._maxDiagnosticsPerFile),startLineNumber:f[f.length-1].startLineNumber,startColumn:f[f.length-1].startColumn,endLineNumber:f[f.length-1].endLineNumber,endColumn:f[f.length-1].endColumn})}else f=l.map(b=>D.Diagnostic.from(b));m.push([E,f])}this._proxy.$changeMany(this._owner,m)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,a){this._checkDisposed();for(let p of this._data.keys())r.apply(a,[p,this.get(p),this])}get(r){this._checkDisposed();const a=this._data.get(r);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,a){return r[0].toString()<a[0].toString()?-1:r[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=P;let d=class Vt{constructor(r,a){this._logService=a,this._collections=new Map,this._onDidChangeDiagnostics=new S.Emitter,this.onDidChangeDiagnostics=S.Event.map(S.Event.debounce(this._onDidChangeDiagnostics.event,Vt._debouncer,50),Vt._mapper),this._proxy=r.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(r,a){return r?r.concat(a):a}static _mapper(r){const a=[],p=new Set;for(const m of r)typeof m=="string"?p.has(m)||(p.add(m),a.push(A.URI.parse(m))):p.has(m.toString())||(p.add(m.toString()),a.push(m));return Object.freeze(a),{uris:a}}createDiagnosticCollection(r,a){const{_collections:p,_proxy:m,_onDidChangeDiagnostics:E,_logService:f}=this,l=new class{$changeMany(n,u){m.$changeMany(n,u),f.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,n,u.length===0?"CLEARING":u)}$clear(n){m.$clear(n),f.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,n)}dispose(){m.dispose()}};let b;if(!a)a="_generated_diagnostic_collection_name_#"+Vt._idPool++,b=a;else if(!p.has(a))b=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do b=a+Vt._idPool++;while(p.has(b))}return new class extends P{constructor(){super(a,b,Vt._maxDiagnosticsPerFile,l,E);p.set(b,this)}dispose(){super.dispose(),p.delete(b)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const a=new Map,p=[];for(const m of this._collections.values())m.forEach((E,f)=>{let l=a.get(E.toString());typeof l=="undefined"&&(l=p.length,a.set(E.toString(),l),p.push([E,[]])),p[l][1]=p[l][1].concat(...f)});return p}}_getDiagnostics(r){let a=[];for(let p of this._collections.values())p.has(r)&&(a=a.concat(p.get(r)));return a}$acceptMarkersChange(r){if(!this._mirrorCollection){const a="_generated_mirror",p=new P(a,a,Vt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(a,p),this._mirrorCollection=p}for(const[a,p]of r)this._mirrorCollection.set(A.URI.revive(a),p.map(D.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=Ve([qe(1,C.ILogService)],d),e.ExtHostDiagnostics=d}),define(we[193],_e([0,1,2,5]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(y){this._proxy=y.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(D=>D?D.map(S=>w.URI.revive(S)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(D=>D?w.URI.revive(D):void 0)}}e.ExtHostDialogs=A}),define(we[194],_e([0,1,12,2,7,5,19,20,8]),function(Y,e,w,I,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(P,d,h){this._documentsAndEditors=d,this._logService=h,this._documentContentProviders=new Map,this._proxy=P.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,d){if(Object.keys(y.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const h=C._handlePool++;this._documentContentProviders.set(h,d),this._proxy.$registerTextContentProvider(h,P);let r;return typeof d.onDidChange=="function"&&(r=d.onDidChange(a=>{if(a.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(h,a).then(p=>{if(!(!p&&typeof p!="string")){const m=this._documentsAndEditors.getDocument(a);if(!!m){const E=(0,S.splitLines)(p);if(!m.equalLines(E))return this._proxy.$onVirtualDocumentChange(a,p)}}},w.onUnexpectedError)})),new A.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(P,d){const h=this._documentContentProviders.get(P);return h?Promise.resolve(h.provideTextDocumentContent(I.URI.revive(d),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(we[195],_e([0,1,3,6,2,5,95,9,10,23]),function(Y,e,w,I,A,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(d,h){this._onDidAddDocument=new w.Emitter,this._onDidRemoveDocument=new w.Emitter,this._onDidChangeDocument=new w.Emitter,this._onDidSaveDocument=new w.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const a of r)this._onDidRemoveDocument.fire(a.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const a of r)this._onDidAddDocument.fire(a.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!!d){const h=this._documentsAndEditors.getDocument(d);if(h)return h}}getDocument(d){const h=this.getDocumentData(d);if(!(h==null?void 0:h.document))throw new Error(`Unable to retrieve document from URI '${d}'`);return h.document}ensureDocumentData(d){const h=this._documentsAndEditors.getDocument(d);if(h)return Promise.resolve(h);let r=this._documentLoader.get(d.toString());return r||(r=this._proxy.$tryOpenDocument(d).then(a=>{this._documentLoader.delete(d.toString());const p=A.URI.revive(a);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(p))},a=>(this._documentLoader.delete(d.toString()),Promise.reject(a))),this._documentLoader.set(d.toString(),r)),r}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(h=>A.URI.revive(h))}$acceptModelModeChanged(d,h){const r=A.URI.revive(d),a=this._documentsAndEditors.getDocument(r);if(!a)throw new Error("unknown document");this._onDidRemoveDocument.fire(a.document),a._acceptLanguageId(h),this._onDidAddDocument.fire(a.document)}$acceptModelSaved(d){const h=A.URI.revive(d),r=this._documentsAndEditors.getDocument(h);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(d,h){const r=A.URI.revive(d),a=this._documentsAndEditors.getDocument(r);if(!a)throw new Error("unknown document");a._acceptIsDirty(h),this._onDidChangeDocument.fire({document:a.document,contentChanges:[]})}$acceptModelChanged(d,h,r){const a=A.URI.revive(d),p=this._documentsAndEditors.getDocument(a);if(!p)throw new Error("unknown document");p._acceptIsDirty(r),p.onEvents(h),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:p.document,contentChanges:h.changes.map(m=>({range:D.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text}))}))}setWordDefinitionFor(d,h){(0,y.setWordDefinitionFor)(d,h)}}e.ExtHostDocuments=i}),define(we[39],_e([0,1,42,3,6,2,4,5,95,14,97,9,18,22,19,43,108]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(l,b){this._extHostRpc=l,this._logService=b,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const b=[],t=[],n=[];if(l.removedDocuments)for(const u of l.removedDocuments){const o=T.URI.revive(u),s=this._documents.get(o);(s==null?void 0:s.unref())&&(this._documents.delete(o),b.push(s.value))}if(l.addedDocuments)for(const u of l.addedDocuments){const o=T.URI.revive(u.uri);let s=this._documents.get(o);if(s&&o.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${o} already exists!'`);s||(s=new m(new S.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),o,u.lines,u.EOL,u.versionId,u.modeId,u.isDirty,u.notebook)),this._documents.set(o,s),t.push(s.value)),s.ref()}if(l.removedEditors)for(const u of l.removedEditors){const o=this._editors.get(u);this._editors.delete(u),o&&n.push(o)}if(l.addedEditors)for(const u of l.addedEditors){const o=T.URI.revive(u.documentUri);w.ok(this._documents.has(o),`document '${o}' does not exist`),w.ok(!this._editors.has(u.id),`editor '${u.id}' already exists!`);const s=this._documents.get(o).value,c=new i.ExtHostTextEditor(u.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>s.document),u.selections.map(P.Selection.to),u.options,u.visibleRanges.map(v=>P.Range.to(v)),typeof u.editorPosition=="number"?P.ViewColumn.to(u.editorPosition):void 0);this._editors.set(u.id,c)}l.newActiveEditor!==void 0&&(w.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,A.dispose)(b),(0,A.dispose)(n),l.removedDocuments&&this._onDidRemoveDocuments.fire(b),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(u=>u.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){var b;return(b=this._documents.get(l))===null||b===void 0?void 0:b.value}allDocuments(){return a.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!!this._activeEditorId){const b=this._editors.get(this._activeEditorId);return l?b:b==null?void 0:b.value}}allEditors(){return[...this._editors.values()]}};E=Ve([qe(0,C.IExtHostRpcService),qe(1,d.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[196],_e([0,1,2,5,6,7,9,118,8,24]),function(Y,e,w,I,A,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const r=this._schemes.indexOf(h);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),r=[];let a,p,m=14,E=14;for(const f of h){let l=a?(0,S.commonPrefixLength)(a,f):0;for(l===0?p=1:p=E;l<f.length;l++)l+1===f.length?(m=E,E=9):E+=1,r.push([p,f.toUpperCase().charCodeAt(l),E]),r.push([p,f.toLowerCase().charCodeAt(l),E]),p=E;a=f,E=m}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new D.StateMachine(r)}}provideDocumentLinks(h){this._initStateMachine();const r=[],a=D.LinkComputer.computeLinks({getLineContent(p){return h.lineAt(p-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const p of a){const m=y.DocumentLink.to(p);m.target&&r.push(m)}return r}}class P{constructor(h,r){this._extHostLanguageFeatures=r,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var h;(h=this._linkProviderRegistration)===null||h===void 0||h.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,r,a,p={}){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const m=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(m,a);let E=2;p.isCaseSensitive&&(E+=1024),p.isReadonly&&(E+=2048),typeof a.copy=="function"&&(E+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(m,r,E).catch(l=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${r}`),console.error(l)});const f=a.onDidChangeFile(l=>{const b=[];for(const t of l){let{uri:n,type:u}=t;if(n.scheme===r){let o;switch(u){case T.FileChangeType.Changed:o=0;break;case T.FileChangeType.Created:o=1;break;case T.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}b.push({resource:n,type:o})}}this._proxy.$onFileSystemChange(m,b)});return(0,A.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(m),this._proxy.$unregisterProvider(m)})}static _asIStat(h){const{type:r,ctime:a,mtime:p,size:m}=h;return{type:r,ctime:a,mtime:p,size:m}}$stat(h,r){return Promise.resolve(this._getFsProvider(h).stat(w.URI.revive(r))).then(P._asIStat)}$readdir(h,r){return Promise.resolve(this._getFsProvider(h).readDirectory(w.URI.revive(r)))}$readFile(h,r){return Promise.resolve(this._getFsProvider(h).readFile(w.URI.revive(r))).then(a=>C.VSBuffer.wrap(a))}$writeFile(h,r,a,p){return Promise.resolve(this._getFsProvider(h).writeFile(w.URI.revive(r),a.buffer,p))}$delete(h,r,a){return Promise.resolve(this._getFsProvider(h).delete(w.URI.revive(r),a))}$rename(h,r,a,p){return Promise.resolve(this._getFsProvider(h).rename(w.URI.revive(r),w.URI.revive(a),p))}$copy(h,r,a,p){const m=this._getFsProvider(h);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(w.URI.revive(r),w.URI.revive(a),p))}$mkdir(h,r){return Promise.resolve(this._getFsProvider(h).createDirectory(w.URI.revive(r)))}$watch(h,r,a,p){const m=this._getFsProvider(h).watch(w.URI.revive(a),p);this._watches.set(r,m)}$unwatch(h,r){const a=this._watches.get(r);a&&(a.dispose(),this._watches.delete(r))}$open(h,r,a){const p=this._getFsProvider(h);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(w.URI.revive(r),a))}$close(h,r){const a=this._getFsProvider(h);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(r))}$read(h,r,a,p){const m=this._getFsProvider(h);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const E=C.VSBuffer.alloc(p);return Promise.resolve(m.read(r,a,E.buffer,0,p)).then(f=>E.slice(0,f))}$write(h,r,a,p){const m=this._getFsProvider(h);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(r,a,p.buffer,0,p.byteLength))}_getFsProvider(h){const r=this._fsProvider.get(h);if(!r){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return r}}e.ExtHostFileSystem=P}),define(we[77],_e([0,1,5,64,7,24,4,14,49]),function(Y,e,w,I,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Ot{constructor(P,d){const h=P.getProxy(w.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return h.$stat(r).catch(Ot._handleError)},readDirectory(r){return h.$readdir(r).catch(Ot._handleError)},createDirectory(r){return h.$mkdir(r).catch(Ot._handleError)},async readFile(r){return h.$readFile(r).then(a=>a.buffer).catch(Ot._handleError)},writeFile(r,a){return h.$writeFile(r,T.VSBuffer.wrap(a)).catch(Ot._handleError)},delete(r,a){return h.$delete(r,Object.assign({recursive:!1,useTrash:!1},a)).catch(Ot._handleError)},rename(r,a,p){return h.$rename(r,a,Object.assign({overwrite:!1},p)).catch(Ot._handleError)},copy(r,a,p){return h.$copy(r,a,Object.assign({overwrite:!1},p)).catch(Ot._handleError)},isWritableFileSystem(r){const a=d.getCapabilities(r);if(typeof a=="number")return!(a&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new A.FileSystemError(String(P));if(P.name==="ENOPRO")throw A.FileSystemError.Unavailable(P.message);switch(P.name){case I.FileSystemProviderErrorCode.FileExists:throw A.FileSystemError.FileExists(P.message);case I.FileSystemProviderErrorCode.FileNotFound:throw A.FileSystemError.FileNotFound(P.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw A.FileSystemError.FileNotADirectory(P.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw A.FileSystemError.FileIsADirectory(P.message);case I.FileSystemProviderErrorCode.NoPermissions:throw A.FileSystemError.NoPermissions(P.message);case I.FileSystemProviderErrorCode.Unavailable:throw A.FileSystemError.Unavailable(P.message);default:throw new A.FileSystemError(P.message,P.name)}}};C=Ve([qe(0,D.IExtHostRpcService),qe(1,S.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(we[197],_e([0,1,6,5]),function(Y,e,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class A{constructor(y){this._handlePool=0,this._proxy=y.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,y),(0,w.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=A}),define(we[198],_e([0,1,2,23,9,7,11,5,8,32,15,10,115,6,87,54,68,55,12]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r,a,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor(x,q){this._documents=x,this._provider=q}provideDocumentSymbols(x,q){const ne=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ne,q)).then(le=>{if(!(0,i.isFalsyOrEmpty)(le))return le[0]instanceof T.DocumentSymbol?le.map(A.DocumentSymbol.from):f._asDocumentSymbolTree(le)})}static _asDocumentSymbolTree(x){var q;x=x.slice(0).sort((fe,Se)=>{let Oe=fe.location.range.start.compareTo(Se.location.range.start);return Oe===0&&(Oe=Se.location.range.end.compareTo(fe.location.range.end)),Oe});const ne=[],le=[];for(const fe of x){const Se={name:fe.name||"!!MISSING: name!!",kind:A.SymbolKind.from(fe.kind),tags:((q=fe.tags)===null||q===void 0?void 0:q.map(A.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:A.Range.from(fe.location.range),selectionRange:A.Range.from(fe.location.range),children:[]};for(;;){if(le.length===0){le.push(Se),ne.push(Se);break}const Oe=le[le.length-1];if(C.Range.containsRange(Oe.range,Se.range)&&!C.Range.equalsRange(Oe.range,Se.range)){Oe.children&&Oe.children.push(Se),le.push(Se);break}le.pop()}}return ne}}class l{constructor(x,q,ne){this._documents=x,this._commands=q,this._provider=ne,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,q){const ne=this._documents.getDocument(x),le=await this._provider.provideCodeLenses(ne,q);if(!(!le||q.isCancellationRequested)){const fe=this._cache.add(le),Se=new h.DisposableStore;this._disposables.set(fe,Se);const Oe={cacheId:fe,lenses:[]};for(let me=0;me<le.length;me++)Oe.lenses.push({cacheId:[fe,me],range:A.Range.from(le[me].range),command:this._commands.toInternal(le[me].command,Se)});return Oe}}async resolveCodeLens(x,q){var ne;const le=x.cacheId&&this._cache.get(...x.cacheId);if(!!le){let fe;if(typeof this._provider.resolveCodeLens!="function"||le.isResolved?fe=le:fe=await this._provider.resolveCodeLens(le,q),fe||(fe=le),!q.isCancellationRequested){const Se=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!Se)return x.command=this._commands.toInternal((ne=fe.command)!==null&&ne!==void 0?ne:l._badCmd,Se),x}}}releaseCodeLenses(x){var q;(q=this._disposables.get(x))===null||q===void 0||q.dispose(),this._disposables.delete(x),this._cache.delete(x)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function b(We){return Array.isArray(We)?We.map(A.DefinitionLink.from):We?[A.DefinitionLink.from(We)]:[]}class t{constructor(x,q){this._documents=x,this._provider=q}provideDefinition(x,q,ne){const le=this._documents.getDocument(x),fe=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDefinition(le,fe,ne)).then(b)}}class n{constructor(x,q){this._documents=x,this._provider=q}provideDeclaration(x,q,ne){const le=this._documents.getDocument(x),fe=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDeclaration(le,fe,ne)).then(b)}}class u{constructor(x,q){this._documents=x,this._provider=q}provideImplementation(x,q,ne){const le=this._documents.getDocument(x),fe=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideImplementation(le,fe,ne)).then(b)}}class o{constructor(x,q){this._documents=x,this._provider=q}provideTypeDefinition(x,q,ne){const le=this._documents.getDocument(x),fe=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(le,fe,ne)).then(b)}}class s{constructor(x,q){this._documents=x,this._provider=q}provideHover(x,q,ne){const le=this._documents.getDocument(x),fe=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideHover(le,fe,ne)).then(Se=>{if(!(!Se||(0,i.isFalsyOrEmpty)(Se.contents)))return Se.range||(Se.range=le.getWordRangeAtPosition(fe)),Se.range||(Se.range=new T.Range(fe,fe)),A.Hover.from(Se)})}}class c{constructor(x,q){this._documents=x,this._provider=q}provideEvaluatableExpression(x,q,ne){const le=this._documents.getDocument(x),fe=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(le,fe,ne)).then(Se=>{if(Se)return A.EvaluatableExpression.from(Se)})}}class v{constructor(x,q){this._documents=x,this._provider=q}provideInlineValues(x,q,ne,le){const fe=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideInlineValues(fe,A.Range.to(q),A.InlineValueContext.to(ne),le)).then(Se=>{if(Array.isArray(Se))return Se.map(Oe=>A.InlineValue.from(Oe))})}}class k{constructor(x,q){this._documents=x,this._provider=q}provideDocumentHighlights(x,q,ne){const le=this._documents.getDocument(x),fe=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(le,fe,ne)).then(Se=>{if(Array.isArray(Se))return Se.map(A.DocumentHighlight.from)})}}class g{constructor(x,q){this._documents=x,this._provider=q}provideLinkedEditingRanges(x,q,ne){const le=this._documents.getDocument(x),fe=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(le,fe,ne)).then(Se=>{if(Se&&Array.isArray(Se.ranges))return{ranges:(0,i.coalesce)(Se.ranges.map(A.Range.from)),wordPattern:Se.wordPattern}})}}class _{constructor(x,q){this._documents=x,this._provider=q}provideReferences(x,q,ne,le){const fe=this._documents.getDocument(x),Se=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideReferences(fe,Se,ne,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(A.location.from)})}}class R{constructor(x,q,ne,le,fe,Se,Oe){this._documents=x,this._commands=q,this._diagnostics=ne,this._provider=le,this._logService=fe,this._extension=Se,this._apiDeprecation=Oe,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(x,q,ne,le){const fe=this._documents.getDocument(x),Se=d.Selection.isISelection(q)?A.Selection.to(q):A.Range.to(q),Oe=[];for(const Ce of this._diagnostics.getDiagnostics(x))if(Se.intersection(Ce.range)&&Oe.push(Ce)>R._maxCodeActionsPerFile)break;const me={diagnostics:Oe,only:ne.only?new T.CodeActionKind(ne.only):void 0,triggerKind:A.CodeActionTriggerKind.to(ne.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(fe,Se,me,le)).then(Ce=>{var Pe;if(!(!(0,i.isNonEmptyArray)(Ce)||le.isCancellationRequested)){const $e=this._cache.add(Ce),Ee=new h.DisposableStore;this._disposables.set($e,Ee);const je=[];for(let z=0;z<Ce.length;z++){const ee=Ce[z];!ee||(R._isCommand(ee)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:ee.title,command:this._commands.toInternal(ee,Ee)})):(me.only&&(ee.kind?me.only.contains(ee.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${me.only.value} 'requested but returned code action is of kind '${ee.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[$e,z],title:ee.title,command:ee.command&&this._commands.toInternal(ee.command,Ee),diagnostics:ee.diagnostics&&ee.diagnostics.map(A.Diagnostic.from),edit:ee.edit&&A.WorkspaceEdit.from(ee.edit),kind:ee.kind&&ee.kind.value,isPreferred:ee.isPreferred,disabled:(Pe=ee.disabled)===null||Pe===void 0?void 0:Pe.reason})))}return{cacheId:$e,actions:je}}})}async resolveCodeAction(x,q){var ne;const[le,fe]=x,Se=this._cache.get(le,fe);if(!(!Se||R._isCommand(Se))&&!!this._provider.resolveCodeAction){const Oe=(ne=await this._provider.resolveCodeAction(Se,q))!==null&&ne!==void 0?ne:Se;return(Oe==null?void 0:Oe.edit)?A.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(x){var q;(q=this._disposables.get(x))===null||q===void 0||q.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}R._maxCodeActionsPerFile=1e3;class B{constructor(x,q){this._documents=x,this._provider=q}provideDocumentFormattingEdits(x,q,ne){const le=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(le,q,ne)).then(fe=>{if(Array.isArray(fe))return fe.map(A.TextEdit.from)})}}class Q{constructor(x,q){this._documents=x,this._provider=q}provideDocumentRangeFormattingEdits(x,q,ne,le){const fe=this._documents.getDocument(x),Se=A.Range.to(q);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,Se,ne,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(A.TextEdit.from)})}}class ge{constructor(x,q){this._documents=x,this._provider=q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(x,q,ne,le,fe){const Se=this._documents.getDocument(x),Oe=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Se,Oe,ne,le,fe)).then(me=>{if(Array.isArray(me))return me.map(A.TextEdit.from)})}}class V{constructor(x,q){this._provider=x,this._logService=q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(x,q){const ne=D.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(x,q)).then(le=>{if((0,i.isNonEmptyArray)(le)){for(const fe of le)if(!!fe){if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const Se=D.IdObject.mixin(A.WorkspaceSymbol.from(fe));this._symbolCache.set(Se._id,fe),ne.symbols.push(Se)}}}).then(()=>(ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne))}async resolveWorkspaceSymbol(x,q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const ne=this._symbolCache.get(x._id);if(ne){const le=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ne,q));return le&&(0,I.mixin)(x,A.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(x){const q=this._resultCache.get(x);if(q){for(let[ne,le]=q;ne<=le;ne++)this._symbolCache.delete(ne);this._resultCache.delete(x)}}}class H{constructor(x,q,ne){this._documents=x,this._provider=q,this._logService=ne}static supportsResolving(x){return typeof x.prepareRename=="function"}provideRenameEdits(x,q,ne,le){const fe=this._documents.getDocument(x),Se=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(fe,Se,ne,le)).then(Oe=>{if(!!Oe)return A.WorkspaceEdit.from(Oe)},Oe=>{const me=H._asMessage(Oe);return me?{rejectReason:me,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(x,q,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(x),fe=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.prepareRename(le,fe,ne)).then(Se=>{let Oe,me;if(T.Range.isRange(Se)?(Oe=Se,me=le.getText(Se)):(0,P.isObject)(Se)&&(Oe=Se.range,me=Se.placeholder),!!Oe){if(Oe.start.line>fe.line||Oe.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(Oe),text:me}}},Se=>{const Oe=H._asMessage(Se);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(Se)})}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class te{constructor(x,q){this.resultId=x,this.tokens=q}}class ${constructor(x,q){this._documents=x,this._provider=q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(x,q,ne){const le=this._documents.getDocument(x),fe=q!==0?this._previousResults.get(q):null;return(0,y.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(le,fe.resultId,ne):this._provider.provideDocumentSemanticTokens(le,ne)).then(Se=>(fe&&this._previousResults.delete(q),Se?(Se=$._fixProvidedSemanticTokens(Se),this._send($._convertToEdits(fe,Se),Se)):null))}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return $._isSemanticTokens(x)?$._isCorrectSemanticTokens(x)?x:new T.SemanticTokens(new Uint32Array(x.data),x.resultId):$._isSemanticTokensEdits(x)?$._isCorrectSemanticTokensEdits(x)?x:new T.SemanticTokensEdits(x.edits.map(q=>new T.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const q of x.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,q){if(!$._isSemanticTokens(q)||!x||!x.tokens)return q;const ne=x.tokens,le=ne.length,fe=q.data,Se=fe.length;let Oe=0;const me=Math.min(le,Se);for(;Oe<me&&ne[Oe]===fe[Oe];)Oe++;if(Oe===le&&Oe===Se)return new T.SemanticTokensEdits([],q.resultId);let Ce=0;const Pe=me-Oe;for(;Ce<Pe&&ne[le-Ce-1]===fe[Se-Ce-1];)Ce++;return new T.SemanticTokensEdits([{start:Oe,deleteCount:le-Oe-Ce,data:fe.subarray(Oe,Se-Ce)}],q.resultId)}_send(x,q){if($._isSemanticTokens(x)){const ne=this._nextResultId++;return this._previousResults.set(ne,new te(x.resultId,x.data)),(0,r.encodeSemanticTokensDto)({id:ne,type:"full",data:x.data})}if($._isSemanticTokensEdits(x)){const ne=this._nextResultId++;return $._isSemanticTokens(q)?this._previousResults.set(ne,new te(q.resultId,q.data)):this._previousResults.set(ne,new te(x.resultId)),(0,r.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(x.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=$;class F{constructor(x,q){this._documents=x,this._provider=q}provideDocumentRangeSemanticTokens(x,q,ne){const le=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(le,A.Range.to(q),ne)).then(fe=>fe?this._send(fe):null)}_send(x){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=F;class L{constructor(x,q,ne,le,fe){this._documents=x,this._commands=q,this._provider=ne,this._apiDeprecation=le,this._extension=fe,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,q,ne,le){const fe=this._documents.getDocument(x),Se=A.Position.to(q),Oe=fe.getWordRangeAtPosition(Se)||new T.Range(Se,Se),me=Oe.with({end:Se}),Ce=new m.StopWatch(!0),Pe=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(fe,Se,le,A.CompletionContext.to(ne)));if(!!Pe&&!le.isCancellationRequested){const $e=Array.isArray(Pe)?new T.CompletionList(Pe):Pe,Ee=L.supportsResolving(this._provider)?this._cache.add($e.items):this._cache.add([]),je=new h.DisposableStore;this._disposables.set(Ee,je);const z=[],ee={x:Ee,b:z,a:{replace:A.Range.from(Oe),insert:A.Range.from(me)},c:$e.isIncomplete||void 0,d:Ce.elapsed()};for(let ve=0;ve<$e.items.length;ve++){const Le=$e.items[ve],He=this._convertCompletionItem(Le,[Ee,ve],me,Oe);z.push(He)}return ee}}async resolveCompletionItem(x,q){if(typeof this._provider.resolveCompletionItem=="function"){const ne=this._cache.get(...x);if(!!ne){const le=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ne,q));if(!!le)return this._convertCompletionItem(le,x)}}}releaseCompletionItems(x){var q;(q=this._disposables.get(x))===null||q===void 0||q.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,q,ne,le){var fe;const Se=this._disposables.get(q[0]);if(!Se)throw Error("DisposableStore is missing...");const Oe={x:q,a:(fe=x.label)!==null&&fe!==void 0?fe:"",o:x.label2,b:x.kind!==void 0?A.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(A.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:A.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(A.TextEdit.from),m:this._commands.toInternal(x.command,Se)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=x.textEdit.newText):typeof x.insertText=="string"?Oe.h=x.insertText:x.insertText instanceof T.SnippetString&&(Oe.h=x.insertText.value,Oe.i|=4);let me;return x.textEdit?me=x.textEdit.range:x.range&&(me=x.range),T.Range.isRange(me)?Oe.j=A.Range.from(me):me&&(!(ne==null?void 0:ne.isEqual(me.inserting))||!(le==null?void 0:le.isEqual(me.replacing)))&&(Oe.j={insert:A.Range.from(me.inserting),replace:A.Range.from(me.replacing)}),Oe}}class M{constructor(x,q){this._documents=x,this._provider=q,this._cache=new p.Cache("SignatureHelp")}provideSignatureHelp(x,q,ne,le){const fe=this._documents.getDocument(x),Se=A.Position.to(q),Oe=this.reviveContext(ne);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(fe,Se,le,Oe)).then(me=>{if(me){const Ce=this._cache.add([me]);return Object.assign(Object.assign({},A.SignatureHelp.from(me)),{id:Ce})}})}reviveContext(x){let q;if(x.activeSignatureHelp){const ne=A.SignatureHelp.to(x.activeSignatureHelp),le=this._cache.get(x.activeSignatureHelp.id,0);le?(q=le,q.activeSignature=ne.activeSignature,q.activeParameter=ne.activeParameter):q=ne}return Object.assign(Object.assign({},x),{activeSignatureHelp:q})}releaseSignatureHelp(x){this._cache.delete(x)}}class U{constructor(x,q){this._documents=x,this._provider=q}provideInlayHints(x,q,ne){const le=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideInlayHints(le,A.Range.to(q),ne)).then(fe=>fe?{hints:fe.map(A.InlayHint.from)}:void 0)}}class G{constructor(x,q){this._documents=x,this._provider=q,this._cache=new p.Cache("DocumentLink")}provideLinks(x,q){const ne=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ne,q)).then(le=>{if(!(!Array.isArray(le)||le.length===0)&&!q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.map(A.DocumentLink.from)};{const fe=this._cache.add(le),Se={links:[],id:fe};for(let Oe=0;Oe<le.length;Oe++){const me=A.DocumentLink.from(le[Oe]);me.cacheId=[fe,Oe],Se.links.push(me)}return Se}}})}resolveLink(x,q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ne=this._cache.get(...x);return ne?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ne,q)).then(le=>le&&A.DocumentLink.from(le)||void 0):Promise.resolve(void 0)}releaseLinks(x){this._cache.delete(x)}}class J{constructor(x,q){this._documents=x,this._provider=q}provideColors(x,q){const ne=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ne,q)).then(le=>Array.isArray(le)?le.map(Se=>({color:A.Color.from(Se.color),range:A.Range.from(Se.range)})):[])}provideColorPresentations(x,q,ne){const le=this._documents.getDocument(x),fe=A.Range.to(q.range),Se=A.Color.to(q.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(Se,{document:le,range:fe},ne)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(A.ColorPresentation.from)})}}class re{constructor(x,q){this._documents=x,this._provider=q}provideFoldingRanges(x,q,ne){const le=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(le,q,ne)).then(fe=>{if(!!Array.isArray(fe))return fe.map(A.FoldingRange.from)})}}class pe{constructor(x,q,ne){this._documents=x,this._provider=q,this._logService=ne}provideSelectionRanges(x,q,ne){const le=this._documents.getDocument(x),fe=q.map(A.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(le,fe,ne)).then(Se=>{if(!(0,i.isNonEmptyArray)(Se))return[];if(Se.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let me=0;me<fe.length;me++){const Ce=[];Oe.push(Ce);let Pe=fe[me],$e=Se[me];for(;;){if(!$e.range.contains(Pe))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(A.SelectionRange.from($e)),!$e.parent)break;Pe=$e.range,$e=$e.parent}}return Oe})}}class Te{constructor(x,q){this._documents=x,this._provider=q,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(x,q,ne){const le=this._documents.getDocument(x),fe=A.Position.to(q),Se=await this._provider.prepareCallHierarchy(le,fe,ne);if(!!Se){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(Se)?Se.map(me=>this._cacheAndConvertItem(Oe,me)):[this._cacheAndConvertItem(Oe,Se)]}}async provideCallsTo(x,q,ne){const le=this._itemFromCache(x,q);if(!le)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(le,ne);if(!!fe)return fe.map(Se=>({from:this._cacheAndConvertItem(x,Se.from),fromRanges:Se.fromRanges.map(Oe=>A.Range.from(Oe))}))}async provideCallsFrom(x,q,ne){const le=this._itemFromCache(x,q);if(!le)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(le,ne);if(!!fe)return fe.map(Se=>({to:this._cacheAndConvertItem(x,Se.to),fromRanges:Se.fromRanges.map(Oe=>A.Range.from(Oe))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,q){var ne;const le=this._cache.get(x),fe={_sessionId:x,_itemId:le.size.toString(36),name:q.name,detail:q.detail,kind:A.SymbolKind.from(q.kind),uri:q.uri,range:A.Range.from(q.range),selectionRange:A.Range.from(q.selectionRange),tags:(ne=q.tags)===null||ne===void 0?void 0:ne.map(A.SymbolTag.from)};return le.set(fe._itemId,q),fe}_itemFromCache(x,q){const ne=this._cache.get(x);return ne==null?void 0:ne.get(q)}}class Be{constructor(x,q){this.adapter=x,this.extension=q}}class Ae{constructor(x,q,ne,le,fe,Se,Oe){this._adapter=new Map,this._uriTransformer=q,this._proxy=x.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=le,this._diagnostics=fe,this._logService=Se,this._apiDeprecation=Oe}_transformDocumentSelector(x){return(0,i.coalesce)((0,i.asArray)(x).map(q=>this._doTransformDocumentSelector(q)))}_doTransformDocumentSelector(x){if(typeof x=="string")return{$serialized:!0,language:x};if(x)return{$serialized:!0,language:x.language,scheme:this._transformScheme(x.scheme),pattern:typeof x.pattern=="undefined"?void 0:A.GlobPattern.from(x.pattern),exclusive:x.exclusive}}_transformScheme(x){return this._uriTransformer&&typeof x=="string"?this._uriTransformer.transformOutgoingScheme(x):x}_createDisposable(x){return new T.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return Ae._handlePool++}_withAdapter(x,q,ne,le,fe=!1){const Se=this._adapter.get(x);if(!Se)return Promise.resolve(le);if(Se.adapter instanceof q){let Oe;Se.extension&&(Oe=Date.now(),this._logService.trace(`[${Se.extension.identifier.value}] INVOKE provider '${q.name}'`));const me=ne(Se.adapter,Se.extension),Ce=Se.extension;return Ce&&Promise.resolve(me).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Pe=>{fe&&Pe instanceof E.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Pe))}),me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,q){const ne=this._nextHandle();return this._adapter.set(ne,new Be(x,q)),ne}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,q,ne,le){const fe=this._addNewAdapter(new f(this._documents,ne),x),Se=le&&le.label||Ae._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(q),Se),this._createDisposable(fe)}$provideDocumentSymbols(x,q,ne){return this._withAdapter(x,f,le=>le.provideDocumentSymbols(w.URI.revive(q),ne),void 0)}registerCodeLensProvider(x,q,ne){const le=this._nextHandle(),fe=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new Be(new l(this._documents,this._commands.converter,ne),x)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(q),fe);let Se=this._createDisposable(le);if(fe!==void 0){const Oe=ne.onDidChangeCodeLenses(me=>this._proxy.$emitCodeLensEvent(fe));Se=T.Disposable.from(Se,Oe)}return Se}$provideCodeLenses(x,q,ne){return this._withAdapter(x,l,le=>le.provideCodeLenses(w.URI.revive(q),ne),void 0)}$resolveCodeLens(x,q,ne){return this._withAdapter(x,l,le=>le.resolveCodeLens(q,ne),void 0)}$releaseCodeLenses(x,q){this._withAdapter(x,l,ne=>Promise.resolve(ne.releaseCodeLenses(q)),void 0)}registerDefinitionProvider(x,q,ne){const le=this._addNewAdapter(new t(this._documents,ne),x);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDefinition(x,q,ne,le){return this._withAdapter(x,t,fe=>fe.provideDefinition(w.URI.revive(q),ne,le),[])}registerDeclarationProvider(x,q,ne){const le=this._addNewAdapter(new n(this._documents,ne),x);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDeclaration(x,q,ne,le){return this._withAdapter(x,n,fe=>fe.provideDeclaration(w.URI.revive(q),ne,le),[])}registerImplementationProvider(x,q,ne){const le=this._addNewAdapter(new u(this._documents,ne),x);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideImplementation(x,q,ne,le){return this._withAdapter(x,u,fe=>fe.provideImplementation(w.URI.revive(q),ne,le),[])}registerTypeDefinitionProvider(x,q,ne){const le=this._addNewAdapter(new o(this._documents,ne),x);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideTypeDefinition(x,q,ne,le){return this._withAdapter(x,o,fe=>fe.provideTypeDefinition(w.URI.revive(q),ne,le),[])}registerHoverProvider(x,q,ne,le){const fe=this._addNewAdapter(new s(this._documents,ne),x);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(q)),this._createDisposable(fe)}$provideHover(x,q,ne,le){return this._withAdapter(x,s,fe=>fe.provideHover(w.URI.revive(q),ne,le),void 0)}registerEvaluatableExpressionProvider(x,q,ne,le){const fe=this._addNewAdapter(new c(this._documents,ne),x);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(q)),this._createDisposable(fe)}$provideEvaluatableExpression(x,q,ne,le){return this._withAdapter(x,c,fe=>fe.provideEvaluatableExpression(w.URI.revive(q),ne,le),void 0)}registerInlineValuesProvider(x,q,ne,le){const fe=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Se=this._addNewAdapter(new v(this._documents,ne),x);this._proxy.$registerInlineValuesProvider(Se,this._transformDocumentSelector(q),fe);let Oe=this._createDisposable(Se);if(fe!==void 0){const me=ne.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(fe));Oe=T.Disposable.from(Oe,me)}return Oe}$provideInlineValues(x,q,ne,le,fe){return this._withAdapter(x,v,Se=>Se.provideInlineValues(w.URI.revive(q),ne,le,fe),void 0)}registerDocumentHighlightProvider(x,q,ne){const le=this._addNewAdapter(new k(this._documents,ne),x);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDocumentHighlights(x,q,ne,le){return this._withAdapter(x,k,fe=>fe.provideDocumentHighlights(w.URI.revive(q),ne,le),void 0)}registerLinkedEditingRangeProvider(x,q,ne){const le=this._addNewAdapter(new g(this._documents,ne),x);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideLinkedEditingRanges(x,q,ne,le){return this._withAdapter(x,g,async fe=>{const Se=await fe.provideLinkedEditingRanges(w.URI.revive(q),ne,le);if(Se)return{ranges:Se.ranges,wordPattern:Se.wordPattern?Ae._serializeRegExp(Se.wordPattern):void 0}},void 0)}registerReferenceProvider(x,q,ne){const le=this._addNewAdapter(new _(this._documents,ne),x);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideReferences(x,q,ne,le,fe){return this._withAdapter(x,_,Se=>Se.provideReferences(w.URI.revive(q),ne,le,fe),void 0)}registerCodeActionProvider(x,q,ne,le){var fe,Se;const Oe=new h.DisposableStore,me=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(me,this._transformDocumentSelector(q),{providedKinds:(fe=le==null?void 0:le.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(Ce=>Ce.value),documentation:(Se=le==null?void 0:le.documentation)===null||Se===void 0?void 0:Se.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Oe)}))},Ae._extLabel(x),Boolean(ne.resolveCodeAction)),Oe.add(this._createDisposable(me)),Oe}$provideCodeActions(x,q,ne,le,fe){return this._withAdapter(x,R,Se=>Se.provideCodeActions(w.URI.revive(q),ne,le,fe),void 0)}$resolveCodeAction(x,q,ne){return this._withAdapter(x,R,le=>le.resolveCodeAction(q,ne),void 0)}$releaseCodeActions(x,q){this._withAdapter(x,R,ne=>Promise.resolve(ne.releaseCodeActions(q)),void 0)}registerDocumentFormattingEditProvider(x,q,ne){const le=this._addNewAdapter(new B(this._documents,ne),x);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(q),x.identifier,x.displayName||x.name),this._createDisposable(le)}$provideDocumentFormattingEdits(x,q,ne,le){return this._withAdapter(x,B,fe=>fe.provideDocumentFormattingEdits(w.URI.revive(q),ne,le),void 0)}registerDocumentRangeFormattingEditProvider(x,q,ne){const le=this._addNewAdapter(new Q(this._documents,ne),x);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(q),x.identifier,x.displayName||x.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(x,q,ne,le,fe){return this._withAdapter(x,Q,Se=>Se.provideDocumentRangeFormattingEdits(w.URI.revive(q),ne,le,fe),void 0)}registerOnTypeFormattingEditProvider(x,q,ne,le){const fe=this._addNewAdapter(new ge(this._documents,ne),x);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(q),le,x.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(x,q,ne,le,fe,Se){return this._withAdapter(x,ge,Oe=>Oe.provideOnTypeFormattingEdits(w.URI.revive(q),ne,le,fe,Se),void 0)}registerWorkspaceSymbolProvider(x,q){const ne=this._addNewAdapter(new V(q,this._logService),x);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(x,q,ne){return this._withAdapter(x,V,le=>le.provideWorkspaceSymbols(q,ne),{symbols:[]})}$resolveWorkspaceSymbol(x,q,ne){return this._withAdapter(x,V,le=>le.resolveWorkspaceSymbol(q,ne),void 0)}$releaseWorkspaceSymbols(x,q){this._withAdapter(x,V,ne=>ne.releaseWorkspaceSymbols(q),void 0)}registerRenameProvider(x,q,ne){const le=this._addNewAdapter(new H(this._documents,ne,this._logService),x);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(q),H.supportsResolving(ne)),this._createDisposable(le)}$provideRenameEdits(x,q,ne,le,fe){return this._withAdapter(x,H,Se=>Se.provideRenameEdits(w.URI.revive(q),ne,le,fe),void 0)}$resolveRenameLocation(x,q,ne,le){return this._withAdapter(x,H,fe=>fe.resolveRenameLocation(w.URI.revive(q),ne,le),void 0)}registerDocumentSemanticTokensProvider(x,q,ne,le){const fe=this._nextHandle(),Se=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Be(new $(this._documents,ne),x)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(q),le,Se);let Oe=this._createDisposable(fe);if(Se){const me=ne.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Se));Oe=T.Disposable.from(Oe,me)}return Oe}$provideDocumentSemanticTokens(x,q,ne,le){return this._withAdapter(x,$,fe=>fe.provideDocumentSemanticTokens(w.URI.revive(q),ne,le),null,!0)}$releaseDocumentSemanticTokens(x,q){this._withAdapter(x,$,ne=>ne.releaseDocumentSemanticColoring(q),void 0)}registerDocumentRangeSemanticTokensProvider(x,q,ne,le){const fe=this._addNewAdapter(new F(this._documents,ne),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(q),le),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(x,q,ne,le){return this._withAdapter(x,F,fe=>fe.provideDocumentRangeSemanticTokens(w.URI.revive(q),ne,le),null,!0)}registerCompletionItemProvider(x,q,ne,le){const fe=this._addNewAdapter(new L(this._documents,this._commands.converter,ne,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(q),le,L.supportsResolving(ne),`${x.identifier.value}(${le.join("")})`),this._createDisposable(fe)}$provideCompletionItems(x,q,ne,le,fe){return this._withAdapter(x,L,Se=>Se.provideCompletionItems(w.URI.revive(q),ne,le,fe),void 0)}$resolveCompletionItem(x,q,ne){return this._withAdapter(x,L,le=>le.resolveCompletionItem(q,ne),void 0)}$releaseCompletionItems(x,q){this._withAdapter(x,L,ne=>ne.releaseCompletionItems(q),void 0)}registerSignatureHelpProvider(x,q,ne,le){const fe=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,Se=this._addNewAdapter(new M(this._documents,ne),x);return this._proxy.$registerSignatureHelpProvider(Se,this._transformDocumentSelector(q),fe),this._createDisposable(Se)}$provideSignatureHelp(x,q,ne,le,fe){return this._withAdapter(x,M,Se=>Se.provideSignatureHelp(w.URI.revive(q),ne,le,fe),void 0)}$releaseSignatureHelp(x,q){this._withAdapter(x,M,ne=>ne.releaseSignatureHelp(q),void 0)}registerInlayHintsProvider(x,q,ne){const le=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new U(this._documents,ne),x);this._proxy.$registerInlayHintsProvider(fe,this._transformDocumentSelector(q),le);let Se=this._createDisposable(fe);if(le!==void 0){const Oe=ne.onDidChangeInlayHints(me=>this._proxy.$emitInlayHintsEvent(le));Se=T.Disposable.from(Se,Oe)}return Se}$provideInlayHints(x,q,ne,le){return this._withAdapter(x,U,fe=>fe.provideInlayHints(w.URI.revive(q),ne,le),void 0)}registerDocumentLinkProvider(x,q,ne){const le=this._addNewAdapter(new G(this._documents,ne),x);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(q),typeof ne.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(x,q,ne){return this._withAdapter(x,G,le=>le.provideLinks(w.URI.revive(q),ne),void 0)}$resolveDocumentLink(x,q,ne){return this._withAdapter(x,G,le=>le.resolveLink(q,ne),void 0)}$releaseDocumentLinks(x,q){this._withAdapter(x,G,ne=>ne.releaseLinks(q),void 0)}registerColorProvider(x,q,ne){const le=this._addNewAdapter(new J(this._documents,ne),x);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDocumentColors(x,q,ne){return this._withAdapter(x,J,le=>le.provideColors(w.URI.revive(q),ne),[])}$provideColorPresentations(x,q,ne,le){return this._withAdapter(x,J,fe=>fe.provideColorPresentations(w.URI.revive(q),ne,le),void 0)}registerFoldingRangeProvider(x,q,ne){const le=this._nextHandle(),fe=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new Be(new re(this._documents,ne),x)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(q),fe);let Se=this._createDisposable(le);if(fe!==void 0){const Oe=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));Se=T.Disposable.from(Se,Oe)}return Se}$provideFoldingRanges(x,q,ne,le){return this._withAdapter(x,re,fe=>fe.provideFoldingRanges(w.URI.revive(q),ne,le),void 0)}registerSelectionRangeProvider(x,q,ne){const le=this._addNewAdapter(new pe(this._documents,ne,this._logService),x);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideSelectionRanges(x,q,ne,le){return this._withAdapter(x,pe,fe=>fe.provideSelectionRanges(w.URI.revive(q),ne,le),[])}registerCallHierarchyProvider(x,q,ne){const le=this._addNewAdapter(new Te(this._documents,ne),x);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$prepareCallHierarchy(x,q,ne,le){return this._withAdapter(x,Te,fe=>Promise.resolve(fe.prepareSession(w.URI.revive(q),ne,le)),void 0)}$provideCallHierarchyIncomingCalls(x,q,ne,le){return this._withAdapter(x,Te,fe=>fe.provideCallsTo(q,ne,le),void 0)}$provideCallHierarchyOutgoingCalls(x,q,ne,le){return this._withAdapter(x,Te,fe=>fe.provideCallsFrom(q,ne,le),void 0)}$releaseCallHierarchy(x,q){this._withAdapter(x,Te,ne=>Promise.resolve(ne.releaseSession(q)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,S.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:Ae._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:Ae._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?Ae._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?Ae._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:Ae._serializeRegExp(x.beforeText),afterText:x.afterText?Ae._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?Ae._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(Ae._serializeOnEnterRule)}setLanguageConfiguration(x,q,ne){let{wordPattern:le}=ne;if(le&&(0,S.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(q,le):this._documents.setWordDefinitionFor(q,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const fe=this._nextHandle(),Se={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?Ae._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?Ae._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?Ae._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,q,Se),this._createDisposable(fe)}$setWordDefinitions(x){for(const q of x)this._documents.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=Ae,Ae._handlePool=0}),define(we[199],_e([0,1,5,9,7]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(D,S){this._proxy=D.getProxy(w.MainContext.MainThreadLanguages),this._documents=S}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,S){await this._proxy.$changeLanguage(D,S);const C=this._documents.getDocumentData(D);if(!C)throw new Error(`document '${D.toString}' NOT found`);return C.document}async tokenAtPosition(D,S){var C;const i=D.version,P=I.Position.from(S),d=await this._proxy.$tokensAtPosition(D.uri,P),h={type:A.StandardTokenType.Other,range:(C=D.getWordRangeAtPosition(S))!==null&&C!==void 0?C:new A.Range(S.line,S.character,S.line,S.character)};if(!d)return h;const r={range:I.Range.to(d.range),type:I.TokenType.to(d.type)};return!r.range.contains(S)||i!==D.version?h:r}}e.ExtHostLanguages=T}),define(we[200],_e([0,1,5,18,33]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(D){return D&&D.title}let y=class{constructor(S,C){this._logService=C,this._proxy=S.getProxy(w.MainContext.MainThreadMessageService)}showMessage(S,C,i,P,d){const h={extension:S};let r;typeof P=="string"||T(P)?r=[P,...d]:(h.modal=P&&P.modal,h.useCustom=P&&P.useCustom,r=d),h.useCustom&&(0,A.checkProposedApiEnabled)(S);const a=[];for(let p=0;p<r.length;p++){const m=r[p];if(typeof m=="string")a.push({title:m,handle:p,isCloseAffordance:!1});else if(typeof m=="object"){let{title:E,isCloseAffordance:f}=m;a.push({title:E,isCloseAffordance:!!f,handle:p})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(C,i,h,a).then(p=>{if(typeof p=="number")return r[p]})}};y=Ve([qe(1,I.ILogService)],y),e.ExtHostMessageService=y}),define(we[201],_e([0,1,11,24,20,3,56,54,6,22,8,10,2,68,5,9,7,73,178,179]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r,a,p,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class l{constructor(s,c){const v=l._Keys.nextId();s.$registerNotebookEditorDecorationType(v,a.NotebookDecorationRenderOptions.from(c)),this.value={key:v,dispose(){s.$removeNotebookEditorDecorationType(v)}}}}e.NotebookEditorDecorationType=l,l._Keys=new D.IdGenerator("NotebookEditorDecorationType");class b{constructor(s,c,v,k,g,_){this._textDocumentsAndEditors=v,this._textDocuments=k,this.logService=g,this._extensionStoragePaths=_,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new T.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new T.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new T.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new T.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new C.ResourceMap,this._statusBarCache=new h.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(r.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(r.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(r.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:R=>{var B;if(R&&R.$mid===12){const Q=(B=R.notebookEditor)===null||B===void 0?void 0:B.notebookUri,ge=R.cell.handle,V=this._documents.get(Q),H=V==null?void 0:V.getCell(ge);if(H)return H.apiCell}return R}})}get activeNotebookEditor(){var s;return(s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){return this._editors.get(s)}getIdByEditor(s){for(const[c,v]of this._editors)if(v.apiEditor===s)return c}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(s){return this._documents.get(s)}_getNotebookDocument(s){const c=this._documents.get(s);if(!c)throw new Error(`NO notebook document for '${s}'`);return c}_getProviderData(s){const c=this._notebookContentProviders.get(s);if(!c)throw new Error(`NO provider for '${s}'`);return c}registerNotebookContentProvider(s,c,v,k){var g,_,R;if((0,i.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:s,provider:v});let B;v.onDidChangeNotebookContentOptions&&(B=v.onDidChangeNotebookContentOptions(()=>{const V=a.NotebookDocumentContentOptions.from(v.options);this._notebookProxy.$updateNotebookProviderOptions(c,V)}));const Q=(g=k==null?void 0:k.viewOptions)===null||g===void 0?void 0:g.filenamePattern.map(V=>a.NotebookExclusiveDocumentPattern.from(V)).filter(V=>V!==void 0);((_=k==null?void 0:k.viewOptions)===null||_===void 0?void 0:_.filenamePattern)&&!Q&&console.warn(`Notebook content provider view options file name pattern is invalid ${(R=k==null?void 0:k.viewOptions)===null||R===void 0?void 0:R.filenamePattern}`);const ge=a.NotebookDocumentContentOptions.from(k);return this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},c,{transientOutputs:ge.transientOutputs,transientCellMetadata:ge.transientCellMetadata,transientDocumentMetadata:ge.transientDocumentMetadata,viewOptions:(k==null?void 0:k.viewOptions)&&Q?{displayName:k.viewOptions.displayName,filenamePattern:Q,exclusive:k.viewOptions.exclusive||!1}:void 0}),new p.Disposable(()=>{B==null||B.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}registerNotebookCellStatusBarItemProvider(s,c,v){const k=b._notebookStatusBarItemProviderHandlePool++,g=typeof v.onDidChangeCellStatusBarItems=="function"?b._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(k,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(k,g,c);let _;return g!==void 0&&(_=v.onDidChangeCellStatusBarItems(R=>this._notebookProxy.$emitCellStatusBarEvent(g))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(k),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(k,g),_&&_.dispose()})}createNotebookEditorDecorationType(s){return new l(this._notebookEditorsProxy,s).value}async openNotebookDocument(s){const c=this._documents.get(s);if(c)return c.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenDocument(s),k=this._documents.get(d.URI.revive(v));return(0,P.assertIsDefined)(k==null?void 0:k.apiNotebook)}async showNotebookDocument(s,c){var v;d.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let k;typeof c=="object"?k={position:a.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(a.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:k={preserveFocus:!1};const g=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.viewType,k),_=g&&((v=this._editors.get(g))===null||v===void 0?void 0:v.apiEditor);if(_)return _;throw g?new Error(`Could NOT open editor for "${s.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.toString()}".`)}async $provideNotebookCellStatusBarItems(s,c,v,k){var g;const _=this._notebookStatusBarItemProviders.get(s),R=d.URI.revive(c),B=this._documents.get(R);if(!(!B||!_)){const Q=B.getCellFromIndex(v);if(!!Q){const ge=await _.provideCellStatusBarItems(Q.apiCell,k);if(!!ge){const V=new S.DisposableStore,H=this._statusBarCache.add([V]),te=(g=ge&&ge.map($=>a.NotebookStatusBarItem.from($,this._commandsConverter,V)))!==null&&g!==void 0?g:void 0;return{cacheId:H,items:te}}}}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,c,v,k){if((0,i.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const g=this._handlePool++;this._notebookSerializer.set(g,v);const _=a.NotebookDocumentContentOptions.from(k);return this._notebookProxy.$registerNotebookSerializer(g,{id:s.identifier,location:s.extensionLocation},c,_),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(g)})}async $dataToNotebook(s,c,v){const k=this._notebookSerializer.get(s);if(!k)throw new Error("NO serializer found");const g=await k.deserializeNotebook(c.buffer,v);return{metadata:a.NotebookDocumentMetadata.from(g.metadata),cells:g.cells.map(a.NotebookCellData.from)}}async $notebookToData(s,c,v){const k=this._notebookSerializer.get(s);if(!k)throw new Error("NO serializer found");const g=await k.serializeNotebook({metadata:a.NotebookDocumentMetadata.to(c.metadata),cells:c.cells.map(a.NotebookCellData.to)},v);return I.VSBuffer.wrap(g)}cancelOneNotebookCellExecution(s){const c=this._activeExecutions.get(s.uri);c==null||c.cancel()}async $openNotebook(s,c,v,k,g){const{provider:_}=this._getProviderData(s),R=await _.openNotebook(d.URI.revive(c),{backupId:v,untitledDocumentData:k==null?void 0:k.buffer},g);return{metadata:a.NotebookDocumentMetadata.from(R.metadata),cells:R.cells.map(a.NotebookCellData.from)}}async $saveNotebook(s,c,v){const k=this._getNotebookDocument(d.URI.revive(c)),{provider:g}=this._getProviderData(s);return await g.saveNotebook(k.apiNotebook,v),!0}async $saveNotebookAs(s,c,v,k){const g=this._getNotebookDocument(d.URI.revive(c)),{provider:_}=this._getProviderData(s);return await _.saveNotebookAs(d.URI.revive(v),g.apiNotebook,k),!0}async $backupNotebook(s,c,v){var k;const g=this._getNotebookDocument(d.URI.revive(c)),_=this._getProviderData(s),R=(k=this._extensionStoragePaths.workspaceValue(_.extension))!==null&&k!==void 0?k:this._extensionStoragePaths.globalValue(_.extension),B=String((0,y.hash)([g.uri.toString(),this._backupIdPool++])),Q=d.URI.joinPath(R,B),ge=await _.provider.backupNotebook(g.apiNotebook,{destination:Q},v);return g.updateBackup(ge),ge.id}$acceptModelChanged(s,c,v){this._getNotebookDocument(d.URI.revive(s)).acceptModelChanged(c,v)}$acceptDirtyStateChanged(s,c){const v=this._getNotebookDocument(d.URI.revive(s));v.acceptModelChanged({rawEvents:[],versionId:v.apiNotebook.version},c)}$acceptModelSaved(s){const c=this._getNotebookDocument(d.URI.revive(s));this._onDidSaveNotebookDocument.fire(c.apiNotebook)}$acceptEditorPropertiesChanged(s,c){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",s,c);const v=this._editors.get(s);if(!v)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);c.visibleRanges&&v._acceptVisibleRanges(c.visibleRanges.ranges.map(a.NotebookRange.to)),c.selections&&v._acceptSelections(c.selections.selections.map(a.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:v.apiEditor,visibleRanges:v.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:v.apiEditor,selections:v.apiEditor.selections}))}$acceptEditorViewColumns(s){for(const c in s){const v=this._editors.get(c);if(!v)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);v._acceptViewColumn(a.ViewColumn.to(s[c]))}}$acceptDocumentPropertiesChanged(s,c){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",s.path,c);const v=this._getNotebookDocument(d.URI.revive(s));v.acceptDocumentPropertiesChanged(c),c.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:v.apiNotebook})}_createExtHostEditor(s,c,v){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const k=new f.ExtHostNotebookEditor(c,this._notebookEditorsProxy,s,v.visibleRanges.map(a.NotebookRange.to),v.selections.map(a.NotebookRange.to),typeof v.viewColumn=="number"?a.ViewColumn.to(v.viewColumn):void 0);this._editors.set(c,k)}$acceptDocumentAndEditorsDelta(s){var c,v,k;if(s.removedDocuments)for(const _ of s.removedDocuments){const R=d.URI.revive(_),B=this._documents.get(R);B&&(B.dispose(),this._documents.delete(R),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:B.apiNotebook.getCells().map(Q=>Q.document.uri)}),this._onDidCloseNotebookDocument.fire(B.apiNotebook));for(const Q of this._editors.values())Q.notebookData.uri.toString()===R.toString()&&this._editors.delete(Q.id)}if(s.addedDocuments){const _=[];for(const R of s.addedDocuments){const B=d.URI.revive(R.uri),Q=R.viewType;if(this._documents.has(B))throw new Error(`adding EXISTING notebook ${B} `);const ge=this,V=new E.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(H){ge._onDidChangeNotebookCells.fire(H)},emitCellOutputsChange(H){ge._onDidChangeCellOutputs.fire(H)},emitCellMetadataChange(H){ge._onDidChangeCellMetadata.fire(H)},emitCellExecutionStateChange(H){ge._onDidChangeCellExecutionState.fire(H)}},Q,R.metadata?a.NotebookDocumentMetadata.to(R.metadata):new p.NotebookDocumentMetadata,B);V.acceptModelChanged({versionId:R.versionId,rawEvents:[{kind:m.NotebookCellsChangeType.Initialize,changes:[[0,0,R.cells]]}]},!1),_.push(...R.cells.map(H=>E.ExtHostCell.asModelAddData(V.apiNotebook,H))),(c=this._documents.get(B))===null||c===void 0||c.dispose(),this._documents.set(B,V),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:_}),this._onDidOpenNotebookDocument.fire(V.apiNotebook)}}if(s.addedEditors)for(const _ of s.addedEditors){if(this._editors.has(_.id))return;const R=d.URI.revive(_.documentUri),B=this._documents.get(R);B&&this._createExtHostEditor(B,_.id,_)}const g=[];if(s.removedEditors)for(const _ of s.removedEditors){const R=this._editors.get(_);R&&(this._editors.delete(_),((v=this._activeNotebookEditor)===null||v===void 0?void 0:v.id)===R.id&&(this._activeNotebookEditor=void 0),g.push(R))}if(s.visibleEditors){this._visibleNotebookEditors=s.visibleEditors.map(R=>this._editors.get(R)).filter(R=>!!R);const _=new Set;this._visibleNotebookEditors.forEach(R=>_.add(R.id));for(const R of this._editors.values()){const B=_.has(R.id);R._acceptVisibility(B)}this._visibleNotebookEditors=[...this._editors.values()].map(R=>R).filter(R=>R.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.newActiveEditor===null?this._activeNotebookEditor=void 0:s.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.newActiveEditor)),s.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((k=this._activeNotebookEditor)===null||k===void 0?void 0:k.apiEditor)}createNotebookCellExecution(s,c,v){const k=this.lookupNotebookDocument(s);if(!k)throw new Error(`Invalid uri: ${s} `);const g=k.getCellFromIndex(c);if(!g)throw new Error(`Invalid cell index: ${s}, ${c} `);if(this._activeExecutions.has(g.uri))throw new Error(`duplicate execution for ${g.uri}`);const _=new n(s,k,g,this._notebookDocumentsProxy);this._activeExecutions.set(g.uri,_);const R=_.onDidChangeState(()=>{_.state===t.Resolved&&(_.dispose(),R.dispose(),this._activeExecutions.delete(g.uri))});return _.asApiObject()}}e.ExtHostNotebookController=b,b._notebookStatusBarItemProviderHandlePool=0;var t;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(t||(t={}));class n extends S.Disposable{constructor(s,c,v,k){super();this._uri=s,this._document=c,this._cell=v,this._proxy=k,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new A.CancellationTokenSource),this._collector=new u(10,g=>this.applyEdits(g)),this._executionOrder=v.internalMetadata.executionOrder,this.mixinMetadata({runState:p.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(s){await this._collector.addItem(s)}async applyEdits(s){return this._proxy.$applyEdits(this._uri,s,!1)}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(s){const c={editType:8,handle:this._cell.handle,metadata:s};this.applyEdits([c])}cellIndexToHandle(s){const c=typeof s=="number"?this._document.getCellFromIndex(s):this._cell;if(!!c)return c.handle}asApiObject(){const s=this;return Object.freeze({get document(){return s._document.apiNotebook},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(c){s._executionOrder=c,s.mixinMetadata({executionOrder:c})},start(c){var v;if(s._state===t.Resolved||s._state===t.Started)throw new Error("Cannot call start again");s._state=t.Started,s._onDidChangeState.fire(),s.mixinMetadata({runState:p.NotebookCellExecutionState.Executing,runStartTime:(v=c==null?void 0:c.startTime)!==null&&v!==void 0?v:null})},end(c){var v,k;if(s._state===t.Resolved)throw new Error("Cannot call resolve twice");s._state=t.Resolved,s._onDidChangeState.fire(),s.mixinMetadata({runState:p.NotebookCellExecutionState.Idle,lastRunSuccess:(v=c==null?void 0:c.success)!==null&&v!==void 0?v:null,runEndTime:(k=c==null?void 0:c.endTime)!==null&&k!==void 0?k:null})},clearOutput(c){return s.verifyStateForOutput(),this.replaceOutput([],c)},async appendOutput(c,v){s.verifyStateForOutput();const k=s.cellIndexToHandle(v);if(typeof k=="number")return c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:2,handle:k,append:!0,outputs:c.map(a.NotebookCellOutput.from)})},async replaceOutput(c,v){s.verifyStateForOutput();const k=s.cellIndexToHandle(v);if(typeof k=="number")return c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:2,handle:k,outputs:c.map(a.NotebookCellOutput.from)})},async appendOutputItems(c,v){return s.verifyStateForOutput(),c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:7,append:!0,items:c.map(a.NotebookCellOutputItem.from),outputId:v})},async replaceOutputItems(c,v){return s.verifyStateForOutput(),c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:7,items:c.map(a.NotebookCellOutputItem.from),outputId:v})},token:s._tokenSource.token})}}class u{constructor(s,c){this.delay=s,this.callback=c,this.batch=[]}addItem(s){return this.batch.push(s),this.waitPromise||(this.waitPromise=(0,w.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const c=this.batch;return this.batch=[],this.callback(c)})),this.waitPromise}}}),define(we[202],_e([0,1,3,6,5,26,2,9,72,22]),function(Y,e,w,I,A,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class i{constructor(d,h,r){this._initData=h,this._extHostNotebook=r,this._kernelData=new Map,this._handlePool=0,this._proxy=d.getProxy(A.MainContext.MainThreadNotebookKernels)}createNotebookController(d,h,r,a,p,m){for(let R of this._kernelData.values())if(R.controller.id===h&&T.ExtensionIdentifier.equals(d.identifier,R.extensionId))throw new Error(`notebook controller with id '${h}' ALREADY exist`);const E=this._handlePool++,f=this,l=()=>console.warn(`NO execute handler from notebook controller '${o.id}' of extension: '${d.identifier}'`);let b=!1;const t=new I.DisposableStore,n=new w.Emitter,u=new w.Emitter,o={id:`${d.identifier.value}/${h}`,viewType:r,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:a||d.identifier.value,preloads:m?m.map(D.NotebookKernelPreload.from):[]};let s=p!=null?p:l,c;this._proxy.$addKernel(E,o).catch(R=>{console.log(R),b=!0});let v=0;const k=()=>{if(!b){const R=++v;Promise.resolve().then(()=>{R===v&&this._proxy.$updateKernel(E,o)})}},g=new C.ResourceMap,_={get id(){return h},get viewType(){return o.viewType},onDidChangeNotebookAssociation:n.event,get label(){return o.label},set label(R){var B;o.label=(B=R!=null?R:d.displayName)!==null&&B!==void 0?B:d.name,k()},get detail(){var R;return(R=o.detail)!==null&&R!==void 0?R:""},set detail(R){o.detail=R,k()},get description(){var R;return(R=o.description)!==null&&R!==void 0?R:""},set description(R){o.description=R,k()},get supportedLanguages(){return o.supportedLanguages},set supportedLanguages(R){o.supportedLanguages=R,k()},get hasExecutionOrder(){var R;return(R=o.hasExecutionOrder)!==null&&R!==void 0?R:!1},set hasExecutionOrder(R){o.hasExecutionOrder=R,k()},get preloads(){return o.preloads?o.preloads.map(D.NotebookKernelPreload.to):[]},get executeHandler(){return s},set executeHandler(R){s=R!=null?R:l},get interruptHandler(){return c},set interruptHandler(R){c=R,o.supportsInterrupt=Boolean(R),k()},createNotebookCellExecutionTask(R){if(b)throw new Error("notebook controller is DISPOSED");if(!g.has(R.notebook.uri))throw new Error(`notebook controller is NOT associated to notebook: ${R.notebook.uri.toString()}`);return f._extHostNotebook.createNotebookCellExecution(R.notebook.uri,R.index,o.id)},dispose:()=>{b||(b=!0,this._kernelData.delete(E),t.dispose(),n.dispose(),u.dispose(),this._proxy.$removeKernel(E))},onDidReceiveMessage:u.event,postMessage(R,B){return f._proxy.$postMessage(E,B&&f._extHostNotebook.getIdByEditor(B),R)},asWebviewUri(R){return(0,S.asWebviewUri)(f._initData.environment,String(E),R)},updateNotebookAffinity(R,B){f._proxy.$updateNotebookPriority(E,R.uri,B)}};return this._kernelData.set(E,{extensionId:d.identifier,controller:_,onDidReceiveMessage:u,onDidChangeSelection:n,associatedNotebooks:g}),_}$acceptSelection(d,h,r){const a=this._kernelData.get(d);if(a){const p=this._extHostNotebook.lookupNotebookDocument(y.URI.revive(h));r?a.associatedNotebooks.set(p.uri,!0):a.associatedNotebooks.delete(p.uri),a.onDidChangeSelection.fire({selected:r,notebook:p.apiNotebook})}}async $executeCells(d,h,r){const a=this._kernelData.get(d);if(!!a){const p=this._extHostNotebook.lookupNotebookDocument(y.URI.revive(h));if(!p)throw new Error("MISSING notebook");const m=[];for(let E of r){const f=p.getCell(E);f&&m.push(f.apiCell)}try{await a.controller.executeHandler.call(a.controller,m,p.apiNotebook,a.controller)}catch(E){console.error(E)}}}async $cancelCells(d,h,r){const a=this._kernelData.get(d);if(!!a){const p=this._extHostNotebook.lookupNotebookDocument(y.URI.revive(h));if(!p)throw new Error("MISSING notebook");a.controller.interruptHandler&&await a.controller.interruptHandler.call(a.controller,p.apiNotebook);for(let m of r){const E=p.getCell(m);E&&this._extHostNotebook.cancelOneNotebookCellExecution(E)}}}$acceptKernelMessageFromRenderer(d,h,r){const a=this._kernelData.get(d);if(!!a){const p=this._extHostNotebook.getEditorById(h);if(!p)throw new Error(`send message for UNKNOWN editor: ${h}`);a.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:r}))}}}e.ExtHostNotebookKernels=i}),define(we[100],_e([0,1,5,3,6,24,4,14]),function(Y,e,w,I,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends A.Disposable{constructor(r,a,p,m){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=m,this._id=m.$register(this.name,a,p),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?T.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(a=>this._proxy.$clear(a,r))}show(r,a){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof r=="boolean"?r:a)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class C extends S{constructor(r,a){super(r,!1,void 0,a)}append(r){super.append(r),this._id.then(a=>this._proxy.$append(a,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class i extends S{constructor(r,a,p){super(r,!0,a,p)}append(r){throw new Error("Not supported")}}class P{constructor(r,a){this.name=r,this._channel=a}append(r){this._channel.then(a=>a.append(r))}appendLine(r){this._channel.then(a=>a.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,a){this._channel.then(p=>p.show(r,a))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=P;let d=class{constructor(r){this._proxy=r.getProxy(w.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new C(r,this._proxy)}createOutputChannelFromLogFile(r,a){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!a)throw new Error("illegal argument `file`. must not be falsy");return new i(r,a,this._proxy)}};d=Ve([qe(0,D.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(we[203],_e([0,1,11,20,3,6,5,2,7,12,15,47]),function(Y,e,w,I,A,T,y,D,S,C,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(h,r,a){const p=h.getProxy(y.MainContext.MainThreadQuickOpen);class m{constructor(o,s){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=s}showQuickPick(o,s,c,v=I.CancellationToken.None){this._onDidSelectItem=void 0;const k=Promise.resolve(o),g=++this._instances,_=p.$show(g,{title:c==null?void 0:c.title,placeHolder:c==null?void 0:c.placeHolder,matchOnDescription:c==null?void 0:c.matchOnDescription,matchOnDetail:c==null?void 0:c.matchOnDetail,ignoreFocusLost:c==null?void 0:c.ignoreFocusOut,canPickMany:c==null?void 0:c.canPickMany},v),R={},B=_.then(()=>R);return Promise.race([B,k]).then(Q=>{if(Q!==R)return k.then(ge=>{const V=[];for(let H=0;H<ge.length;H++){const te=ge[H];let $,F,L,M,U;typeof te=="string"?$=te:($=te.label,F=te.description,L=te.detail,M=te.picked,U=te.alwaysShow),V.push({label:$,description:F,handle:H,detail:L,picked:M,alwaysShow:U})}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{c.onDidSelectItem(ge[H])}),p.$setItems(g,V),_.then(H=>{if(typeof H=="number")return ge[H];if(Array.isArray(H))return H.map(te=>ge[te])})})}).then(void 0,Q=>{if(!(0,C.isPromiseCanceledError)(Q))return p.$setError(g,Q),Promise.reject(Q)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,s=I.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,p.$input(o,typeof this._validateInput=="function",s).then(void 0,c=>{if(!(0,C.isPromiseCanceledError)(c))return Promise.reject(c)})}$validateInput(o){return this._validateInput?(0,w.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,s=I.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!!c){const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(k=>k.uri.toString()===c.uri.toString())}}createQuickPick(o,s){const c=new t(o,s,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}createInputBox(o){const s=new n(o,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}$onDidChangeValue(o,s){const c=this._sessions.get(o);c&&c._fireDidChangeValue(s)}$onDidAccept(o){const s=this._sessions.get(o);s&&s._fireDidAccept()}$onDidChangeActive(o,s){const c=this._sessions.get(o);c instanceof t&&c._fireDidChangeActive(s)}$onDidChangeSelection(o,s){const c=this._sessions.get(o);c instanceof t&&c._fireDidChangeSelection(s)}$onDidTriggerButton(o,s){const c=this._sessions.get(o);c&&c._fireDidTriggerButton(s)}$onDidHide(o){const s=this._sessions.get(o);s&&s._fireDidHide()}}class E{constructor(o,s){this._extensionId=o,this._onDidDispose=s,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((s,c)=>{const v=s===S.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(v,s)}),this.update({buttons:o.map((s,c)=>({iconPath:f(s.iconPath),tooltip:s.tooltip,handle:s===S.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const s=this._handlesToButtons.get(o);s&&this._onDidTriggerButtonEmitter.fire(s)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(o){if(!this._disposed){for(const s of Object.keys(o)){const c=o[s];this._pendingUpdate[s]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function f(u){if(u instanceof S.ThemeIcon)return{id:u.id};const o=b(u),s=l(u);return{dark:typeof o=="string"?D.URI.file(o):o,light:typeof s=="string"?D.URI.file(s):s}}function l(u){return typeof u=="object"&&"light"in u?u.light:u}function b(u){return typeof u=="object"&&"dark"in u?u.dark:u}class t extends E{constructor(o,s,c){super(o,c);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((s,c)=>{this._handlesToItems.set(c,s),this._itemsToHandles.set(s,c)}),this.update({items:o.map((s,c)=>({label:s.label,description:s.description,handle:c,detail:s.detail,picked:s.picked,alwaysShow:s.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(s=>this._itemsToHandles.has(s)),this.update({activeItems:this._activeItems.map(s=>this._itemsToHandles.get(s))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(s=>this._itemsToHandles.has(s)),this.update({selectedItems:this._selectedItems.map(s=>this._itemsToHandles.get(s))})}_fireDidChangeActive(o){const s=(0,i.coalesce)(o.map(c=>this._handlesToItems.get(c)));this._activeItems=s,this._onDidChangeActiveEmitter.fire(s)}_fireDidChangeSelection(o){const s=(0,i.coalesce)(o.map(c=>this._handlesToItems.get(c)));this._selectedItems=s,this._onDidChangeSelectionEmitter.fire(s)}}class n extends E{constructor(o,s){super(o,s);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?P.default.Error:P.default.Ignore})}}return new m(r,a)}e.createExtHostQuickOpen=d}),define(we[204],_e([0,1,2,3,52,6,11,5,15,112,18,26,33]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(o){if(o)return typeof o.iconPath=="string"?w.URI.file(o.iconPath):o.iconPath}function r(o,s){if(!o.iconPath&&!s.iconPath)return 0;if(o.iconPath){if(!s.iconPath)return 1}else return-1;const c=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath,v=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath;return(0,C.comparePaths)(c,v)}function a(o,s){let c=0;if(o.strikeThrough!==s.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==s.faded)return o.faded?1:-1;if(o.tooltip!==s.tooltip)return(o.tooltip||"").localeCompare(s.tooltip||"");if(c=r(o,s),c!==0)return c;if(o.light&&s.light)c=r(o.light,s.light);else{if(o.light)return 1;if(s.light)return-1}if(c!==0)return c;if(o.dark&&s.dark)c=r(o.dark,s.dark);else{if(o.dark)return 1;if(s.dark)return-1}return c}function p(o,s){if(o.command!==s.command)return o.command<s.command?-1:1;if(o.title!==s.title)return o.title<s.title?-1:1;if(o.tooltip!==s.tooltip){if(o.tooltip!==void 0&&s.tooltip!==void 0)return o.tooltip<s.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(o.arguments===s.arguments)return 0;if(o.arguments)if(s.arguments){if(o.arguments.length!==s.arguments.length)return o.arguments.length-s.arguments.length}else return 1;else return-1;for(let c=0;c<o.arguments.length;c++){const v=o.arguments[c],k=s.arguments[c];if(v!==k)return v<k?-1:1}return 0}function m(o,s){let c=(0,C.comparePaths)(o.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(c!==0)return c;if(o.command&&s.command)c=p(o.command,s.command);else{if(o.command)return 1;if(s.command)return-1}if(c!==0)return c;if(o.decorations&&s.decorations)c=a(o.decorations,s.decorations);else{if(o.decorations)return 1;if(s.decorations)return-1}return c}function E(o,s){for(let c=0;c<o.length;c++)if(o[c]!==s[c])return!1;return!0}function f(o,s){return o.command===s.command&&o.title===s.title&&o.tooltip===s.tooltip&&(o.arguments&&s.arguments?E(o.arguments,s.arguments):o.arguments===s.arguments)}function l(o,s){return(0,S.equals)(o,s,f)}class b{constructor(s,c,v){this._extension=s,this._proxy=c,this._sourceControlHandle=v,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(s){if((0,d.checkProposedApiEnabled)(this._extension),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(s,c){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,s,c)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=b;class t{constructor(s,c,v,k,g){this._proxy=s,this._commands=c,this._sourceControlHandle=v,this._id=k,this._label=g,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,c){const v=this._resourceStatesCommandsMap.get(s);return v?(0,y.asPromise)(()=>this._commands.executeCommand(v.command,...v.arguments||[],c)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var s;const c=[...this._resourceStates].sort(m),k=(0,S.sortedDiff)(this._resourceSnapshot,c,m).map(R=>{const B=R.toInsert.map(Q=>{const ge=this._resourceHandlePool++;this._resourceStatesMap.set(ge,Q);const V=Q.resourceUri,H=h(Q.decorations),te=Q.decorations&&h(Q.decorations.light)||H,$=Q.decorations&&h(Q.decorations.dark)||H,F=[];let L;if(Q.command)if(Q.command.command==="vscode.open"||Q.command.command==="vscode.diff"){const pe=new T.DisposableStore;L=this._commands.converter.toInternal(Q.command,pe),this._resourceStatesDisposablesMap.set(ge,pe)}else this._resourceStatesCommandsMap.set(ge,Q.command);te&&F.push(te),$&&$.toString()!==(te==null?void 0:te.toString())&&F.push($);const M=Q.decorations&&Q.decorations.tooltip||"",U=Q.decorations&&!!Q.decorations.strikeThrough,G=Q.decorations&&!!Q.decorations.faded,J=Q.contextValue||"";return{rawResource:[ge,V,F,M,U,G,J,L],handle:ge}});return{start:R.start,deleteCount:R.deleteCount,toInsert:B}}),g=k.map(({start:R,deleteCount:B,toInsert:Q})=>[R,B,Q.map(ge=>ge.rawResource)]),_=k.reverse();for(const{start:R,deleteCount:B,toInsert:Q}of _){const ge=Q.map(H=>H.handle),V=this._handlesSnapshot.splice(R,B,...ge);for(const H of V)this._resourceStatesMap.delete(H),this._resourceStatesCommandsMap.delete(H),(s=this._resourceStatesDisposablesMap.get(H))===null||s===void 0||s.dispose(),this._resourceStatesDisposablesMap.delete(H)}return this._resourceSnapshot=c,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(s,c,v,k,g,_){this._proxy=c,this._commands=v,this._id=k,this._label=g,this._rootUri=_,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new b(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,k,g,_)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=s;const c=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:c})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(!(this._statusBarCommands&&s&&l(this._statusBarCommands,s))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=s;const c=(s||[]).map(v=>this._commands.converter.toInternal(v,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:c})}}get selected(){return this._selected}createResourceGroup(s,c){const v=new t(this._proxy,this._commands,this.handle,s,c),k=I.Event.once(v.onDidDispose)(()=>this.createdResourceGroups.delete(v));return this.createdResourceGroups.set(v,k),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const s=[],c=[];for(const[v,k]of this.createdResourceGroups){k.dispose();const g=v.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(v),this.eventuallyUpdateResourceStates()});I.Event.once(v.onDidDispose)(()=>{this.updatedResourceGroups.delete(v),g.dispose(),this._groups.delete(v.handle),this._proxy.$unregisterGroup(this.handle,v.handle)}),s.push([v.handle,v.id,v.label,v.features]);const _=v._takeResourceStateSnapshot();_.length>0&&c.push([v.handle,_]),this._groups.set(v.handle,v)}this._proxy.$registerGroups(this.handle,s,c),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(c=>{const v=c._takeResourceStateSnapshot();v.length!==0&&s.push([c.handle,v])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([(0,A.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([(0,A.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let u=class Rn{constructor(s,c,v){this._commands=c,this.logService=v,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=s.getProxy(D.MainContext.MainThreadSCM),this._telemetry=s.getProxy(D.MainContext.MainThreadTelemetry),c.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===3){const g=this._sourceControls.get(k.sourceControlHandle);if(!g)return k;const _=g.getResourceGroup(k.groupHandle);return _?_.getResourceState(k.handle):k}else if(k&&k.$mid===4){const g=this._sourceControls.get(k.sourceControlHandle);return g?g.getResourceGroup(k.groupHandle):k}else if(k&&k.$mid===5){const g=this._sourceControls.get(k.handle);return g||k}return k}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,c,v,k){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,c,v,k),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const g=Rn._handlePool++,_=new n(s,this._proxy,this._commands,c,v,k);this._sourceControls.set(g,_);const R=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(s.identifier))||[];return R.push(_),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(s.identifier),R),_}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const c=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(s.identifier)),v=c&&c[c.length-1];return v&&v.inputBox}$provideOriginalResource(s,c,v){const k=w.URI.revive(c);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,k.toString());const g=this._sourceControls.get(s);return!g||!g.quickDiffProvider||!g.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>g.quickDiffProvider.provideOriginalResource(k,v)).then(_=>_||null)}$onInputBoxValueChange(s,c){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const v=this._sourceControls.get(s);return v&&v.inputBox.$onInputBoxValueChange(c),Promise.resolve(void 0)}$executeResourceCommand(s,c,v,k){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,c,v);const g=this._sourceControls.get(s);if(!g)return Promise.resolve(void 0);const _=g.getResourceGroup(c);return _?_.$executeResourceCommand(v,k):Promise.resolve(void 0)}$validateInput(s,c,v){this.logService.trace("ExtHostSCM#$validateInput",s);const k=this._sourceControls.get(s);return!k||!k.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>k.inputBox.validateInput(c,v)).then(g=>g?Promise.resolve([g.message,g.type]):Promise.resolve(void 0))}$setSelectedSourceControl(s){var c,v;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&((c=this._sourceControls.get(s))===null||c===void 0||c.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((v=this._sourceControls.get(this._selectedSourceControlHandle))===null||v===void 0||v.setSelectionState(!1)),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};u._handlePool=0,u=Ve([qe(2,i.ILogService)],u),e.ExtHostSCM=u});var tt=this&&this.__classPrivateFieldSet||function(Y,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Y,w):A?A.value=w:e.set(Y,w),w},Me=this&&this.__classPrivateFieldGet||function(Y,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Y):I?I.value:e.get(Y)};define(we[205],_e([0,1,7,5,134,6]),function(Y,e,w,I,A,T){"use strict";var y,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class S{constructor(d,h,r,a,p=w.StatusBarAlignment.Left,m,E){y.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,tt(this,y,d,"f"),tt(this,D,h,"f"),this._id=S.ID_GEN++,this._statusId=r,this._statusName=a,this._alignment=p,this._priority=m,this._accessibilityInformation=E}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var d;return(d=this._command)===null||d===void 0?void 0:d.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!S.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){var h;((h=this._command)===null||h===void 0?void 0:h.fromApi)!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Me(this,D,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Me(this,D,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var d;this._timeoutHandle=void 0;let h=this._color;this._backgroundColor&&(h=S.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Me(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(d=this._command)===null||d===void 0?void 0:d.internal,h,this._backgroundColor,this._alignment===w.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=S,y=new WeakMap,D=new WeakMap,S.ID_GEN=0,S.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new w.ThemeColor("statusBarItem.errorForeground")]]);class C{constructor(d){this._messages=[],this._item=d.createStatusBarEntry("status.extensionMessage",(0,A.localize)(0,null),w.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const h={message:d};return this._messages.unshift(h),this._update(),new w.Disposable(()=>{const r=this._messages.indexOf(h);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(d,h){this._proxy=d.getProxy(I.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new C(this)}createStatusBarEntry(d,h,r,a,p){return new S(this._proxy,this._commands,d,h,r,a,p)}setStatusBarMessage(d,h){const r=this._statusMessage.setMessage(d);let a;return typeof h=="number"?a=setTimeout(()=>r.dispose(),h):typeof h!="undefined"&&h.then(()=>r.dispose(),()=>r.dispose()),new w.Disposable(()=>{r.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=i}),define(we[78],_e([0,1,5,3,4]),function(Y,e,w,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(D){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(w.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,S){this._proxy.$registerExtensionStorageKeysToSync(D,S)}getValue(D,S,C){return this._proxy.$getValue(D,S).then(i=>i||C)}setValue(D,S,C){return this._proxy.$setValue(D,S,C)}$acceptValue(D,S,C){this._onDidChangeStorage.fire({shared:D,key:S,value:C})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,A.createDecorator)("IExtHostStorage")}),define(we[79],_e([0,1,4,27,18,77,2]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,w.createDecorator)("IExtensionStoragePaths");let D=class{constructor(C,i,P){var d;this._logService=i,this._extHostFileSystem=P,this._workspace=(d=C.workspace)!==null&&d!==void 0?d:void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getOrCreateWorkspaceStoragePath(){var C;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,P=y.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch(d){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(C=y.URI.revive(this._workspace.configuration))===null||C===void 0?void 0:C.toString(),name:this._workspace.name},void 0,2))),P}catch(d){this._logService.error("[ExtHostStorage]",d);return}}workspaceValue(C){if(this._value)return y.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return y.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}};D=Ve([qe(0,I.IExtHostInitDataService),qe(1,A.ILogService),qe(2,T.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(we[40],_e([0,1,3,5,4,2,14,6,7,135,12,172,20,31,155]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,A.createDecorator)("IExtHostTerminalService");class a{constructor(t,n,u,o){this._proxy=t,this._id=n,this._creationOptions=u,this._name=o,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(c=>this._pidPromiseComplete=c);const s=this;this.value={get name(){return s._name||""},get processId(){return s._pidPromise},get creationOptions(){return s._creationOptions},get exitStatus(){return s._exitStatus},sendText(c,v=!0){s._checkDisposed(),s._proxy.$sendText(s._id,c,v)},show(c){s._checkDisposed(),s._proxy.$show(s._id,c)},hide(){s._checkDisposed(),s._proxy.$hide(s._id)},dispose(){s._disposed||(s._disposed=!0,s._proxy.$dispose(s._id))},get dimensions(){if(!(s._cols===void 0||s._rows===void 0))return{columns:s._cols,rows:s._rows}}}}async create(t,n,u,o,s,c,v,k,g,_,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:u,env:o,icon:s,initialText:c,waitOnExit:v,strictEnv:k,hideFromUser:g,isFeatureTerminal:_,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=a;class p{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new w.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new w.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new w.Emitter,this._onProcessTitleChanged=new w.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new w.Emitter,this._onProcessShellTypeChanged=new w.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let m=1,E=class extends D.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new w.Emitter,this._onDidOpenTerminal=new w.Emitter,this._onDidChangeActiveTerminal=new w.Emitter,this._onDidChangeTerminalDimensions=new w.Emitter,this._proxy=n.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new w.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[u,o]of this._terminalProcesses)o.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new a(this._proxy,(0,h.generateUuid)(),t,t.name),u=new p(t.pty);return n.createExtensionTerminal().then(o=>{const s=this._setupExtHostProcessListeners(o,u);this._terminalProcessDisposables[o]=s}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const o=new p(n),s=this._setupExtHostProcessListeners(t,o);this._terminalProcessDisposables[t]=s}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(t);u&&(this._activeTerminal=u,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const u=this._getTerminalById(t);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:n})}async $acceptTerminalDimensions(t,n,u){const o=this._getTerminalById(t);o&&o.setDimensions(n,u)&&this._onDidChangeTerminalDimensions.fire({terminal:o.value,dimensions:o.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,u){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(n,u)}async $acceptTerminalTitleChange(t,n){const u=this._getTerminalById(t);u&&(u.name=n)}async $acceptTerminalClosed(t,n){const u=this._getTerminalObjectIndexById(this._terminals,t);if(u!==null){const o=this._terminals.splice(u,1)[0];o.setExitCode(n),this._onDidCloseTerminal.fire(o.value)}}$acceptTerminalOpened(t,n,u,o){if(n){const v=this._getTerminalObjectIndexById(this._terminals,n);if(v!==null){this._terminals[v]._id=t,this._onDidOpenTerminal.fire(this.terminals[v]),this._terminals[v].isOpen=!0;return}}const s={name:o.name,shellPath:o.executable,shellArgs:o.args,cwd:typeof o.cwd=="string"?o.cwd:T.URI.revive(o.cwd),env:o.env,hideFromUser:o.hideFromUser},c=new a(this._proxy,t,s,u);this._terminals.push(c),this._onDidOpenTerminal.fire(c.value),c.isOpen=!0}async $acceptTerminalProcessId(t,n){const u=this._getTerminalById(t);u&&u._setProcessId(n)}async $startExtensionTerminal(t,n){const u=this._getTerminalById(t);if(!u)return{message:(0,C.localize)(0,null,t)};u.isOpen||await new Promise(s=>{const c=this.onDidOpenTerminal(async v=>{v===u.value&&(c.dispose(),s())})});const o=this._terminalProcesses.get(t);o?o.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const u=new D.DisposableStore;u.add(n.onProcessReady(s=>this._proxy.$sendProcessReady(t,s.pid,s.cwd))),u.add(n.onProcessTitleChanged(s=>this._proxy.$sendProcessTitle(t,s))),this._bufferer.startBuffering(t,n.onProcessData),u.add(n.onProcessExit(s=>this._onProcessExit(t,s))),n.onProcessOverrideDimensions&&u.add(n.onProcessOverrideDimensions(s=>this._proxy.$sendOverrideDimensions(t,s))),this._terminalProcesses.set(t,n);const o=this._extensionTerminalAwaitingStart[t];return o&&n instanceof p&&(n.startSendingEvents(o.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),u}$acceptProcessAckDataEvent(t,n){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.input(n)}$acceptProcessResize(t,n,u){var o;try{(o=this._terminalProcesses.get(t))===null||o===void 0||o.resize(n,u)}catch(s){if(s.code!=="EPIPE"&&s.code!=="ERR_IPC_CHANNEL_CLOSED")throw s}}$acceptProcessShutdown(t,n){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(u=>this._proxy.$sendProcessInitialCwd(t,u))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(u=>this._proxy.$sendProcessCwd(t,u))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const u=this._getTerminalById(t);if(!u)return[];this._terminalLinkCache.delete(t);const o=this._terminalLinkCancellationSource.get(t);o&&o.dispose(!0);const s=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,s);const c=[],v={terminal:u.value,line:n},k=[];for(const R of this._linkProviders)k.push(new Promise(async B=>{s.token.onCancellationRequested(()=>B({provider:R,links:[]}));const Q=await R.provideTerminalLinks(v,s.token)||[];s.token.isCancellationRequested||B({provider:R,links:Q})}));const g=await Promise.all(k);if(s.token.isCancellationRequested)return[];const _=new Map;for(const R of g)R&&R.links.length>0&&c.push(...R.links.map(B=>{const Q={id:m++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return _.set(Q.id,{provider:R.provider,link:B}),Q}));return this._terminalLinkCache.set(t,_),c}$activateLink(t,n){var u;const o=(u=this._terminalLinkCache.get(t))===null||u===void 0?void 0:u.get(n);!o||o.provider.handleTerminalLink(o.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const u=this._terminalProcessDisposables[t];u&&(u.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const u=this._getTerminalObjectIndexById(t,n);return u!==null?t[u]:null}_getTerminalObjectIndexById(t,n){let u=null;return t.some((o,s)=>o._id===n?(u=s,!0):!1),u}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new f,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const u=(0,P.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const u=n[0],o=new f(n[1]);this._setEnvironmentVariableCollection(u,o)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};E=Ve([qe(1,y.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class f{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new w.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const u=this.map.get(t);(!u||u.value!==n.value||u.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((u,o)=>t.call(n,o,u,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=f;let l=class extends E{constructor(t){super(!1,t)}createTerminal(t,n,u){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}getDefaultShell(t,n){throw new i.NotSupportedError}getDefaultShellArgs(t,n){throw new i.NotSupportedError}async getDefaultShellAndArgs(t){throw new i.NotSupportedError}$getAvailableProfiles(t){throw new i.NotSupportedError}};l=Ve([qe(0,y.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l}),define(we[206],_e([0,1,3,15,5,97,9,7]),function(Y,e,w,I,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(i,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new w.Emitter,this._onDidChangeTextEditorOptions=new w.Emitter,this._onDidChangeTextEditorVisibleRanges=new w.Emitter,this._onDidChangeTextEditorViewColumn=new w.Emitter,this._onDidChangeActiveTextEditor=new w.Emitter,this._onDidChangeVisibleTextEditors=new w.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const P=this._extHostDocumentsAndEditors.allEditors();return i?P:P.map(d=>d.value)}async showTextDocument(i,P,d){let h;typeof P=="number"?h={position:y.ViewColumn.from(P),preserveFocus:d}:typeof P=="object"?h={position:y.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?y.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:h={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(i.uri,h),a=r&&this._extHostDocumentsAndEditors.getEditor(r);if(a)return a.value;throw r?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new T.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,P){const d=this._extHostDocumentsAndEditors.getEditor(i);if(!d)throw new Error("unknown text editor");if(P.options&&d._acceptOptions(P.options),P.selections){const h=P.selections.selections.map(y.Selection.to);d._acceptSelections(h)}if(P.visibleRanges){const h=I.coalesce(P.visibleRanges.map(y.Range.to));d._acceptVisibleRanges(h)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:Object.assign(Object.assign({},P.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(P.options.lineNumbers)})}),P.selections){const h=D.TextEditorSelectionChangeKind.fromValue(P.selections.source),r=P.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:r,kind:h})}if(P.visibleRanges){const h=I.coalesce(P.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:h})}}$acceptEditorPositionData(i){for(const P in i){const d=this._extHostDocumentsAndEditors.getEditor(P);if(!d)throw new Error("Unknown text editor");const h=y.ViewColumn.to(i[P]);d.value.viewColumn!==h&&(d._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:h}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=S});var Qt=this&&this.__rest||function(Y,e){var w={};for(var I in Y)Object.prototype.hasOwnProperty.call(Y,I)&&e.indexOf(I)<0&&(w[I]=Y[I]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(Y);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(Y,I[A])&&(w[I[A]]=Y[I[A]]);return w};define(we[207],_e([0,1,2,4,5,6,7]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class D{constructor(i,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(A.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:d=>{var h,r;if(d&&d.$mid===11){const a=d.uri===void 0?void 0:w.URI.revive(d.uri);return(r=(h=this._itemsBySourceAndUriMap.get(d.source))===null||h===void 0?void 0:h.get(S(a)))===null||r===void 0?void 0:r.get(d.handle)}return d}})}async $getTimeline(i,P,d,h,r){const a=this._providers.get(i);return a==null?void 0:a.provideTimeline(w.URI.revive(P),d,h,r)}registerTimelineProvider(i,P,d,h){const r=new T.DisposableStore,a=this.convertTimelineItem(P.id,h,r).bind(this);let p;P.onDidChange&&(p=P.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:P.id})),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},P),{scheme:i,onDidChange:void 0,async provideTimeline(E,f,l,b){var t;(b==null?void 0:b.resetCache)&&(r.clear(),(t=m.get(P.id))===null||t===void 0||t.clear());const n=await P.provideTimeline(E,f,l);if(n!=null){const u=a(E,b);return Object.assign(Object.assign({},n),{source:P.id,items:n.items.map(u)})}},dispose(){var E;for(const f of m.values())(E=f.get(P.id))===null||E===void 0||E.clear();p==null||p.dispose(),r.dispose()}}))}convertTimelineItem(i,P,d){return(h,r)=>{let a;if(r==null?void 0:r.cacheResults){let p=this._itemsBySourceAndUriMap.get(i);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(i,p));const m=S(h);a=p.get(m),a===void 0&&(a=new Map,p.set(m,a))}return p=>{var m,E;const{iconPath:f}=p,l=Qt(p,["iconPath"]),b=`${i}|${(m=p.id)!==null&&m!==void 0?m:p.timestamp}`;a==null||a.set(b,p);let t,n,u;return p.iconPath&&(f instanceof y.ThemeIcon?u={id:f.id}:w.URI.isUri(f)?(t=f,n=f):{light:t,dark:n}=f),Object.assign(Object.assign({},l),{id:(E=l.id)!==null&&E!==void 0?E:void 0,handle:b,source:i,command:p.command?P.toInternal(p.command,d):void 0,icon:t,iconDark:n,themeIcon:u,accessibilityInformation:p.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,T.toDisposable)(()=>{var d;for(const h of this._itemsBySourceAndUriMap.values())(d=h.get(i.id))===null||d===void 0||d.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=D;function S(C){return C==null?void 0:C.toString()}}),define(we[208],_e([0,1,6,19,2,5]),function(Y,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(S){this._openers=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,C,i,P){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const d=P.schemes.find(h=>!y.supportedSchemes.has(h));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,i),this._proxy.$registerUriOpener(C,P.schemes,S,P.label),(0,w.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(S,C,i){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener with id: ${S}`);const d=A.URI.revive(C);return P.canOpenExternalUri(d,i)}async $openUri(S,C,i){const P=this._openers.get(S);if(!P)throw new Error(`Unknown opener id: '${S}'`);return P.openExternalUri(A.URI.revive(C.resolvedUri),{sourceUri:A.URI.revive(C.sourceUri)},i)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(we[209],_e([0,1,5,2,6,12,26]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(w.MainContext.MainThreadUrls)}registerUriHandler(C,i){if(this.handles.has(y.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const P=D.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(C)),this.handlers.set(P,i),this._proxy.$registerUriHandler(P,C),(0,A.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(C)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(C,i){const P=this.handlers.get(C);if(!P)return Promise.resolve(void 0);try{P.handleUri(I.URI.revive(i))}catch(d){(0,T.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(C){return I.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=D,D.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Y,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Y,w):A?A.value=w:e.set(Y,w),w},Me=this&&this.__classPrivateFieldGet||function(Y,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Y):I?I.value:e.get(Y)};define(we[50],_e([0,1,3,2,144,165,72,5]),function(Y,e,w,I,A,T,y,D){"use strict";var S,C,i,P,d,h,r,a,p,m,E,f;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(v,k,g,_,R,B,Q){S.set(this,void 0),C.set(this,void 0),i.set(this,void 0),P.set(this,void 0),d.set(this,void 0),h.set(this,void 0),r.set(this,""),a.set(this,void 0),p.set(this,!1),m.set(this,!1),E.set(this,!1),this._onMessageEmitter=new w.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,f.set(this,new w.Emitter),this._onDidDispose=Me(this,f,"f").event,tt(this,S,v,"f"),tt(this,C,k,"f"),tt(this,a,g,"f"),tt(this,P,_,"f"),tt(this,d,R,"f"),tt(this,h,B,"f"),tt(this,E,b(B),"f"),tt(this,i,Q,"f")}dispose(){tt(this,p,!0,"f"),Me(this,f,"f").fire(),Me(this,f,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return tt(this,m,!0,"f"),(0,y.asWebviewUri)(Me(this,P,"f"),Me(this,S,"f"),v)}get cspSource(){return Me(this,P,"f").webviewCspSource.replace("{{uuid}}",Me(this,S,"f"))}get html(){return this.assertNotDisposed(),Me(this,r,"f")}set html(v){this.assertNotDisposed(),Me(this,r,"f")!==v&&(tt(this,r,v,"f"),!Me(this,m,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(tt(this,m,!0,"f"),Me(this,i,"f").report("Webview vscode-resource: uris",Me(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,C,"f").$setHtml(Me(this,S,"f"),v))}get options(){return this.assertNotDisposed(),Me(this,a,"f")}set options(v){this.assertNotDisposed(),Me(this,C,"f").$setOptions(Me(this,S,"f"),u(Me(this,h,"f"),Me(this,d,"f"),v)),tt(this,a,v,"f")}async postMessage(v){if(Me(this,p,"f"))return!1;const k=(0,T.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:Me(this,E,"f")});return Me(this,C,"f").$postMessage(Me(this,S,"f"),k.message,...k.buffers)}assertNotDisposed(){if(Me(this,p,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=l,S=new WeakMap,C=new WeakMap,i=new WeakMap,P=new WeakMap,d=new WeakMap,h=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap,m=new WeakMap,E=new WeakMap,f=new WeakMap;function b(c){try{const v=(0,A.normalizeVersion)((0,A.parseVersion)(c.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch(v){return!1}}e.shouldSerializeBuffersForPostMessage=b;class t{constructor(v,k,g,_,R){this.initData=k,this.workspace=g,this._logService=_,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=v.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(v,k,...g){const _=this.getWebview(v);if(_){const{message:R}=(0,T.deserializeWebviewMessage)(k,g);_._onMessageEmitter.fire(R)}}$onMissingCsp(v,k){this._logService.warn(`${k} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,k,g){const _=new l(v,this._webviewProxy,o(k),this.initData,this.workspace,g,this._deprecationService);return this._webviews.set(v,_),_._onDidDispose(()=>{this._webviews.delete(v)}),_}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=t;function n(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=n;function u(c,v,k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots||s(c,v)}}e.serializeWebviewOptions=u;function o(c){var v;return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,portMapping:c.portMapping,localResourceRoots:(v=c.localResourceRoots)===null||v===void 0?void 0:v.map(k=>I.URI.from(k))}}e.reviveOptions=o;function s(c,v){return[...((v==null?void 0:v.getWorkspaceFolders())||[]).map(k=>k.uri),c.extensionLocation]}}),define(we[210],_e([0,1,20,56,6,19,25,2,9,50,68,5,7]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class r{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,u){const o=this.key(t,n.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const s=new h(n,u);return this._documents.set(o,s),s}delete(t,n){const u=this.key(t,n.uri);this._documents.delete(u)}key(t,n){return`${t}@@@${n}`}}var a;(function(b){b[b.Text=0]="Text",b[b.Custom=1]="Custom"})(a||(a={}));class p{constructor(){this._providers=new Map}addTextProvider(t,n,u){return this.add(0,t,n,u)}addCustomProvider(t,n,u){return this.add(1,t,n,u)}get(t){return this._providers.get(t)}add(t,n,u,o){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:u,provider:o}),new d.Disposable(()=>this._providers.delete(n))}}class m{constructor(t,n,u,o,s){this._extHostDocuments=n,this._extensionStoragePaths=u,this._extHostWebview=o,this._extHostWebviewPanels=s,this._editorProviders=new p,this._documents=new r,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,u,o){const s=new A.DisposableStore;return E(u)?(s.add(this._editorProviders.addTextProvider(n,t,u)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(t),n,o.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(t))):(s.add(this._editorProviders.addCustomProvider(n,t,u)),this.supportEditing(u)&&s.add(u.onDidChangeCustomDocument(c=>{const v=this.getCustomDocumentEntry(n,c.document.uri);if(f(c)){const k=v.addEdit(c);this._proxy.$onDidEdit(c.document.uri,n,k,c.label)}else this._proxy.$onContentChange(c.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(t),n,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(s,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,u,o,s){var c;const v=this._editorProviders.get(n);if(!v)throw new Error(`No provider found for '${n}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${n}'`);const k=D.URI.revive(t),g=await v.provider.openCustomDocument(k,{backupId:u,untitledDocumentData:o==null?void 0:o.buffer},s);let _;return this.supportEditing(v.provider)&&this._extensionStoragePaths&&(_=(c=this._extensionStoragePaths.workspaceValue(v.extension))!==null&&c!==void 0?c:this._extensionStoragePaths.globalValue(v.extension)),this._documents.add(n,g,_),{editable:this.supportEditing(v.provider)}}async $disposeCustomDocument(t,n){const u=this._editorProviders.get(n);if(!u)throw new Error(`No provider found for '${n}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${n}'`);const o=D.URI.revive(t),{document:s}=this.getCustomDocumentEntry(n,o);this._documents.delete(n,s),s.dispose()}async $resolveWebviewEditor(t,n,u,o,s,c){const v=this._editorProviders.get(u);if(!v)throw new Error(`No provider found for '${u}'`);const k=S.ViewColumn.to(s),g=this._extHostWebview.createNewWebview(n,o.webviewOptions,v.extension),_=this._extHostWebviewPanels.createNewWebviewPanel(n,u,o.title,k,o.panelOptions,g),R=D.URI.revive(t);switch(v.type){case 1:{const{document:B}=this.getCustomDocumentEntry(u,R);return v.provider.resolveCustomEditor(B,_,c)}case 0:{const B=this._extHostDocuments.getDocument(R);return v.provider.resolveCustomTextEditor(B,_,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,u){this.getCustomDocumentEntry(n,t).disposeEdits(u)}async $onMoveCustomEditor(t,n,u){const o=this._editorProviders.get(u);if(!o)throw new Error(`No provider found for '${u}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const c=D.URI.revive(n),v=this._extHostDocuments.getDocument(c);await o.provider.moveCustomTextEditor(v,s,w.CancellationToken.None)}async $undo(t,n,u,o){return this.getCustomDocumentEntry(n,t).undo(u,o)}async $redo(t,n,u,o){return this.getCustomDocumentEntry(n,t).redo(u,o)}async $revert(t,n,u){const o=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(o.document,u),o.disposeBackup()}async $onSave(t,n,u){const o=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(o.document,u),o.disposeBackup()}async $onSaveAs(t,n,u,o){const s=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(s.document,D.URI.revive(u),o)}async $backup(t,n,u){const o=this.getCustomDocumentEntry(n,t),c=await this.getCustomEditorProvider(n).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},u);return o.updateBackup(c),c.id}getCustomDocumentEntry(t,n){const u=this._documents.get(t,D.URI.revive(n));if(!u)throw new Error("No custom document found");return u}getCustomEditorProvider(t){const n=this._editorProviders.get(t),u=n==null?void 0:n.provider;if(!u||!this.supportEditing(u))throw new Error("Custom document is not editable");return u}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function E(b){return typeof b.resolveCustomTextEditor=="function"}function f(b){return typeof b.undo=="function"&&typeof b.redo=="function"}function l(b){const t=b.scheme===T.Schemas.file||b.scheme===T.Schemas.untitled?b.fsPath:b.toString();return(0,I.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(Y,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Y,w):A?A.value=w:e.set(Y,w),w},Me=this&&this.__classPrivateFieldGet||function(Y,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Y):I?I.value:e.get(Y)};define(we[211],_e([0,1,3,6,2,31,9,50,5,7]),function(Y,e,w,I,A,T,y,D,S,C){"use strict";var i,P,d,h,r,a,p,m,E,f,l,b,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends I.Disposable{constructor(c,v,k,g,_,R,B){super();i.set(this,void 0),P.set(this,void 0),d.set(this,void 0),h.set(this,void 0),r.set(this,void 0),a.set(this,void 0),p.set(this,void 0),m.set(this,void 0),E.set(this,!0),f.set(this,!0),l.set(this,!1),b.set(this,this._register(new w.Emitter)),this.onDidDispose=Me(this,b,"f").event,t.set(this,this._register(new w.Emitter)),this.onDidChangeViewState=Me(this,t,"f").event,tt(this,i,c,"f"),tt(this,P,v,"f"),tt(this,d,k,"f"),tt(this,r,R,"f"),tt(this,m,_,"f"),tt(this,a,g,"f"),tt(this,h,B,"f")}dispose(){Me(this,l,"f")||(tt(this,l,!0,"f"),Me(this,b,"f").fire(),Me(this,P,"f").$disposeWebview(Me(this,i,"f")),Me(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,h,"f")}get viewType(){return this.assertNotDisposed(),Me(this,d,"f")}get title(){return this.assertNotDisposed(),Me(this,a,"f")}set title(c){this.assertNotDisposed(),Me(this,a,"f")!==c&&(tt(this,a,c,"f"),Me(this,P,"f").$setTitle(Me(this,i,"f"),c))}get iconPath(){return this.assertNotDisposed(),Me(this,p,"f")}set iconPath(c){this.assertNotDisposed(),Me(this,p,"f")!==c&&(tt(this,p,c,"f"),Me(this,P,"f").$setIconPath(Me(this,i,"f"),A.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Me(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,m,"f")=="number"&&Me(this,m,"f")<0))return Me(this,m,"f")}get active(){return this.assertNotDisposed(),Me(this,f,"f")}get visible(){return this.assertNotDisposed(),Me(this,E,"f")}_updateViewState(c){Me(this,l,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(tt(this,f,c.active,"f"),tt(this,E,c.visible,"f"),tt(this,m,c.viewColumn,"f"),Me(this,t,"f").fire({webviewPanel:this}))}reveal(c,v){this.assertNotDisposed(),Me(this,P,"f").$reveal(Me(this,i,"f"),{viewColumn:c?y.ViewColumn.from(c):void 0,preserveFocus:!!v})}assertNotDisposed(){if(Me(this,l,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,P=new WeakMap,d=new WeakMap,h=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap,m=new WeakMap,E=new WeakMap,f=new WeakMap,l=new WeakMap,b=new WeakMap,t=new WeakMap;class u{constructor(c,v,k){this.webviews=v,this.workspace=k,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(c,v,k,g,_={}){const R=typeof g=="object"?g.viewColumn:g,B={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof g=="object"&&!!g.preserveFocus},Q=(0,D.shouldSerializeBuffersForPostMessage)(c),ge=u.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(c),ge,v,{title:k,panelOptions:o(_),webviewOptions:(0,D.serializeWebviewOptions)(c,this.workspace,_),serializeBuffersForPostMessage:Q},B);const V=this.webviews.createNewWebview(ge,_,c);return this.createNewWebviewPanel(ge,v,k,R,_,V)}$onDidChangeWebviewPanelViewStates(c){const v=Object.keys(c);v.sort((k,g)=>{const _=c[k],R=c[g];return _.active?1:R.active?-1:+_.visible-+R.visible});for(const k of v){const g=this.getWebviewPanel(k);if(!!g){const _=c[k];g._updateViewState({active:_.active,visible:_.visible,viewColumn:y.ViewColumn.to(_.position)})}}}async $onDidDisposeWebviewPanel(c){const v=this.getWebviewPanel(c);v==null||v.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,v,k){if(this._serializers.has(v))throw new Error(`Serializer for '${v}' already registered`);return this._serializers.set(v,{serializer:k,extension:c}),this._proxy.$registerSerializer(v,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(c)}),new C.Disposable(()=>{this._serializers.delete(v),this._proxy.$unregisterSerializer(v)})}async $deserializeWebviewPanel(c,v,k,g){const _=this._serializers.get(v);if(!_)throw new Error(`No serializer found for '${v}'`);const{serializer:R,extension:B}=_,Q=this.webviews.createNewWebview(c,k.webviewOptions,B),ge=this.createNewWebviewPanel(c,v,k.title,g,k.panelOptions,Q);await R.deserializeWebviewPanel(ge,k.state)}createNewWebviewPanel(c,v,k,g,_,R){const B=new n(c,this._proxy,v,k,g,_,R);return this._webviewPanels.set(c,B),B}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=u;function o(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Y,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Y,w):A?A.value=w:e.set(Y,w),w},Me=this&&this.__classPrivateFieldGet||function(Y,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Y):I?I.value:e.get(Y)};define(we[212],_e([0,1,3,6,50,5,7]),function(Y,e,w,I,A,T,y){"use strict";var D,S,C,i,P,d,h,r,a,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends I.Disposable{constructor(l,b,t,n,u,o){super();D.set(this,void 0),S.set(this,void 0),C.set(this,void 0),i.set(this,void 0),P.set(this,!1),d.set(this,void 0),h.set(this,void 0),r.set(this,void 0),a.set(this,this._register(new w.Emitter)),this.onDidChangeVisibility=Me(this,a,"f").event,p.set(this,this._register(new w.Emitter)),this.onDidDispose=Me(this,p,"f").event,tt(this,C,t,"f"),tt(this,h,n,"f"),tt(this,D,l,"f"),tt(this,S,b,"f"),tt(this,i,u,"f"),tt(this,d,o,"f")}dispose(){Me(this,P,"f")||(tt(this,P,!0,"f"),Me(this,p,"f").fire(),Me(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,h,"f")}set title(l){this.assertNotDisposed(),Me(this,h,"f")!==l&&(tt(this,h,l,"f"),Me(this,S,"f").$setWebviewViewTitle(Me(this,D,"f"),l))}get description(){return this.assertNotDisposed(),Me(this,r,"f")}set description(l){this.assertNotDisposed(),Me(this,r,"f")!==l&&(tt(this,r,l,"f"),Me(this,S,"f").$setWebviewViewDescription(Me(this,D,"f"),l))}get visible(){return Me(this,d,"f")}get webview(){return Me(this,i,"f")}get viewType(){return Me(this,C,"f")}_setVisible(l){l===Me(this,d,"f")||Me(this,P,"f")||(tt(this,d,l,"f"),Me(this,a,"f").fire())}show(l){this.assertNotDisposed(),Me(this,S,"f").$show(Me(this,D,"f"),!!l)}assertNotDisposed(){if(Me(this,P,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,S=new WeakMap,C=new WeakMap,i=new WeakMap,P=new WeakMap,d=new WeakMap,h=new WeakMap,r=new WeakMap,a=new WeakMap,p=new WeakMap;class E{constructor(l,b){this._extHostWebview=b,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=l.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(l,b,t,n){if(this._viewProviders.has(b))throw new Error(`View provider for '${b}' already registered`);return this._viewProviders.set(b,{provider:t,extension:l}),this._proxy.$registerWebviewViewProvider((0,A.toExtensionData)(l),b,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(b),this._proxy.$unregisterWebviewViewProvider(b)})}async $resolveWebviewView(l,b,t,n,u){const o=this._viewProviders.get(b);if(!o)throw new Error(`No view provider found for '${b}'`);const{provider:s,extension:c}=o,v=this._extHostWebview.createNewWebview(l,{},c),k=new m(l,this._proxy,b,t,v,!0);this._webviewViews.set(l,k),await s.resolveWebviewView(k,{state:n},u)}async $onDidChangeWebviewViewVisibility(l,b){this.getWebviewView(l)._setVisible(b)}async $disposeWebviewView(l){const b=this.getWebviewView(l);this._webviewViews.delete(l),b.dispose(),this._extHostWebview.deleteWebview(l)}getWebviewView(l){const b=this._webviewViews.get(l);if(!b)throw new Error("No webview found");return b}}e.ExtHostWebviewViews=E}),define(we[101],_e([0,1,3,5,2,19,8,4,14]),function(Y,e,w,I,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Fn{constructor(P){this._onDidChangeWindowState=new w.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Fn.InitialState,this._proxy=P.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:P}),this._onDidChangeWindowState.fire(this._state))}openUri(P,d){let h;if(typeof P=="string"){h=P;try{P=A.URI.parse(P)}catch(r){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,y.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,h,d)}async asExternalUri(P,d){if((0,y.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(P.scheme))return Promise.reject(`Invalid scheme '${P.scheme}'`);const h=await this._proxy.$asExternalUri(P,d);return A.URI.from(h)}};C.InitialState={focused:!0},C=Ve([qe(0,S.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(we[213],_e([0,1,18,5,27,14]),function(Y,e,w,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let y=class extends w.AbstractLogger{constructor(S,C){super();this._proxy=S.getProxy(I.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(S){this.setLevel(S)}trace(S,...C){this.getLevel()<=w.LogLevel.Trace&&this._proxy.$log(this._logFile,w.LogLevel.Trace,Array.from(arguments))}debug(S,...C){this.getLevel()<=w.LogLevel.Debug&&this._proxy.$log(this._logFile,w.LogLevel.Debug,Array.from(arguments))}info(S,...C){this.getLevel()<=w.LogLevel.Info&&this._proxy.$log(this._logFile,w.LogLevel.Info,Array.from(arguments))}warn(S,...C){this.getLevel()<=w.LogLevel.Warning&&this._proxy.$log(this._logFile,w.LogLevel.Warning,Array.from(arguments))}error(S,...C){this.getLevel()<=w.LogLevel.Error&&this._proxy.$log(this._logFile,w.LogLevel.Error,Array.from(arguments))}critical(S,...C){this.getLevel()<=w.LogLevel.Critical&&this._proxy.$log(this._logFile,w.LogLevel.Critical,Array.from(arguments))}flush(){}};y=Ve([qe(0,T.IExtHostRpcService),qe(1,A.IExtHostInitDataService)],y),e.ExtHostLogService=y}),define(we[214],_e([0,1,11,20,12,3,6,113,186,98,24]),function(Y,e,w,I,A,T,y,D,S,C,i){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function d(o,s){try{return JSON.stringify(o,s)}catch(c){return"null"}}function h(o,s){return JSON.stringify(o,s)}function r(o){return o?(s,c)=>c&&c.$mid===1?o.transformOutgoing(c):c:null}var a;(function(o){o[o.LocalSide=0]="LocalSide",o[o.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(o){o[o.Responsive=0]="Responsive",o[o.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const m=()=>{},E=Symbol.for("rpcProtocol"),f=Symbol.for("rpcProxy");class l extends y.Disposable{constructor(s,c=null,v=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=s,this._logger=c,this._uriTransformer=v,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let k=0,g=C.ProxyIdentifier.count;k<g;k++)this._locals[k]=null,this._proxies[k]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new w.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(k=>this._receiveOneMessage(k))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(s=>{this._pendingRPCReplies[s].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(s){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(s){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(s){this._responsiveState!==s&&(this._responsiveState=s,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(s){return this._uriTransformer?(0,D.transformIncomingURIs)(s,this._uriTransformer):s}getProxy(s){const{nid:c,sid:v}=s;return this._proxies[c]||(this._proxies[c]=this._createProxy(c,v)),this._proxies[c]}_createProxy(s,c){let v={get:(k,g)=>(typeof g=="string"&&!k[g]&&g.charCodeAt(0)===36&&(k[g]=(..._)=>this._remoteCall(s,g,_)),g===f?c:k[g])};return new Proxy(Object.create(null),v)}set(s,c){return this._locals[s.nid]=c,c}assertRegistered(s){for(let c=0,v=s.length;c<v;c++){const k=s[c];if(!this._locals[k.nid])throw new Error(`Missing actor ${k.sid} (isMain: ${k.isMain})`)}}_receiveOneMessage(s){if(!this._isDisposed){const c=s.byteLength,v=b.read(s,0),k=v.readUInt8(),g=v.readUInt32();switch(k){case 1:case 2:{let{rpcId:_,method:R,args:B}=t.deserializeRequestJSONArgs(v);this._uriTransformer&&(B=(0,D.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(c,g,_,R,B,k===2);break}case 3:case 4:{let{rpcId:_,method:R,args:B}=t.deserializeRequestMixedArgs(v);this._uriTransformer&&(B=(0,D.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(c,g,_,R,B,k===4);break}case 5:{this._logger&&this._logger.logIncoming(c,g,0,"ack"),this._onDidReceiveAcknowledge(g);break}case 6:{this._receiveCancel(c,g);break}case 7:{this._receiveReply(c,g,void 0);break}case 9:{let _=t.deserializeReplyOKJSON(v);this._uriTransformer&&(_=(0,D.transformIncomingURIs)(_,this._uriTransformer)),this._receiveReply(c,g,_);break}case 8:{let _=t.deserializeReplyOKVSBuffer(v);this._receiveReply(c,g,_);break}case 10:{let _=t.deserializeReplyErrError(v);this._uriTransformer&&(_=(0,D.transformIncomingURIs)(_,this._uriTransformer)),this._receiveReplyErr(c,g,_);break}case 11:{this._receiveReplyErr(c,g,void 0);break}default:console.error("received unexpected message"),console.error(s)}}}_receiveRequest(s,c,v,k,g,_){this._logger&&this._logger.logIncoming(s,c,1,`receiveRequest ${(0,C.getStringIdentifierForProxy)(v)}.${k}(`,g);const R=String(c);let B,Q;if(_){const V=new I.CancellationTokenSource;g.push(V.token),B=this._invokeHandler(v,k,g),Q=()=>V.cancel()}else B=this._invokeHandler(v,k,g),Q=m;this._cancelInvokedHandlers[R]=Q;const ge=t.serializeAcknowledged(c);this._logger&&this._logger.logOutgoing(ge.byteLength,c,1,"ack"),this._protocol.send(ge),B.then(V=>{delete this._cancelInvokedHandlers[R];const H=t.serializeReplyOK(c,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(H.byteLength,c,1,"reply:",V),this._protocol.send(H)},V=>{delete this._cancelInvokedHandlers[R];const H=t.serializeReplyErr(c,V);this._logger&&this._logger.logOutgoing(H.byteLength,c,1,"replyErr:",V),this._protocol.send(H)})}_receiveCancel(s,c){this._logger&&this._logger.logIncoming(s,c,1,"receiveCancel");const v=String(c);this._cancelInvokedHandlers[v]&&this._cancelInvokedHandlers[v]()}_receiveReply(s,c,v){this._logger&&this._logger.logIncoming(s,c,0,"receiveReply:",v);const k=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(k)){const g=this._pendingRPCReplies[k];delete this._pendingRPCReplies[k],g.resolveOk(v)}}_receiveReplyErr(s,c,v){this._logger&&this._logger.logIncoming(s,c,0,"receiveReplyErr:",v);const k=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(k)){const g=this._pendingRPCReplies[k];delete this._pendingRPCReplies[k];let _;v&&(v.$isError?(_=new Error,_.name=v.name,_.message=v.message,_.stack=v.stack):_=v),g.resolveErr(_)}}_invokeHandler(s,c,v){try{return Promise.resolve(this._doInvokeHandler(s,c,v))}catch(k){return Promise.reject(k)}}_doInvokeHandler(s,c,v){const k=this._locals[s];if(!k)throw new Error("Unknown actor "+(0,C.getStringIdentifierForProxy)(s));let g=k[c];if(typeof g!="function")throw new Error("Unknown method "+c+" on actor "+(0,C.getStringIdentifierForProxy)(s));return g.apply(k,v)}_remoteCall(s,c,v){if(this._isDisposed)return Promise.reject(A.canceled());let k=null;if(v.length>0&&I.CancellationToken.isCancellationToken(v[v.length-1])&&(k=v.pop()),k&&k.isCancellationRequested)return Promise.reject(A.canceled());const g=t.serializeRequestArguments(v,this._uriReplacer),_=++this._lastMessageId,R=String(_),B=new S.LazyPromise;k&&k.onCancellationRequested(()=>{const ge=t.serializeCancel(_);this._logger&&this._logger.logOutgoing(ge.byteLength,_,0,"cancel"),this._protocol.send(t.serializeCancel(_))}),this._pendingRPCReplies[R]=B,this._onWillSendRequest(_);const Q=t.serializeRequest(_,s,c,g,!!k);return this._logger&&this._logger.logOutgoing(Q.byteLength,_,0,`request: ${(0,C.getStringIdentifierForProxy)(s)}.${c}(`,v),this._protocol.send(Q),B}}e.RPCProtocol=l,P=E,l.UNRESPONSIVE_TIME=3*1e3;class b{constructor(s,c){this._buff=s,this._offset=c}static alloc(s,c,v){let k=new b(i.VSBuffer.alloc(v+1+4),0);return k.writeUInt8(s),k.writeUInt32(c),k}static read(s,c){return new b(s,c)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(s){this._buff.writeUInt8(s,this._offset),this._offset+=1}readUInt8(){const s=this._buff.readUInt8(this._offset);return this._offset+=1,s}writeUInt32(s){this._buff.writeUInt32BE(s,this._offset),this._offset+=4}readUInt32(){const s=this._buff.readUInt32BE(this._offset);return this._offset+=4,s}static sizeShortString(s){return 1+s.byteLength}writeShortString(s){this._buff.writeUInt8(s.byteLength,this._offset),this._offset+=1,this._buff.set(s,this._offset),this._offset+=s.byteLength}readShortString(){const s=this._buff.readUInt8(this._offset);this._offset+=1;const v=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,v}static sizeLongString(s){return 4+s.byteLength}writeLongString(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readLongString(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,v}writeBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}static sizeVSBuffer(s){return 4+s.byteLength}writeVSBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readVSBuffer(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const c=this._buff.slice(this._offset,this._offset+s);return this._offset+=s,c}static sizeMixedArray(s,c){let v=0;v+=1;for(let k=0,g=s.length;k<g;k++){const _=s[k],R=c[k];switch(v+=1,R){case 1:v+=this.sizeLongString(_);break;case 2:v+=this.sizeVSBuffer(_);break;case 3:break}}return v}writeMixedArray(s,c){this._buff.writeUInt8(s.length,this._offset),this._offset+=1;for(let v=0,k=s.length;v<k;v++){const g=s[v];switch(c[v]){case 1:this.writeUInt8(1),this.writeLongString(g);break;case 2:this.writeUInt8(2),this.writeVSBuffer(g);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const s=this._buff.readUInt8(this._offset);this._offset+=1;let c=new Array(s);for(let v=0;v<s;v++)switch(this.readUInt8()){case 1:c[v]=this.readLongString();break;case 2:c[v]=this.readVSBuffer();break;case 3:c[v]=void 0;break}return c}}class t{static _arrayContainsBufferOrUndefined(s){for(let c=0,v=s.length;c<v;c++)if(s[c]instanceof i.VSBuffer||typeof s[c]=="undefined")return!0;return!1}static serializeRequestArguments(s,c){if(this._arrayContainsBufferOrUndefined(s)){let v=[],k=[];for(let g=0,_=s.length;g<_;g++){const R=s[g];R instanceof i.VSBuffer?(v[g]=R,k[g]=2):typeof R=="undefined"?(v[g]=i.VSBuffer.alloc(0),k[g]=3):(v[g]=i.VSBuffer.fromString(h(R,c)),k[g]=1)}return{type:"mixed",args:v,argsType:k}}return{type:"simple",args:h(s,c)}}static serializeRequest(s,c,v,k,g){return k.type==="mixed"?this._requestMixedArgs(s,c,v,k.args,k.argsType,g):this._requestJSONArgs(s,c,v,k.args,g)}static _requestJSONArgs(s,c,v,k,g){const _=i.VSBuffer.fromString(v),R=i.VSBuffer.fromString(k);let B=0;B+=b.sizeUInt8(),B+=b.sizeShortString(_),B+=b.sizeLongString(R);let Q=b.alloc(g?2:1,s,B);return Q.writeUInt8(c),Q.writeShortString(_),Q.writeLongString(R),Q.buffer}static deserializeRequestJSONArgs(s){const c=s.readUInt8(),v=s.readShortString(),k=s.readLongString();return{rpcId:c,method:v,args:JSON.parse(k)}}static _requestMixedArgs(s,c,v,k,g,_){const R=i.VSBuffer.fromString(v);let B=0;B+=b.sizeUInt8(),B+=b.sizeShortString(R),B+=b.sizeMixedArray(k,g);let Q=b.alloc(_?4:3,s,B);return Q.writeUInt8(c),Q.writeShortString(R),Q.writeMixedArray(k,g),Q.buffer}static deserializeRequestMixedArgs(s){const c=s.readUInt8(),v=s.readShortString(),k=s.readMixedArray(),g=new Array(k.length);for(let _=0,R=k.length;_<R;_++){const B=k[_];typeof B=="string"?g[_]=JSON.parse(B):g[_]=B}return{rpcId:c,method:v,args:g}}static serializeAcknowledged(s){return b.alloc(5,s,0).buffer}static serializeCancel(s){return b.alloc(6,s,0).buffer}static serializeReplyOK(s,c,v){return typeof c=="undefined"?this._serializeReplyOKEmpty(s):c instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(s,c):this._serializeReplyOKJSON(s,d(c,v))}static _serializeReplyOKEmpty(s){return b.alloc(7,s,0).buffer}static _serializeReplyOKVSBuffer(s,c){let v=0;v+=b.sizeVSBuffer(c);let k=b.alloc(8,s,v);return k.writeVSBuffer(c),k.buffer}static deserializeReplyOKVSBuffer(s){return s.readVSBuffer()}static _serializeReplyOKJSON(s,c){const v=i.VSBuffer.fromString(c);let k=0;k+=b.sizeLongString(v);let g=b.alloc(9,s,k);return g.writeLongString(v),g.buffer}static deserializeReplyOKJSON(s){const c=s.readLongString();return JSON.parse(c)}static serializeReplyErr(s,c){return c?this._serializeReplyErrEror(s,c):this._serializeReplyErrEmpty(s)}static _serializeReplyErrEror(s,c){const v=i.VSBuffer.fromString(d(A.transformErrorForSerialization(c),null));let k=0;k+=b.sizeLongString(v);let g=b.alloc(10,s,k);return g.writeLongString(v),g.buffer}static deserializeReplyErrError(s){const c=s.readLongString();return JSON.parse(c)}static _serializeReplyErrEmpty(s){return b.alloc(11,s,0).buffer}}var n;(function(o){o[o.RequestJSONArgs=1]="RequestJSONArgs",o[o.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",o[o.RequestMixedArgs=3]="RequestMixedArgs",o[o.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",o[o.Acknowledged=5]="Acknowledged",o[o.Cancel=6]="Cancel",o[o.ReplyOKEmpty=7]="ReplyOKEmpty",o[o.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",o[o.ReplyOKJSON=9]="ReplyOKJSON",o[o.ReplyErrError=10]="ReplyErrError",o[o.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var u;(function(o){o[o.String=1]="String",o[o.VSBuffer=2]="VSBuffer",o[o.Undefined=3]="Undefined"})(u||(u={}))}),define(we[215],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const w=function(T){const y=D=>{self.removeEventListener("message",y);const S=D.data;Object.defineProperties(self,{postMessage:{value(C,i){S.postMessage(C,i)}},onmessage:{get(){return S.onmessage},set(C){S.onmessage=C}}}),S.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",y)}.toString();class I extends EventTarget{constructor(T,y,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${w})('${y}'))`,C=new Blob([S],{type:"application/javascript"}),i=URL.createObjectURL(C),P=new MessageChannel,d=i,h={type:"_newWorker",id:d,port:P.port2,url:i,options:D};T(h,[P.port2]),this.postMessage=P.port1.postMessage.bind(P.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:d};P.port1.postMessage(r),URL.revokeObjectURL(i),P.port1.close(),P.port2.close()},Object.defineProperties(this,{onmessage:{get(){return P.port1.onmessage},set(r){P.port1.onmessage=r}},onmessageerror:{get(){return P.port1.onmessageerror},set(r){P.port1.onmessageerror=r}}}),P.port1.addEventListener("messageerror",r=>{const a=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(a)}),P.port1.addEventListener("message",r=>{const a=new MessageEvent("message",{data:r.data});this.dispatchEvent(a)}),P.port1.start()}}e.NestedWorker=I}),define(we[216],_e([0,1,4]),function(Y,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,w.createDecorator)("remoteAgentService")}),define(we[217],_e([0,1,19,13,21,2,4,216]),function(Y,e,w,I,A,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let S=class{constructor(i,P){this.localUserHome=i,this.remoteAgentService=P,this.resolveOS=(async()=>{const d=await this.remoteAgentService.getEnvironment();return(d==null?void 0:d.os)||A.OS})(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(d==null?void 0:d.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?I.win32:I.posix)}async fileURI(i){let P="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const h=i.indexOf("/",2);h===-1?(P=i.substring(2),i="/"):(P=i.substring(2,h),i=i.substring(h)||"/")}return T.URI.from({scheme:w.Schemas.file,authority:P,path:i,query:"",fragment:""})}};S=Ve([qe(1,D.IRemoteAgentService)],S),e.AbstractPathService=S}),define(we[102],_e([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class w{constructor(y,D){this.line=y,this.character=D}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,D){return new w(0,0)}with(y){return new w(0,0)}}e.Position=w;class I{constructor(y,D,S,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(y,D),this.end=new w(S,C)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new I(0,0,0,0)}with(y){return new I(0,0,0,0)}}e.Range=I;var A;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(A=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[41],_e([0,1,15,28,23,37,8,4,13,12,102]),function(Y,e,w,I,A,T,y,D,S,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",d=" characters skipped \u27EB",h=(P.length+d.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var r;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(r=e.SearchProviderType||(e.SearchProviderType={}));var a;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(a=e.QueryType||(e.QueryType={}));function p(F){return!!F.preview}e.resultIsMatch=p;function m(F){return!!F.resource}e.isFileMatch=m;function E(F){return!!F.message}e.isProgressMessage=E;var f;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(f=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class l{constructor(L){this.resource=L,this.results=[]}}e.FileMatch=l;class b{constructor(L,M,U){this.ranges=M;const G=Array.isArray(M)?M:[M];if(U&&U.matchLines===1&&t(G)){L=(0,y.getNLines)(L,U.matchLines);let J="",re=0,pe=0;const Te=Math.floor(U.charsPerLine/5),Be=[];for(const Ae of G){const We=Math.max(Ae.startColumn-Te,0),x=Ae.startColumn+U.charsPerLine;if(We>pe+Te+h){const q=P+(We-pe)+d;J+=q+L.slice(We,x),re+=We-(pe+q.length)}else J+=L.slice(pe,x);Be.push(new u(0,Ae.startColumn-re,Ae.endColumn-re)),pe=x}this.preview={text:J,matches:Array.isArray(this.ranges)?Be:Be[0]}}else{const J=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:L,matches:(0,w.mapArrayOrNot)(M,re=>new n(re.startLineNumber-J,re.startColumn,re.endLineNumber-J,re.endColumn))}}}}e.TextSearchMatch=b;function t(F){const L=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==L||M.endLineNumber!==L)return!1;return!0}class n{constructor(L,M,U,G){this.startLineNumber=L,this.startColumn=M,this.endLineNumber=U,this.endColumn=G}}e.SearchRange=n;class u extends n{constructor(L,M,U){super(L,M,L,U)}}e.OneLineRange=u;var o;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function s(F,L=!0){const M=F&&F.files&&F.files.exclude,U=L&&F&&F.search&&F.search.exclude;if(!(!M&&!U)){if(!M||!U)return M||U;let G=Object.create(null);return G=A.mixin(G,A.deepClone(M)),G=A.mixin(G,A.deepClone(U),!0),G}}e.getExcludes=s;function c(F,L){return F.excludePattern&&I.match(F.excludePattern,L)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&I.match(F.includePattern,L)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const U=M.folder.fsPath;if(T.isEqualOrParent(L,U)){const G=S.relative(U,L);return!M.includePattern||!!I.match(M.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var v;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class k extends Error{constructor(L,M){super(L);this.code=M}}e.SearchError=k;function g(F){const L=F.message;if((0,C.isPromiseCanceledError)(F))return new k(L,v.canceled);try{const M=JSON.parse(L);return new k(M.message,M.code)}catch(M){return new k(L,v.other)}}e.deserializeSearchError=g;function _(F){const L={message:F.message,code:F.code};return new Error(JSON.stringify(L))}e.serializeSearchError=_;function R(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=R;function B(F){return F.type==="success"}e.isSerializedSearchSuccess=B;function Q(F){return!!F.path}e.isSerializedFileMatch=Q;function ge(F,L){const M=F.searchPath?F.searchPath:F.relativePath;return(0,y.fuzzyContains)(M,L)}e.isFilePatternMatch=ge;class V{constructor(L){this.path=L,this.results=[]}addMatch(L){this.results.push(L)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=V;function H(F,L){const M=Object.assign(Object.assign({},F||{}),L||{});return Object.keys(M).filter(U=>{const G=M[U];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=H;class te{constructor(L,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},L.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let U=L.includePattern;M.includePattern&&(U?U=Object.assign(Object.assign({},U),M.includePattern):U=M.includePattern),U&&(this._parsedIncludeExpression=I.parse(U))}includedInQuerySync(L,M,U){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(L,M,U)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(L,M,U))}includedInQuery(L,M,U){return Promise.resolve(this._parsedExcludeExpression(L,M,U)).then(J=>!!J).then(J=>J?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(L,M,U)).then(re=>!!re):Promise.resolve(!0)).then(J=>J)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=te;function $(F){for(const L in F)if(typeof F[L]!="boolean")return!0;return!1}}),define(we[30],_e([0,1,15,11,20,3,22,19,81,25,8,10,2,137,4,18,152,48,49,27,14,7,41,5]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r,a,p,m,E,f,l,b,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(R,B,Q){return new C.ExtUri(ge=>v(ge,Q)).isEqual(R,B)}function o(R,B,Q){return u(R.uri,B.uri,Q)?0:(0,i.compare)(R.uri.toString(),B.uri.toString())}function s(R,B,Q){return R.index!==B.index?R.index<B.index?-1:1:u(R.uri,B.uri,Q)?(0,i.compare)(R.name,B.name):(0,i.compare)(R.uri.toString(),B.uri.toString())}function c(R,B,Q,ge){const V=R.slice(0).sort((te,$)=>Q(te,$,ge)),H=B.slice(0).sort((te,$)=>Q(te,$,ge));return(0,w.delta)(V,H,(te,$)=>Q(te,$,ge))}function v(R,B){const Q=B.getCapabilities(R.scheme);return!(Q&&Q&1024)}class k extends m.Workspace{constructor(B,Q,ge,V,H,te){super(B,ge.map($=>new m.WorkspaceFolder($)),V,te);this._name=Q,this._isUntitled=H,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(te),ge.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(B,Q,ge,V){if(!B)return{workspace:null,added:[],removed:[]};const{id:H,name:te,folders:$,configuration:F,isUntitled:L}=B,M=[],U=Q;Q?$.forEach((pe,Te)=>{const Be=d.URI.revive(pe.uri),Ae=k._findFolder(ge||Q,Be,V);Ae?(Ae.name=pe.name,Ae.index=pe.index,M.push(Ae)):M.push({uri:Be,name:pe.name,index:Te})}):M.push(...$.map(({uri:pe,name:Te,index:Be})=>({uri:d.URI.revive(pe),name:Te,index:Be}))),M.sort((pe,Te)=>pe.index<Te.index?-1:1);const G=new k(H,te,M,F?d.URI.revive(F):null,!!L,pe=>v(pe,V)),{added:J,removed:re}=c(U?U.workspaceFolders:[],G.workspaceFolders,o,V);return{workspace:G,added:J,removed:re}}static _findFolder(B,Q,ge){for(let V=0;V<B.folders.length;V++){const H=B.workspaceFolders[V];if(u(H.uri,Q,ge))return H}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(B,Q){return Q&&this._structure.get(B)&&(B=(0,C.dirname)(B)),this._structure.findSubstr(B)}resolveWorkspaceFolder(B){return this._structure.get(B)}}let g=class{constructor(B,Q,ge,V){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=V,this._extHostFileSystemInfo=ge,this._requestIdProvider=new S.Counter,this._barrier=new I.Barrier,this._proxy=B.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=B.getProxy(n.MainContext.MainThreadMessageService);const H=Q.workspace;this._confirmedWorkspace=H?new k(H.id,H.name,[],H.configuration?d.URI.revive(H.configuration):null,!!H.isUntitled,te=>v(te,ge)):void 0}$initializeWorkspace(B,Q){this._trusted=Q,this.$acceptWorkspaceData(B),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:D.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(B,Q,ge,...V){const H=[];if(Array.isArray(V)&&V.forEach(M=>{d.URI.isUri(M.uri)&&!H.some(U=>u(U.uri,M.uri,this._extHostFileSystemInfo))&&H.push({uri:M.uri,name:M.name||(0,C.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[Q,ge].some(M=>typeof M!="number"||M<0)||ge===0&&H.length===0)return!1;const te=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(Q+ge>te.length)return!1;const $=te.slice(0);$.splice(Q,ge,...H.map(M=>({uri:M.uri,name:M.name||(0,C.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<$.length;M++){const U=$[M];if($.some((G,J)=>J!==M&&u(U.uri,G.uri,this._extHostFileSystemInfo)))return!1}$.forEach((M,U)=>M.index=U);const{added:F,removed:L}=c(te,$,s,this._extHostFileSystemInfo);if(F.length===0&&L.length===0)return!1;if(this._proxy){const M=B.displayName||B.name;this._proxy.$updateWorkspaceFolders(M,Q,ge,H).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,h.localize)(0,null,M,U.toString()),{extension:B},[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(B,Q){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(B,Q)}async getWorkspaceFolder2(B,Q){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(B,Q)}async resolveWorkspaceFolder(B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(B)}getPath(){if(!!this._actualWorkspace){const{folders:B}=this._actualWorkspace;if(B.length!==0)return B[0].uri.fsPath}}getRelativePath(B,Q){let ge,V="";if(typeof B=="string"?(ge=d.URI.file(B),V=B):typeof B!="undefined"&&(ge=B,V=B.fsPath),!ge)return V;const H=this.getWorkspaceFolder(ge,!0);if(!H)return V;typeof Q=="undefined"&&this._actualWorkspace&&(Q=this._actualWorkspace.folders.length>1);let te=(0,C.relativePath)(H.uri,ge);return Q&&H.name&&(te=`${H.name}/${te}`),te}trySetWorkspaceFolders(B){this._actualWorkspace&&(this._unconfirmedWorkspace=k.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:B,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(B){const{workspace:Q,added:ge,removed:V}=k.toExtHostWorkspace(B,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=Q||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ge,removed:V}))}findFiles(B,Q,ge,V,H=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let te;if(Q===null?te=!1:Q&&(typeof Q=="string"?te=Q:te=Q.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:$,folder:F}=_(B);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)($),(0,P.withUndefinedAsNull)(F),(0,P.withUndefinedAsNull)(te),(0,P.withUndefinedAsNull)(ge),H).then(L=>Array.isArray(L)?L.map(M=>d.URI.revive(M)):[])}async findTextInFiles(B,Q,ge,V,H=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const te=this._requestIdProvider.getNext(),$=typeof Q.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:Q.previewOptions,{includePattern:F,folder:L}=_(Q.include),M=typeof Q.exclude=="string"?Q.exclude:Q.exclude?Q.exclude.pattern:void 0,U={ignoreSymlinks:typeof Q.followSymlinks=="boolean"?!Q.followSymlinks:void 0,disregardIgnoreFiles:typeof Q.useIgnoreFiles=="boolean"?!Q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof Q.useGlobalIgnoreFiles=="boolean"?!Q.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof Q.useDefaultExcludes=="boolean"?!Q.useDefaultExcludes:!0,fileEncoding:Q.encoding,maxResults:Q.maxResults,previewOptions:$,afterContext:Q.afterContext,beforeContext:Q.beforeContext,includePattern:F,excludePattern:M},G=!1;if(this._activeSearchCallbacks[te]=J=>{if(!G){const re=d.URI.revive(J.resource);J.results.forEach(pe=>{(0,t.resultIsMatch)(pe)?ge({uri:re,preview:{text:pe.preview.text,matches:(0,w.mapArrayOrNot)(pe.preview.matches,Te=>new b.Range(Te.startLineNumber,Te.startColumn,Te.endLineNumber,Te.endColumn))},ranges:(0,w.mapArrayOrNot)(pe.ranges,Te=>new b.Range(Te.startLineNumber,Te.startColumn,Te.endLineNumber,Te.endColumn))}):ge({uri:re,text:pe.text,lineNumber:pe.lineNumber})})}},H.isCancellationRequested)return{};try{const J=await this._proxy.$startTextSearch(B,(0,P.withUndefinedAsNull)(L),U,te,H);return delete this._activeSearchCallbacks[te],J||{}}catch(J){throw delete this._activeSearchCallbacks[te],J}}$handleTextSearchResult(B,Q){this._activeSearchCallbacks[Q]&&this._activeSearchCallbacks[Q](B)}saveAll(B){return this._proxy.$saveAll(B)}resolveProxy(B){return this._proxy.$resolveProxy(B)}get trusted(){return this._trusted}requestWorkspaceTrust(B){return this._proxy.$requestWorkspaceTrust(B)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};g=Ve([qe(0,l.IExtHostRpcService),qe(1,f.IExtHostInitDataService),qe(2,E.IExtHostFileSystemInfo),qe(3,a.ILogService)],g),e.ExtHostWorkspace=g,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function _(R){let B,Q;return R&&(typeof R=="string"?B=R:(B=R.pattern,Q=R.baseFolder||d.URI.file(R.base))),{includePattern:B,folder:Q}}}),define(we[34],_e([0,1,23,3,30,5,7,154,66,10,11,4,14,18,2]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(n,u){if(u){const o=u.split(".");let s=n;for(let c=0;s&&c<o.length;c++)s=s[o[c]];return s}}function p(n){return n instanceof r.URI}function m(n){return n&&n.uri instanceof r.URI&&n.languageId&&typeof n.languageId=="string"}function E(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function f(n){return n&&n.uri instanceof r.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function l(n){if(p(n))return{resource:n};if(m(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(E(n))return{overrideIdentifier:n.languageId};if(f(n))return{resource:n.uri};if(n===null)return{resource:null}}let b=class{constructor(u,o,s){this._proxy=u.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=s,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(u=>this._actual)}$initializeConfiguration(u){this._actual=new t(this._proxy,this._extHostWorkspace,u,this._logService),this._barrier.open()}$acceptConfigurationChanged(u,o){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(u,o))}};b=Ve([qe(0,d.IExtHostRpcService),qe(1,A.IExtHostWorkspace),qe(2,h.ILogService)],b),e.ExtHostConfiguration=b;class t{constructor(u,o,s,c){this._onDidChangeConfiguration=new I.Emitter,this._proxy=u,this._logService=c,this._extHostWorkspace=o,this._configuration=D.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(u,o){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,s))}getConfiguration(u,o,s){const c=l(o)||{},v=this._toReadonlyValue(u?a(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),u):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));u&&this._validateConfigurationAccess(u,c,s==null?void 0:s.identifier);function k(_){if(_==null)return null;if(typeof _=="boolean")return _?1:4;switch(_){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const g={has(_){return typeof a(v,_)!="undefined"},get:(_,R)=>{this._validateConfigurationAccess(u?`${u}.${_}`:_,c,s==null?void 0:s.identifier);let B=a(v,_);if(typeof B=="undefined")B=R;else{let Q;const ge=(V,H)=>{let te;const $=()=>{Q=Q||(0,w.deepClone)(v),te=te||a(Q,H)};return(0,C.isObject)(V)?new Proxy(V,{get:(F,L)=>{if(typeof L=="string"&&L.toLowerCase()==="tojson")return $(),()=>te;if(Q)return te=te||a(Q,H),te[L];const M=F[L];return typeof L=="string"?ge(M,`${H}.${L}`):M},set:(F,L,M)=>($(),te&&(te[L]=M),!0),deleteProperty:(F,L)=>($(),te&&delete te[L],!0),defineProperty:(F,L,M)=>($(),te&&Object.defineProperty(te,L,M),!0)}):V};B=ge(B,_)}return B},update:(_,R,B,Q)=>{_=u?`${u}.${_}`:_;const ge=k(B);return R!==void 0?this._proxy.$updateConfigurationOption(ge,_,R,c,Q):this._proxy.$removeConfigurationOption(ge,_,c,Q)},inspect:_=>{var R,B,Q,ge,V,H,te,$;_=u?`${u}.${_}`:_;const F=(0,w.deepClone)(this._configuration.inspect(_,c,this._extHostWorkspace.workspace));if(F)return{key:_,defaultValue:(R=F.default)===null||R===void 0?void 0:R.value,globalValue:(B=F.user)===null||B===void 0?void 0:B.value,workspaceValue:(Q=F.workspace)===null||Q===void 0?void 0:Q.value,workspaceFolderValue:(ge=F.workspaceFolder)===null||ge===void 0?void 0:ge.value,defaultLanguageValue:(V=F.default)===null||V===void 0?void 0:V.override,globalLanguageValue:(H=F.user)===null||H===void 0?void 0:H.override,workspaceLanguageValue:(te=F.workspace)===null||te===void 0?void 0:te.override,workspaceFolderLanguageValue:($=F.workspaceFolder)===null||$===void 0?void 0:$.override,languageIds:F.overrideIdentifiers}}};return typeof v=="object"&&(0,w.mixin)(g,v,!1),Object.freeze(g)}_toReadonlyValue(u){const o=s=>(0,C.isObject)(s)?new Proxy(s,{get:(c,v)=>o(c[v]),set:(c,v,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(c,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(c,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return o(u)}_validateConfigurationAccess(u,o,s){const c=S.OVERRIDE_PROPERTY_PATTERN.test(u)?4:this._configurationScopes.get(u),v=s?`[${s.value}] `:"";if(c===4){typeof(o==null?void 0:o.resource)=="undefined"&&this._logService.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){(o==null?void 0:o.resource)&&this._logService.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(u,o){const s=new D.ConfigurationChangeEvent(u,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,v)=>s.affectsConfiguration(c,l(v))})}_toMap(u){return u.reduce((o,s)=>(o.set(s[0],s[1]),o),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Y,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Y,w):A?A.value=w:e.set(Y,w),w},Me=this&&this.__classPrivateFieldGet||function(Y,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Y):I?I.value:e.get(Y)};define(we[103],_e([0,1,2,11,3,5,7,30,39,34,20,40,14,27,4,19,21,18,75,171,12]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r,a,p,m,E,f,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(V){function H($){if($!=null)return $}V.from=H;function te($){if($!=null)return $}V.to=te})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(V){function H($){if($!=null)return $}V.from=H;function te($){if($!=null)return $}V.to=te})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var u;(function(V){function H($){if($!=null)return $}V.from=H;function te($){if($!=null)return $}V.to=te})(u=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(V){function H(F){if(F){const L=F;return L&&!!L.process}else return!1}V.is=H;function te(F){if(F!=null){const L={process:F.process,args:F.args};return F.options&&(L.options=u.from(F.options)),L}}V.from=te;function $(F){if(F!=null)return new y.ProcessExecution(F.process,F.args,F.options)}V.to=$})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(V){function H($){if($!=null)return $}V.from=H;function te($){if($!=null)return $}V.to=te})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(V){function H(F){if(F){const L=F;return L&&(!!L.commandLine||!!L.command)}else return!1}V.is=H;function te(F){if(F!=null){const L={};return F.commandLine!==void 0?L.commandLine=F.commandLine:(L.command=F.command,L.args=F.args),F.options&&(L.options=s.from(F.options)),L}}V.from=te;function $(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new y.ShellExecution(F.commandLine,F.options):new y.ShellExecution(F.command,F.args?F.args:[],F.options)}V.to=$})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var v;(function(V){function H(F){if(F){let L=F;return L&&L.customExecution==="customExecution"}else return!1}V.is=H;function te(F){return{customExecution:"customExecution"}}V.from=te;function $(F,L){return L.get(F)}V.to=$})(v=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var k;(function(V){function H(te,$){let F;return te.scope!==void 0&&typeof te.scope!="number"?F=te.scope.uri:te.scope!==void 0&&typeof te.scope=="number"&&(te.scope===y.TaskScope.Workspace&&$&&$.workspaceFile?F=$.workspaceFile:F=f.USER_TASKS_GROUP_KEY),{id:te._id,workspaceFolder:F}}V.from=H})(k=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(V){function H(F,L){if(F==null)return[];const M=[];for(let U of F){const G=te(U,L);G&&M.push(G)}return M}V.fromMany=H;function te(F,L){if(F!=null){let M;F.execution instanceof y.ProcessExecution?M=o.from(F.execution):F.execution instanceof y.ShellExecution?M=c.from(F.execution):F.execution&&F.execution instanceof y.CustomExecution&&(M=v.from(F.execution));const U=t.from(F.definition);let G;if(F.scope?typeof F.scope=="number"?G=F.scope:G=F.scope.uri:G=y.TaskScope.Workspace,!(!U||!G)){const J=F.group?F.group.id:void 0;return{_id:F._id,definition:U,name:F.name,source:{extensionId:L.identifier.value,label:F.source,scope:G},execution:M,isBackground:F.isBackground,group:J,presentationOptions:n.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}}}V.from=te;async function $(F,L,M){if(F!=null){let U;o.is(F.execution)?U=o.to(F.execution):c.is(F.execution)?U=c.to(F.execution):v.is(F.execution)&&(U=v.to(F._id,M));const G=t.to(F.definition);let J;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?J=F.source.scope:J=await L.resolveWorkspaceFolder(w.URI.revive(F.source.scope)):J=y.TaskScope.Workspace),!(!G||!J)){const re=new y.Task(G,J,F.name,F.source.label,U,F.problemMatchers);return F.isBackground!==void 0&&(re.isBackground=F.isBackground),F.group!==void 0&&(re.group=y.TaskGroup.from(F.group)),F.presentationOptions&&(re.presentationOptions=n.to(F.presentationOptions)),F._id&&(re._id=F._id),F.detail&&(re.detail=F.detail),re}}}V.to=$})(g=e.TaskDTO||(e.TaskDTO={}));var _;(function(V){function H($){return $}V.from=H;function te($){if(!!$)return Object.assign(Object.create(null),$)}V.to=te})(_=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(H,te,$){this._id=te,this._task=$,b.set(this,void 0),tt(this,b,H,"f")}get task(){return this._task}terminate(){Me(this,b,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}b=new WeakMap;var B;(function(V){function H(te){return{id:te._id,task:void 0}}V.from=H})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let Q=class{constructor(H,te,$,F,L,M,U,G){this._onDidExecuteTask=new A.Emitter,this._onDidTerminateTask=new A.Emitter,this._onDidTaskProcessStarted=new A.Emitter,this._onDidTaskProcessEnded=new A.Emitter,this._proxy=H.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=F,this._configurationService=L,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=U,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,te,$){if(!$)return new y.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:te,provider:$,extension:H}),this._proxy.$registerTaskProvider(F,te),new y.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(H,te){this._proxy.$registerTaskSystem(H,te)}fetchTasks(H){return this._proxy.$fetchTasks(_.from(H)).then(async te=>{const $=[];for(let F of te){const L=await g.to(F,this._workspaceProvider,this._providedCustomExecutions2);L&&$.push(L)}return $})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(te=>H.push(te)),H}terminateTask(H){if(!(H instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,te,$){const F=this._providedCustomExecutions2.get(H.id);if(F){if(this._activeCustomExecutions2.get(H.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(H.id,F),this._terminalService.attachPtyToTerminal(te,await F.callback($))}this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const te=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:te})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const te=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:te,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const te=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:te,exitCode:H.exitCode})}$provideTasks(H,te){const $=this._handlers.get(H);if(!$)return Promise.reject(new Error("no handler found"));const F=[],L=(0,I.asPromise)(()=>$.provider.provideTasks(i.CancellationToken.None)).then(M=>this.provideTasksInternal(te,F,$,M));return new Promise(M=>{L.then(U=>{Promise.all(F).then(()=>{M(U)})})})}async $resolveTask(H,te){const $=this._handlers.get(H);if(!$)return Promise.reject(new Error("no handler found"));if(te.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${te.definition.type}] cannot be resolved by provider of type [${$.type}].`);const F=await g.to(te,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const L=await $.provider.resolveTask(F,i.CancellationToken.None);if(!!L){this.checkDeprecation(L,$);const M=g.from(L,$.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(L.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(M.execution)&&await this.addCustomExecution(M,L,!0),await this.resolveTaskInternal(M)}}nextHandle(){return this._handleCounter++}async addCustomExecution(H,te,$){const F=await this._proxy.$createTaskId(H);!$&&!this._providedCustomExecutions2.has(F)&&this._notProvidedCustomExecutions.add(F),this._providedCustomExecutions2.set(F,te.execution)}async getTaskExecution(H,te){if(typeof H=="string"){const L=this._taskExecutionPromises.get(H);if(!L)throw new Error("Unexpected: The specified task is missing an execution");return L}let $=this._taskExecutionPromises.get(H.id);if($)return $;const F=new Promise(async(L,M)=>{const U=te||await g.to(H.task,this._workspaceProvider,this._providedCustomExecutions2);U?L(new R(this,H.id,U)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(H.id,F),F.then(L=>(this._taskExecutions.set(H.id,L),L),L=>Promise.reject(L))}checkDeprecation(H,te){H._deprecated&&this._deprecationService.report("Task.constructor",te.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));let $=this._notProvidedCustomExecutions.values(),F=$.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=$.next()}};Q=Ve([qe(0,d.IExtHostRpcService),qe(1,h.IExtHostInitDataService),qe(2,D.IExtHostWorkspace),qe(3,S.IExtHostDocumentsAndEditors),qe(4,C.IExtHostConfiguration),qe(5,P.IExtHostTerminalService),qe(6,m.ILogService),qe(7,E.IExtHostApiDeprecationService)],Q),e.ExtHostTaskBase=Q;let ge=class extends Q{constructor(H,te,$,F,L,M,U,G){super(H,te,$,F,L,M,U,G);this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(H,te){if(!te.execution)throw new Error("Tasks to execute must include an execution");const $=g.from(te,H);if($===void 0)throw new Error("Task is not valid");if(v.is($.execution))await this.addCustomExecution($,te,!1);else throw new l.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution($),te);return this._proxy.$executeTask($).catch(L=>{throw new Error(L)}),F}provideTasksInternal(H,te,$,F){const L=[];if(F)for(let M of F){this.checkDeprecation(M,$),(!M.definition||!H[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const U=g.from(M,$.extension);U&&v.is(U.execution)?(L.push(U),te.push(this.addCustomExecution(U,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:L,extension:$.extension}}async resolveTaskInternal(H){if(v.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,te){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(H,te,$){}};ge=Ve([qe(0,d.IExtHostRpcService),qe(1,h.IExtHostInitDataService),qe(2,D.IExtHostWorkspace),qe(3,S.IExtHostDocumentsAndEditors),qe(4,C.IExtHostConfiguration),qe(5,P.IExtHostTerminalService),qe(6,m.ILogService),qe(7,E.IExtHostApiDeprecationService)],ge),e.WorkerExtHostTask=ge,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(Y,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Y,w):A?A.value=w:e.set(Y,w),w},Me=this&&this.__classPrivateFieldGet||function(Y,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Y):I?I.value:e.get(Y)},Qt=this&&this.__rest||function(Y,e){var w={};for(var I in Y)Object.prototype.hasOwnProperty.call(Y,I)&&e.indexOf(I)<0&&(w[I]=Y[I]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(Y);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(Y,I[A])&&(w[I[A]]=Y[I[A]]);return w};define(we[218],_e([0,1,15,11,24,20,3,53,43,6,23,10,2,31,5,39,14,69,9,7,30,182,96]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r,a,p,m,E,f,l,b,t){"use strict";var n,u,o,s;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const c=($,F)=>`${$}:${F.toString()}`;let v=class{constructor(F,L,M){this.documents=L,this.workspace=M,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new b.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(r.MainContext.MainThreadTesting),this.runQueue=new k(this.proxy),this.workspaceObservers=new H(this.proxy),this.textDocumentObservers=new te(this.proxy,L)}registerTestController(F,L){const M=(0,h.generateUuid)();this.controllers.set(M,{instance:L,extensionId:F}),this.proxy.$registerTestController(M);const U=[...this.testControllers.keys()];return setTimeout(()=>{var G;for(const J of U)(G=this.testControllers.get(J))===null||G===void 0||G.subscribeFn(M,L)},0),new f.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(F){return this.textDocumentObservers.checkout(F.uri)}createWorkspaceTestObserver(F){return this.workspaceObservers.checkout(F.uri)}async runTests(F,L=T.CancellationToken.None){const M=U=>U.map(this.getInternalTestForReference,this).filter(P.isDefined).map(G=>({src:G.src,testId:G.item.extId}));await this.proxy.$runTests({exclude:F.exclude?M(F.exclude).map(U=>U.testId):void 0,tests:M(F.tests),debug:F.debug},L)}createTestRun(F,L,M,U=!0){return this.runQueue.createTestRun(F,L,M,U)}$publishTestResults(F){this.results=Object.freeze(F.map(L=>(0,i.deepFreeze)(E.TestResults.to(L))).concat(this.results).sort((L,M)=>M.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(F,L){const M=d.URI.revive(L),U=c(F,M);if(!this.testControllers.has(U)){const G=new T.CancellationTokenSource;let J;if(F===1){let Ae=this.documents.getDocument(M);if(!Ae){const We=new C.DisposableStore;Ae=await new Promise(x=>{We.add((0,I.disposableTimeout)(()=>x(void 0),5e3)),We.add(this.documents.onDidAddDocuments(q=>{const ne=q.find(le=>le.document.uri.toString()===M.toString());ne&&x(ne)}))}).finally(()=>We.dispose())}if(Ae){const We=await this.workspace.getWorkspaceFolder2(M,!1);J=x=>x.createDocumentTestRoot?x.createDocumentTestRoot(Ae.document,G.token):(0,e.createDefaultDocumentTestRoot)(x,Ae.document,We,G.token)}}else{const Ae=await this.workspace.getWorkspaceFolder2(M,!1);Ae&&(J=We=>We.createWorkspaceTestRoot(Ae,G.token))}if(!!J){const re=async(Ae,We)=>{try{const x=await J(We);x&&Te.addRoot(x,Ae)}catch(x){console.error(x)}},pe=new C.DisposableStore,Te=pe.add(this.ownedTests.createForHierarchy(Ae=>this.proxy.$publishDiff(F,L,Ae)));pe.add((0,C.toDisposable)(()=>G.dispose(!0)));const Be=[];for(const[Ae,We]of this.controllers)Be.push(re(Ae,We.instance));Promise.all(Be).then(()=>Te.pushDiff([3,-1])),this.testControllers.set(U,{store:pe,collection:Te,subscribeFn:re})}}}async $expandTest(F,L){const M=(0,w.mapFind)(this.testControllers.values(),U=>U.collection.treeId===F.src.tree?U:void 0);await(M==null?void 0:M.collection.expand(F.testId,L<0?Infinity:L)),this.flushCollectionDiffs()}$unsubscribeFromTests(F,L){var M;const U=d.URI.revive(L),G=c(F,U);(M=this.testControllers.get(G))===null||M===void 0||M.store.dispose(),this.testControllers.delete(G)}$acceptDiff(F,L,M){F===1?this.textDocumentObservers.acceptDiff(d.URI.revive(L),M):this.workspaceObservers.acceptDiff(d.URI.revive(L),M)}async $runTestsForProvider(F,L){const M=this.controllers.get(F.tests[0].src.controller);if(!!M){const U=F.tests.map(({testId:re,src:pe})=>this.ownedTests.getTestById(re,pe==null?void 0:pe.tree)).filter(P.isDefined).map(([re,pe])=>pe),G=F.excludeExtIds.map(re=>this.ownedTests.getTestById(re)).filter(P.isDefined).filter(([re,pe])=>U.some(Te=>re.comparePositions(Te,pe)===1));if(!!U.length){const J={tests:U.map(re=>B.unwrap(re.actual)),exclude:G.map(([,re])=>B.unwrap(re.actual)),debug:F.debug};await this.runQueue.enqueueRun({dto:g.fromInternal(F),token:L,extensionId:M.extensionId,req:J,doRun:()=>M.instance.runTests(J,L)})}}}$lookupTest(F){const L=this.ownedTests.getTestById(F.testId);if(!L)return Promise.resolve(void 0);const M=L[1],{actual:U,discoverCts:G,expandLevels:J}=M,re=Qt(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(re)}flushCollectionDiffs(){for(const{collection:F}of this.testControllers.values())F.flushDiff()}getInternalTestForReference(F){var L,M;return(M=(L=this.workspaceObservers.getMirroredTestDataByReference(F))!==null&&L!==void 0?L:(0,w.mapFind)(this.testControllers.values(),U=>U.collection.getTestByReference(F)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(F)}};v=Ve([qe(0,p.IExtHostRpcService),qe(1,a.IExtHostDocumentsAndEditors),qe(2,l.IExtHostWorkspace)],v),e.ExtHostTesting=v;class k{constructor(F){this.proxy=F,this.state=new Map}enqueueRun(F){let L=this.state.get(F.extensionId);L||(L={queue:[],current:void 0},this.state.set(F.extensionId,L));const M=new I.DeferredPromise,U=()=>{const G=[],J=new Set;L.current={publicReq:F.req,factory:re=>{const pe=new _(re,F.dto,J,this.proxy);return G.push(pe),F.token.onCancellationRequested(()=>pe.end()),pe}},this.invokeRunner(F.extensionId,F.dto.id,F.doRun,G).finally(()=>M.complete())};return L.queue.push(U),L.queue.length===1&&U(),M.p}createTestRun(F,L,M,U){var G,J;const re=this.state.get(F);if((re==null?void 0:re.current.publicReq)===L)return re.current.factory(M);const pe=g.fromPublic(L),Te=new _(M,pe,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:L.debug,exclude:(J=(G=L.exclude)===null||G===void 0?void 0:G.map(Be=>Be.id))!==null&&J!==void 0?J:[],id:pe.id,tests:L.tests.map(Be=>Be.id),persist:U}),Te.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(pe.id)),Te}invokeRunner(F,L,M,U){try{const G=M();return(0,I.isThenable)(G)?G.then(()=>this.handleInvokeResult(F,L,U,void 0)).catch(J=>this.handleInvokeResult(F,L,U,J)):this.handleInvokeResult(F,L,U,void 0)}catch(G){return this.handleInvokeResult(F,L,U,G)}}async handleInvokeResult(F,L,M,U){const G=this.state.get(F);!G||(G.queue.shift(),G.queue.length>0?G.queue[0]():this.state.delete(F),await Promise.all(M.map(J=>J.onEnd.wait())))}}class g{constructor(F,L,M){this.id=F,this.include=L,this.exclude=M}static fromPublic(F){var L,M;return new g((0,h.generateUuid)(),new Set(F.tests.map(U=>U.id)),new Set((M=(L=F.exclude)===null||L===void 0?void 0:L.map(U=>U.id))!==null&&M!==void 0?M:S.Iterable.empty()))}static fromInternal(F){return new g(F.runId,new Set(F.tests.map(L=>L.testId)),new Set(F.excludeExtIds))}isIncluded(F){for(let L=F;L;L=L.parent){if(this.include.has(L.id))return!0;if(this.exclude.has(L.id))return!1}return!0}}class _{constructor(F,L,M,U){this.name=F,n.set(this,void 0),u.set(this,void 0),o.set(this,(0,h.generateUuid)()),s.set(this,void 0),this.onEnd=new I.Barrier,tt(this,n,U,"f"),tt(this,u,L,"f"),tt(this,s,M,"f"),U.$startedTestRunTask(L.id,{id:Me(this,o,"f"),name:F,running:!0})}setState(F,L,M){Me(this,u,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Me(this,n,"f").$updateTestStateInRun(Me(this,u,"f").id,Me(this,o,"f"),F.id,L,M))}appendMessage(F,L){Me(this,u,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Me(this,n,"f").$appendTestMessageInRun(Me(this,u,"f").id,Me(this,o,"f"),F.id,E.TestMessage.from(L)))}appendOutput(F){Me(this,n,"f").$appendOutputToRun(Me(this,u,"f").id,Me(this,o,"f"),A.VSBuffer.fromString(F))}end(){Me(this,n,"f").$finishedTestRunTask(Me(this,u,"f").id,Me(this,o,"f")),this.onEnd.open()}ensureTestIsKnown(F){const L=Me(this,s,"f");if(!L.has(F.id)){const M=[];for(;M.unshift(E.TestItem.from(F)),!(L.has(F.id)||(L.add(F.id),!F.parent));)F=F.parent;Me(this,n,"f").$addTestsToRun(Me(this,u,"f").id,M)}}}n=new WeakMap,u=new WeakMap,o=new WeakMap,s=new WeakMap;const R=async($,F,L,M)=>{if(!!L){const U=await $.createWorkspaceTestRoot(L,M);if(!!U){M.onCancellationRequested(()=>{B.removeFilter(F)});const G=B.getWrapperForTestItem(U,F);return G.refreshMatch(),G}}};e.createDefaultDocumentTestRoot=R;class B extends f.TestItemImpl{constructor(F,L,M){super(F.id,F.label,F.uri,void 0);if(this.actual=F,this.filterDocument=L,this.actualParent=M,!(F instanceof f.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${F.id} did not`);this.debuggable=F.debuggable,this.runnable=F.runnable,this.description=F.description,this.error=F.error,this.status=F.status,this.range=F.range,this.resolveHandler=F.resolveHandler;const U=(0,m.getPrivateApiFor)(this);(0,m.getPrivateApiFor)(F).bus.event(J=>{switch(J[0]){case 3:this[J[1]]=J[2];break;case 0:const re=B.getWrapperForTestItem(J[1],this.filterDocument,this);(0,m.getPrivateApiFor)(re).parent=F,re.refreshMatch();break;default:U.bus.fire(J)}})}static removeFilter(F){this.wrapperMap.delete(F)}static getWrapperForTestItem(F,L,M){let U=this.wrapperMap.get(L);if(U==null?void 0:U.has(F))return U.get(F);U||(U=new WeakMap,this.wrapperMap.set(L,U));const G=new B(F,L,M);return U.set(F,G),G}static unwrap(F){return F instanceof B?F.actual:F}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var F;const L=this._cachedMatchesFilter;for(const U of this.actual.children.values()){const G=B.getWrapperForTestItem(U,this.filterDocument,this);G.hasNodeMatchingFilter?this.children.has(G.id)||this.addChild(G):G.dispose()}const M=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==L&&((F=this.actualParent)===null||F===void 0||F.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,m.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,m.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=B,B.wrapperMap=new WeakMap;class Q extends t.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,E.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:L,removed:M}=this;return{get added(){return[...F].map(U=>U.revived)},get updated(){return[...L].map(U=>U.revived)},get removed(){return[...M].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ge extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(F){let L=[];for(const M of F){const U=this.items.get(M);U&&L.push(U.revived)}return L}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,L){return Object.assign(Object.assign({},F),{revived:E.TestItem.toPlain(F.item),depth:L?L.depth+1:0,children:new Set})}createChangeCollector(){return new Q(this.changeEmitter)}}e.MirroredTestCollection=ge;class V{constructor(){this.resources=new Map}checkout(F){var L,M;const U=F.toString(),G=(L=this.resources.get(U))!==null&&L!==void 0?L:this.createObserverData(F);return(M=G.pendingDeletion)===null||M===void 0||M.dispose(),G.observers++,{onDidChangeTest:G.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return G.tests.rootTestItems},dispose:(0,D.once)(()=>{--G.observers||(G.pendingDeletion=this.eventuallyDispose(F))})}}getMirroredTestDataByReference(F){for(const{tests:L}of this.resources.values()){const M=L.getMirroredTestDataByReference(F);if(M)return M}}eventuallyDispose(F){return(0,I.disposableTimeout)(()=>this.unlisten(F),10*1e3)}createObserverData(F){const L=new ge,M=this.listen(F,G=>L.apply(G)),U={observers:0,tests:L,listener:M};return this.resources.set(F.toString(),U),U}unlisten(F){var L;const M=F.toString(),U=this.resources.get(M);U&&(U.observers=-1,(L=U.pendingDeletion)===null||L===void 0||L.dispose(),U.listener.dispose(),this.resources.delete(M))}}class H extends V{constructor(F){super();this.proxy=F,this.diffListeners=new Map}acceptDiff(F,L){var M;(M=this.diffListeners.get(F.toString()))===null||M===void 0||M(L)}listen(F,L){this.proxy.$subscribeToDiffs(0,F);const M=F.toString();return this.diffListeners.set(M,L),new f.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,F),this.diffListeners.delete(M)})}}class te extends V{constructor(F,L){super();this.proxy=F,this.documents=L,this.diffListeners=new Map}acceptDiff(F,L){var M;(M=this.diffListeners.get(F.toString()))===null||M===void 0||M(L)}listen(F,L){if(!this.documents.getDocument(F))return new f.Disposable(()=>{});const U=F.toString();return this.diffListeners.set(U,L),this.proxy.$subscribeToDiffs(1,F),new f.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,F),this.diffListeners.delete(U)})}}}),define(we[219],_e([0,1,15,51,28,58,22,19,13,25,8,10,2,116,140,92,48,174,217,41]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r,a,p,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let l=class{constructor(k,g,_,R){this.configurationService=k,this.workspaceContextService=g,this.editorGroupsService=_,this.pathService=R}text(k,g,_={}){k=this.getContentPattern(k,_);const R=this.configurationService.getValue(),B=g&&g.some(ge=>!this.configurationService.getValue({resource:ge}).search.useRipgrep),Q=this.commonQuery(g==null?void 0:g.map(p.toWorkspaceFolder),_);return Object.assign(Object.assign({},Q),{type:2,contentPattern:k,previewOptions:_.previewOptions,maxFileSize:_.maxFileSize,usePCRE2:R.search.usePCRE2||B||!1,beforeContext:_.beforeContext,afterContext:_.afterContext,userDisabledExcludesAndIgnoreFiles:_.disregardExcludeSettings&&_.disregardIgnoreFiles})}getContentPattern(k,g){const _=this.configurationService.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},k),{wordSeparators:_.editor.wordSeparators});return this.isCaseSensitive(k,g)&&(R.isCaseSensitive=!0),this.isMultiline(k)&&(R.isMultiline=!0),R}file(k,g={}){const _=this.commonQuery(k,g);return Object.assign(Object.assign({},_),{type:1,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey})}handleIncludeExclude(k,g){return k?(k=Array.isArray(k)?k.map(o):o(k),g?this.parseSearchPaths(k):{pattern:t(...Array.isArray(k)?k:[k])}):{}}commonQuery(k=[],g={}){const _=this.handleIncludeExclude(g.includePattern,g.expandPatterns),R=this.handleIncludeExclude(g.excludePattern,g.expandPatterns),B=k.length>1,Q=(_.searchPaths&&_.searchPaths.length?_.searchPaths.map(H=>this.getFolderQueryForSearchPath(H,g,R)):k.map(H=>this.getFolderQueryForRoot(H,g,R,B))).filter(H=>!!H),ge={_reason:g._reason,folderQueries:Q,usingSearchPaths:!!(_.searchPaths&&_.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:R.pattern,includePattern:_.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const te=w.coalesce(w.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(L=>L.resource)))).filter(F=>(0,f.pathIncludedInQuery)(ge,F.fsPath)),$=this.commonQueryFromFileList(te);return Object.assign(Object.assign({},ge),$)}const V=g.extraFileResources&&g.extraFileResources.filter(H=>(0,f.pathIncludedInQuery)(ge,H.fsPath));return ge.extraFileResources=V&&V.length?V:void 0,ge}commonQueryFromFileList(k){const g=[],_=new y.ResourceMap,R={};let B=!1;return k.forEach(Q=>{var ge,V;if(Q.scheme!==D.Schemas.walkThrough)if((0,C.isAbsolutePath)(Q)){const te=(V=(ge=this.workspaceContextService.getWorkspaceFolder(Q))===null||ge===void 0?void 0:ge.uri)!==null&&V!==void 0?V:Q.with({path:S.dirname(Q.fsPath)});let $=_.get(te);$||(B=!0,$={folder:te,includePattern:{}},g.push($),_.set(te,$));const F=S.relative(te.fsPath,Q.fsPath);(0,P.assertIsDefined)($.includePattern)[F.replace(/\\/g,"/")]=!0}else Q.fsPath&&(B=!0,R[Q.fsPath]=!0)}),{folderQueries:g,includePattern:R,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}isCaseSensitive(k,g){if(g.isSmartCase){if(k.isRegExp){if(i.containsUppercaseCharacter(k.pattern,!0))return!0}else if(i.containsUppercaseCharacter(k.pattern))return!0}return!!k.isCaseSensitive}isMultiline(k){return k.isMultiline||k.isRegExp&&(0,h.isMultilineRegexSource)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const g=$=>S.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),R=(Array.isArray(k)?k:n(k)).map($=>{const F=this.pathService.resolvedUserHome;return F?(0,T.untildify)($,F.scheme===D.Schemas.file?F.fsPath:F.path):$}),B=I.groupBy(R,$=>g($)?"searchPaths":"exprSegments"),Q=(B.exprSegments||[]).map($=>i.rtrim($,"/")).map($=>i.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),u($))),ge={},V=this.expandSearchPathPatterns(B.searchPaths||[]);V&&V.length&&(ge.searchPaths=V);const H=w.flatten(Q),te=t(...H);return te&&(ge.pattern=te),ge}getExcludesForFolder(k,g){return g.disregardExcludeSettings?void 0:(0,f.getExcludes)(k,!g.disregardSearchExcludeSettings)}expandSearchPathPatterns(k){if(!k||!k.length)return[];const g=w.flatten(k.map(R=>{let{pathPortion:B,globPortion:Q}=b(R);Q&&(Q=s(Q));const ge=this.expandOneSearchPath(B);return w.flatten(ge.map(V=>this.resolveOneSearchPathPattern(V,Q)))})),_=new Map;return g.forEach(R=>{const B=R.searchPath.toString(),Q=_.get(B);Q?R.pattern&&(Q.pattern=Q.pattern||{},Q.pattern[R.pattern]=!0):_.set(B,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(_.values())}expandOneSearchPath(k){if(S.isAbsolute(k)){const g=this.workspaceContextService.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==D.Schemas.file?[{searchPath:g[0].uri.with({path:k})}]:[{searchPath:d.URI.file(S.normalize(k))}]}if(this.workspaceContextService.getWorkbenchState()===2){const g=this.workspaceContextService.getWorkspace().folders[0].uri;if(k=o(k),k.startsWith("../")||k===".."){const R=S.posix.resolve(g.path,k);return[{searchPath:g.with({path:R})}]}const _=s(k);return[{searchPath:g,pattern:_}]}else{if(k==="./"||k===".\\")return[];{const g=k.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(B=>{const Q=g.match(new RegExp(`^${B.name}(?:/(.*))?`));return Q?{match:Q,folder:B}:null}).filter(P.isDefined);if(R.length)return R.map(B=>{const Q=B.match[1];return{searchPath:B.folder.uri,pattern:Q&&s(Q)}});{const B=k.match(/\.[\/\\](.+)[\/\\]?/),Q=B?B[1]:k,ge=r.localize(0,null,Q);throw new Error(ge)}}}}resolveOneSearchPathPattern(k,g){const _=k.pattern&&g?`${k.pattern}/${g}`:k.pattern||g,R=[{searchPath:k.searchPath,pattern:_}];return _&&!_.endsWith("**")&&R.push({searchPath:k.searchPath,pattern:_+"/**"}),R}getFolderQueryForSearchPath(k,g,_){const R=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(k.searchPath),g,_,!1);return R?Object.assign(Object.assign({},R),{includePattern:k.pattern}):null}getFolderQueryForRoot(k,g,_,R){let B;const Q=d.URI.isUri(k)?k:k.uri;if(_.searchPaths){const $=_.searchPaths.filter(F=>(0,C.isEqual)(F.searchPath,Q))[0];if($&&!$.pattern)return null;$&&(B=$.pattern)}const ge=this.configurationService.getValue({resource:Q}),V=this.getExcludesForFolder(ge,g),H=Object.assign(Object.assign({},V||{}),B||{}),te=d.URI.isUri(k)?(0,C.basename)(k):k.name;return{folder:Q,folderName:R?te:void 0,excludePattern:Object.keys(H).length>0?H:void 0,fileEncoding:ge.files&&ge.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!ge.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!ge.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!ge.search.followSymlinks}}};l=Ve([qe(0,a.IConfigurationService),qe(1,p.IWorkspaceContextService),qe(2,m.IEditorGroupsService),qe(3,E.IPathService)],l),e.QueryBuilder=l;function b(v){const k=v.match(/[\*\{\}\(\)\[\]\?]/);if(k){const g=k.index,_=v.substr(0,g).match(/[/|\\][^/\\]*$/);if(_){let R=v.substr(0,_.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:v.substr((_.index||0)+1)}}}return{pathPortion:v}}function t(...v){return v.length?v.reduce((k,g)=>(k[g]=!0,k),Object.create(null)):void 0}function n(v){return A.splitGlobAware(v,",").map(k=>k.trim()).filter(k=>!!k.length)}function u(v){return[`**/${v}/**`,`**/${v}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function o(v){return v.replace(/\\/g,"/")}function s(v){return o(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(v,k){v=w.distinct(v,R=>R.toString());const g=[],_=k.getWorkspace();return v&&v.forEach(R=>{let B;if(k.getWorkbenchState()===2)B=(0,C.relativePath)(_.folders[0].uri,R),B&&B!=="."&&(B="./"+B);else{const Q=k.getWorkspaceFolder(R);if(Q){const ge=Q.name;if(_.folders.filter(H=>H.name===ge).length===1){const H=(0,C.relativePath)(Q.uri,R);H===""?B=`./${Q.name}`:B=`./${Q.name}/${H}`}else B=R.fsPath}}B&&g.push(B)}),g}e.resolveResourcesForSearchIncludes=c}),define(we[220],_e([0,1,25,2,20,12,4,219,41,48]),function(Y,e,w,I,A,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function P(a,p){const m=p.activationEvents;if(!m)return Promise.resolve(void 0);const E=[],f=[];for(const o of m)if(/^workspaceContains:/.test(o)){const s=o.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||a.forceUsingSearch?f.push(s):E.push(s)}if(E.length===0&&f.length===0)return Promise.resolve(void 0);let l;const b=new Promise((o,s)=>{l=o}),t=o=>l({activationEvent:o}),n=Promise.all(E.map(o=>d(a,o,t))).then(()=>{}),u=h(a,p.identifier,f,t);return Promise.all([n,u]).then(()=>{l(void 0)}),b}e.checkActivateWorkspaceContainsExtension=P;async function d(a,p,m){for(const E of a.folders)if(await a.exists(w.joinPath(I.URI.revive(E),p))){m(`workspaceContains:${p}`);return}}async function h(a,p,m,E){if(m.length===0)return Promise.resolve(void 0);const f=new A.CancellationTokenSource,l=a.checkExists(a.folders,m,f.token),b=setTimeout(async()=>{f.cancel(),E(`workspaceContainsTimeout:${m.join(",")}`)},i);let t=!1;try{t=await l}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}f.dispose(),clearTimeout(b),t&&E(`workspaceContains:${m.join(",")}`)}function r(a,p,m,E){const f=a.get(y.IInstantiationService),l=a.get(S.ISearchService),t=f.createInstance(D.QueryBuilder).file(p.map(n=>(0,C.toWorkspaceFolder)(I.URI.revive(n))),{_reason:"checkExists",includePattern:m,exists:!0});return l.fileSearch(t,E).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=r});var tt=this&&this.__classPrivateFieldSet||function(Y,e,w,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!A:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Y,w):A?A.value=w:e.set(Y,w),w},Me=this&&this.__classPrivateFieldGet||function(Y,e,w,I){if(w==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?I:w==="a"?I.call(Y):I?I.value:e.get(Y)};define(we[35],_e([0,1,132,13,80,25,11,6,22,2,18,5,34,185,78,30,33,183,12,26,24,161,7,67,4,27,79,14,65,70,40,3,220,74,162]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r,a,p,m,E,f,l,b,t,n,u,o,s,c,v,k,g,_,R,B,Q){"use strict";var ge,V,H;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,u.createDecorator)("IHostUtils");let te=class Ln extends D.Disposable{constructor(M,U,G,J,re,pe,Te,Be,Ae,We){super();this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=U,this._extHostContext=G,this._initData=Te,this._extHostWorkspace=J,this._extHostConfiguration=re,this._logService=pe,this._extHostTunnelService=Ae,this._extHostTerminalService=We,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new m.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new B.ExtHostSecretState(this._extHostContext),this._storagePath=Be,this._instaService=M.createChild(new v.ServiceCollection([r.IExtHostStorage,this._storage],[B.IExtHostSecretState,this._secretState]));const x=new Set;this._initData.hostExtensions.forEach(q=>x.add(f.ExtensionIdentifier.toKey(q))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(q,ne,le)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(q,E.transformErrorForSerialization(ne),le)},actualActivateExtension:async(q,ne)=>{if(x.has(f.ExtensionIdentifier.toKey(q)))return await this._mainThreadExtensionsProxy.$activateExtension(q,ne),new h.HostExtension;const le=this._registry.getExtensionDescription(q);return this._activateExtension(le,ne)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),A.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){E.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(re=>re.identifier).filter(re=>this.isActivated(re)).map(re=>this._deactivate(re))}catch(U){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,U){return this._activator.activateByEvent(M,U)}_activateById(M,U){return this._activator.activateById(M,U)}activateByIdWithErrors(M,U){return this._activateById(M,U).then(()=>{const G=this._activator.getActivatedExtension(M);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=S.TernarySearchTree.forPaths(),U=this._registry.getAllExtensionDescriptions().map(G=>{if(!!this._getEntryPoint(G))return this._hostUtils.realpath(G.extensionLocation.fsPath).then(J=>M.set(C.URI.file(J).fsPath,G))});this._extensionPathIndex=Promise.all(U).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let U=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return U;const G=this._activator.getActivatedExtension(M);if(!G)return U;try{typeof G.module.deactivate=="function"&&(U=Promise.resolve(G.module.deactivate()).then(void 0,J=>Promise.resolve(void 0)))}catch(J){}try{(0,D.dispose)(G.subscriptions)}catch(J){}return U}async _activateExtension(M,U){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,U).then(G=>{const J=G.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,J.codeLoadingTime,J.activateCallTime,J.activateResolvedTime,U),this._logExtensionActivationTimes(M,U,"success",J),G},G=>{throw this._logExtensionActivationTimes(M,U,"failure"),G})}_logExtensionActivationTimes(M,U,G,J){const re=$(M,U);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},re),J||{}),{outcome:G}))}_doActivateExtension(M,U){const G=$(M,U);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",G);const J=this._getEntryPoint(M);if(!J)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(U)}`),this._logService.flush();const re=new h.ExtensionActivationTimesBuilder(U.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,T.joinPath)(M.extensionLocation,J),re),this._loadExtensionContext(M)]).then(pe=>(A.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Ln._callActivate(this._logService,M.identifier,pe[0],pe[1],re))).then(pe=>(A.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),pe))}_loadExtensionContext(M){const U=new b.ExtensionGlobalMemento(M,this._storage),G=new b.ExtensionMemento(M.identifier.value,!1,this._storage),J=new Q.ExtensionSecrets(M,this._secretState),re=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,pe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([U.whenReady,G.whenReady,this._storagePath.whenReady]).then(()=>{const Te=this;let Be;return Object.freeze({globalState:U,workspaceState:G,secrets:J,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Ae){return I.join(M.extensionLocation.fsPath,Ae)},get storagePath(){var Ae;return(Ae=Te._storagePath.workspaceValue(M))===null||Ae===void 0?void 0:Ae.fsPath},get globalStoragePath(){return Te._storagePath.globalValue(M).fsPath},get logPath(){return I.join(Te._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return C.URI.joinPath(Te._initData.logsLocation,M.identifier.value)},get storageUri(){return Te._storagePath.workspaceValue(M)},get globalStorageUri(){return Te._storagePath.globalValue(M)},get extensionMode(){return re},get extension(){return Be===void 0&&(Be=new F(Te,M.identifier,M,pe)),Be},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(M),Te.extensionRuntime},get environmentVariableCollection(){return Te._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,U,G,J,re){return G=G||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,U,G,J,re).then(pe=>new h.ActivatedExtension(!1,null,re.build(),G,pe,J.subscriptions))}static _callActivateOptional(M,U,G,J,re){if(typeof G.activate=="function")try{re.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${U.value}`);const pe=typeof global=="object"?global:self,Te=G.activate.apply(pe,[J]);return re.activateCallStop(),re.activateResolveStart(),Promise.resolve(Te).then(Be=>(re.activateResolveStop(),Be))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(G)}_activateOneStartupFinished(M,U){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:U}).then(void 0,G=>{this._logService.error(G)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(A.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const U of M.activationEvents)U==="onStartupFinished"&&this._activateOneStartupFinished(M,U)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,re=>{this._logService.error(re)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(re=>this._handleWorkspaceContainsEagerExtensions(re.added)));const U=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],G=this._handleWorkspaceContainsEagerExtensions(U),J=Promise.all([M,G]).then(()=>{});return Promise.race([J,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),J}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(U=>this._handleWorkspaceContainsEagerExtension(M,U))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,U){if(!this.isActivated(U.identifier)){const G=!this._initData.remote.isRemote&&!!this._initData.remote.authority,J={folders:M.map(pe=>pe.uri),forceUsingSearch:G,exists:pe=>this._hostUtils.exists(pe.fsPath),checkExists:(pe,Te,Be)=>this._mainThreadWorkspaceProxy.$checkExists(pe,Te,Be)},re=await(0,R.checkActivateWorkspaceContainsExtension)(J,U);if(!!re)return this._activateById(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:re.activationEvent}).then(void 0,pe=>this._logService.error(pe))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:U}=this._initData.environment;if(!M||!U)throw new Error(w.localize(0,null));const G=await this._loadCommonJSModule(null,U,new h.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(w.localize(1,null,U.toString()));return new Promise((J,re)=>{const pe=(Ae,We)=>{Ae?re(Ae):J(typeof We=="number"&&We>0?1:0)},Te=(0,T.originalFSPath)(U),Be=G.run(Te,pe);Be&&Be.then&&Be.then(()=>{J(0)}).catch(Ae=>{re(Ae.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,U){return this._resolvers[M]=U,(0,D.toDisposable)(()=>{delete this._resolvers[M]})}async $resolveAuthority(M,U){const G=M.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const J=M.substr(0,G);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${J}`,!1);const re=this._resolvers[J];if(!re)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${J}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(re)),A.mark(`code/extHost/willResolveAuthority/${J}`);const pe=await re.resolve(M,{resolveAttempt:U});A.mark(`code/extHost/didResolveAuthorityOK/${J}`);const Te={authority:M,host:pe.host,port:pe.port,connectionToken:pe.connectionToken},Be={extensionHostEnv:pe.extensionHostEnv,trust:pe.trust};return{type:"ok",value:{authority:Te,options:Be,tunnelInformation:{environmentTunnels:pe.environmentTunnels}}}}catch(pe){if(A.mark(`code/extHost/didResolveAuthorityError/${J}`),pe instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:pe._code,message:pe._message,detail:pe._detail}};throw pe}}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,U){return U===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(G=>this._activateByEvent(M,!1))}async $activate(M,U){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,U),!0):!1}async $deltaExtensions(M,U){M.forEach(J=>J.extensionLocation=C.URI.revive(J.extensionLocation));const G=await this.getExtensionPathIndex();return await Promise.all(U.map(async J=>{const re=this._registry.getExtensionDescription(J);if(!!re){const pe=await this._hostUtils.realpath(re.extensionLocation.fsPath);G.delete(C.URI.file(pe).fsPath)}})),await Promise.all(M.map(async J=>{const re=await this._hostUtils.realpath(J.extensionLocation.fsPath);G.set(C.URI.file(re).fsPath,J)})),this._registry.deltaExtensions(M,U),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let U=l.VSBuffer.alloc(M),G=Math.random()%256;for(let J=0;J<M;J++)U.writeUInt8(G,J);return U}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};te=Ve([qe(0,u.IInstantiationService),qe(1,e.IHostUtils),qe(2,c.IExtHostRpcService),qe(3,a.IExtHostWorkspace),qe(4,d.IExtHostConfiguration),qe(5,i.ILogService),qe(6,o.IExtHostInitDataService),qe(7,s.IExtensionStoragePaths),qe(8,k.IExtHostTunnelService),qe(9,g.IExtHostTerminalService)],te),e.AbstractExtHostExtensionService=te;function $(L,M){return{id:L.identifier.value,name:L.name,extensionVersion:L.version,publisherDisplayName:L.publisher,activationEvents:L.activationEvents?L.activationEvents.join(","):null,isBuiltin:L.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,u.createDecorator)("IExtHostExtensionService");class F{constructor(M,U,G,J){ge.set(this,void 0),V.set(this,void 0),H.set(this,void 0),tt(this,ge,M,"f"),tt(this,V,U,"f"),tt(this,H,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=I.normalize((0,T.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=J}get isActive(){return Me(this,ge,"f").isActivated(Me(this,H,"f"))}get exports(){if(this.packageJSON.api!=="none")return Me(this,ge,"f").getExtensionExports(Me(this,H,"f"))}activate(){return Me(this,ge,"f").activateByIdWithErrors(Me(this,H,"f"),{startup:!1,extensionId:Me(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,ge=new WeakMap,V=new WeakMap,H=new WeakMap}),define(we[104],_e([0,1,13,2,3,11,5,7,169,30,35,39,173,34,170,14,4,10,46]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r,a,p,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let f=class{constructor(c,v,k,g,_){this._workspaceService=v,this._extensionService=k,this._editorsService=g,this._configurationService=_,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=c.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new b(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(B=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,v){const k=c;if(typeof k.sourceReference=="number"&&k.sourceReference>0){let g=`debug:${encodeURIComponent(k.path||"")}`,_="?";return v&&(g+=`${_}session=${encodeURIComponent(v.id)}`,_="&"),g+=`${_}ref=${k.sourceReference}`,I.URI.parse(g)}else{if(k.path)return I.URI.file(k.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const v=[];for(const k of c.getAllExtensionDescriptions())if(k.contributes){const g=k.contributes.debuggers;if(g&&g.length>0)for(const _ of g)(0,r.isDebuggerMainContribution)(_)&&v.push(_.type)}this._debugServiceProxy.$registerDebugTypes(v)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(v=>c.push(v)),c}addBreakpoints(c){this.startBreakpoints();const v=c.filter(_=>{const R=_.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,_),!0)});this.fireBreakpointChanges(v,[],[]);const k=[],g=new Map;for(const _ of v)if(_ instanceof D.SourceBreakpoint){let R=g.get(_.location.uri.toString());R||(R={type:"sourceMulti",uri:_.location.uri,lines:[]},g.set(_.location.uri.toString(),R),k.push(R)),R.lines.push({id:_.id,enabled:_.enabled,condition:_.condition,hitCondition:_.hitCondition,logMessage:_.logMessage,line:_.location.range.start.line,character:_.location.range.start.character})}else _ instanceof D.FunctionBreakpoint&&k.push({type:"function",id:_.id,enabled:_.enabled,hitCondition:_.hitCondition,logMessage:_.logMessage,condition:_.condition,functionName:_.functionName});return this._debugServiceProxy.$registerBreakpoints(k)}removeBreakpoints(c){this.startBreakpoints();const v=c.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],v,[]);const k=v.filter(R=>R instanceof D.SourceBreakpoint).map(R=>R.id),g=v.filter(R=>R instanceof D.FunctionBreakpoint).map(R=>R.id),_=v.filter(R=>R instanceof D.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(k,g,_)}startDebugging(c,v,k){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,v,{parentSessionID:k.parentSession?k.parentSession.id:void 0,repl:k.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:k.noDebug,compact:k.compact})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,v,k){if(!v)return new D.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:g,provider:v}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,k,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,g),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(_=>_.provider!==v),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(c,v,k){if(!k)return new D.Disposable(()=>{});if(!this.definesDebugType(c,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.getAdapterDescriptorFactoryByType(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:v,handle:g,factory:k}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(v,g),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(_=>_.factory!==k),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(c,v){if(!v)return new D.Disposable(()=>{});const k=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:k,factory:v}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==v)})}async $runInTerminal(c,v){return Promise.resolve(void 0)}async $substituteVariables(c,v){if(!this._variableResolver){const[_,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(_||[],this._editorsService,R)}let k;const g=await this.getFolder(c);return g&&(k={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(k,v)}createDebugAdapter(c,v){if(c.type==="implementation")return new u(c.implementation)}createSignService(){}async $startDASession(c,v){const k=this,g=await this.getSession(v);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const R=this.convertToDto(_),B=this.createDebugAdapter(R,g);if(!B)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const Q=B;return this._debugAdapters.set(c,Q),this.getDebugAdapterTrackers(g).then(ge=>(ge&&this._debugAdaptersTrackers.set(c,ge),Q.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const H=V,te={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(H.arguments.value);te.body={signature:$},Q.sendResponse(te)}else throw new Error("no signer")}catch($){te.success=!1,te.message=$.message,Q.sendResponse(te)}}else ge&&ge.onDidSendMessage&&ge.onDidSendMessage(V),V=(0,r.convertToVSCPaths)(V,!0),k._debugServiceProxy.$acceptDAMessage(c,V)}),Q.onError(V=>{ge&&ge.onError&&ge.onError(V),this._debugServiceProxy.$acceptDAError(c,V.name,V.message,V.stack)}),Q.onExit(V=>{ge&&ge.onExit&&ge.onExit((0,m.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,m.withNullAsUndefined)(V),void 0)}),ge&&ge.onWillStartSession&&ge.onWillStartSession(),Q.startSession()))})}$sendDAMessage(c,v){v=(0,r.convertToDAPaths)(v,!1);const k=this._debugAdaptersTrackers.get(c);k&&k.onWillReceiveMessage&&k.onWillReceiveMessage(v);const g=this._debugAdapters.get(c);g&&g.sendMessage(v)}$stopDASession(c){const v=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),v&&v.onWillStopSession&&v.onWillStopSession();const k=this._debugAdapters.get(c);return this._debugAdapters.delete(c),k?k.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const v=[],k=[],g=[];if(c.added)for(const _ of c.added){const R=_.id;if(R&&!this._breakpoints.has(R)){let B;if(_.type==="function")B=new D.FunctionBreakpoint(_.functionName,_.enabled,_.condition,_.hitCondition,_.logMessage);else if(_.type==="data")B=new D.DataBreakpoint(_.label,_.dataId,_.canPersist,_.enabled,_.hitCondition,_.condition,_.logMessage);else{const Q=I.URI.revive(_.uri);B=new D.SourceBreakpoint(new D.Location(Q,new D.Position(_.line,_.character)),_.enabled,_.condition,_.hitCondition,_.logMessage)}B._id=R,this._breakpoints.set(R,B),v.push(B)}}if(c.removed)for(const _ of c.removed){const R=this._breakpoints.get(_);R&&(this._breakpoints.delete(_),k.push(R))}if(c.changed){for(const _ of c.changed)if(_.id){const R=this._breakpoints.get(_.id);if(R){if(R instanceof D.FunctionBreakpoint&&_.type==="function"){const B=R;B.enabled=_.enabled,B.condition=_.condition,B.hitCondition=_.hitCondition,B.logMessage=_.logMessage,B.functionName=_.functionName}else if(R instanceof D.SourceBreakpoint&&_.type==="source"){const B=R;B.enabled=_.enabled,B.condition=_.condition,B.hitCondition=_.hitCondition,B.logMessage=_.logMessage,B.location=new D.Location(I.URI.revive(_.uri),new D.Position(_.line,_.character))}g.push(R)}}}this.fireBreakpointChanges(v,k,g)}$provideDebugConfigurations(c,v,k){return(0,T.asPromise)(async()=>{const g=this.getConfigProviderByHandle(c);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const _=await this.getFolder(v);return g.provideDebugConfigurations(_,k)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(c,v,k,g){return(0,T.asPromise)(async()=>{const _=this.getConfigProviderByHandle(c);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(v);return _.resolveDebugConfiguration(R,k,g)})}$resolveDebugConfigurationWithSubstitutedVariables(c,v,k,g){return(0,T.asPromise)(async()=>{const _=this.getConfigProviderByHandle(c);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(v);return _.resolveDebugConfigurationWithSubstitutedVariables(R,k,g)})}async $provideDebugAdapter(c,v){const k=this.getAdapterDescriptorFactoryByHandle(c);if(!k)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(v);return this.getAdapterDescriptor(k,g).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(_)})}async $acceptDebugSessionStarted(c){const v=await this.getSession(c);this._onDidStartDebugSession.fire(v)}async $acceptDebugSessionTerminated(c){const v=await this.getSession(c);v&&(this._onDidTerminateDebugSession.fire(v),this._debugSessions.delete(v.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,v){const k=await this.getSession(c);k&&k._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(c,v){const g={session:await this.getSession(c),event:v.event,body:v.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(c){if(c instanceof D.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof D.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const v=this._adapterFactories.filter(k=>k.type===c);if(v.length>0)return v[0].factory}getAdapterDescriptorFactoryByHandle(c){const v=this._adapterFactories.filter(k=>k.handle===c);if(v.length>0)return v[0].factory}getConfigProviderByHandle(c){const v=this._configProviders.filter(k=>k.handle===c);if(v.length>0)return v[0].provider}definesDebugType(c,v){if(c.contributes){const k=c.contributes.debuggers;if(k&&k.length>0){for(const g of k)if(g.label&&g.type&&g.type===v)return!0}}return!1}getDebugAdapterTrackers(c){const k=c.configuration.type,g=this._trackerFactories.filter(_=>_.type===k||_.type==="*").map(_=>(0,T.asPromise)(()=>_.factory.createDebugAdapterTracker(c)).then(R=>R,R=>null));return Promise.race([Promise.all(g).then(_=>{const R=_.filter(B=>!!B);if(R.length>0)return new n(R)}),new Promise((_,R)=>{const B=setTimeout(()=>{clearTimeout(B),R(new Error("timeout"))},1e3)})]).catch(_=>{})}async getAdapterDescriptor(c,v){const k=v.configuration.debugServer;if(typeof k=="number")return Promise.resolve(new D.DebugAdapterServer(k));if(c){const _=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>c.createDebugAdapterDescriptor(v,this.daExecutableFromPackage(v,_))).then(R=>{if(R)return R})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(v,g))}daExecutableFromPackage(c,v){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,v,k){(c.length>0||v.length>0||k.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:v,changed:k}))}async getSession(c){if(c)if(typeof c=="string"){const v=this._debugSessions.get(c);if(v)return v}else{let v=this._debugSessions.get(c.id);if(!v){const k=await this.getFolder(c.folderUri);v=new l(this._debugServiceProxy,c.id,c.type,c.name,k,c.configuration),this._debugSessions.set(v.id,v),this._debugServiceProxy.$sessionCached(v.id)}return v}throw new Error("cannot find session")}getFolder(c){if(c){const v=I.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}};f=Ve([qe(0,a.IExtHostRpcService),qe(1,C.IExtHostWorkspace),qe(2,i.IExtHostExtensionService),qe(3,P.IExtHostDocumentsAndEditors),qe(4,h.IExtHostConfiguration)],f),e.ExtHostDebugServiceBase=f;class l{constructor(c,v,k,g,_,R){this._debugServiceProxy=c,this._id=v,this._type=k,this._name=g,this._workspaceFolder=_,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,v){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,v)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=l;class b{constructor(c){this.value=Object.freeze({append(v){c.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.ExtHostDebugConsole=b;class t extends d.AbstractVariableResolverService{constructor(c,v,k,g){super({getFolderUri:_=>{const R=c.filter(B=>B.name===_);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(_,R)=>k.getConfiguration(void 0,_).get(R),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(v){const _=v.activeEditor();if(_)return w.normalize(_.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(v&&g){const _=v.activeEditor();if(_){const R=g.getWorkspaceFolder(_.document.uri);if(R)return w.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(v){const _=v.activeEditor();if(_&&!_.selection.isEmpty)return _.document.getText(_.selection)}},getLineNumber:()=>{if(v){const _=v.activeEditor();if(_)return String(_.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=t;class n{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(v=>v.onError?v.onError(c):void 0)}onExit(c,v){this.trackers.forEach(k=>k.onExit?k.onExit(c,v):void 0)}}class u extends S.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends f{constructor(c,v,k,g,_){super(c,v,k,g,_)}createVariableResolver(c,v,k){return new t(c,v,k)}};o=Ve([qe(0,a.IExtHostRpcService),qe(1,C.IExtHostWorkspace),qe(2,i.IExtHostExtensionService),qe(3,P.IExtHostDocumentsAndEditors),qe(4,h.IExtHostConfiguration)],o),e.WorkerExtHostDebugService=o}),define(we[221],_e([0,1,80,2,5,34,33,26,14,27,4,35,46,18]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(f,l,b,t,n,u,o){this._apiFactory=f,this._extensionRegistry=l,this._instaService=b,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=u,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),w.mark("code/extHost/willWaitForConfig");const f=await this._extHostConfiguration.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,l,this._extensionRegistry,f,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,l,this._initData.environment.appUriScheme))}register(f){if(Array.isArray(f.nodeModuleName))for(let l of f.nodeModuleName)this._factories.set(l,f);else this._factories.set(f.nodeModuleName,f);typeof f.alternativeModuleName=="function"&&this._alternatives.push(l=>f.alternativeModuleName(l))}};r=Ve([qe(2,i.IInstantiationService),qe(3,T.IExtHostConfiguration),qe(4,P.IExtHostExtensionService),qe(5,C.IExtHostInitDataService),qe(6,h.ILogService)],r),e.RequireInterceptor=r;class a{constructor(f,l,b,t,n){this._apiFactory=f,this._extensionPaths=l,this._extensionRegistry=b,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(f,l){const b=this._extensionPaths.findSubstr(l.fsPath);if(b){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(b.identifier));return t||(t=this._apiFactory(b,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(b.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,u)=>t+=`	${u} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(f,l){this.nodeModuleName="keytar";const{environment:b}=l,t=f.getProxy(A.MainContext.MainThreadKeytar);if(b.appRoot){let n=b.appRoot.fsPath;d.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,u)=>t.$getPassword(n,u),setPassword:(n,u,o)=>t.$setPassword(n,u,o),deletePassword:(n,u)=>t.$deletePassword(n,u),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(f,l){return this._impl}alternativeModuleName(f){const l=f.length;if(!(l<=7||!this.alternativeNames)){const b=l-7;if((f.charAt(b)==="/"||f.charAt(b)==="\\")&&f.endsWith("keytar")&&(f=f.replace(/\\/g,"/"),this.alternativeNames.has(f)))return"keytar"}}};p=Ve([qe(0,S.IExtHostRpcService),qe(1,C.IExtHostInitDataService)],p);let m=class{constructor(f,l,b){this._extensionPaths=f,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=b.getProxy(A.MainContext.MainThreadTelemetry);const t=b.getProxy(A.MainContext.MainThreadWindow);this._impl=(n,u)=>{const o=I.URI.parse(n);return u?this.callOriginal(n,u):o.scheme==="http"||o.scheme==="https"?t.$openUri(o,n,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?t.$openUri(o,n,{}):this.callOriginal(n,u)}}load(f,l,b){const t=this._extensionPaths.findSubstr(l.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=b(f),this._impl}callOriginal(f,l){return this.sendNoForwardTelemetry(),this._original(f,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=Ve([qe(2,S.IExtHostRpcService)],m)}),define(we[222],_e([0,1,11,12,80,6,2,5,214,18,61,65,27,151,14,71,35,40]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r,a,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(l,b,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const u=new S.RPCProtocol(l,null,n);b=E._transform(b,u);const o=new P.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());o.set(d.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},b)),o.set(r.IExtHostRpcService,new r.ExtHostRpcService(u)),o.set(a.IURITransformerService,new a.URITransformerService(n)),o.set(p.IHostUtils,t);const s=new h.InstantiationService(o,!0),c=s.invokeFunction(_=>_.get(m.IExtHostTerminalService));this._disposables.add(c),this._logService=s.invokeFunction(_=>_.get(C.ILogService)),A.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",b),this._extensionService=s.invokeFunction(_=>_.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(_=>{Error.prepareStackTrace=(R,B)=>{let Q="",ge,V;for(const H of B)Q+=`
	at ${H.toString()}`,V=H.getFileName(),!ge&&V&&(ge=_.findSubstr(V));return v.set(R,ge),`${R.name||"Error"}: ${R.message||""}${Q}`}});const k=u.getProxy(D.MainContext.MainThreadExtensionService),g=u.getProxy(D.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(_=>{const R=I.transformErrorForSerialization(_),B=v.get(_);B?k.$onExtensionRuntimeError(B.identifier,R):g.$onUnexpectedError(R)})}terminate(l){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${l}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(t=>{});const b=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,w.timeout)(4e3),b]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(l,b){l.extensions.forEach(n=>n.extensionLocation=y.URI.revive(b.transformIncomingURIs(n.extensionLocation))),l.environment.appRoot=y.URI.revive(b.transformIncomingURIs(l.environment.appRoot));const t=l.environment.extensionDevelopmentLocationURI;return t&&(l.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(b.transformIncomingURIs(n)))),l.environment.extensionTestsLocationURI=y.URI.revive(b.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=y.URI.revive(b.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=y.URI.revive(b.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=y.URI.revive(b.transformIncomingURIs(l.logsLocation)),l.logFile=y.URI.revive(b.transformIncomingURIs(l.logFile)),l.workspace=b.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=E}),define(we[223],_e([0,1,13,20,60,28,25,55,41]),function(Y,e,w,I,A,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(d,h,r){this.config=d,this.provider=h,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&T.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&T.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const h=this.config.folderQueries||[];return new Promise((r,a)=>{const p=m=>{this.resultCount++,d(m)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(m=>{const E=m.toString(),f=w.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,f)||this.matchFile(p,{base:m,basename:f})}),Promise.all(h.map(m=>this.searchInFolder(m,p))).then(m=>{r({limitHit:this.isLimitHit,stats:m[0]||void 0})},m=>{a(new Error((0,A.toErrorMessage)(m)))})})}async searchInFolder(d,h){const r=new I.CancellationTokenSource,a=this.getSearchOptionsForFolder(d),p=this.initDirectoryTree(),m=new S.QueryGlobTester(this.config,d),E=!m.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(r),f=D.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,r.token),b=f.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(n=>{const u=w.posix.relative(d.folder.path,n.path);if(E){const o=w.basename(n.path);this.matchFile(h,{base:d.folder,relativePath:u,basename:o});return}this.addDirectoryEntries(p,d.folder,u,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,m,h),{providerTime:b,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(d){const h=(0,S.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),r=(0,S.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:r,includes:h,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},h,r,a){if(r===this.filePattern){const m=w.basename(this.filePattern);this.matchFile(a,{base:h,relativePath:this.filePattern,basename:m})}function p(m){const E=w.basename(m),f=w.dirname(m);let l=d[f];l||(l=d[f]=[],p(f)),l.push({base:h,relativePath:m,basename:E})}p(r)}matchDirectoryTree({rootEntries:d,pathToEntries:h},r,a){const p=this,m=this.filePattern;function E(f){const l=T.hasSiblingFn(()=>f.map(b=>b.basename));for(let b=0,t=f.length;b<t;b++){const n=f[b],{relativePath:u,basename:o}=n;if(!!r.includedInQuerySync(u,o,m!==o?l:void 0)){const s=h[u];if(s)E(s);else{if(u===m)continue;p.matchFile(a,n)}if(p.isLimitHit)break}}}E(d)}matchFile(d,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(h))}}class i{constructor(){this.sessions=new Map}fileSearch(d,h,r,a){const p=this.getSessionTokenSource(d.cacheKey),m=new C(d,h,p&&p.token);let E=0;const f=l=>{E+=l.length,r(l.map(b=>this.rawMatchToSearchItem(b)))};return this.doSearch(m,i.BATCH_SIZE,f,a).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:l.stats}}))}clearCache(d){const h=this.getSessionTokenSource(d);h&&h.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new I.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:y.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,h,r,a){a.onCancellationRequested(()=>{d.cancel()});const p=E=>{E&&(m.push(E),h>0&&m.length>=h&&(r(m),m=[]))};let m=[];return d.search(p).then(E=>(m.length&&r(m),E),E=>(m.length&&r(m),Promise.reject(E)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(we[224],_e([0,1,13,15,20,60,25,28,2,41,19,10]),function(Y,e,w,I,A,T,y,D,S,C,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(f,l,b){this.query=f,this.provider=l,this.fileUtils=b,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,l){const b=this.query.folderQueries||[],t=new A.CancellationTokenSource;return l.onCancellationRequested(()=>t.cancel()),new Promise((n,u)=>{this.collector=new r(f);let o=!1;const s=(c,v)=>{if(!o&&!this.isLimitHit){const k=this.resultSize(c);p(c)&&typeof this.query.maxResults=="number"&&this.resultCount+k>this.query.maxResults&&(this.isLimitHit=!0,o=!0,t.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const g=this.resultSize(c);this.resultCount+=g,(g>0||!p(c))&&this.collector.add(c,v)}};Promise.all(b.map((c,v)=>this.searchInFolder(c,k=>s(k,v),t.token))).then(c=>{t.dispose(),this.collector.flush();const v=c.some(k=>!!k&&!!k.limitHit);n({limitHit:this.isLimitHit||v,messages:(0,I.flatten)(c.map(k=>(k==null?void 0:k.message)?(0,P.isArray)(k.message)?k.message:[k.message]:[])),stats:{type:"textSearchProvider"}})},c=>{t.dispose();const v=(0,T.toErrorMessage)(c);u(new Error(v))})})}resultSize(f){return p(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,l){const b=Array.isArray(f.ranges)?f.ranges:[f.ranges],t=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:b.slice(0,l),preview:{matches:t.slice(0,l),text:f.preview.text},uri:f.uri}}async searchInFolder(f,l,b){const t=new C.QueryGlobTester(this.query,f),n=[],u={report:c=>{if(!!this.validateProviderResult(c)){const v=f.folder.scheme===i.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(c.uri))):void 0,k=y.relativePath(f.folder,c.uri);k&&n.push(t.includedInQuery(k,w.basename(k),v).then(g=>{g&&l(c)}))}}},o=this.getSearchOptionsForFolder(f),s=await this.provider.provideTextSearchResults(h(this.query.contentPattern),o,u,b);return await Promise.all(n),s}validateProviderResult(f){if(p(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const l=(0,C.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),b=(0,C.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),t={folder:S.URI.from(f.folder),excludes:b,includes:l,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function h(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class r{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,l=>this.sendItems(l))}add(f,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!y.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(a(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=r;function a(E){return p(E)?{preview:{matches:(0,I.mapArrayOrNot)(E.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:E.preview.text},ranges:(0,I.mapArrayOrNot)(E.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function p(E){return!!E.preview}e.extensionResultIsMatch=p;class m{constructor(f,l){this.maxBatchSize=f,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,l){!f||this.addItemToBatch(f,l)}addItems(f,l){!f||this.addItemsToBatch(f,l)}addItemToBatch(f,l){this.batch.push(f),this.batchSize+=l,this.onUpdate()}addItemsToBatch(f,l){this.batch=this.batch.concat(f),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m,m.TIMEOUT=4e3,m.START_BATCH_AFTER_COUNT=50}),define(we[105],_e([0,1,6,5,4,223,14,71,18,2,224]),function(Y,e,w,I,A,T,y,D,S,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,A.createDecorator)("IExtHostSearch");let P=class{constructor(a,p,m){this.extHostRpc=a,this._uriTransformer=p,this._logService=m,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,p){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const m=this._handlePool++;return this._textSearchProvider.set(m,p),this._proxy.$registerTextSearchProvider(m,this._transformScheme(a)),(0,w.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(a,p){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const m=this._handlePool++;return this._fileSearchProvider.set(m,p),this._proxy.$registerFileSearchProvider(m,this._transformScheme(a)),(0,w.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(a,p,m,E){const f=d(m),l=this._fileSearchProvider.get(a);if(l)return this._fileSearchManager.fileSearch(f,l,b=>{this._proxy.$handleFileMatch(a,p,b.map(t=>t.resource))},E);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,p,m,E){const f=this._textSearchProvider.get(a);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const l=d(m);return this.createTextSearchManager(l,f).search(t=>this._proxy.$handleTextMatch(a,p,t),E)}createTextSearchManager(a,p){return new i.TextSearchManager(a,p,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m})}};P=Ve([qe(0,y.IExtHostRpcService),qe(1,D.IURITransformerService),qe(2,S.ILogService)],P),e.ExtHostSearch=P;function d(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(h),extraFileResources:r.extraFileResources&&r.extraFileResources.map(a=>C.URI.revive(a))})}e.reviveQuery=d;function h(r){return Object.assign(Object.assign({},r),{folder:C.URI.revive(r.folder)})}}),define(we[225],_e([0,1,130,20,12,3,47,2,123,85,117,59,64,5,190,189,76,191,34,192,193,194,176,195,39,35,196,177,198,199,200,100,180,203,204,205,78,40,206,181,9,7,209,50,101,30,33,51,166,197,93,99,103,104,105,18,71,14,27,201,164,70,75,187,207,163,79,77,212,210,211,188,49,218,208,74,160,94,202,67,102]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r,a,p,m,E,f,l,b,t,n,u,o,s,c,v,k,g,_,R,B,Q,ge,V,H,te,$,F,L,M,U,G,J,re,pe,Te,Be,Ae,We,x,q,ne,le,fe,Se,Oe,me,Ce,Pe,$e,Ee,je,z,ee,ve,Le,He,Ue,Xe,W,ie,ce,j,X,ae,he,ye,ze){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function xe(Ne){const Ge=Ne.get(Oe.IExtHostInitDataService),nt=Ne.get(W.IExtHostFileSystemInfo),dt=Ne.get(ve.IExtHostConsumerFileSystem),it=Ne.get(o.IExtHostExtensionService),Je=Ne.get(J.IExtHostWorkspace),mt=Ne.get(ae.IExtHostTelemetry),bt=Ne.get(E.IExtHostConfiguration),be=Ne.get(fe.IURITransformerService),de=Ne.get(Se.IExtHostRpcService),oe=Ne.get(V.IExtHostStorage),K=Ne.get(ee.IExtensionStoragePaths),Re=Ne.get(le.ILogService),Ie=Ne.get(Pe.IExtHostTunnelService),Qe=Ne.get($e.IExtHostApiDeprecationService),Ze=Ne.get(G.IExtHostWindow),ut=Ne.get(j.IExtHostSecretState);de.set(h.ExtHostContext.ExtHostFileSystemInfo,nt),de.set(h.ExtHostContext.ExtHostLogService,Re),de.set(h.ExtHostContext.ExtHostWorkspace,Je),de.set(h.ExtHostContext.ExtHostConfiguration,bt),de.set(h.ExtHostContext.ExtHostExtensionService,it),de.set(h.ExtHostContext.ExtHostStorage,oe),de.set(h.ExtHostContext.ExtHostTunnelService,Ie),de.set(h.ExtHostContext.ExtHostWindow,Ze),de.set(h.ExtHostContext.ExtHostSecretState,ut),de.set(h.ExtHostContext.ExtHostTelemetry,mt);const ht=de.set(h.ExtHostContext.ExtHostDecorations,Ne.get(We.IExtHostDecorations)),Ye=de.set(h.ExtHostContext.ExtHostDocumentsAndEditors,Ne.get(u.IExtHostDocumentsAndEditors)),ot=de.set(h.ExtHostContext.ExtHostCommands,Ne.get(p.IExtHostCommands)),ft=de.set(h.ExtHostContext.ExtHostTerminalService,Ne.get(H.IExtHostTerminalService)),at=de.set(h.ExtHostContext.ExtHostDebugService,Ne.get(q.IExtHostDebugService)),Et=de.set(h.ExtHostContext.ExtHostSearch,Ne.get(ne.IExtHostSearch)),vt=de.set(h.ExtHostContext.ExtHostTask,Ne.get(x.IExtHostTask)),kt=de.set(h.ExtHostContext.ExtHostOutputService,Ne.get(_.IExtHostOutputService)),At=de.set(h.ExtHostContext.ExtHostEditorTabs,new X.ExtHostEditorTabs),Tt=de.set(h.ExtHostContext.ExtHostUrls,new M.ExtHostUrls(de)),_t=de.set(h.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(de,Ye)),Yt=de.set(h.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(de,Ye,Re)),Jt=de.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Re,_t,de.getProxy(h.MainContext.MainThreadBulkEdits))),gt=de.set(h.ExtHostContext.ExtHostNotebook,new me.ExtHostNotebookController(de,ot,Ye,_t,Re,K)),Xt=de.set(h.ExtHostContext.ExtHostNotebookKernels,new he.ExtHostNotebookKernels(de,Ge,gt)),St=de.set(h.ExtHostContext.ExtHostEditors,new te.ExtHostEditors(de,Ye)),jt=de.set(h.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(de.getProxy(h.MainContext.MainThreadTreeViews),ot,Re)),Zt=de.set(h.ExtHostContext.ExtHostEditorInsets,new Te.ExtHostEditorInsets(de.getProxy(h.MainContext.MainThreadEditorInsets),St,Ge.environment)),qt=de.set(h.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(de,Re)),lt=de.set(h.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(de,be,_t,ot,qt,Re,Qe)),en=de.set(h.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(de,lt)),Rt=de.set(h.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(de,Re,Ye)),Bt=de.set(h.ExtHostContext.ExtHostQuickOpen,(0,B.createExtHostQuickOpen)(de,Je,ot)),dn=de.set(h.ExtHostContext.ExtHostSCM,new Q.ExtHostSCM(de,ot,Re)),_n=de.set(h.ExtHostContext.ExtHostComments,new m.ExtHostComments(de,ot,_t)),hn=de.set(h.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(de.getProxy(h.MainContext.MainThreadProgress))),tn=de.set(h.ExtHostContext.ExtHosLabelService,new Be.ExtHostLabelService(de)),Kt=de.set(h.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(de)),Nt=de.set(h.ExtHostContext.ExtHostAuthentication,new Ee.ExtHostAuthentication(de)),En=de.set(h.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(de,ot)),nn=de.set(h.ExtHostContext.ExtHostWebviews,new U.ExtHostWebviews(de,Ge.environment,Je,Re,Qe)),rn=de.set(h.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(de,nn,Je)),Gt=de.set(h.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(de,_t,K,nn,rn)),yn=de.set(h.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(de,nn)),Ft=de.set(h.ExtHostContext.ExtHostTesting,new ie.ExtHostTesting(de,Ye,Je)),sn=de.set(h.ExtHostContext.ExtHostUriOpeners,new ce.ExtHostUriOpeners(de)),Sn=(0,pe.values)(h.ExtHostContext);de.assertRegistered(Sn);const $t=new Xe.ExtHostBulkEdits(de,Ye),on=new a.ExtHostClipboard(de),Ut=new g.ExtHostMessageService(de,Re),Lt=new l.ExtHostDialogs(de),fn=new ge.ExtHostStatusBar(de,ot.converter),Wt=new k.ExtHostLanguages(de,_t);return r.ExtHostApiCommands.register(ot),function(Fe,an,ln){const pt=function(){let Z=!Fe.isUnderDevelopment;function ue(ke){Z||(Re.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function ke(rt){if(Array.isArray(rt))rt.forEach(ke);else if(typeof rt=="string")ue(rt);else{const wt=rt;typeof wt.scheme=="undefined"&&ue(rt),!Fe.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,re.throwProposedApiError)(Fe)}return rt}}(),Dn={getSession(Z,ue,ke){return Nt.getSession(Fe,Z,ue,ke)},get onDidChangeSessions(){return Nt.onDidChangeSessions},registerAuthenticationProvider(Z,ue,ke,rt){return Nt.registerAuthenticationProvider(Z,ue,ke,rt)},get onDidChangeAuthenticationProviders(){return(0,re.checkProposedApiEnabled)(Fe),Nt.onDidChangeAuthenticationProviders},get providers(){return(0,re.checkProposedApiEnabled)(Fe),Nt.providers},logout(Z,ue){return(0,re.checkProposedApiEnabled)(Fe),Nt.removeSession(Z,ue)}},Cn={registerCommand(Z,ue,ke){return ot.registerCommand(!0,Z,ue,ke)},registerTextEditorCommand(Z,ue,ke){return ot.registerCommand(!0,Z,(...rt)=>{const wt=St.getActiveTextEditor();if(!wt){Re.warn("Cannot execute "+Z+" because there is no active text editor.");return}return wt.edit(Dt=>{ue.apply(ke,[wt,Dt,...rt])}).then(Dt=>{Dt||Re.warn("Edits from command "+Z+" were not applied.")},Dt=>{Re.warn("An error occurred while running command "+Z,Dt)})})},registerDiffInformationCommand:(Z,ue,ke)=>((0,re.checkProposedApiEnabled)(Fe),ot.registerCommand(!0,Z,async(...rt)=>{const wt=Ye.activeEditor(!0);if(!wt){Re.warn("Cannot execute "+Z+" because there is no active text editor.");return}const Dt=await St.getDiffInformation(wt.id);ue.apply(ke,[Dt,...rt])})),executeCommand(Z,...ue){return ot.executeCommand(Z,...ue)},getCommands(Z=!1){return ot.getCommands(Z)}},mn={get machineId(){return Ge.telemetryInfo.machineId},get sessionId(){return Ge.telemetryInfo.sessionId},get language(){return Ge.environment.appLanguage},get appName(){return Ge.environment.appName},get appRoot(){var Z,ue;return(ue=(Z=Ge.environment.appRoot)===null||Z===void 0?void 0:Z.fsPath)!==null&&ue!==void 0?ue:""},get uriScheme(){return Ge.environment.appUriScheme},get clipboard(){return on.value},get shell(){return ft.getDefaultShell(!1,ln)},get isTelemetryEnabled(){return mt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return mt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Z=Date.now()-new Date(Ge.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,ue){return Ze.openUri(Z,{allowTunneling:!!Ge.remote.authority,allowContributedOpeners:ue==null?void 0:ue.allowContributedOpeners})},asExternalUri(Z){return Z.scheme===Ge.environment.appUriScheme?Tt.createAppUri(Z):Ze.asExternalUri(Z,{allowTunneling:!!Ge.remote.authority})},get remoteName(){return(0,Ae.getRemoteName)(Ge.remote.authority)},get uiKind(){return Ge.uiKind}};Ge.environment.extensionTestsLocationURI||Object.freeze(mn);const gn=Ge.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Ht={registerTestController(Z){return(0,re.checkProposedApiEnabled)(Fe),Ft.registerTestController(Fe.identifier.value,Z)},createDocumentTestObserver(Z){return(0,re.checkProposedApiEnabled)(Fe),Ft.createTextDocumentTestObserver(Z)},createWorkspaceTestObserver(Z){return(0,re.checkProposedApiEnabled)(Fe),Ft.createWorkspaceTestObserver(Z)},runTests(Z){return(0,re.checkProposedApiEnabled)(Fe),Ft.runTests(Z)},createTestItem(Z,ue){return new L.TestItemImpl(Z.id,Z.label,Z.uri,ue)},createTestRun(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),Ft.createTestRun(Fe.identifier.value,Z,ue,ke)},get onDidChangeTestResults(){return(0,re.checkProposedApiEnabled)(Fe),Ft.onResultsChanged},get testResults(){return(0,re.checkProposedApiEnabled)(Fe),Ft.results}};Ht.createTestRunTask=Ht.createTestRun;const kn={getExtension(Z){const ue=an.getExtensionDescription(Z);if(ue)return new o.Extension(it,Fe.identifier,ue,gn)},get all(){return an.getAllExtensionDescriptions().map(Z=>new o.Extension(it,Fe.identifier,Z,gn))},get onDidChange(){return an.onDidChange}},In={createDiagnosticCollection(Z){return qt.createDiagnosticCollection(Fe.identifier,Z)},get onDidChangeDiagnostics(){return qt.onDidChangeDiagnostics},getDiagnostics:Z=>qt.getDiagnostics(Z),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Z,ue){return Wt.changeLanguage(Z.uri,ue)},match(Z,ue){return(0,P.score)(F.LanguageSelector.from(Z),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(Z,ue,ke){return lt.registerCodeActionProvider(Fe,pt(Z),ue,ke)},registerCodeLensProvider(Z,ue){return lt.registerCodeLensProvider(Fe,pt(Z),ue)},registerDefinitionProvider(Z,ue){return lt.registerDefinitionProvider(Fe,pt(Z),ue)},registerDeclarationProvider(Z,ue){return lt.registerDeclarationProvider(Fe,pt(Z),ue)},registerImplementationProvider(Z,ue){return lt.registerImplementationProvider(Fe,pt(Z),ue)},registerTypeDefinitionProvider(Z,ue){return lt.registerTypeDefinitionProvider(Fe,pt(Z),ue)},registerHoverProvider(Z,ue){return lt.registerHoverProvider(Fe,pt(Z),ue,Fe.identifier)},registerEvaluatableExpressionProvider(Z,ue){return lt.registerEvaluatableExpressionProvider(Fe,pt(Z),ue,Fe.identifier)},registerInlineValuesProvider(Z,ue){return lt.registerInlineValuesProvider(Fe,pt(Z),ue,Fe.identifier)},registerDocumentHighlightProvider(Z,ue){return lt.registerDocumentHighlightProvider(Fe,pt(Z),ue)},registerLinkedEditingRangeProvider(Z,ue){return lt.registerLinkedEditingRangeProvider(Fe,pt(Z),ue)},registerReferenceProvider(Z,ue){return lt.registerReferenceProvider(Fe,pt(Z),ue)},registerRenameProvider(Z,ue){return lt.registerRenameProvider(Fe,pt(Z),ue)},registerDocumentSymbolProvider(Z,ue,ke){return lt.registerDocumentSymbolProvider(Fe,pt(Z),ue,ke)},registerWorkspaceSymbolProvider(Z){return lt.registerWorkspaceSymbolProvider(Fe,Z)},registerDocumentFormattingEditProvider(Z,ue){return lt.registerDocumentFormattingEditProvider(Fe,pt(Z),ue)},registerDocumentRangeFormattingEditProvider(Z,ue){return lt.registerDocumentRangeFormattingEditProvider(Fe,pt(Z),ue)},registerOnTypeFormattingEditProvider(Z,ue,ke,...rt){return lt.registerOnTypeFormattingEditProvider(Fe,pt(Z),ue,[ke].concat(rt))},registerDocumentSemanticTokensProvider(Z,ue,ke){return lt.registerDocumentSemanticTokensProvider(Fe,pt(Z),ue,ke)},registerDocumentRangeSemanticTokensProvider(Z,ue,ke){return lt.registerDocumentRangeSemanticTokensProvider(Fe,pt(Z),ue,ke)},registerSignatureHelpProvider(Z,ue,ke,...rt){return typeof ke=="object"?lt.registerSignatureHelpProvider(Fe,pt(Z),ue,ke):lt.registerSignatureHelpProvider(Fe,pt(Z),ue,typeof ke=="undefined"?[]:[ke,...rt])},registerCompletionItemProvider(Z,ue,...ke){return lt.registerCompletionItemProvider(Fe,pt(Z),ue,ke)},registerDocumentLinkProvider(Z,ue){return lt.registerDocumentLinkProvider(Fe,pt(Z),ue)},registerColorProvider(Z,ue){return lt.registerColorProvider(Fe,pt(Z),ue)},registerFoldingRangeProvider(Z,ue){return lt.registerFoldingRangeProvider(Fe,pt(Z),ue)},registerSelectionRangeProvider(Z,ue){return lt.registerSelectionRangeProvider(Fe,Z,ue)},registerCallHierarchyProvider(Z,ue){return lt.registerCallHierarchyProvider(Fe,Z,ue)},setLanguageConfiguration:(Z,ue)=>lt.setLanguageConfiguration(Fe,Z,ue),getTokenInformationAtPosition(Z,ue){return(0,re.checkProposedApiEnabled)(Fe),Wt.tokenAtPosition(Z,ue)},registerInlayHintsProvider(Z,ue){return(0,re.checkProposedApiEnabled)(Fe),lt.registerInlayHintsProvider(Fe,Z,ue)}},Pn={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(Z,ue,ke){const rt=await(D.URI.isUri(Z)?Promise.resolve(pn.openTextDocument(Z)):Promise.resolve(Z));return St.showTextDocument(rt,ue,ke)},createTextEditorDecorationType(Z){return St.createTextEditorDecorationType(Z)},onDidChangeActiveTextEditor(Z,ue,ke){return St.onDidChangeActiveTextEditor(Z,ue,ke)},onDidChangeVisibleTextEditors(Z,ue,ke){return St.onDidChangeVisibleTextEditors(Z,ue,ke)},onDidChangeTextEditorSelection(Z,ue,ke){return St.onDidChangeTextEditorSelection(Z,ue,ke)},onDidChangeTextEditorOptions(Z,ue,ke){return St.onDidChangeTextEditorOptions(Z,ue,ke)},onDidChangeTextEditorVisibleRanges(Z,ue,ke){return St.onDidChangeTextEditorVisibleRanges(Z,ue,ke)},onDidChangeTextEditorViewColumn(Z,ue,ke){return St.onDidChangeTextEditorViewColumn(Z,ue,ke)},onDidCloseTerminal(Z,ue,ke){return ft.onDidCloseTerminal(Z,ue,ke)},onDidOpenTerminal(Z,ue,ke){return ft.onDidOpenTerminal(Z,ue,ke)},onDidChangeActiveTerminal(Z,ue,ke){return ft.onDidChangeActiveTerminal(Z,ue,ke)},onDidChangeTerminalDimensions(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),ft.onDidChangeTerminalDimensions(Z,ue,ke)},onDidWriteTerminalData(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),ft.onDidWriteTerminalData(Z,ue,ke)},get state(){return Ze.state},onDidChangeWindowState(Z,ue,ke){return Ze.onDidChangeWindowState(Z,ue,ke)},showInformationMessage(Z,...ue){return Ut.showMessage(Fe,y.default.Info,Z,ue[0],ue.slice(1))},showWarningMessage(Z,...ue){return Ut.showMessage(Fe,y.default.Warning,Z,ue[0],ue.slice(1))},showErrorMessage(Z,...ue){return Ut.showMessage(Fe,y.default.Error,Z,ue[0],ue.slice(1))},showQuickPick(Z,ue,ke){return Bt.showQuickPick(Z,!!Fe.enableProposedApi,ue,ke)},showWorkspaceFolderPick(Z){return Bt.showWorkspaceFolderPick(Z)},showInputBox(Z,ue){return Bt.showInput(Z,ue)},showOpenDialog(Z){return Lt.showOpenDialog(Z)},showSaveDialog(Z){return Lt.showSaveDialog(Z)},createStatusBarItem(Z,ue){let ke,rt,wt,Dt;return Z&&typeof Z!="number"?(ke=Z.id,rt=Z.name,wt=Z.alignment,ue=Z.priority,Dt=Z.accessibilityInformation):(ke=Fe.identifier.value,rt=w.localize(0,null,Fe.displayName||Fe.name),wt=Z),fn.createStatusBarEntry(ke,rt,wt,ue,Dt)},setStatusBarMessage(Z,ue){return fn.setStatusBarMessage(Z,ue)},withScmProgress(Z){return Qe.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),hn.withProgress(Fe,{location:L.ProgressLocation.SourceControl},(ue,ke)=>Z({report(rt){}}))},withProgress(Z,ue){return hn.withProgress(Fe,Z,ue)},createOutputChannel(Z){return kt.createOutputChannel(Z)},createWebviewPanel(Z,ue,ke,rt){return rn.createWebviewPanel(Fe,Z,ue,ke,rt)},createWebviewTextEditorInset(Z,ue,ke,rt){return(0,re.checkProposedApiEnabled)(Fe),Zt.createWebviewEditorInset(Z,ue,ke,rt,Fe)},createTerminal(Z,ue,ke){return typeof Z=="object"?"pty"in Z?ft.createExtensionTerminal(Z):(Z.icon&&(0,re.checkProposedApiEnabled)(Fe),ft.createTerminalFromOptions(Z)):ft.createTerminal(Z,ue,ke)},registerTerminalLinkProvider(Z){return ft.registerLinkProvider(Z)},registerTreeDataProvider(Z,ue){return jt.registerTreeDataProvider(Z,ue,Fe)},createTreeView(Z,ue){return jt.createTreeView(Z,ue,Fe)},registerWebviewPanelSerializer:(Z,ue)=>rn.registerWebviewPanelSerializer(Fe,Z,ue),registerCustomEditorProvider:(Z,ue,ke={})=>Gt.registerCustomEditorProvider(Fe,Z,ue,ke),registerFileDecorationProvider(Z){return ht.registerFileDecorationProvider(Z,Fe.identifier)},registerUriHandler(Z){return Tt.registerUriHandler(Fe.identifier,Z)},createQuickPick(){return Bt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Bt.createInputBox(Fe.identifier)},get activeColorTheme(){return Kt.activeColorTheme},onDidChangeActiveColorTheme(Z,ue,ke){return Kt.onDidChangeActiveColorTheme(Z,ue,ke)},registerWebviewViewProvider(Z,ue,ke){return yn.registerWebviewViewProvider(Fe,Z,ue,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,re.checkProposedApiEnabled)(Fe),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeActiveNotebookEditor(Z,ue,ke)},get visibleNotebookEditors(){return(0,re.checkProposedApiEnabled)(Fe),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookEditorSelection(Z,ue,ke)},onDidChangeNotebookEditorVisibleRanges(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookEditorVisibleRanges(Z,ue,ke)},showNotebookDocument(Z,ue){return(0,re.checkProposedApiEnabled)(Fe),gt.showNotebookDocument(Z,ue)},registerExternalUriOpener(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),sn.registerExternalUriOpener(Fe.identifier,Z,ue,ke)},get openEditors(){return(0,re.checkProposedApiEnabled)(Fe),At.tabs},get onDidChangeOpenEditors(){return(0,re.checkProposedApiEnabled)(Fe),At.onDidChangeTabs}},pn={get rootPath(){return Qe.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Je.getPath()},set rootPath(Z){throw A.readonly()},getWorkspaceFolder(Z){return Je.getWorkspaceFolder(Z)},get workspaceFolders(){return Je.getWorkspaceFolders()},get name(){return Je.name},set name(Z){throw A.readonly()},get workspaceFile(){return Je.workspaceFile},set workspaceFile(Z){throw A.readonly()},updateWorkspaceFolders:(Z,ue,...ke)=>Je.updateWorkspaceFolders(Fe,Z,ue||0,...ke),onDidChangeWorkspaceFolders:function(Z,ue,ke){return Je.onDidChangeWorkspace(Z,ue,ke)},asRelativePath:(Z,ue)=>Je.getRelativePath(Z,ue),findFiles:(Z,ue,ke,rt)=>Je.findFiles(F.GlobPattern.from(Z),F.GlobPattern.from(ue),ke,Fe.identifier,rt),findTextInFiles:(Z,ue,ke,rt)=>{let wt,Dt;return typeof ue=="object"?(wt=ue,Dt=ke):(wt={},Dt=ue,rt=ke),Je.findTextInFiles(Z,wt||{},Dt,Fe.identifier,rt)},saveAll:Z=>Je.saveAll(Z),applyEdit(Z){return $t.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,ue,ke,rt)=>Rt.createFileSystemWatcher(F.GlobPattern.from(Z),ue,ke,rt),get textDocuments(){return _t.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw A.readonly()},openTextDocument(Z){let ue;const ke=Z;if(typeof Z=="string")ue=Promise.resolve(D.URI.file(Z));else if(D.URI.isUri(Z))ue=Promise.resolve(Z);else if(!ke||typeof ke=="object")ue=_t.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(rt=>_t.ensureDocumentData(rt).then(wt=>wt.document))},onDidOpenTextDocument:(Z,ue,ke)=>_t.onDidAddDocument(Z,ue,ke),onDidCloseTextDocument:(Z,ue,ke)=>_t.onDidRemoveDocument(Z,ue,ke),onDidChangeTextDocument:(Z,ue,ke)=>_t.onDidChangeDocument(Z,ue,ke),onDidSaveTextDocument:(Z,ue,ke)=>_t.onDidSaveDocument(Z,ue,ke),onWillSaveTextDocument:(Z,ue,ke)=>Jt.getOnWillSaveTextDocumentEvent(Fe)(Z,ue,ke),onDidChangeConfiguration:(Z,ue,ke)=>ln.onDidChangeConfiguration(Z,ue,ke),getConfiguration(Z,ue){return ue=arguments.length===1?void 0:ue,ln.getConfiguration(Z,ue,Fe)},registerTextDocumentContentProvider(Z,ue){return Yt.registerTextDocumentContentProvider(Z,ue)},registerTaskProvider:(Z,ue)=>(Qe.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Fe,Z,ue)),registerFileSystemProvider(Z,ue,ke){return en.registerFileSystemProvider(Fe.identifier,Z,ue,ke)},get fs(){return dt.value},registerFileSearchProvider:(Z,ue)=>((0,re.checkProposedApiEnabled)(Fe),Et.registerFileSearchProvider(Z,ue)),registerTextSearchProvider:(Z,ue)=>((0,re.checkProposedApiEnabled)(Fe),Et.registerTextSearchProvider(Z,ue)),registerRemoteAuthorityResolver:(Z,ue)=>((0,re.checkProposedApiEnabled)(Fe),it.registerRemoteAuthorityResolver(Z,ue)),registerResourceLabelFormatter:Z=>((0,re.checkProposedApiEnabled)(Fe),tn.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,ue,ke)=>Rt.onDidCreateFile(Z,ue,ke),onDidDeleteFiles:(Z,ue,ke)=>Rt.onDidDeleteFile(Z,ue,ke),onDidRenameFiles:(Z,ue,ke)=>Rt.onDidRenameFile(Z,ue,ke),onWillCreateFiles:(Z,ue,ke)=>Rt.getOnWillCreateFileEvent(Fe)(Z,ue,ke),onWillDeleteFiles:(Z,ue,ke)=>Rt.getOnWillDeleteFileEvent(Fe)(Z,ue,ke),onWillRenameFiles:(Z,ue,ke)=>Rt.getOnWillRenameFileEvent(Fe)(Z,ue,ke),openTunnel:Z=>((0,re.checkProposedApiEnabled)(Fe),Ie.openTunnel(Fe,Z).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,re.checkProposedApiEnabled)(Fe),Ie.getTunnels()},onDidChangeTunnels:(Z,ue,ke)=>((0,re.checkProposedApiEnabled)(Fe),Ie.onDidChangeTunnels(Z,ue,ke)),registerPortAttributesProvider:(Z,ue)=>((0,re.checkProposedApiEnabled)(Fe),Ie.registerPortsAttributesProvider(Z,ue)),registerTimelineProvider:(Z,ue)=>((0,re.checkProposedApiEnabled)(Fe),En.registerTimelineProvider(Z,ue,Fe.identifier,ot.converter)),get isTrusted(){return Je.trusted},requestWorkspaceTrust:Z=>((0,re.checkProposedApiEnabled)(Fe),Je.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,ue,ke)=>Je.onDidGrantWorkspaceTrust(Z,ue,ke)},An={get inputBox(){return Qe.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),dn.getLastInputBox(Fe)},createSourceControl(Z,ue,ke){return dn.createSourceControl(Fe,Z,ue,ke)}},vn={createCommentController(Z,ue){return _n.createCommentController(Fe,Z,ue)}},bn={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(Z,ue,ke){return at.onDidStartDebugSession(Z,ue,ke)},onDidTerminateDebugSession(Z,ue,ke){return at.onDidTerminateDebugSession(Z,ue,ke)},onDidChangeActiveDebugSession(Z,ue,ke){return at.onDidChangeActiveDebugSession(Z,ue,ke)},onDidReceiveDebugSessionCustomEvent(Z,ue,ke){return at.onDidReceiveDebugSessionCustomEvent(Z,ue,ke)},onDidChangeBreakpoints(Z,ue,ke){return at.onDidChangeBreakpoints(Z,ue,ke)},registerDebugConfigurationProvider(Z,ue,ke){return at.registerDebugConfigurationProvider(Z,ue,ke||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,ue){return at.registerDebugAdapterDescriptorFactory(Fe,Z,ue)},registerDebugAdapterTrackerFactory(Z,ue){return at.registerDebugAdapterTrackerFactory(Z,ue)},startDebugging(Z,ue,ke){return!ke||typeof ke=="object"&&"configuration"in ke?at.startDebugging(Z,ue,{parentSession:ke}):at.startDebugging(Z,ue,ke||{})},stopDebugging(Z){return at.stopDebugging(Z)},addBreakpoints(Z){return at.addBreakpoints(Z)},removeBreakpoints(Z){return at.removeBreakpoints(Z)},asDebugSourceUri(Z,ue){return at.asDebugSourceUri(Z,ue)}},xt={registerTaskProvider:(Z,ue)=>vt.registerTaskProvider(Fe,Z,ue),fetchTasks:Z=>vt.fetchTasks(Z),executeTask:Z=>vt.executeTask(Fe,Z),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(Z,ue,ke)=>vt.onDidStartTask(Z,ue,ke),onDidEndTask:(Z,ue,ke)=>vt.onDidEndTask(Z,ue,ke),onDidStartTaskProcess:(Z,ue,ke)=>vt.onDidStartTaskProcess(Z,ue,ke),onDidEndTaskProcess:(Z,ue,ke)=>vt.onDidEndTaskProcess(Z,ue,ke)},zt={openNotebookDocument:Z=>((0,re.checkProposedApiEnabled)(Fe),gt.openNotebookDocument(Z)),get onDidOpenNotebookDocument(){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,re.checkProposedApiEnabled)(Fe),gt.notebookDocuments.map(Z=>Z.apiNotebook)},registerNotebookSerializer(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.registerNotebookSerializer(Fe,Z,ue,ke)},registerNotebookContentProvider:(Z,ue,ke)=>((0,re.checkProposedApiEnabled)(Fe),gt.registerNotebookContentProvider(Fe,Z,ue,ke)),registerNotebookCellStatusBarItemProvider:(Z,ue)=>((0,re.checkProposedApiEnabled)(Fe),gt.registerNotebookCellStatusBarItemProvider(Fe,Z,ue)),createNotebookEditorDecorationType(Z){return(0,re.checkProposedApiEnabled)(Fe),gt.createNotebookEditorDecorationType(Z)},onDidChangeNotebookDocumentMetadata(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookDocumentMetadata(Z,ue,ke)},onDidChangeNotebookCells(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCells(Z,ue,ke)},onDidChangeCellExecutionState(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCellExecutionState(Z,ue,ke)},onDidChangeCellOutputs(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeCellOutputs(Z,ue,ke)},onDidChangeCellMetadata(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeCellMetadata(Z,ue,ke)},createConcatTextDocument(Z,ue){return(0,re.checkProposedApiEnabled)(Fe),new z.ExtHostNotebookConcatDocument(gt,_t,Z,ue)},createNotebookController(Z,ue,ke,rt,wt){return(0,re.checkProposedApiEnabled)(Fe),Xt.createNotebookController(Fe,Z,ue,ke,rt,wt)}};return{version:Ge.version,authentication:Dn,commands:Cn,comments:vn,debug:bn,env:mn,extensions:kn,languages:In,notebook:zt,scm:An,tasks:xt,test:Ht,window:Pn,workspace:pn,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,EventEmitter:T.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:d.FileType,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,Hover:L.Hover,IndentAction:i.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,UIKind:h.UIKind,Uri:D.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlayHint:L.InlayHint,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,RemoteTrustOption:ye.RemoteTrustOption,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookDocumentMetadata:L.NotebookDocumentMetadata,NotebookCellMetadata:L.NotebookCellMetadata,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookKernelPreload:L.NotebookKernelPreload,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,LinkedEditingRanges:L.LinkedEditingRanges,TestItemStatus:L.TestItemStatus,TestResultState:L.TestResultState,TestMessage:L.TestMessage,TextSearchCompleteMessageType:ze.TextSearchCompleteMessageType,TestMessageSeverity:L.TestMessageSeverity,WorkspaceTrustState:L.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=xe}),define(we[226],_e([0,1,61,100,30,99,34,76,39,40,103,104,105,79,78,70,75,101,77,49,74,94]),function(Y,e,w,I,A,T,y,D,S,C,i,P,d,h,r,a,p,m,E,f,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(h.IExtensionStoragePaths,h.ExtensionStoragePaths),(0,w.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,w.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,w.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,w.registerSingleton)(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),(0,w.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,w.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,w.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,w.registerSingleton)(f.IExtHostFileSystemInfo,f.ExtHostFileSystemInfo),(0,w.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,w.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,w.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,w.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,w.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,w.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,w.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,w.registerSingleton)(A.IExtHostWorkspace,A.ExtHostWorkspace),(0,w.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,w.registerSingleton)(b.IExtHostTelemetry,b.ExtHostTelemetry)}),define(we[227],_e([0,1,225,35,221,7,11,5]),function(Y,e,w,I,A,T,y,D){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(r){var a;const p=(a=self.trustedTypes)===null||a===void 0?void 0:a.createPolicy("TrustedFunctionWorkaround",{createScript:(E,...f)=>{f.forEach(n=>{var u;if(!((u=self.trustedTypes)===null||u===void 0?void 0:u.isScript(n)))throw new Error("TrustedScripts only, please")});const l=f.slice(0,-1).join(","),b=f.pop().toString();return`(function anonymous(${l}) {
${b}
})`}});function m(...E){return p?self.eval(p.createScript("",...E)):new Function(...E)}r.create=m})(C||(C={}));class i extends A.RequireInterceptor{_installInterceptor(){}getModule(a,p){for(let m of this._alternatives){let E=m(a);if(E){a=E;break}}if(this._factories.has(a))return this._factories.get(a).load(a,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const a=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);h(a,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(w.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(a){return a.browser}async _loadCommonJSModule(a,p,m){var E,f,l,b,t,n,u,o;p=p.with({path:d(p.path,".js")}),a&&performance.mark(`code/extHost/willFetchExtensionCode/${a.value}`);const s=await fetch(p.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a.value}`),s.status!==200)throw new Error(s.statusText);const c=await s.text(),v=`${p.toString(!0)}#vscode-extension`,k=`${c}
//# sourceURL=${v}`;let g;try{g=C.create((f=(E=P._ttpExtensionScripts)===null||E===void 0?void 0:E.createScript("module"))!==null&&f!==void 0?f:"module",(b=(l=P._ttpExtensionScripts)===null||l===void 0?void 0:l.createScript("exports"))!==null&&b!==void 0?b:"exports",(n=(t=P._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&n!==void 0?n:"require",(o=(u=P._ttpExtensionScripts)===null||u===void 0?void 0:u.createScript(k))!==null&&o!==void 0?o:k)}catch(Q){throw a?console.error(`Loading code for extension ${a.value} failed: ${Q.message}`):console.error(`Loading code failed: ${Q.message}`),console.error(`${p.toString(!0)}${typeof Q.line=="number"?` line ${Q.line}`:""}${typeof Q.column=="number"?` column ${Q.column}`:""}`),console.error(Q),Q}const _={},R={exports:_},B=Q=>{const ge=this._fakeModules.getModule(Q,p);if(ge===void 0)throw new Error(`Cannot load module '${Q}'`);return ge};try{return m.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a.value}`),g(R,_,B),R.exports!==_?R.exports:_}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(a){throw new Error("Not supported")}async _waitForDebuggerAttachment(a=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const p=Date.now()+a;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,y.timeout)(10)}}}e.ExtHostExtensionService=P,P._ttpExtensionScripts=(S=self.trustedTypes)===null||S===void 0?void 0:S.createPolicy("ExtensionScripts",{createScript:r=>r});function d(r,a){return r.endsWith(a)?r:r+a}function h(r,a){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(f,l){const b=console[f];console[f]=function(){r.$logExtensionHostMessage({type:"__$console",severity:l,arguments:E(arguments)}),a&&b.apply(console,arguments)}}const m=1e5;function E(f){const l=[],b=[];if(f.length)for(let t=0;t<f.length;t++){if(typeof f[t]=="undefined")f[t]="undefined";else if(f[t]instanceof Error){const n=f[t];n.stack?f[t]=n.stack:f[t]=n.toString()}b.push(f[t])}try{const t=JSON.stringify(b,function(n,u){if(u&&typeof u=="object"){if(l.indexOf(u)!==-1)return"[Circular]";l.push(u)}return u});return t.length>m?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(we[228],_e([0,1,61,18,35,227,213]),function(Y,e,w,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(A.IExtHostExtensionService,T.ExtHostExtensionService),(0,w.registerSingleton)(I.ILogService,y.ExtHostLogService)}),define(we[230],_e([0,1,24,3,184,222,215,13,80,226,228]),function(Y,e,w,I,A,T,y,D,S){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0});const i=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const P=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const p=(C=self.trustedTypes)===null||C===void 0?void 0:C.createPolicy("extensionHostWorker",{createScriptURL:E=>E}),m=self.Worker;Worker=function(E,f){const l=`importScripts('${E}');`;f=f||{},f.name=f.name||D.basename(E.toString());const b=new Blob([l],{type:"application/javascript"}),t=URL.createObjectURL(b);return new m(p?p.createScriptURL(t):t,f)}}else self.Worker=class extends y.NestedWorker{constructor(p,m){super(P,p,Object.assign({name:D.basename(p.toString())},m))}};const d=new class{exit(p){i()}async exists(p){return!0}async realpath(p){return p}};class h{constructor(){const m=new MessageChannel,E=new I.Emitter;let f=!1;P(m.port2,[m.port2]),m.port1.onmessage=l=>{const{data:b}=l;if(!(b instanceof ArrayBuffer)){console.warn("UNKNOWN data received",b);return}const t=w.VSBuffer.wrap(new Uint8Array(b,0,b.byteLength));if((0,A.isMessageOfType)(t,2)){f=!0,a("received terminate message from renderer");return}E.fire(t)},this.protocol={onMessage:E.event,send:l=>{if(!f){const b=l.buffer.buffer.slice(l.buffer.byteOffset,l.buffer.byteOffset+l.buffer.byteLength);m.port1.postMessage(b,[b])}}}}}function r(p){return new Promise(m=>{const E=p.onMessage(f=>{E.dispose();const l=JSON.parse(f.toString());p.send((0,A.createMessageOfType)(0)),m({protocol:p,initData:l})});p.send((0,A.createMessageOfType)(1))})}let a=p=>i();(function(){const m=new h;S.mark("code/extHost/willConnectToRenderer"),r(m.protocol).then(E=>{S.mark("code/extHost/didWaitForInitData");const f=new T.ExtensionHostMain(E.protocol,E.initData,d,null);a=l=>f.terminate(l)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fe23c2041f848d6c2f6bd27875112a37bcc82f84/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
